/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/platform","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/path","vs/base/common/uri","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","electron","vs/nls","vs/base/common/types","vs/base/common/errors","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/workspace/common/workspace","os","vs/base/common/strings","vs/base/common/extpath","fs","vs/base/common/arrays","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/labels","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","child_process","vs/base/common/decorators","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/objects","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/parts/ipc/node/ipc.net","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/keybindings","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/storage/common/storage","vs/platform/terminal/node/shellEnv","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/node/shellEnv","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/credentials/node/credentialsMainService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","path","graceful-fs","worker_threads","vs/code/electron-main/main"],x=function(V){for(var e=[],w=0,n=V.length;w<n;w++)e[w]=Z[V[w]];return e};define(Z[106],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(n,L){if(!n)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=w}),define(Z[107],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function w(k){return k?k.replace(/\$\((.*?)\)/g,(b,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=w;class n{constructor(b,g,S){this.id=b,this.definition=g,this.description=S,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function L(k,b){const g=["codicon","codicon-"+k];return b&&g.push("codicon-modifier-"+b),g}e.getClassNamesArray=L;var D;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function g(E){if(E instanceof n)return["codicon","codicon-"+E.id];const I=b.exec(E.id);if(!I)return g(n.error);let[,p,t]=I;const d=["codicon","codicon-"+p];return t&&d.push("codicon-modifier-"+t.substr(1)),d}k.asClassNameArray=g;function S(E){return g(E).join(" ")}k.asClassName=S;function C(E){return"."+g(E).join(".")}k.asCSSSelector=C})(D=e.CSSIcon||(e.CSSIcon={}))}),define(Z[46],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(k){return(b,g,S)=>{let C=null,E=null;if(typeof S.value=="function"?(C="value",E=S.value):typeof S.get=="function"&&(C="get",E=S.get),!E)throw new Error("not supported");S[C]=k(E,g)}}e.createDecorator=w;function n(k,b,g){let S=null,C=null;if(typeof g.value=="function"?(S="value",C=g.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(S="get",C=g.get),!C)throw new Error("not supported");const E=`$memoize$${b}`;g[S]=function(...I){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,I)}),this[E]}}e.memoize=n;function L(k,b,g){return w((S,C)=>{const E=`$debounce$${C}`,I=`$debounce$result$${C}`;return function(...p){this[I]||(this[I]=g?g():void 0),clearTimeout(this[E]),b&&(this[I]=b(this[I],...p),p=[this[I]]),this[E]=setTimeout(()=>{S.apply(this,p),this[I]=g?g():void 0},k)}})}e.debounce=L;function D(k,b,g){return w((S,C)=>{const E=`$throttle$timer$${C}`,I=`$throttle$result$${C}`,p=`$throttle$lastRun$${C}`,t=`$throttle$pending$${C}`;return function(...d){if(this[I]||(this[I]=g?g():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),b&&(this[I]=b(this[I],...d)),this[t])return;const m=this[p]+k;m<=Date.now()?(this[p]=Date.now(),S.apply(this,[this[I]]),this[I]=g?g():void 0):(this[t]=!0,this[E]=setTimeout(()=>{this[t]=!1,this[p]=Date.now(),S.apply(this,[this[I]]),this[I]=g?g():void 0},m-Date.now()))}})}e.throttle=D}),define(Z[15],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(l){setTimeout(()=>{throw l.stack?new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.listeners.push(l),()=>{this._removeListener(l)}}emit(l){this.listeners.forEach(c=>{c(l)})}_removeListener(l){this.listeners.splice(this.listeners.indexOf(l),1)}setUnexpectedErrorHandler(l){this.unexpectedErrorHandler=l}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(l){this.unexpectedErrorHandler(l),this.emit(l)}onUnexpectedExternalError(l){this.unexpectedErrorHandler(l)}}e.ErrorHandler=w,e.errorHandler=new w;function n(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=n;function L(h){g(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=L;function D(h){g(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=D;function k(h){if(h instanceof Error){let{name:l,message:c}=h;const a=h.stacktrace||h.stack;return{$isError:!0,name:l,message:c,stack:a}}return h}e.transformErrorForSerialization=k;const b="Canceled";function g(h){return h instanceof S?!0:h instanceof Error&&h.name===b&&h.message===b}e.isCancellationError=g;class S extends Error{constructor(){super(b);this.name=this.message}}e.CancellationError=S;function C(){const h=new Error(b);return h.name=h.message,h}e.canceled=C;function E(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=E;function I(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=I;function p(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function t(h){const l=new Error(`${h} has been disposed`);return l.name="DISPOSED",l}e.disposed=t;function d(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=d;class m extends Error{constructor(l){super("NotImplemented");l&&(this.message=l)}}e.NotImplementedError=m;class v extends Error{constructor(l){super("NotSupported");l&&(this.message=l)}}e.NotSupportedError=v;class M extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=M}),define(Z[30],x([0,1,15]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(T,A=0){return T[T.length-(1+A)]}e.tail=n;function L(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=L;function D(T,A,O=(_,j)=>_===j){if(T===A)return!0;if(!T||!A||T.length!==A.length)return!1;for(let _=0,j=T.length;_<j;_++)if(!O(T[_],A[_]))return!1;return!0}e.equals=D;function k(T,A,O){let _=0,j=T.length-1;for(;_<=j;){const ie=(_+j)/2|0,ae=O(T[ie],A);if(ae<0)_=ie+1;else if(ae>0)j=ie-1;else return ie}return-(_+1)}e.binarySearch=k;function b(T,A){let O=0,_=T.length;if(_===0)return 0;for(;O<_;){const j=Math.floor((O+_)/2);A(T[j])?_=j:O=j+1}return O}e.findFirstInSorted=b;function g(T,A,O){if(T=T|0,T>=A.length)throw new TypeError("invalid index");let _=A[Math.floor(A.length*Math.random())],j=[],ie=[],ae=[];for(let ce of A){const ne=O(ce,_);ne<0?j.push(ce):ne>0?ie.push(ce):ae.push(ce)}return T<j.length?g(T,j,O):T<j.length+ae.length?ae[0]:g(T-(j.length+ae.length),ie,O)}e.quickSelect=g;function S(T,A){const O=[];let _;for(const j of T.slice(0).sort(A))!_||A(_[0],j)!==0?(_=[j],O.push(_)):_.push(j);return O}e.groupBy=S;function C(T,A,O){const _=[];function j(ce,ne,le){if(ne===0&&le.length===0)return;const he=_[_.length-1];he&&he.start+he.deleteCount===ce?(he.deleteCount+=ne,he.toInsert.push(...le)):_.push({start:ce,deleteCount:ne,toInsert:le})}let ie=0,ae=0;for(;;){if(ie===T.length){j(ie,0,A.slice(ae));break}if(ae===A.length){j(ie,T.length-ie,[]);break}const ce=T[ie],ne=A[ae],le=O(ce,ne);le===0?(ie+=1,ae+=1):le<0?(j(ie,1,[]),ie+=1):le>0&&(j(ie,0,[ne]),ae+=1)}return _}e.sortedDiff=C;function E(T,A,O){const _=C(T,A,O),j=[],ie=[];for(const ae of _)j.push(...T.slice(ae.start,ae.start+ae.deleteCount)),ie.push(...ae.toInsert);return{removed:j,added:ie}}e.delta=E;function I(T,A,O){if(O===0)return[];const _=T.slice(0,O).sort(A);return t(T,A,_,O,T.length),_}e.top=I;function p(T,A,O,_,j){return O===0?Promise.resolve([]):new Promise((ie,ae)=>{(async()=>{const ce=T.length,ne=T.slice(0,O).sort(A);for(let le=O,he=Math.min(O+_,ce);le<ce;le=he,he=Math.min(he+_,ce)){if(le>O&&await new Promise(we=>setTimeout(we)),j&&j.isCancellationRequested)throw(0,w.canceled)();t(T,A,ne,le,he)}return ne})().then(ie,ae)})}e.topAsync=p;function t(T,A,O,_,j){for(const ie=O.length;_<j;_++){const ae=T[_];if(A(ae,O[ie-1])<0){O.pop();const ce=b(O,ne=>A(ae,ne)<0);O.splice(ce,0,ae)}}}function d(T){return T.filter(A=>!!A)}e.coalesce=d;function m(T){let A=0;for(let O=0;O<T.length;O++)T[O]&&(T[A]=T[O],A+=1);T.length=A}e.coalesceInPlace=m;function v(T,A,O){T.splice(O,0,T.splice(A,1)[0])}e.move=v;function M(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=M;function h(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=h;function l(T,A=O=>O){const O=new Set;return T.filter(_=>{const j=A(_);return O.has(j)?!1:(O.add(j),!0)})}e.distinct=l;function c(T){const A=new Set;return O=>{const _=T(O);return A.has(_)?!1:(A.add(_),!0)}}e.uniqueFilter=c;function a(T,A){const O=f(T,A);if(O!==-1)return T[O]}e.findLast=a;function f(T,A){for(let O=T.length-1;O>=0;O--){const _=T[O];if(A(_))return O}return-1}e.lastIndex=f;function s(T,A){return T.length>0?T[0]:A}e.firstOrDefault=s;function i(T,A,O=(_,j)=>_===j){let _=0;for(let j=0,ie=Math.min(T.length,A.length);j<ie&&O(T[j],A[j]);j++)_++;return _}e.commonPrefixLength=i;function r(T){return[].concat(...T)}e.flatten=r;function o(T,A){let O=typeof A=="number"?T:0;typeof A=="number"?O=T:(O=0,A=T);const _=[];if(O<=A)for(let j=O;j<A;j++)_.push(j);else for(let j=O;j>A;j--)_.push(j);return _}e.range=o;function u(T,A,O){return T.reduce((_,j)=>(_[A(j)]=O?O(j):j,_),Object.create(null))}e.index=u;function y(T,A){return T.push(A),()=>P(T,A)}e.insert=y;function P(T,A){const O=T.indexOf(A);if(O>-1)return T.splice(O,1),A}e.remove=P;function R(T,A,O){const _=T.slice(0,A),j=T.slice(A);return _.concat(O,j)}e.arrayInsert=R;function W(T,A){let O;if(typeof A=="number"){let _=A;O=()=>{const j=Math.sin(_++)*179426549;return j-Math.floor(j)}}else O=Math.random;for(let _=T.length-1;_>0;_-=1){const j=Math.floor(O()*(_+1)),ie=T[_];T[_]=T[j],T[j]=ie}}e.shuffle=W;function U(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.unshift(A))}e.pushToStart=U;function G(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.push(A))}e.pushToEnd=G;function ee(T,A){return Array.isArray(T)?T.map(A):A(T)}e.mapArrayOrNot=ee;function X(T){return Array.isArray(T)?T:[T]}e.asArray=X;function J(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=J;function H(T,A){for(const O of T){const _=A(O);if(_!==void 0)return _}}e.mapFind=H;function B(T,A,O){const _=se(T,A),j=T.length,ie=O.length;T.length=j+ie;for(let ae=j-1;ae>=_;ae--)T[ae+ie]=T[ae];for(let ae=0;ae<ie;ae++)T[ae+_]=O[ae]}e.insertInto=B;function Y(T,A,O,_){const j=se(T,A),ie=T.splice(j,O);return B(T,j,_),ie}e.splice=Y;function se(T,A){return A<0?Math.max(A+T.length,0):Math.min(A,T.length)}function $(T,A){return(O,_)=>A(T(O),T(_))}e.compareBy=$;const q=(T,A)=>T-A;e.numberComparator=q;function Q(T,A){if(T.length===0)return;let O=T[0];for(let _=1;_<T.length;_++){const j=T[_];A(j,O)>0&&(O=j)}return O}e.findMaxBy=Q;function z(T,A){if(T.length===0)return;let O=T[0];for(let _=1;_<T.length;_++){const j=T[_];A(j,O)>=0&&(O=j)}return O}e.findLastMaxBy=z;function F(T,A){return Q(T,(O,_)=>-A(O,_))}e.findMinBy=F;class N{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let O=this.firstIdx;for(;O<this.items.length&&A(this.items[O]);)O++;const _=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,_}takeFromEndWhile(A){let O=this.lastIdx;for(;O>=0&&A(this.items[O]);)O--;const _=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,_}peek(){return this.items[this.firstIdx]}dequeue(){const A=this.items[this.firstIdx];return this.firstIdx++,A}takeCount(A){const O=this.items.slice(this.firstIdx,this.firstIdx+A);return this.firstIdx+=A,O}}e.ArrayQueue=N}),define(Z[43],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(n){const L=this;let D=!1,k;return function(){return D||(D=!0,k=n.apply(L,arguments)),k}}e.once=w}),define(Z[68],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(n){function L(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=L;const D=Object.freeze([]);function k(){return D}n.empty=k;function*b(c){yield c}n.single=b;function g(c){return c||D}n.from=g;function S(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=S;function C(c){return c[Symbol.iterator]().next().value}n.first=C;function E(c,a){for(const f of c)if(a(f))return!0;return!1}n.some=E;function I(c,a){for(const f of c)if(a(f))return f}n.find=I;function*p(c,a){for(const f of c)a(f)&&(yield f)}n.filter=p;function*t(c,a){let f=0;for(const s of c)yield a(s,f++)}n.map=t;function*d(...c){for(const a of c)for(const f of a)yield f}n.concat=d;function*m(c){for(const a of c)for(const f of a)yield f}n.concatNested=m;function v(c,a,f){let s=f;for(const i of c)s=a(s,i);return s}n.reduce=v;function*M(c,a,f=c.length){for(a<0&&(a+=c.length),f<0?f+=c.length:f>c.length&&(f=c.length);a<f;a++)yield c[a]}n.slice=M;function h(c,a=Number.POSITIVE_INFINITY){const f=[];if(a===0)return[f,c];const s=c[Symbol.iterator]();for(let i=0;i<a;i++){const r=s.next();if(r.done)return[f,n.empty()];f.push(r.value)}return[f,{[Symbol.iterator](){return s}}]}n.consume=h;function l(c,a,f=(s,i)=>s===i){const s=c[Symbol.iterator](),i=a[Symbol.iterator]();for(;;){const r=s.next(),o=i.next();if(r.done!==o.done)return!1;if(r.done)return!0;if(!f(r.value,o.value))return!1}}n.equals=l})(w=e.Iterable||(e.Iterable={}))}),define(Z[44],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var n;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(a){a.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function k(a,f=!1){let s=0,i=a.length,r="",o=0,u=16,y=0;function P(J){let H=0,B=0;for(;H<J;){const Y=a.charCodeAt(s);if(Y>=48&&Y<=57)B=B*16+Y-48;else if(Y>=65&&Y<=70)B=B*16+Y-65+10;else if(Y>=97&&Y<=102)B=B*16+Y-97+10;else break;s++,H++}return H<J&&(B=-1),B}function R(J){s=J,r="",o=0,u=16,y=0}function W(){const J=s;if(a.charCodeAt(s)===48)s++;else for(s++;s<a.length&&S(a.charCodeAt(s));)s++;if(s<a.length&&a.charCodeAt(s)===46)if(s++,s<a.length&&S(a.charCodeAt(s)))for(s++;s<a.length&&S(a.charCodeAt(s));)s++;else return y=3,a.substring(J,s);let H=s;if(s<a.length&&(a.charCodeAt(s)===69||a.charCodeAt(s)===101))if(s++,(s<a.length&&a.charCodeAt(s)===43||a.charCodeAt(s)===45)&&s++,s<a.length&&S(a.charCodeAt(s))){for(s++;s<a.length&&S(a.charCodeAt(s));)s++;H=s}else y=3;return a.substring(J,H)}function U(){let J="",H=s;for(;;){if(s>=i){J+=a.substring(H,s),y=2;break}const B=a.charCodeAt(s);if(B===34){J+=a.substring(H,s),s++;break}if(B===92){if(J+=a.substring(H,s),s++,s>=i){y=2;break}switch(a.charCodeAt(s++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const se=P(4);se>=0?J+=String.fromCharCode(se):y=4;break}default:y=5}H=s;continue}if(B>=0&&B<=31)if(g(B)){J+=a.substring(H,s),y=2;break}else y=6;s++}return J}function G(){if(r="",y=0,o=s,s>=i)return o=i,u=17;let J=a.charCodeAt(s);if(b(J)){do s++,r+=String.fromCharCode(J),J=a.charCodeAt(s);while(b(J));return u=15}if(g(J))return s++,r+=String.fromCharCode(J),J===13&&a.charCodeAt(s)===10&&(s++,r+=`
`),u=14;switch(J){case 123:return s++,u=1;case 125:return s++,u=2;case 91:return s++,u=3;case 93:return s++,u=4;case 58:return s++,u=6;case 44:return s++,u=5;case 34:return s++,r=U(),u=10;case 47:{const H=s-1;if(a.charCodeAt(s+1)===47){for(s+=2;s<i&&!g(a.charCodeAt(s));)s++;return r=a.substring(H,s),u=12}if(a.charCodeAt(s+1)===42){s+=2;const B=i-1;let Y=!1;for(;s<B;){if(a.charCodeAt(s)===42&&a.charCodeAt(s+1)===47){s+=2,Y=!0;break}s++}return Y||(s++,y=1),r=a.substring(H,s),u=13}return r+=String.fromCharCode(J),s++,u=16}case 45:if(r+=String.fromCharCode(J),s++,s===i||!S(a.charCodeAt(s)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=W(),u=11;default:for(;s<i&&ee(J);)s++,J=a.charCodeAt(s);if(o!==s){switch(r=a.substring(o,s),r){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return r+=String.fromCharCode(J),s++,u=16}}function ee(J){if(b(J)||g(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function X(){let J;do J=G();while(J>=12&&J<=15);return J}return{setPosition:R,getPosition:()=>s,scan:f?X:G,getToken:()=>u,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>s-o,getTokenError:()=>y}}e.createScanner=k;function b(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function g(a){return a===10||a===13||a===8232||a===8233}function S(a){return a>=48&&a<=57}var C;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(C||(C={}));function E(a,f){const s=[],i=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function y(P,R,W,U){o.value=P,o.offset=R,o.length=W,o.type=U,o.colonOffset=void 0,r=o}try{h(a,{onObjectBegin:(P,R)=>{if(f<=P)throw i;r=void 0,u=f>P,s.push("")},onObjectProperty:(P,R,W)=>{if(f<R||(y(P,R,W,"property"),s[s.length-1]=P,f<=R+W))throw i},onObjectEnd:(P,R)=>{if(f<=P)throw i;r=void 0,s.pop()},onArrayBegin:(P,R)=>{if(f<=P)throw i;r=void 0,s.push(0)},onArrayEnd:(P,R)=>{if(f<=P)throw i;r=void 0,s.pop()},onLiteralValue:(P,R,W)=>{if(f<R||(y(P,R,W,c(P)),f<=R+W))throw i},onSeparator:(P,R,W)=>{if(f<=R)throw i;if(P===":"&&r&&r.type==="property")r.colonOffset=R,u=!1,r=void 0;else if(P===","){const U=s[s.length-1];typeof U=="number"?s[s.length-1]=U+1:(u=!0,s[s.length-1]=""),r=void 0}}})}catch(P){if(P!==i)throw P}return{path:s,previousNode:r,isAtPropertyKey:u,matches:P=>{let R=0;for(let W=0;R<P.length&&W<s.length;W++)if(P[R]===s[W]||P[R]==="*")R++;else if(P[R]!=="**")return!1;return R===P.length}}}e.getLocation=E;function I(a,f=[],s=D.DEFAULT){let i=null,r=[];const o=[];function u(P){Array.isArray(r)?r.push(P):i!==null&&(r[i]=P)}return h(a,{onObjectBegin:()=>{const P={};u(P),o.push(r),r=P,i=null},onObjectProperty:P=>{i=P},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const P=[];u(P),o.push(r),r=P,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:u,onError:(P,R,W)=>{f.push({error:P,offset:R,length:W})}},s),r[0]}e.parse=I;function p(a,f=[],s=D.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(P){i.type==="property"&&(i.length=P-i.offset,i=i.parent)}function o(P){return i.children.push(P),P}h(a,{onObjectBegin:P=>{i=o({type:"object",offset:P,length:-1,parent:i,children:[]})},onObjectProperty:(P,R,W)=>{i=o({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:P,offset:R,length:W,parent:i})},onObjectEnd:(P,R)=>{i.length=P+R-i.offset,i=i.parent,r(P+R)},onArrayBegin:(P,R)=>{i=o({type:"array",offset:P,length:-1,parent:i,children:[]})},onArrayEnd:(P,R)=>{i.length=P+R-i.offset,i=i.parent,r(P+R)},onLiteralValue:(P,R,W)=>{o({type:c(P),offset:R,length:W,parent:i,value:P}),r(R+W)},onSeparator:(P,R,W)=>{i.type==="property"&&(P===":"?i.colonOffset=R:P===","&&r(R))},onError:(P,R,W)=>{f.push({error:P,offset:R,length:W})}},s);const y=i.children[0];return y&&delete y.parent,y}e.parseTree=p;function t(a,f){if(!a)return;let s=a;for(let i of f)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const o of s.children)if(Array.isArray(o.children)&&o.children[0].value===i){s=o.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=t;function d(a){if(!a.parent||!a.parent.children)return[];const f=d(a.parent);if(a.parent.type==="property"){const s=a.parent.children[0].value;f.push(s)}else if(a.parent.type==="array"){const s=a.parent.children.indexOf(a);s!==-1&&f.push(s)}return f}e.getNodePath=d;function m(a){switch(a.type){case"array":return a.children.map(m);case"object":{const f=Object.create(null);for(let s of a.children){const i=s.children[1];i&&(f[s.children[0].value]=m(i))}return f}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=m;function v(a,f,s=!1){return f>=a.offset&&f<a.offset+a.length||s&&f===a.offset+a.length}e.contains=v;function M(a,f,s=!1){if(v(a,f,s)){const i=a.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=f;r++){const o=M(i[r],f,s);if(o)return o}return a}}e.findNodeAtOffset=M;function h(a,f,s=D.DEFAULT){const i=k(a,!1);function r(N){return N?()=>N(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(N){return N?T=>N(T,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=r(f.onObjectBegin),y=o(f.onObjectProperty),P=r(f.onObjectEnd),R=r(f.onArrayBegin),W=r(f.onArrayEnd),U=o(f.onLiteralValue),G=o(f.onSeparator),ee=r(f.onComment),X=o(f.onError),J=s&&s.disallowComments,H=s&&s.allowTrailingComma;function B(){for(;;){const N=i.scan();switch(i.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:J||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(N){case 12:case 13:J?Y(10):ee();break;case 16:Y(1);break;case 15:case 14:break;default:return N}}}function Y(N,T=[],A=[]){if(X(N),T.length+A.length>0){let O=i.getToken();for(;O!==17;){if(T.indexOf(O)!==-1){B();break}else if(A.indexOf(O)!==-1)break;O=B()}}}function se(N){const T=i.getTokenValue();return N?U(T):y(T),B(),!0}function $(){switch(i.getToken()){case 11:{let N=0;try{N=JSON.parse(i.getTokenValue()),typeof N!="number"&&(Y(2),N=0)}catch{Y(2)}U(N);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return B(),!0}function q(){return i.getToken()!==10?(Y(3,[],[2,5]),!1):(se(!1),i.getToken()===6?(G(":"),B(),F()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function Q(){u(),B();let N=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(N||Y(4,[],[]),G(","),B(),i.getToken()===2&&H)break}else N&&Y(6,[],[]);q()||Y(4,[],[2,5]),N=!0}return P(),i.getToken()!==2?Y(7,[2],[]):B(),!0}function z(){R(),B();let N=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(N||Y(4,[],[]),G(","),B(),i.getToken()===4&&H)break}else N&&Y(6,[],[]);F()||Y(4,[],[4,5]),N=!0}return W(),i.getToken()!==4?Y(8,[4],[]):B(),!0}function F(){switch(i.getToken()){case 3:return z();case 1:return Q();case 10:return se(!0);default:return $()}}return B(),i.getToken()===17?s.allowEmptyContent?!0:(Y(4,[],[]),!1):F()?(i.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}e.visit=h;function l(a,f){let s=k(a),i=[],r,o=0,u;do switch(u=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:o!==u&&i.push(a.substring(o,u)),f!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,f)),o=s.getPosition();break}while(r!==17);return i.join("")}e.stripComments=l;function c(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[108],x([0,1,44]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(S,C,E){let I,p,t,d,m;if(C){for(d=C.offset,m=d+C.length,t=d;t>0&&!g(S,t-1);)t--;let u=m;for(;u<S.length&&!g(S,u);)u++;p=S.substring(t,u),I=k(p,E)}else p=S,I=0,t=0,d=0,m=S.length;const v=b(E,S);let M=!1,h=0,l;E.insertSpaces?l=D(" ",E.tabSize||4):l="	";const c=(0,w.createScanner)(p,!1);let a=!1;function f(){return v+D(l,I+h)}function s(){let u=c.scan();for(M=!1;u===15||u===14;)M=M||u===14,u=c.scan();return a=u===16||c.getTokenError()!==0,u}const i=[];function r(u,y,P){!a&&y<m&&P>d&&S.substring(y,P)!==u&&i.push({offset:y,length:P-y,content:u})}let o=s();if(o!==17){const u=c.getTokenOffset()+t,y=D(l,I);r(y,t,u)}for(;o!==17;){let u=c.getTokenOffset()+c.getTokenLength()+t,y=s(),P="";for(;!M&&(y===12||y===13);){const W=c.getTokenOffset()+t;r(" ",u,W),u=c.getTokenOffset()+c.getTokenLength()+t,P=y===12?f():"",y=s()}if(y===2)o!==1&&(h--,P=f());else if(y===4)o!==3&&(h--,P=f());else{switch(o){case 3:case 1:h++,P=f();break;case 5:case 12:P=f();break;case 13:M?P=f():P=" ";break;case 6:P=" ";break;case 10:if(y===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?P=" ":y!==5&&y!==17&&(a=!0);break;case 16:a=!0;break}M&&(y===12||y===13)&&(P=f())}const R=c.getTokenOffset()+t;r(P,u,R),o=y}return i}e.format=n;function L(S,C){const E=JSON.stringify(S,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?E.replace(/\r\n|\r|\n/g,C.eol):E}e.toFormattedString=L;function D(S,C){let E="";for(let I=0;I<C;I++)E+=S;return E}function k(S,C){let E=0,I=0;const p=C.tabSize||4;for(;E<S.length;){const t=S.charAt(E);if(t===" ")I++;else if(t==="	")I+=p;else break;E++}return Math.floor(I/p)}function b(S,C){for(let E=0;E<C.length;E++){const I=C.charAt(E);if(I==="\r")return E+1<C.length&&C.charAt(E+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=b;function g(S,C){return`\r
`.indexOf(S.charAt(C))!==-1}e.isEOL=g}),define(Z[109],x([0,1,44,108]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(S,C,E){return D(S,C,void 0,E)}e.removeProperty=L;function D(S,C,E,I,p){const t=C.slice(),d=[],m=(0,w.parseTree)(S,d);let v,M;for(;t.length>0&&(M=t.pop(),v=(0,w.findNodeAtLocation)(m,t),v===void 0&&E!==void 0);)typeof M=="string"?E={[M]:E}:E=[E];if(v)if(v.type==="object"&&typeof M=="string"&&Array.isArray(v.children)){const h=(0,w.findNodeAtLocation)(v,[M]);if(h!==void 0)if(E===void 0){if(!h.parent)throw new Error("Malformed AST");const l=v.children.indexOf(h.parent);let c,a=h.parent.offset+h.parent.length;if(l>0){const f=v.children[l-1];c=f.offset+f.length}else c=v.offset+1,v.children.length>1&&(a=v.children[1].offset);return k(S,{offset:c,length:a-c,content:""},I)}else return k(S,{offset:h.offset,length:h.length,content:JSON.stringify(E)},I);else{if(E===void 0)return[];const l=`${JSON.stringify(M)}: ${JSON.stringify(E)}`,c=p?p(v.children.map(f=>f.children[0].value)):v.children.length;let a;if(c>0){const f=v.children[c-1];a={offset:f.offset+f.length,length:0,content:","+l}}else v.children.length===0?a={offset:v.offset+1,length:0,content:l}:a={offset:v.offset+1,length:0,content:l+","};return k(S,a,I)}}else if(v.type==="array"&&typeof M=="number"&&Array.isArray(v.children))if(E!==void 0){const h=`${JSON.stringify(E)}`;let l;if(v.children.length===0||M===0)l={offset:v.offset+1,length:0,content:v.children.length===0?h:h+","};else{const c=M===-1||M>v.children.length?v.children.length:M,a=v.children[c-1];l={offset:a.offset+a.length,length:0,content:","+h}}return k(S,l,I)}else{const h=M,l=v.children[h];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===h){const a=v.children[h-1],f=a.offset+a.length,s=v.offset+v.length;c={offset:f,length:s-2-f,content:""}}else c={offset:l.offset,length:v.children[h+1].offset-l.offset,content:""};return k(S,c,I)}else throw new Error(`Can not add ${typeof M!="number"?"index":"property"} to parent of type ${v.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return k(S,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(E)},I)}}e.setProperty=D;function k(S,C,E){let I=b(S,C),p=C.offset,t=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;p>0&&!(0,n.isEOL)(I,p-1);)p--;for(;t<I.length&&!(0,n.isEOL)(I,t);)t++}const d=(0,n.format)(I,{offset:p,length:t-p},E);for(let v=d.length-1;v>=0;v--){const M=d[v];I=b(I,M),p=Math.min(p,M.offset),t=Math.max(t,M.offset+M.length),t+=M.content.length-M.length}const m=S.length-(I.length-t)-p;return[{offset:p,length:m,content:I.substring(p,t)}]}e.withFormatting=k;function b(S,C){return S.substring(0,C.offset)+C.content+S.substring(C.offset+C.length)}e.applyEdit=b;function g(S,C){let E=C.slice(0).sort((p,t)=>{const d=p.offset-t.offset;return d===0?p.length-t.length:d}),I=S.length;for(let p=E.length-1;p>=0;p--){let t=E[p];if(t.offset+t.length<=I)S=b(S,t);else throw new Error("Overlapping edit");I=t.offset}return S}e.applyEdits=g}),define(Z[83],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var w;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.Clear=126]="Clear",t[t.MAX_VALUE=127]="MAX_VALUE"})(w=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class L{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(d,m){this._keyCodeToStr[d]=m,this._strToKeyCode[m.toLowerCase()]=d}keyCodeToStr(d){return this._keyCodeToStr[d]}strToKeyCode(d){return this._strToKeyCode[d.toLowerCase()]||0}}const D=new L,k=new L,b=new L;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const g=[],S=Object.create(null),C=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>C[t]||0,toEnum:t=>S[t]||0,toString:t=>g[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=127;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",d=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let m=[],v=[];for(const M of d){const[h,l,c,a,f,s,i,r,o,u]=M;if(v[c]||(v[c]=!0,g[c]=a,S[a]=c,C[a.toLowerCase()]=c,l&&(e.IMMUTABLE_CODE_TO_KEY_CODE[c]=f,f!==0&&f!==3&&f!==5&&f!==4&&f!==6&&f!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[f]=c))),!m[f]){if(m[f]=!0,!s)throw new Error(`String representation missing for key code ${f} around scan code ${a}`);D.define(f,s),k.define(f,o||s),b.define(f,u||o||s)}i&&(e.EVENT_KEY_CODE_MAP[i]=f),r&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var E;(function(t){function d(c){return D.keyCodeToStr(c)}t.toString=d;function m(c){return D.strToKeyCode(c)}t.fromString=m;function v(c){return k.keyCodeToStr(c)}t.toUserSettingsUS=v;function M(c){return b.keyCodeToStr(c)}t.toUserSettingsGeneral=M;function h(c){return k.strToKeyCode(c)||b.strToKeyCode(c)}t.fromUserSettings=h;function l(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return D.keyCodeToStr(c)}t.toElectronAccelerator=l})(E=e.KeyCodeUtils||(e.KeyCodeUtils={}));var I;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(I=e.KeyMod||(e.KeyMod={}));function p(t,d){const m=(d&65535)<<16>>>0;return(t|m)>>>0}e.KeyChord=p}),define(Z[59],x([0,1,15]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(E){E[E.CtrlCmd=2048]="CtrlCmd",E[E.Shift=1024]="Shift",E[E.Alt=512]="Alt",E[E.WinCtrl=256]="WinCtrl",E[E.KeyCode=255]="KeyCode"})(n||(n={}));function L(E,I){if(E===0)return null;const p=(E&65535)>>>0,t=(E&4294901760)>>>16;return t!==0?new b([D(p,I),D(t,I)]):new b([D(p,I)])}e.createKeybinding=L;function D(E,I){const p=!!(E&2048),t=!!(E&256),d=I===2?t:p,m=!!(E&1024),v=!!(E&512),M=I===2?p:t,h=E&255;return new k(d,m,v,M,h)}e.createSimpleKeybinding=D;class k{constructor(I,p,t,d,m){this.ctrlKey=I,this.shiftKey=p,this.altKey=t,this.metaKey=d,this.keyCode=m}equals(I){return this.ctrlKey===I.ctrlKey&&this.shiftKey===I.shiftKey&&this.altKey===I.altKey&&this.metaKey===I.metaKey&&this.keyCode===I.keyCode}getHashCode(){const I=this.ctrlKey?"1":"0",p=this.shiftKey?"1":"0",t=this.altKey?"1":"0",d=this.metaKey?"1":"0";return`${I}${p}${t}${d}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=k;class b{constructor(I){if(I.length===0)throw(0,w.illegalArgument)("parts");this.parts=I}getHashCode(){let I="";for(let p=0,t=this.parts.length;p<t;p++)p!==0&&(I+=";"),I+=this.parts[p].getHashCode();return I}equals(I){if(I===null||this.parts.length!==I.parts.length)return!1;for(let p=0;p<this.parts.length;p++)if(!this.parts[p].equals(I.parts[p]))return!1;return!0}}e.ChordKeybinding=b;class g{constructor(I,p,t,d,m){this.ctrlKey=I,this.shiftKey=p,this.altKey=t,this.metaKey=d,this.scanCode=m}equals(I){return this.ctrlKey===I.ctrlKey&&this.shiftKey===I.shiftKey&&this.altKey===I.altKey&&this.metaKey===I.metaKey&&this.scanCode===I.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=g;class S{constructor(I,p,t,d,m,v){this.ctrlKey=I,this.shiftKey=p,this.altKey=t,this.metaKey=d,this.keyLabel=m,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=S;class C{}e.ResolvedKeybinding=C}),define(Z[110],x([0,1,83,59]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class L{static _readModifiers(k){k=k.toLowerCase().trim();let b=!1,g=!1,S=!1,C=!1,E;do E=!1,/^ctrl(\+|\-)/.test(k)&&(b=!0,k=k.substr("ctrl-".length),E=!0),/^shift(\+|\-)/.test(k)&&(g=!0,k=k.substr("shift-".length),E=!0),/^alt(\+|\-)/.test(k)&&(S=!0,k=k.substr("alt-".length),E=!0),/^meta(\+|\-)/.test(k)&&(C=!0,k=k.substr("meta-".length),E=!0),/^win(\+|\-)/.test(k)&&(C=!0,k=k.substr("win-".length),E=!0),/^cmd(\+|\-)/.test(k)&&(C=!0,k=k.substr("cmd-".length),E=!0);while(E);let I;const p=k.indexOf(" ");return p>0?(I=k.substring(0,p),k=k.substring(p)):(I=k,k=""),{remains:k,ctrl:b,shift:g,alt:S,meta:C,key:I}}static parseSimpleKeybinding(k){const b=this._readModifiers(k),g=w.KeyCodeUtils.fromUserSettings(b.key);return[new n.SimpleKeybinding(b.ctrl,b.shift,b.alt,b.meta,g),b.remains]}static parseKeybinding(k,b){if(!k)return null;const g=[];let S;do[S,k]=this.parseSimpleKeybinding(k),g.push(S);while(k.length>0);return new n.ChordKeybinding(g)}static parseSimpleUserBinding(k){const b=this._readModifiers(k),g=b.key.match(/^\[([^\]]+)\]$/);if(g){const C=g[1],E=w.ScanCodeUtils.lowerCaseToEnum(C);return[new n.ScanCodeBinding(b.ctrl,b.shift,b.alt,b.meta,E),b.remains]}const S=w.KeyCodeUtils.fromUserSettings(b.key);return[new n.SimpleKeybinding(b.ctrl,b.shift,b.alt,b.meta,S),b.remains]}static parseUserBinding(k){if(!k)return[];const b=[];let g;for(;k.length>0;)[g,k]=this.parseSimpleUserBinding(k),b.push(g);return b}}e.KeybindingParser=L}),define(Z[111],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new w(()=>L(this.getValue()))}}e.Lazy=w}),define(Z[3],x([0,1,43,68]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let D=null;function k(r){D=r}if(e.setDisposableTracker=k,L){const r="__is_disposable_tracked__";k(new class{trackDisposable(o){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[r]||console.log(u)},3e3)}setParent(o,u){if(o&&o!==M.None)try{o[r]=!0}catch{}}markAsDisposed(o){if(o&&o!==M.None)try{o[r]=!0}catch{}}markAsSingleton(o){}})}function b(r){return D?.trackDisposable(r),r}function g(r){D?.markAsDisposed(r)}function S(r,o){D?.setParent(r,o)}function C(r,o){if(!!D)for(const u of r)D.setParent(u,o)}function E(r){return D?.markAsSingleton(r),r}e.markAsSingleton=E;class I extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=I;function p(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=p;function t(r){if(n.Iterable.is(r)){let o=[];for(const u of r)if(u)try{u.dispose()}catch(y){o.push(y)}if(o.length===1)throw o[0];if(o.length>1)throw new I(o);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=t;function d(...r){const o=m(()=>t(r));return C(r,o),o}e.combinedDisposable=d;function m(r){const o=b({dispose:(0,w.once)(()=>{g(o),r()})});return o}e.toDisposable=m;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return S(o,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class M{constructor(){this._store=new v,b(this),S(this._store,this)}dispose(){g(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=M,M.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&S(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&S(o,null),o}}e.MutableDisposable=h;class l{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(o){let u=o;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,g(this))},this}}e.SafeDisposable=c;class a{constructor(){this.references=new Map}acquire(o,...u){let y=this.references.get(o);y||(y={counter:0,object:this.createReferencedObject(o,...u)},this.references.set(o,y));const{object:P}=y,R=(0,w.once)(()=>{--y.counter==0&&(this.destroyReferencedObject(o,y.object),this.references.delete(o))});return y.counter++,{object:P,dispose:R}}}e.ReferenceCollection=a;class f{constructor(o){this.referenceCollection=o}async acquire(o,...u){const y=this.referenceCollection.acquire(o,...u);try{return{object:await y.object,dispose:()=>y.dispose()}}catch(P){throw y.dispose(),P}}}e.AsyncReferenceCollection=f;class s{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=s;function i(r){const o=new v;try{r(o)}finally{o.dispose()}}e.disposeOnReturn=i}),define(Z[112],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(D){this.element=D,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class n{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let D=this._first;for(;D!==w.Undefined;){const k=D.next;D.prev=w.Undefined,D.next=w.Undefined,D=k}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,k){const b=new w(D);if(this._first===w.Undefined)this._first=b,this._last=b;else if(k){const S=this._last;this._last=b,b.prev=S,S.next=b}else{const S=this._first;this._first=b,b.next=S,S.prev=b}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(b))}}shift(){if(this._first!==w.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==w.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==w.Undefined&&D.next!==w.Undefined){const k=D.prev;k.next=D.next,D.next.prev=k}else D.prev===w.Undefined&&D.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):D.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):D.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==w.Undefined;)yield D.element,D=D.next}}e.LinkedList=n}),function(){function V(L){const D=[];typeof L=="number"&&D.push("code/timeOrigin",L);function k(g){D.push(g,Date.now())}function b(){const g=[];for(let S=0;S<D.length;S+=2)g.push({name:D[S],startTime:D[S+1]});return g}return{mark:k,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const k of performance.getEntriesByType("mark"))D.push({name:k.name,startTime:Math.round(L+k.startTime)});return D}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function w(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=w(n))}(),define(Z[2],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const w="en";let n=!1,L=!1,D=!1,k=!1,b=!1,g=!1,S=!1,C=!1,E=!1,I,p=w,t,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const v=typeof m?.versions?.electron=="string",M=v&&m?.type==="renderer";if(e.isElectronSandboxed=M&&m?.sandboxed,typeof navigator=="object"&&!M)d=navigator.userAgent,n=d.indexOf("Windows")>=0,L=d.indexOf("Macintosh")>=0,C=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=d.indexOf("Linux")>=0,g=!0,I=navigator.language,p=I;else if(typeof m=="object"){n=m.platform==="win32",L=m.platform==="darwin",D=m.platform==="linux",k=D&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,S=v,E=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=w,p=w;const o=m.env.VSCODE_NLS_CONFIG;if(o)try{const u=JSON.parse(o),y=u.availableLanguages["*"];I=u.locale,p=y||w,t=u._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var h;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function l(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let c=0;L?c=1:n?c=3:D&&(c=2),e.isWindows=n,e.isMacintosh=L,e.isLinux=D,e.isLinuxSnap=k,e.isNative=b,e.isElectron=S,e.isWeb=g,e.isWebWorker=g&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isCI=E,e.platform=c,e.userAgent=d,e.language=p;var a;(function(o){function u(){return e.language}o.value=u;function y(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=y;function P(){return e.language==="en"}o.isDefault=P})(a=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=t,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeScheduleAsyncWork)for(let P=0,R=o.length;P<R;P++){const W=o[P];if(W.id===y.data.vscodeScheduleAsyncWork){o.splice(P,1),W.callback();return}}});let u=0;return y=>{const P=++u;o.push({id:P,callback:y}),e.globals.postMessage({vscodeScheduleAsyncWork:P},"*")}}return o=>setTimeout(o)})();var f;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||C?2:n?1:3;let s=!0,i=!1;function r(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,s=new Uint16Array(o.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[36],x([0,1,2]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const L=w.globals.vscode.process;n={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(Z[7],x([0,1,36]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,L=97,D=90,k=122,b=46,g=47,S=92,C=58,E=63;class I extends Error{constructor(l,c,a){let f;typeof c=="string"&&c.indexOf("not ")===0?(f="must not be",c=c.replace(/^not /,"")):f="must be";const s=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${s} ${f} of type ${c}`;i+=`. Received type ${typeof a}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function p(h,l){if(typeof h!="string")throw new I(l,"string",h)}function t(h){return h===g||h===S}function d(h){return h===g}function m(h){return h>=n&&h<=D||h>=L&&h<=k}function v(h,l,c,a){let f="",s=0,i=-1,r=0,o=0;for(let u=0;u<=h.length;++u){if(u<h.length)o=h.charCodeAt(u);else{if(a(o))break;o=g}if(a(o)){if(!(i===u-1||r===1))if(r===2){if(f.length<2||s!==2||f.charCodeAt(f.length-1)!==b||f.charCodeAt(f.length-2)!==b){if(f.length>2){const y=f.lastIndexOf(c);y===-1?(f="",s=0):(f=f.slice(0,y),s=f.length-1-f.lastIndexOf(c)),i=u,r=0;continue}else if(f.length!==0){f="",s=0,i=u,r=0;continue}}l&&(f+=f.length>0?`${c}..`:"..",s=2)}else f.length>0?f+=`${c}${h.slice(i+1,u)}`:f=h.slice(i+1,u),s=u-i-1;i=u,r=0}else o===b&&r!==-1?++r:r=-1}return f}function M(h,l){if(l===null||typeof l!="object")throw new I("pathObject","Object",l);const c=l.dir||l.root,a=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${a}`:`${c}${h}${a}`:a}e.win32={resolve(...h){let l="",c="",a=!1;for(let f=h.length-1;f>=-1;f--){let s;if(f>=0){if(s=h[f],p(s,"path"),s.length===0)continue}else l.length===0?s=w.cwd():(s=w.env[`=${l}`]||w.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==l.toLowerCase()&&s.charCodeAt(2)===S)&&(s=`${l}\\`));const i=s.length;let r=0,o="",u=!1;const y=s.charCodeAt(0);if(i===1)t(y)&&(r=1,u=!0);else if(t(y))if(u=!0,t(s.charCodeAt(1))){let P=2,R=P;for(;P<i&&!t(s.charCodeAt(P));)P++;if(P<i&&P!==R){const W=s.slice(R,P);for(R=P;P<i&&t(s.charCodeAt(P));)P++;if(P<i&&P!==R){for(R=P;P<i&&!t(s.charCodeAt(P));)P++;(P===i||P!==R)&&(o=`\\\\${W}\\${s.slice(R,P)}`,r=P)}}}else r=1;else m(y)&&s.charCodeAt(1)===C&&(o=s.slice(0,2),r=2,i>2&&t(s.charCodeAt(2))&&(u=!0,r=3));if(o.length>0)if(l.length>0){if(o.toLowerCase()!==l.toLowerCase())continue}else l=o;if(a){if(l.length>0)break}else if(c=`${s.slice(r)}\\${c}`,a=u,u&&l.length>0)break}return c=v(c,!a,"\\",t),a?`${l}\\${c}`:`${l}${c}`||"."},normalize(h){p(h,"path");const l=h.length;if(l===0)return".";let c=0,a,f=!1;const s=h.charCodeAt(0);if(l===1)return d(s)?"\\":h;if(t(s))if(f=!0,t(h.charCodeAt(1))){let r=2,o=r;for(;r<l&&!t(h.charCodeAt(r));)r++;if(r<l&&r!==o){const u=h.slice(o,r);for(o=r;r<l&&t(h.charCodeAt(r));)r++;if(r<l&&r!==o){for(o=r;r<l&&!t(h.charCodeAt(r));)r++;if(r===l)return`\\\\${u}\\${h.slice(o)}\\`;r!==o&&(a=`\\\\${u}\\${h.slice(o,r)}`,c=r)}}}else c=1;else m(s)&&h.charCodeAt(1)===C&&(a=h.slice(0,2),c=2,l>2&&t(h.charCodeAt(2))&&(f=!0,c=3));let i=c<l?v(h.slice(c),!f,"\\",t):"";return i.length===0&&!f&&(i="."),i.length>0&&t(h.charCodeAt(l-1))&&(i+="\\"),a===void 0?f?`\\${i}`:i:f?`${a}\\${i}`:`${a}${i}`},isAbsolute(h){p(h,"path");const l=h.length;if(l===0)return!1;const c=h.charCodeAt(0);return t(c)||l>2&&m(c)&&h.charCodeAt(1)===C&&t(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let l,c;for(let s=0;s<h.length;++s){const i=h[s];p(i,"path"),i.length>0&&(l===void 0?l=c=i:l+=`\\${i}`)}if(l===void 0)return".";let a=!0,f=0;if(typeof c=="string"&&t(c.charCodeAt(0))){++f;const s=c.length;s>1&&t(c.charCodeAt(1))&&(++f,s>2&&(t(c.charCodeAt(2))?++f:a=!1))}if(a){for(;f<l.length&&t(l.charCodeAt(f));)f++;f>=2&&(l=`\\${l.slice(f)}`)}return e.win32.normalize(l)},relative(h,l){if(p(h,"from"),p(l,"to"),h===l)return"";const c=e.win32.resolve(h),a=e.win32.resolve(l);if(c===a||(h=c.toLowerCase(),l=a.toLowerCase(),h===l))return"";let f=0;for(;f<h.length&&h.charCodeAt(f)===S;)f++;let s=h.length;for(;s-1>f&&h.charCodeAt(s-1)===S;)s--;const i=s-f;let r=0;for(;r<l.length&&l.charCodeAt(r)===S;)r++;let o=l.length;for(;o-1>r&&l.charCodeAt(o-1)===S;)o--;const u=o-r,y=i<u?i:u;let P=-1,R=0;for(;R<y;R++){const U=h.charCodeAt(f+R);if(U!==l.charCodeAt(r+R))break;U===S&&(P=R)}if(R!==y){if(P===-1)return a}else{if(u>y){if(l.charCodeAt(r+R)===S)return a.slice(r+R+1);if(R===2)return a.slice(r+R)}i>y&&(h.charCodeAt(f+R)===S?P=R:R===2&&(P=3)),P===-1&&(P=0)}let W="";for(R=f+P+1;R<=s;++R)(R===s||h.charCodeAt(R)===S)&&(W+=W.length===0?"..":"\\..");return r+=P,W.length>0?`${W}${a.slice(r,o)}`:(a.charCodeAt(r)===S&&++r,a.slice(r,o))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const l=e.win32.resolve(h);if(l.length<=2)return h;if(l.charCodeAt(0)===S){if(l.charCodeAt(1)===S){const c=l.charCodeAt(2);if(c!==E&&c!==b)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(m(l.charCodeAt(0))&&l.charCodeAt(1)===C&&l.charCodeAt(2)===S)return`\\\\?\\${l}`;return h},dirname(h){p(h,"path");const l=h.length;if(l===0)return".";let c=-1,a=0;const f=h.charCodeAt(0);if(l===1)return t(f)?h:".";if(t(f)){if(c=a=1,t(h.charCodeAt(1))){let r=2,o=r;for(;r<l&&!t(h.charCodeAt(r));)r++;if(r<l&&r!==o){for(o=r;r<l&&t(h.charCodeAt(r));)r++;if(r<l&&r!==o){for(o=r;r<l&&!t(h.charCodeAt(r));)r++;if(r===l)return h;r!==o&&(c=a=r+1)}}}}else m(f)&&h.charCodeAt(1)===C&&(c=l>2&&t(h.charCodeAt(2))?3:2,a=c);let s=-1,i=!0;for(let r=l-1;r>=a;--r)if(t(h.charCodeAt(r))){if(!i){s=r;break}}else i=!1;if(s===-1){if(c===-1)return".";s=c}return h.slice(0,s)},basename(h,l){l!==void 0&&p(l,"ext"),p(h,"path");let c=0,a=-1,f=!0,s;if(h.length>=2&&m(h.charCodeAt(0))&&h.charCodeAt(1)===C&&(c=2),l!==void 0&&l.length>0&&l.length<=h.length){if(l===h)return"";let i=l.length-1,r=-1;for(s=h.length-1;s>=c;--s){const o=h.charCodeAt(s);if(t(o)){if(!f){c=s+1;break}}else r===-1&&(f=!1,r=s+1),i>=0&&(o===l.charCodeAt(i)?--i==-1&&(a=s):(i=-1,a=r))}return c===a?a=r:a===-1&&(a=h.length),h.slice(c,a)}for(s=h.length-1;s>=c;--s)if(t(h.charCodeAt(s))){if(!f){c=s+1;break}}else a===-1&&(f=!1,a=s+1);return a===-1?"":h.slice(c,a)},extname(h){p(h,"path");let l=0,c=-1,a=0,f=-1,s=!0,i=0;h.length>=2&&h.charCodeAt(1)===C&&m(h.charCodeAt(0))&&(l=a=2);for(let r=h.length-1;r>=l;--r){const o=h.charCodeAt(r);if(t(o)){if(!s){a=r+1;break}continue}f===-1&&(s=!1,f=r+1),o===b?c===-1?c=r:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||f===-1||i===0||i===1&&c===f-1&&c===a+1?"":h.slice(c,f)},format:M.bind(null,"\\"),parse(h){p(h,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return l;const c=h.length;let a=0,f=h.charCodeAt(0);if(c===1)return t(f)?(l.root=l.dir=h,l):(l.base=l.name=h,l);if(t(f)){if(a=1,t(h.charCodeAt(1))){let P=2,R=P;for(;P<c&&!t(h.charCodeAt(P));)P++;if(P<c&&P!==R){for(R=P;P<c&&t(h.charCodeAt(P));)P++;if(P<c&&P!==R){for(R=P;P<c&&!t(h.charCodeAt(P));)P++;P===c?a=P:P!==R&&(a=P+1)}}}}else if(m(f)&&h.charCodeAt(1)===C){if(c<=2)return l.root=l.dir=h,l;if(a=2,t(h.charCodeAt(2))){if(c===3)return l.root=l.dir=h,l;a=3}}a>0&&(l.root=h.slice(0,a));let s=-1,i=a,r=-1,o=!0,u=h.length-1,y=0;for(;u>=a;--u){if(f=h.charCodeAt(u),t(f)){if(!o){i=u+1;break}continue}r===-1&&(o=!1,r=u+1),f===b?s===-1?s=u:y!==1&&(y=1):s!==-1&&(y=-1)}return r!==-1&&(s===-1||y===0||y===1&&s===r-1&&s===i+1?l.base=l.name=h.slice(i,r):(l.name=h.slice(i,s),l.base=h.slice(i,r),l.ext=h.slice(s,r))),i>0&&i!==a?l.dir=h.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let l="",c=!1;for(let a=h.length-1;a>=-1&&!c;a--){const f=a>=0?h[a]:w.cwd();p(f,"path"),f.length!==0&&(l=`${f}/${l}`,c=f.charCodeAt(0)===g)}return l=v(l,!c,"/",d),c?`/${l}`:l.length>0?l:"."},normalize(h){if(p(h,"path"),h.length===0)return".";const l=h.charCodeAt(0)===g,c=h.charCodeAt(h.length-1)===g;return h=v(h,!l,"/",d),h.length===0?l?"/":c?"./":".":(c&&(h+="/"),l?`/${h}`:h)},isAbsolute(h){return p(h,"path"),h.length>0&&h.charCodeAt(0)===g},join(...h){if(h.length===0)return".";let l;for(let c=0;c<h.length;++c){const a=h[c];p(a,"path"),a.length>0&&(l===void 0?l=a:l+=`/${a}`)}return l===void 0?".":e.posix.normalize(l)},relative(h,l){if(p(h,"from"),p(l,"to"),h===l||(h=e.posix.resolve(h),l=e.posix.resolve(l),h===l))return"";const c=1,a=h.length,f=a-c,s=1,i=l.length-s,r=f<i?f:i;let o=-1,u=0;for(;u<r;u++){const P=h.charCodeAt(c+u);if(P!==l.charCodeAt(s+u))break;P===g&&(o=u)}if(u===r)if(i>r){if(l.charCodeAt(s+u)===g)return l.slice(s+u+1);if(u===0)return l.slice(s+u)}else f>r&&(h.charCodeAt(c+u)===g?o=u:u===0&&(o=0));let y="";for(u=c+o+1;u<=a;++u)(u===a||h.charCodeAt(u)===g)&&(y+=y.length===0?"..":"/..");return`${y}${l.slice(s+o)}`},toNamespacedPath(h){return h},dirname(h){if(p(h,"path"),h.length===0)return".";const l=h.charCodeAt(0)===g;let c=-1,a=!0;for(let f=h.length-1;f>=1;--f)if(h.charCodeAt(f)===g){if(!a){c=f;break}}else a=!1;return c===-1?l?"/":".":l&&c===1?"//":h.slice(0,c)},basename(h,l){l!==void 0&&p(l,"ext"),p(h,"path");let c=0,a=-1,f=!0,s;if(l!==void 0&&l.length>0&&l.length<=h.length){if(l===h)return"";let i=l.length-1,r=-1;for(s=h.length-1;s>=0;--s){const o=h.charCodeAt(s);if(o===g){if(!f){c=s+1;break}}else r===-1&&(f=!1,r=s+1),i>=0&&(o===l.charCodeAt(i)?--i==-1&&(a=s):(i=-1,a=r))}return c===a?a=r:a===-1&&(a=h.length),h.slice(c,a)}for(s=h.length-1;s>=0;--s)if(h.charCodeAt(s)===g){if(!f){c=s+1;break}}else a===-1&&(f=!1,a=s+1);return a===-1?"":h.slice(c,a)},extname(h){p(h,"path");let l=-1,c=0,a=-1,f=!0,s=0;for(let i=h.length-1;i>=0;--i){const r=h.charCodeAt(i);if(r===g){if(!f){c=i+1;break}continue}a===-1&&(f=!1,a=i+1),r===b?l===-1?l=i:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||a===-1||s===0||s===1&&l===a-1&&l===c+1?"":h.slice(l,a)},format:M.bind(null,"/"),parse(h){p(h,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return l;const c=h.charCodeAt(0)===g;let a;c?(l.root="/",a=1):a=0;let f=-1,s=0,i=-1,r=!0,o=h.length-1,u=0;for(;o>=a;--o){const y=h.charCodeAt(o);if(y===g){if(!r){s=o+1;break}continue}i===-1&&(r=!1,i=o+1),y===b?f===-1?f=o:u!==1&&(u=1):f!==-1&&(u=-1)}if(i!==-1){const y=s===0&&c?1:s;f===-1||u===0||u===1&&f===i-1&&f===s+1?l.base=l.name=h.slice(y,i):(l.name=h.slice(y,f),l.base=h.slice(y,i),l.ext=h.slice(f,i))}return s>0?l.dir=h.slice(0,s-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[84],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var w;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(w=e.Source||(e.Source={}));var n;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(D,...k){const b=k.reduce((C,E)=>(C[E]=!0,C),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(C=>!b[C]).forEach(C=>{for(let E=0;E<g.length;E++)if(C.search(g[E])!==-1){delete D[C];break}})}e.sanitizeProcessEnvironment=L}),define(Z[85],x([0,1,2]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=w.globals.performance&&typeof w.globals.performance.now=="function";class L{constructor(k){this._highResolution=n&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new L(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=L}),define(Z[4],x([0,1,15,43,3,112,85]),function(V,e,w,n,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let b=!1,g=!1;var S;(function(s){s.None=()=>L.Disposable.None;function i(z){if(g){const{onListenerDidAdd:F}=z,N=t.create();let T=0;z.onListenerDidAdd=()=>{++T==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),N.print()),F?.()}}}function r(z){return(F,N=null,T)=>{let A=!1,O;return O=z(_=>{if(!A)return O?O.dispose():A=!0,F.call(N,_)},null,T),A&&O.dispose(),O}}s.once=r;function o(z,F,N){return U((T,A=null,O)=>z(_=>T.call(A,F(_)),null,O),N)}s.map=o;function u(z,F,N){return U((T,A=null,O)=>z(_=>{F(_),T.call(A,_)},null,O),N)}s.forEach=u;function y(z,F,N){return U((T,A=null,O)=>z(_=>F(_)&&T.call(A,_),null,O),N)}s.filter=y;function P(z){return z}s.signal=P;function R(...z){return(F,N=null,T)=>(0,L.combinedDisposable)(...z.map(A=>A(O=>F.call(N,O),null,T)))}s.any=R;function W(z,F,N,T){let A=N;return o(z,O=>(A=F(A,O),A),T)}s.reduce=W;function U(z,F){let N;const T={onFirstListenerAdd(){N=z(A.fire,A)},onLastListenerRemove(){N.dispose()}};F||i(T);const A=new m(T);return F&&F.add(A),A.event}function G(z,F,N=100,T=!1,A,O){let _,j,ie,ae=0;const ce={leakWarningThreshold:A,onFirstListenerAdd(){_=z(le=>{ae++,j=F(j,le),T&&!ie&&(ne.fire(j),j=void 0),clearTimeout(ie),ie=setTimeout(()=>{const he=j;j=void 0,ie=void 0,(!T||ae>1)&&ne.fire(he),ae=0},N)})},onLastListenerRemove(){_.dispose()}};O||i(ce);const ne=new m(ce);return O&&O.add(ne),ne.event}s.debounce=G;function ee(z,F=(T,A)=>T===A,N){let T=!0,A;return y(z,O=>{const _=T||!F(O,A);return T=!1,A=O,_},N)}s.latch=ee;function X(z,F,N){return[s.filter(z,F,N),s.filter(z,T=>!F(T),N)]}s.split=X;function J(z,F=!1,N=[]){let T=N.slice(),A=z(j=>{T?T.push(j):_.fire(j)});const O=()=>{T&&T.forEach(j=>_.fire(j)),T=null},_=new m({onFirstListenerAdd(){A||(A=z(j=>_.fire(j)))},onFirstListenerDidAdd(){T&&(F?setTimeout(O):O())},onLastListenerRemove(){A&&A.dispose(),A=null}});return _.event}s.buffer=J;class H{constructor(F){this.event=F}map(F){return new H(o(this.event,F))}forEach(F){return new H(u(this.event,F))}filter(F){return new H(y(this.event,F))}reduce(F,N){return new H(W(this.event,F,N))}latch(){return new H(ee(this.event))}debounce(F,N=100,T=!1,A){return new H(G(this.event,F,N,T,A))}on(F,N,T){return this.event(F,N,T)}once(F,N,T){return r(this.event)(F,N,T)}}function B(z){return new H(z)}s.chain=B;function Y(z,F,N=T=>T){const T=(...j)=>_.fire(N(...j)),A=()=>z.on(F,T),O=()=>z.removeListener(F,T),_=new m({onFirstListenerAdd:A,onLastListenerRemove:O});return _.event}s.fromNodeEventEmitter=Y;function se(z,F,N=T=>T){const T=(...j)=>_.fire(N(...j)),A=()=>z.addEventListener(F,T),O=()=>z.removeEventListener(F,T),_=new m({onFirstListenerAdd:A,onLastListenerRemove:O});return _.event}s.fromDOMEventEmitter=se;function $(z){return new Promise(F=>r(z)(F))}s.toPromise=$;function q(z,F){return F(void 0),z(N=>F(N))}s.runAndSubscribe=q;function Q(z,F){let N=null;function T(O){N?.dispose(),N=new L.DisposableStore,F(O,N)}T(void 0);const A=z(O=>T(O));return(0,L.toDisposable)(()=>{A.dispose(),N?.dispose()})}s.runAndSubscribeWithStore=Q})(S=e.Event||(e.Event={}));class C{constructor(i){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${i}_${C._idPool++}`}start(i){this._stopWatch=new k.StopWatch(!0),this._listenerCount=i}stop(){if(this._stopWatch){const i=this._stopWatch.elapsed();this._elapsedOverall+=i,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${i.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let E=-1;function I(s){const i=E;return E=s,{dispose(){E=i}}}e.setGlobalLeakWarningThreshold=I;class p{constructor(i,r=Math.random().toString(18).slice(2,5)){this.customThreshold=i,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(i,r){let o=E;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||r<o)return;this._stacks||(this._stacks=new Map);const u=this._stacks.get(i.value)||0;if(this._stacks.set(i.value,u+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let y,P=0;for(const[R,W]of this._stacks)(!y||P<W)&&(y=R,P=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${P}):`),console.warn(y)}return()=>{const y=this._stacks.get(i.value)||0;this._stacks.set(i.value,y-1)}}}class t{constructor(i){this.value=i}static create(){return new t(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(i,r,o){this.callback=i,this.callbackThis=r,this.stack=o,this.subscription=new L.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class m{constructor(i){this._disposed=!1,this._options=i,this._leakageMon=E>0?new p(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const i=Array.from(this._listeners);queueMicrotask(()=>{for(const r of i)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(i,r,o)=>{this._listeners||(this._listeners=new D.LinkedList);const u=this._listeners.isEmpty();u&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let y,P;this._leakageMon&&this._listeners.size>=30&&(P=t.create(),y=this._leakageMon.check(P,this._listeners.size+1)),b&&(P=P??t.create());const R=new d(i,r,P),W=this._listeners.push(R);u&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,i,r);const U=R.subscription.set(()=>{y&&y(),this._disposed||(W(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return o instanceof L.DisposableStore?o.add(U):Array.isArray(o)&&o.push(U),U}),this._event}fire(i){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,i]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,o]=this._deliveryQueue.shift();try{r.invoke(o)}catch(u){(0,w.onUnexpectedError)(u)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=m;class v extends m{async fireAsync(i,r,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const u of this._listeners)this._asyncDeliveryQueue.push([u,i]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[u,y]=this._asyncDeliveryQueue.shift(),P=[],R={...y,token:r,waitUntil:W=>{if(Object.isFrozen(P))throw new Error("waitUntil can NOT be called asynchronous");o&&(W=o(W,u.callback)),P.push(W)}};try{u.invoke(R)}catch(W){(0,w.onUnexpectedError)(W);continue}Object.freeze(P),await Promise.allSettled(P).then(W=>{for(const U of W)U.status==="rejected"&&(0,w.onUnexpectedError)(U.reason)})}}}}e.AsyncEmitter=v;class M extends m{constructor(i){super(i);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=i?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const i=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(i))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(i){this._listeners&&(this._isPaused!==0?this._eventQueue.push(i):super.fire(i))}}e.PauseableEmitter=M;class h extends M{constructor(i){super(i);this._delay=i.delay??100}fire(i){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(i)}}e.DebounceEmitter=h;class l extends m{constructor(i){super(i);this._queuedEvents=[],this._mergeFn=i?.merge}fire(i){this._queuedEvents.push(i),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=l;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(i){const r={event:i,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const o=()=>{this.hasListeners&&this.unhook(r);const u=this.events.indexOf(r);this.events.splice(u,1)};return(0,L.toDisposable)((0,n.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(i=>this.hook(i))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(i=>this.unhook(i))}hook(i){i.listener=i.event(r=>this.emitter.fire(r))}unhook(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class a{constructor(){this.buffers=[]}wrapEvent(i){return(r,o,u)=>i(y=>{const P=this.buffers[this.buffers.length-1];P?P.push(()=>r.call(o,y)):r.call(o,y)},void 0,u)}bufferEvents(i){const r=[];this.buffers.push(r);const o=i();return this.buffers.pop(),r.forEach(u=>u()),o}}e.EventBufferer=a;class f{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=L.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(i){this.inputEvent=i,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=i(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=f}),define(Z[23],x([0,1,4]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(b,g){const S=setTimeout(b.bind(g),0);return{dispose(){clearTimeout(S)}}});var L;(function(b){function g(S){return S===b.None||S===b.Cancelled||S instanceof D?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}b.isCancellationToken=g,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(L=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=L.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=k}),define(Z[113],x([0,1,23]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new w.CancellationTokenSource,b=this.task(k.token);return this.result={promise:b,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=n;class L{constructor(k){this.computeFn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const b=JSON.stringify(k);return this.lastArgKey!==b&&(this.lastArgKey=b,this.lastCache=this.computeFn(k)),this.lastCache}}e.LRUCachedComputed=L}),define(Z[48],x([0,1,15,3]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(h){const l=h;return l?[l.on,l.pause,l.resume,l.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=L;function D(h){const l=h;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=D;function k(h,l){return new b(h,l)}e.newWriteableStream=k;class b{constructor(l,c){this.reducer=l,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(c=>c(l))}emitError(l){this.listeners.error.length===0?(0,w.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(c=>c(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,c){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(l,c){if(this.state.destroyed)return;let a;switch(l){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const f=a.indexOf(c);f>=0&&a.splice(f,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function g(h,l){const c=[];let a;for(;(a=h.read())!==null;)c.push(a);return l(c)}e.consumeReadable=g;function S(h,l,c){const a=[];let f;for(;(f=h.read())!==null&&a.length<c;)a.push(f);return f===null&&a.length>0?l(a):{read:()=>{if(a.length>0)return a.shift();if(typeof f!="undefined"){const s=f;return f=void 0,s}return h.read()}}}e.peekReadable=S;function C(h,l){return new Promise((c,a)=>{const f=[];E(h,{onData:s=>{l&&f.push(s)},onError:s=>{l?a(s):c(void 0)},onEnd:()=>{c(l?l(f):void 0)}})})}e.consumeStream=C;function E(h,l){let c=!1;return h.on("error",a=>{c||l.onError(a)}),h.on("end",()=>{c||l.onEnd()}),h.on("data",a=>{c||l.onData(a)}),(0,n.toDisposable)(()=>c=!0)}e.listenStream=E;function I(h,l){return new Promise((c,a)=>{const f=new n.DisposableStore,s=[],i=u=>{if(s.push(u),s.length>l)return f.dispose(),h.pause(),c({stream:h,buffer:s,ended:!1})},r=u=>a(u),o=()=>c({stream:h,buffer:s,ended:!0});f.add((0,n.toDisposable)(()=>h.removeListener("error",r))),h.on("error",r),f.add((0,n.toDisposable)(()=>h.removeListener("end",o))),h.on("end",o),f.add((0,n.toDisposable)(()=>h.removeListener("data",i))),h.on("data",i)})}e.peekStream=I;function p(h,l){const c=k(l);return c.end(h),c}e.toStream=p;function t(){const h=k(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=t;function d(h){let l=!1;return{read:()=>l?null:(l=!0,h)}}e.toReadable=d;function m(h,l,c){const a=k(c);return E(h,{onData:f=>a.write(l.data(f)),onError:f=>a.error(l.error?l.error(f):f),onEnd:()=>a.end()}),a}e.transform=m;function v(h,l,c){let a=!1;return{read:()=>{const f=l.read();return a?f:(a=!0,f!==null?c([h,f]):h)}}}e.prefixedReadable=v;function M(h,l,c){let a=!1;const f=k(c);return E(l,{onData:s=>a?f.write(s):(a=!0,f.write(c([h,s]))),onError:s=>f.error(s),onEnd:()=>{a||(a=!0,f.write(h)),f.end()}}),f}e.prefixedStream=M}),define(Z[16],x([0,1,48]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let L,D;class k{constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}static alloc(y){return n?new k(Buffer.allocUnsafe(y)):new k(new Uint8Array(y))}static wrap(y){return n&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new k(y)}static fromString(y,P){return!(P?.dontUseNodeBuffer||!1)&&n?new k(Buffer.from(y)):(L||(L=new TextEncoder),new k(L.encode(y)))}static fromByteArray(y){const P=k.alloc(y.length);for(let R=0,W=y.length;R<W;R++)P.buffer[R]=y[R];return P}static concat(y,P){if(typeof P=="undefined"){P=0;for(let U=0,G=y.length;U<G;U++)P+=y[U].byteLength}const R=k.alloc(P);let W=0;for(let U=0,G=y.length;U<G;U++){const ee=y[U];R.set(ee,W),W+=ee.byteLength}return R}clone(){const y=k.alloc(this.byteLength);return y.set(this),y}toString(){return n?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(y,P){return new k(this.buffer.subarray(y,P))}set(y,P){if(y instanceof k)this.buffer.set(y.buffer,P);else if(y instanceof Uint8Array)this.buffer.set(y,P);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),P);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return S(this.buffer,y)}writeUInt32BE(y,P){C(this.buffer,y,P)}readUInt32LE(y){return E(this.buffer,y)}writeUInt32LE(y,P){I(this.buffer,y,P)}readUInt8(y){return p(this.buffer,y)}writeUInt8(y,P){t(this.buffer,y,P)}}e.VSBuffer=k;function b(u,y){return u[y+0]<<0>>>0|u[y+1]<<8>>>0}e.readUInt16LE=b;function g(u,y,P){u[P+0]=y&255,y=y>>>8,u[P+1]=y&255}e.writeUInt16LE=g;function S(u,y){return u[y]*2**24+u[y+1]*2**16+u[y+2]*2**8+u[y+3]}e.readUInt32BE=S;function C(u,y,P){u[P+3]=y,y=y>>>8,u[P+2]=y,y=y>>>8,u[P+1]=y,y=y>>>8,u[P]=y}e.writeUInt32BE=C;function E(u,y){return u[y+0]<<0>>>0|u[y+1]<<8>>>0|u[y+2]<<16>>>0|u[y+3]<<24>>>0}e.readUInt32LE=E;function I(u,y,P){u[P+0]=y&255,y=y>>>8,u[P+1]=y&255,y=y>>>8,u[P+2]=y&255,y=y>>>8,u[P+3]=y&255}e.writeUInt32LE=I;function p(u,y){return u[y]}e.readUInt8=p;function t(u,y,P){u[P]=y}e.writeUInt8=t;function d(u){return w.consumeReadable(u,y=>k.concat(y))}e.readableToBuffer=d;function m(u){return w.toReadable(u)}e.bufferToReadable=m;function v(u){return w.consumeStream(u,y=>k.concat(y))}e.streamToBuffer=v;async function M(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await v(u.stream)])}e.bufferedStreamToBuffer=M;function h(u){return w.toStream(u,y=>k.concat(y))}e.bufferToStream=h;function l(u){return w.transform(u,{data:y=>typeof y=="string"?k.fromString(y):k.wrap(y)},y=>k.concat(y))}e.streamToBufferReadableStream=l;function c(u){return w.newWriteableStream(y=>k.concat(y),u)}e.newWriteableBufferStream=c;function a(u,y){return w.prefixedReadable(u,y,P=>k.concat(P))}e.prefixedBufferReadable=a;function f(u,y){return w.prefixedStream(u,y,P=>k.concat(P))}e.prefixedBufferStream=f;function s(u){let y=0,P=0,R=0;const W=new Uint8Array(Math.floor(u.length/4*3)),U=ee=>{switch(P){case 3:W[R++]=y|ee,P=0;break;case 2:W[R++]=y|ee>>>2,y=ee<<6,P=3;break;case 1:W[R++]=y|ee>>>4,y=ee<<4,P=2;break;default:y=ee<<2,P=1}};for(let ee=0;ee<u.length;ee++){const X=u.charCodeAt(ee);if(X>=65&&X<=90)U(X-65);else if(X>=97&&X<=122)U(X-97+26);else if(X>=48&&X<=57)U(X-48+52);else if(X===43||X===45)U(62);else if(X===47||X===95)U(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${u[ee]}`)}}const G=R;for(;P>0;)U(0);return k.wrap(W).slice(0,G)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:u},y=!0,P=!1){const R=P?r:i;let W="";const U=u.byteLength%3;let G=0;for(;G<u.byteLength-U;G+=3){const ee=u[G+0],X=u[G+1],J=u[G+2];W+=R[ee>>>2],W+=R[(ee<<4|X>>>4)&63],W+=R[(X<<2|J>>>6)&63],W+=R[J&63]}if(U===1){const ee=u[G+0];W+=R[ee>>>2],W+=R[ee<<4&63],y&&(W+="==")}else if(U===2){const ee=u[G+0],X=u[G+1];W+=R[ee>>>2],W+=R[(ee<<4|X>>>4)&63],W+=R[X<<2&63],y&&(W+="=")}return W}e.encodeBase64=o}),define(Z[27],x([0,1,113,111]),function(V,e,w,n){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=D;const k=/{(\d+)}/g;function b(K,...re){return re.length===0?K:K.replace(k,function(oe,fe){const ye=parseInt(fe,10);return isNaN(ye)||ye<0||ye>=re.length?oe:re[ye]})}e.format=b;const g=/{([^}]+)}/g;function S(K,re){return K.replace(g,(oe,fe)=>re[fe]??oe)}e.format2=S;function C(K){return K.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=C;function E(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function I(K,re){let oe=0;const fe=re.charCodeAt(0);for(let ye=K.length-1;ye>=0;ye--)K.charCodeAt(ye)===fe&&oe++;return oe}e.count=I;function p(K,re,oe="\u2026"){return K.length<=re?K:`${K.substr(0,re)}${oe}`}e.truncate=p;function t(K,re=" "){const oe=d(K,re);return m(oe,re)}e.trim=t;function d(K,re){if(!K||!re)return K;const oe=re.length;if(oe===0||K.length===0)return K;let fe=0;for(;K.indexOf(re,fe)===fe;)fe=fe+oe;return K.substring(fe)}e.ltrim=d;function m(K,re){if(!K||!re)return K;const oe=re.length,fe=K.length;if(oe===0||fe===0)return K;let ye=fe,Re=-1;for(;Re=K.lastIndexOf(re,ye-1),!(Re===-1||Re+oe!==ye);){if(Re===0)return"";ye=Re}return K.substring(0,ye)}e.rtrim=m;function v(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function M(K){return K.replace(/\*/g,"")}e.stripWildcards=M;function h(K,re,oe={}){if(!K)throw new Error("Cannot create regex from empty string");re||(K=E(K)),oe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let fe="";return oe.global&&(fe+="g"),oe.matchCase||(fe+="i"),oe.multiline&&(fe+="m"),oe.unicode&&(fe+="u"),new RegExp(K,fe)}e.createRegExp=h;function l(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function c(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function a(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=a;function f(K){return K.split(/\r\n|\r|\n/)}e.splitLines=f;function s(K){for(let re=0,oe=K.length;re<oe;re++){const fe=K.charCodeAt(re);if(fe!==32&&fe!==9)return re}return-1}e.firstNonWhitespaceIndex=s;function i(K,re=0,oe=K.length){for(let fe=re;fe<oe;fe++){const ye=K.charCodeAt(fe);if(ye!==32&&ye!==9)return K.substring(re,fe)}return K.substring(re,oe)}e.getLeadingWhitespace=i;function r(K,re=K.length-1){for(let oe=re;oe>=0;oe--){const fe=K.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.lastNonWhitespaceIndex=r;function o(K,re){return K<re?-1:K>re?1:0}e.compare=o;function u(K,re,oe=0,fe=K.length,ye=0,Re=re.length){for(;oe<fe&&ye<Re;oe++,ye++){let Ve=K.charCodeAt(oe),Ae=re.charCodeAt(ye);if(Ve<Ae)return-1;if(Ve>Ae)return 1}const Oe=fe-oe,Ke=Re-ye;return Oe<Ke?-1:Oe>Ke?1:0}e.compareSubstring=u;function y(K,re){return P(K,re,0,K.length,0,re.length)}e.compareIgnoreCase=y;function P(K,re,oe=0,fe=K.length,ye=0,Re=re.length){for(;oe<fe&&ye<Re;oe++,ye++){let Ve=K.charCodeAt(oe),Ae=re.charCodeAt(ye);if(Ve===Ae)continue;if(Ve>=128||Ae>=128)return u(K.toLowerCase(),re.toLowerCase(),oe,fe,ye,Re);R(Ve)&&(Ve-=32),R(Ae)&&(Ae-=32);const qe=Ve-Ae;if(qe!==0)return qe}const Oe=fe-oe,Ke=Re-ye;return Oe<Ke?-1:Oe>Ke?1:0}e.compareSubstringIgnoreCase=P;function R(K){return K>=97&&K<=122}e.isLowerAsciiLetter=R;function W(K){return K>=65&&K<=90}e.isUpperAsciiLetter=W;function U(K,re){return K.length===re.length&&P(K,re)===0}e.equalsIgnoreCase=U;function G(K,re){const oe=re.length;return re.length>K.length?!1:P(K,re,0,oe)===0}e.startsWithIgnoreCase=G;function ee(K,re){let oe,fe=Math.min(K.length,re.length);for(oe=0;oe<fe;oe++)if(K.charCodeAt(oe)!==re.charCodeAt(oe))return oe;return fe}e.commonPrefixLength=ee;function X(K,re){let oe,fe=Math.min(K.length,re.length);const ye=K.length-1,Re=re.length-1;for(oe=0;oe<fe;oe++)if(K.charCodeAt(ye-oe)!==re.charCodeAt(Re-oe))return oe;return fe}e.commonSuffixLength=X;function J(K){return 55296<=K&&K<=56319}e.isHighSurrogate=J;function H(K){return 56320<=K&&K<=57343}e.isLowSurrogate=H;function B(K,re){return(K-55296<<10)+(re-56320)+65536}e.computeCodePoint=B;function Y(K,re,oe){const fe=K.charCodeAt(oe);if(J(fe)&&oe+1<re){const ye=K.charCodeAt(oe+1);if(H(ye))return B(fe,ye)}return fe}e.getNextCodePoint=Y;function se(K,re){const oe=K.charCodeAt(re-1);if(H(oe)&&re>1){const fe=K.charCodeAt(re-2);if(J(fe))return B(fe,oe)}return oe}class ${constructor(re,oe=0){this._str=re,this._len=re.length,this._offset=oe}get offset(){return this._offset}setOffset(re){this._offset=re}prevCodePoint(){const re=se(this._str,this._offset);return this._offset-=re>=65536?2:1,re}nextCodePoint(){const re=Y(this._str,this._len,this._offset);return this._offset+=re>=65536?2:1,re}eol(){return this._offset>=this._len}}e.CodePointIterator=$;class q{constructor(re,oe=0){this._iterator=new $(re,oe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const re=ze.getInstance(),oe=this._iterator,fe=oe.offset;let ye=re.getGraphemeBreakType(oe.nextCodePoint());for(;!oe.eol();){const Re=oe.offset,Oe=re.getGraphemeBreakType(oe.nextCodePoint());if(Ze(ye,Oe)){oe.setOffset(Re);break}ye=Oe}return oe.offset-fe}prevGraphemeLength(){const re=ze.getInstance(),oe=this._iterator,fe=oe.offset;let ye=re.getGraphemeBreakType(oe.prevCodePoint());for(;oe.offset>0;){const Re=oe.offset,Oe=re.getGraphemeBreakType(oe.prevCodePoint());if(Ze(Oe,ye)){oe.setOffset(Re);break}ye=Oe}return fe-oe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function Q(K,re){return new q(K,re).nextGraphemeLength()}e.nextCharLength=Q;function z(K,re){return new q(K,re).prevGraphemeLength()}e.prevCharLength=z;function F(K,re){re>0&&H(K.charCodeAt(re))&&re--;const oe=re+Q(K,re);return[oe-z(K,oe),oe]}e.getCharContainingOffset=F;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function T(K){return N.test(K)}e.containsRTL=T;const A=/^[\t\n\r\x20-\x7E]*$/;function O(K){return A.test(K)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=_;function j(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=j;function ie(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=ie;function ae(K,re){if(K.length<re)return K;const oe=/\b/g;let fe=0;for(;oe.test(K)&&!(K.length-oe.lastIndex<re);)fe=oe.lastIndex,oe.lastIndex+=1;return K.substring(fe).replace(/^\s/,"")}e.lcut=ae;const ce=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function he(K){return K&&(K=K.replace(ce,""),K=K.replace(ne,""),K=K.replace(le,"")),K}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function be(K){return we(K)?K.substr(1):K}e.stripUTF8BOM=be;function Ce(K,re){if(!K||!re||K.length<re.length)return!1;const oe=re.length,fe=K.toLowerCase();let ye=0,Re=-1;for(;ye<oe;){const Oe=fe.indexOf(re[ye],Re+1);if(Oe<0)return!1;Re=Oe,ye++}return!0}e.fuzzyContains=Ce;function Se(K,re=!1){return K?(re&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Se;function pe(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=pe;function Ee(K,re=1){if(re===0)return"";let oe=-1;do oe=K.indexOf(`
`,oe+1),re--;while(re>0&&oe>=0);return oe===-1?K:(K[oe-1]==="\r"&&oe--,K.substr(0,oe))}e.getNLines=Ee;function Le(K){const re=90-65+1;return K=K%(2*re),K<re?String.fromCharCode(97+K):String.fromCharCode(65+K-re)}e.singleLetterHash=Le;function Ne(K){return ze.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Ne;function Ze(K,re){return K===0?re!==5&&re!==7:K===2&&re===3?!1:K===4||K===2||K===3||re===4||re===2||re===3?!0:!(K===8&&(re===8||re===9||re===11||re===12)||(K===11||K===9)&&(re===9||re===10)||(K===12||K===10)&&re===10||re===5||re===13||re===7||K===1||K===13&&re===14||K===6&&re===6)}var Fe;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Ge()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const oe=this._data,fe=oe.length/3;let ye=1;for(;ye<=fe;)if(re<oe[3*ye])ye=2*ye;else if(re>oe[3*ye+1])ye=2*ye+1;else return oe[3*ye+2];return 0}}ze._INSTANCE=null;function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function st(K,re){if(K===0)return 0;const oe=wt(K,re);if(oe!==void 0)return oe;const fe=new $(re,K);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=st;function wt(K,re){const oe=new $(re,K);let fe=oe.prevCodePoint();for(;ot(fe)||fe===65039||fe===8419;){if(oe.offset===0)return;fe=oe.prevCodePoint()}if(!ie(fe))return;let ye=oe.offset;return ye>0&&oe.prevCodePoint()===8205&&(ye=oe.offset),ye}function ot(K){return 127995<=K&&K<=127999}var Ye;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.noBreakWhitespace="\xA0";class He{constructor(re){this.confusableDictionary=re}static getInstance(re){return He.cache.get(Array.from(re))}static getLocales(){return He._locales.getValue()}isAmbiguous(re){return this.confusableDictionary.has(re)}getPrimaryConfusable(re){return this.confusableDictionary.get(re)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=He,L=He,He.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),He.cache=new w.LRUCachedComputed(K=>{function re(Ae){const qe=new Map;for(let je=0;je<Ae.length;je+=2)qe.set(Ae[je],Ae[je+1]);return qe}function oe(Ae,qe){const je=new Map(Ae);for(const[xe,tt]of qe)je.set(xe,tt);return je}function fe(Ae,qe){if(!Ae)return qe;const je=new Map;for(const[xe,tt]of Ae)qe.has(xe)&&je.set(xe,tt);return je}const ye=L.ambiguousCharacterData.getValue();let Re=K.filter(Ae=>!Ae.startsWith("_")&&Ae in ye);Re.length===0&&(Re=["_default"]);let Oe;for(const Ae of Re){const qe=re(ye[Ae]);Oe=fe(Oe,qe)}const Ke=re(ye._common),Ve=oe(Ke,Oe);return new He(Ve)}),He._locales=new n.Lazy(()=>Object.keys(He.ambiguousCharacterData.getValue()).filter(K=>!K.startsWith("_")));class Qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Qe.getRawData())),this._data}static isInvisibleCharacter(re){return Qe.getData().has(re)}static get codePoints(){return Qe.getData()}}e.InvisibleCharacters=Qe,Qe._data=void 0}),define(Z[69],x([0,1,27]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(v){return L(v,0)}e.hash=n;function L(v,M){switch(typeof v){case"object":return v===null?D(349,M):Array.isArray(v)?g(v,M):S(v,M);case"string":return b(v,M);case"boolean":return k(v,M);case"number":return D(v,M);case"undefined":return D(937,M);default:return D(617,M)}}e.doHash=L;function D(v,M){return(M<<5)-M+v|0}e.numberHash=D;function k(v,M){return D(v?433:863,M)}function b(v,M){M=D(149417,M);for(let h=0,l=v.length;h<l;h++)M=D(v.charCodeAt(h),M);return M}e.stringHash=b;function g(v,M){return M=D(104579,M),v.reduce((h,l)=>L(l,h),M)}function S(v,M){return M=D(181387,M),Object.keys(v).sort().reduce((h,l)=>(h=b(l,h),L(v[l],h)),M)}class C{constructor(){this._value=0}get value(){return this._value}hash(M){return this._value=L(M,this._value),this._value}}e.Hasher=C;var E;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function I(v,M,h=32){const l=h-M,c=~((1<<l)-1);return(v<<M|(c&v)>>>l)>>>0}function p(v,M=0,h=v.byteLength,l=0){for(let c=0;c<h;c++)v[M+c]=l}function t(v,M,h="0"){for(;v.length<M;)v=h+v;return v}function d(v,M=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(h=>h.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),M/4)}e.toHexString=d;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(M){const h=M.length;if(h===0)return;const l=this._buff;let c=this._buffLen,a=this._leftoverHighSurrogate,f,s;for(a!==0?(f=a,s=-1,a=0):(f=M.charCodeAt(0),s=0);;){let i=f;if(w.isHighSurrogate(f))if(s+1<h){const r=M.charCodeAt(s+1);w.isLowSurrogate(r)?(s++,i=w.computeCodePoint(f,r)):i=65533}else{a=f;break}else w.isLowSurrogate(f)&&(i=65533);if(c=this._push(l,c,i),s++,s<h)f=M.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=a}_push(M,h,l){return l<128?M[h++]=l:l<2048?(M[h++]=192|(l&1984)>>>6,M[h++]=128|(l&63)>>>0):l<65536?(M[h++]=224|(l&61440)>>>12,M[h++]=128|(l&4032)>>>6,M[h++]=128|(l&63)>>>0):(M[h++]=240|(l&1835008)>>>18,M[h++]=128|(l&258048)>>>12,M[h++]=128|(l&4032)>>>6,M[h++]=128|(l&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,M[0]=M[64+0],M[1]=M[64+1],M[2]=M[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const M=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(M/4294967296),!1),this._buffDV.setUint32(60,M%4294967296,!1),this._step()}_step(){const M=m._bigBlock32,h=this._buffDV;for(let u=0;u<64;u+=4)M.setUint32(u,h.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)M.setUint32(u,I(M.getUint32(u-12,!1)^M.getUint32(u-32,!1)^M.getUint32(u-56,!1)^M.getUint32(u-64,!1),1),!1);let l=this._h0,c=this._h1,a=this._h2,f=this._h3,s=this._h4,i,r,o;for(let u=0;u<80;u++)u<20?(i=c&a|~c&f,r=1518500249):u<40?(i=c^a^f,r=1859775393):u<60?(i=c&a|c&f|a&f,r=2400959708):(i=c^a^f,r=3395469782),o=I(l,5)+i+s+r+M.getUint32(u*4,!1)&4294967295,s=f,f=a,a=I(c,30),c=l,l=o;this._h0=this._h0+l&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+f&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))});var Dt=this&&this.__classPrivateFieldSet||function(V,e,w,n,L){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!L:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?L.call(V,w):L?L.value=w:e.set(V,w),w},Je=this&&this.__classPrivateFieldGet||function(V,e,w,n){if(w==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!n:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?n:w==="a"?n.call(V):n?n.value:e.get(V)};define(Z[35],x([0,1,30,27]),function(V,e,w,n){"use strict";var L,D,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(s,i,r){let o=s.get(i);return o===void 0&&(o=r,s.set(i,o)),o}e.getOrSet=b;function g(s){const i=[];return s.forEach((r,o)=>{i.push(`${o} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=g;function S(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=S;class C{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return r-o}value(){return this._value[this._pos]}}e.StringIterator=C;class E{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class I{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const o=this._value.charCodeAt(r);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=I;var p;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(p||(p={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new I(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(m||(m={}));class v{constructor(i){this._iter=i}static forUris(i=()=>!1){return new v(new t(i))}static forPaths(i=!1){return new v(new I(void 0,!i))}static forStrings(){return new v(new C)}static forConfigKeys(){return new v(new E)}clear(){this._root=void 0}fill(i,r){if(r){const o=r.slice(0);(0,w.shuffle)(o);for(let u of o)this.set(u,i)}else{const o=i.slice(0);(0,w.shuffle)(o);for(let u of o)this.set(u[0],u[1])}}set(i,r){const o=this._iter.reset(i);let u;this._root||(this._root=new d,this._root.segment=o.value());const y=[];for(u=this._root;;){const R=o.cmp(u.segment);if(R>0)u.left||(u.left=new d,u.left.segment=o.value()),y.push([-1,u]),u=u.left;else if(R<0)u.right||(u.right=new d,u.right.segment=o.value()),y.push([1,u]),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new d,u.mid.segment=o.value()),y.push([0,u]),u=u.mid;else break}const P=u.value;u.value=r,u.key=i;for(let R=y.length-1;R>=0;R--){const W=y[R][1];W.updateHeight();const U=W.balanceFactor();if(U<-1||U>1){const G=y[R][0],ee=y[R+1][0];if(G===1&&ee===1)y[R][1]=W.rotateLeft();else if(G===-1&&ee===-1)y[R][1]=W.rotateRight();else if(G===1&&ee===-1)W.right=y[R+1][1]=y[R+1][1].rotateRight(),y[R][1]=W.rotateLeft();else if(G===-1&&ee===1)W.left=y[R+1][1]=y[R+1][1].rotateLeft(),y[R][1]=W.rotateRight();else throw new Error;if(R>0)switch(y[R-1][0]){case-1:y[R-1][1].left=y[R][1];break;case 1:y[R-1][1].right=y[R][1];break;case 0:y[R-1][1].mid=y[R][1];break}else this._root=y[0][1]}}return P}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let o=this._root;for(;o;){const u=r.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const o=this._iter.reset(i),u=[];let y=this._root;for(;y;){const P=o.cmp(y.segment);if(P>0)u.push([-1,y]),y=y.left;else if(P<0)u.push([1,y]),y=y.right;else if(o.hasNext())o.next(),u.push([0,y]),y=y.mid;else break}if(!!y){if(r?(y.left=void 0,y.mid=void 0,y.right=void 0,y.height=1):(y.key=void 0,y.value=void 0),!y.mid&&!y.value)if(y.left&&y.right){const P=this._min(y.right),{key:R,value:W,segment:U}=P;this._delete(P.key,!1),y.key=R,y.value=W,y.segment=U}else{const P=y.left??y.right;if(u.length>0){const[R,W]=u[u.length-1];switch(R){case-1:W.left=P;break;case 0:W.mid=P;break;case 1:W.right=P;break}}else this._root=P}for(let P=u.length-1;P>=0;P--){const R=u[P][1];R.updateHeight();const W=R.balanceFactor();if(W>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),u[P][1]=R.rotateLeft()):W<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),u[P][1]=R.rotateRight()),P>0)switch(u[P-1][0]){case-1:u[P-1][1].left=u[P][1];break;case 1:u[P-1][1].right=u[P][1];break;case 0:u[P-1][1].mid=u[P][1];break}else this._root=u[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let o=this._root,u;for(;o;){const y=r.cmp(o.segment);if(y>0)o=o.left;else if(y<0)o=o.right;else if(r.hasNext())r.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(i){const r=this._iter.reset(i);let o=this._root;for(;o;){const u=r.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[r,o]of this)i(o,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=v;class M{constructor(i,r){this.uri=i,this.value=r}}class h{constructor(i,r){this[L]="ResourceMap",i instanceof h?(this.map=new Map(i.map),this.toKey=r??h.defaultToKey):(this.map=new Map,this.toKey=i??h.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new M(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[o,u]of this.map)i(u.value,u.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=h,h.defaultToKey=s=>s.toString();var l;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class c{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const o=this._map.get(i);if(!!o)return r!==0&&this.touch(o,r),o.value}set(i,r,o=0){let u=this._map.get(i);if(u)u.value=r,o!==0&&this.touch(u,o);else{switch(u={key:i,value:r,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(i,u),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const o=this._state;let u=this._head;for(;u;){if(r?i.bind(r)(u.value,u.key,this):i(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,r=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const y={value:o.key,done:!1};return o=o.next,y}else return{value:void 0,done:!0}}};return u}values(){const i=this,r=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const y={value:o.value,done:!1};return o=o.next,y}else return{value:void 0,done:!0}}};return u}entries(){const i=this,r=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const y={value:[o.key,o.value],done:!1};return o=o.next,y}else return{value:void 0,done:!0}}};return u}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,o=this.size;for(;r&&o>i;)this._map.delete(r.key),r=r.next,o--;this._head=r,this._size=o,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,o=i.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const o=i.next,u=i.previous;i===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const o=i.next,u=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,o)=>{i.push([o,r])}),i}fromJSON(i){this.clear();for(const[r,o]of i)this.set(r,o)}}e.LinkedMap=c;class a extends c{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class f{constructor(i){k.set(this,void 0),Dt(this,k,i,"f")}get size(){return Je(this,k,"f").size}forEach(i,r){Je(this,k,"f").forEach(i,r)}get(i){return Je(this,k,"f").get(i)}has(i){return Je(this,k,"f").has(i)}entries(){return Je(this,k,"f").entries()}keys(){return Je(this,k,"f").keys()}values(){return Je(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Je(this,k,"f").entries()}}e.ReadonlyMapView=f}),define(Z[70],x([0,1,35]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new w.LRUCache(1e4);function L(S){return g(S,"NFC",n)}e.normalizeNFC=L;const D=new w.LRUCache(1e4);function k(S){return g(S,"NFD",D)}e.normalizeNFD=k;const b=/[^\u0000-\u0080]/;function g(S,C,E){if(!S)return S;const I=E.get(S);if(I)return I;let p;return b.test(S)?p=S.normalize(C):p=S,E.set(S,p),p}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(C){return k(C).replace(S,"")}}()}),define(Z[14],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(o){return Array.isArray(o)}e.isArray=w;function n(o){return typeof o=="string"}e.isString=n;function L(o){return Array.isArray(o)&&o.every(u=>n(u))}e.isStringArray=L;function D(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=D;function k(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=k;function b(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=b;function g(o){return o===!0||o===!1}e.isBoolean=g;function S(o){return typeof o=="undefined"}e.isUndefined=S;function C(o){return!E(o)}e.isDefined=C;function E(o){return S(o)||o===null}e.isUndefinedOrNull=E;function I(o,u){if(!o)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=I;function p(o){if(E(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=p;function t(...o){const u=[];for(let y=0;y<o.length;y++){const P=o[y];if(E(P))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);u.push(P)}return u}e.assertAllDefined=t;const d=Object.prototype.hasOwnProperty;function m(o){if(!D(o))return!1;for(let u in o)if(d.call(o,u))return!1;return!0}e.isEmptyObject=m;function v(o){return typeof o=="function"}e.isFunction=v;function M(...o){return o.length>0&&o.every(v)}e.areFunctions=M;function h(o,u){const y=Math.min(o.length,u.length);for(let P=0;P<y;P++)l(o[P],u[P])}e.validateConstraints=h;function l(o,u){if(n(u)){if(typeof o!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(v(u)){try{if(o instanceof u)return}catch{}if(!E(o)&&o.constructor===u||u.length===1&&u.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function c(o){let u=[],y=Object.getPrototypeOf(o);for(;Object.prototype!==y;)u=u.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return u}e.getAllPropertyNames=c;function a(o){const u=[];for(const y of c(o))typeof o[y]=="function"&&u.push(y);return u}e.getAllMethodNames=a;function f(o,u){const y=R=>function(){const W=Array.prototype.slice.call(arguments,0);return u(R,W)};let P={};for(const R of o)P[R]=y(R);return P}e.createProxyObject=f;function s(o){return o===null?void 0:o}e.withNullAsUndefined=s;function i(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=i;function r(o,u="Unreachable"){throw new Error(u)}e.assertNever=r}),define(Z[28],x([0,1,7,2,27,14]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function b(r){return r.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=b;function g(r){return r.indexOf("/")===-1&&(r=b(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=g;function S(r,o=w.posix.sep){if(!r)return"";const u=r.length,y=r.charCodeAt(0);if(k(y)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let R=3;const W=R;for(;R<u&&!k(r.charCodeAt(R));R++);if(W!==R&&!k(r.charCodeAt(R+1))){for(R+=1;R<u;R++)if(k(r.charCodeAt(R)))return r.slice(0,R+1).replace(/[\\/]/g,o)}}return o}else if(v(y)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let P=r.indexOf("://");if(P!==-1){for(P+=3;P<u;P++)if(k(r.charCodeAt(P)))return r.slice(0,P+1)}return""}e.getRoot=S;function C(r){if(!n.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let u=2;const y=u;for(;u<r.length&&(o=r.charCodeAt(u),o!==92);u++);return!(y===u||(o=r.charCodeAt(u+1),isNaN(o)||o===92))}e.isUNC=C;const E=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(r,o=n.isWindows){const u=o?E:I;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||o&&p.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=t;function d(r,o,u){const y=r===o;return!u||y?y:!r||!o?!1:(0,L.equalsIgnoreCase)(r,o)}e.isEqual=d;function m(r,o,u,y=w.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(u){if(!(0,L.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let R=o.length;return o.charAt(o.length-1)===y&&R--,r.charAt(R)===y}return o.charAt(o.length-1)!==y&&(o+=y),r.indexOf(o)===0}e.isEqualOrParent=m;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function M(r,o){return n.isWindows&&r.endsWith(":")&&(r+=w.sep),(0,w.isAbsolute)(r)||(r=(0,w.join)(o,r)),r=(0,w.normalize)(r),n.isWindows?(r=(0,L.rtrim)(r,w.sep),r.endsWith(":")&&(r+=w.sep)):(r=(0,L.rtrim)(r,w.sep),r||(r=w.sep)),r}e.sanitizeFilePath=M;function h(r){const o=(0,w.normalize)(r);return n.isWindows?r.length>3?!1:l(o)&&(r.length===2||o.charCodeAt(2)===92):o===w.posix.sep}e.isRootOrDriveLetter=h;function l(r,o){return(o!==void 0?o:n.isWindows)?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function c(r){return l(r)?r[0]:void 0}e.getDriveLetter=c;function a(r,o,u){return o.length>r.length?-1:r===o?0:(u&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=a;function f(r){const o=r.split(":");let u,y,P;for(const R of o){const W=Number(R);(0,D.isNumber)(W)?y===void 0?y=W:P===void 0&&(P=W):u=u?[u,R].join(":"):R}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:y!==void 0?y:void 0,column:P!==void 0?P:y!==void 0?1:void 0}}e.parseLineAndColumnAware=f;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,o,u=8){let y="";for(let R=0;R<u;R++)y+=s.charAt(Math.floor(Math.random()*s.length));let P;return o?P=`${o}-${y}`:P=y,r?(0,w.join)(r,P):P}e.randomPath=i}),define(Z[49],x([0,1,14]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const m=Array.isArray(d)?[]:{};return Object.keys(d).forEach(v=>{d[v]&&typeof d[v]=="object"?m[v]=n(d[v]):m[v]=d[v]}),m}e.deepClone=n;function L(d){if(!d||typeof d!="object")return d;const m=[d];for(;m.length>0;){const v=m.shift();Object.freeze(v);for(const M in v)if(D.call(v,M)){const h=v[M];typeof h=="object"&&!Object.isFrozen(h)&&m.push(h)}}return d}e.deepFreeze=L;const D=Object.prototype.hasOwnProperty;function k(d,m){return b(d,m,new Set)}e.cloneAndChange=k;function b(d,m,v){if((0,w.isUndefinedOrNull)(d))return d;const M=m(d);if(typeof M!="undefined")return M;if((0,w.isArray)(d)){const h=[];for(const l of d)h.push(b(l,m,v));return h}if((0,w.isObject)(d)){if(v.has(d))throw new Error("Cannot clone recursive data-structure");v.add(d);const h={};for(let l in d)D.call(d,l)&&(h[l]=b(d[l],m,v));return v.delete(d),h}return d}function g(d,m,v=!0){return(0,w.isObject)(d)?((0,w.isObject)(m)&&Object.keys(m).forEach(M=>{M in d?v&&((0,w.isObject)(d[M])&&(0,w.isObject)(m[M])?g(d[M],m[M],v):d[M]=m[M]):d[M]=m[M]}),d):m}e.mixin=g;function S(d,m){if(d===m)return!0;if(d==null||m===null||m===void 0||typeof d!=typeof m||typeof d!="object"||Array.isArray(d)!==Array.isArray(m))return!1;let v,M;if(Array.isArray(d)){if(d.length!==m.length)return!1;for(v=0;v<d.length;v++)if(!S(d[v],m[v]))return!1}else{const h=[];for(M in d)h.push(M);h.sort();const l=[];for(M in m)l.push(M);if(l.sort(),!S(h,l))return!1;for(v=0;v<h.length;v++)if(!S(d[h[v]],m[h[v]]))return!1}return!0}e.equals=S;function C(d){const m=new Set;return JSON.stringify(d,(v,M)=>{if((0,w.isObject)(M)||Array.isArray(M)){if(m.has(M))return"[Circular]";m.add(M)}return M})}e.safeStringify=C;function E(d,m,v){const M=m(d);return typeof M=="undefined"?v:M}e.getOrDefault=E;function I(d,m){const v=Object.create(null);return!d||!m||Object.keys(m).forEach(h=>{const l=d[h],c=m[h];S(l,c)||(v[h]=c)}),v}e.distinct=I;function p(d,m){const v=m.toLowerCase(),M=Object.keys(d).find(h=>h.toLowerCase()===v);return M?d[M]:d[m]}e.getCaseInsensitive=p;function t(d,m){const v=Object.create(null);for(const[M,h]of Object.entries(d))m(M,h)&&(v[M]=h);return v}e.filter=t}),define(Z[8],x([0,1,7,2]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,D=/^\//,k=/^\/\//;function b(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!D.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(s,i){return!s&&!i?"file":s}function S(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const C="",E="/",I=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(i,r,o,u,y,P=!1){typeof i=="object"?(this.scheme=i.scheme||C,this.authority=i.authority||C,this.path=i.path||C,this.query=i.query||C,this.fragment=i.fragment||C):(this.scheme=g(i,P),this.authority=r||C,this.path=S(this.scheme,o||C),this.query=u||C,this.fragment=y||C,b(this,P))}static isUri(i){return i instanceof p?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return h(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:o,path:u,query:y,fragment:P}=i;return r===void 0?r=this.scheme:r===null&&(r=C),o===void 0?o=this.authority:o===null&&(o=C),u===void 0?u=this.path:u===null&&(u=C),y===void 0?y=this.query:y===null&&(y=C),P===void 0?P=this.fragment:P===null&&(P=C),r===this.scheme&&o===this.authority&&u===this.path&&y===this.query&&P===this.fragment?this:new d(r,o,u,y,P)}static parse(i,r=!1){const o=I.exec(i);return o?new d(o[2]||C,f(o[4]||C),f(o[5]||C),f(o[7]||C),f(o[9]||C),r):new d(C,C,C,C,C)}static file(i){let r=C;if(n.isWindows&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const o=i.indexOf(E,2);o===-1?(r=i.substring(2),i=E):(r=i.substring(2,o),i=i.substring(o)||E)}return new d("file",r,i,C,C)}static from(i){const r=new d(i.scheme,i.authority,i.path,i.query,i.fragment);return b(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return n.isWindows&&i.scheme==="file"?o=p.file(w.win32.join(h(i,!0),...r)).path:o=w.posix.join(i.path,...r),i.with({path:o})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof p)return i;{const r=new d(i);return r._formatted=i.external,r._fsPath=i._sep===t?i.fsPath:null,r}}else return i}}e.URI=p;const t=n.isWindows?1:void 0;class d extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(s,i){let r,o=-1;for(let u=0;u<s.length;u++){const y=s.charCodeAt(u);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||i&&y===47)o!==-1&&(r+=encodeURIComponent(s.substring(o,u)),o=-1),r!==void 0&&(r+=s.charAt(u));else{r===void 0&&(r=s.substr(0,u));const P=m[y];P!==void 0?(o!==-1&&(r+=encodeURIComponent(s.substring(o,u)),o=-1),r+=P):o===-1&&(o=u)}}return o!==-1&&(r+=encodeURIComponent(s.substring(o))),r!==void 0?r:s}function M(s){let i;for(let r=0;r<s.length;r++){const o=s.charCodeAt(r);o===35||o===63?(i===void 0&&(i=s.substr(0,r)),i+=m[o]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function h(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=h;function l(s,i){const r=i?M:v;let o="",{scheme:u,authority:y,path:P,query:R,fragment:W}=s;if(u&&(o+=u,o+=":"),(y||u==="file")&&(o+=E,o+=E),y){let U=y.indexOf("@");if(U!==-1){const G=y.substr(0,U);y=y.substr(U+1),U=G.indexOf(":"),U===-1?o+=r(G,!1):(o+=r(G.substr(0,U),!1),o+=":",o+=r(G.substr(U+1),!1)),o+="@"}y=y.toLowerCase(),U=y.indexOf(":"),U===-1?o+=r(y,!1):(o+=r(y.substr(0,U),!1),o+=y.substr(U))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const U=P.charCodeAt(1);U>=65&&U<=90&&(P=`/${String.fromCharCode(U+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const U=P.charCodeAt(0);U>=65&&U<=90&&(P=`${String.fromCharCode(U+32)}:${P.substr(2)}`)}o+=r(P,!0)}return R&&(o+="?",o+=r(R,!1)),W&&(o+="#",o+=i?W:v(W,!1)),o}function c(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(s){return s.match(a)?s.replace(a,i=>c(i)):s}}),define(Z[114],x([0,1,8]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(S){const C=S;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=n;function L(S){const C=[];let E;try{const I=JSON.parse(S.arguments),p=I[I.length-1];p&&p.__$stack&&(I.pop(),E=p.__$stack),C.push(...I)}catch{C.push("Unable to log remote console arguments",S.arguments)}return{args:C,stack:E}}e.parse=L;function D(S){if(typeof S!="string")return D(L(S).stack);const C=S;if(C){const E=k(C),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(I&&I.length===4)return{uri:w.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}e.getFirstFrame=D;function k(S){if(!S)return S;const C=S.indexOf(`
`);return C===-1?S:S.substring(0,C)}function b(S,C){const{args:E,stack:I}=L(S),p=typeof E[0]=="string"&&E.length===1;let t=k(I);t&&(t=`(${t.trim()})`);let d=[];if(typeof E[0]=="string"?t&&p?d=[`%c[${C}] %c${E[0]} %c${t}`,g("blue"),g(""),g("grey")]:d=[`%c[${C}] %c${E[0]}`,g("blue"),g(""),...E.slice(1)]:d=[`%c[${C}]%`,g("blue"),...E],t&&!p&&d.push(t),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,d)}e.log=b;function g(S){return`color: ${S}`}}),define(Z[115],x([0,1,16,27,8]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(S){return JSON.stringify(S,b)}e.stringify=D;function k(S){let C=JSON.parse(S);return C=g(C),C}e.parse=k;function b(S,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,n.regExpFlags)(C)}:C}function g(S,C=0){if(!S||C>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return L.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 14:return new Date(S.source)}if(S instanceof w.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let E=0;E<S.length;++E)S[E]=g(S[E],C+1);else for(const E in S)Object.hasOwnProperty.call(S,E)&&(S[E]=g(S[E],C+1))}return S}e.revive=g}),define(Z[10],x([0,1,2,8]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.userData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}set(g,S,C){this._hosts[g]=S,this._ports[g]=C}setConnectionToken(g,S){this._connectionTokens[g]=S}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)return this._delegate(g);const S=g.authority;let C=this._hosts[S];C&&C.indexOf(":")!==-1&&(C=`[${C}]`);const E=this._ports[S],I=this._connectionTokens[S];let p=`path=${encodeURIComponent(g.path)}`;return typeof I=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),n.URI.from({scheme:w.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${C}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new D;class k{asBrowserUri(g,S){n.URI.isUri(g)&&w.isWebWorker&&console.warn("FileAccess.asBrowserUri should not be used in the web worker!");const C=this.toUri(g,S);return C.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===L.file&&(w.isNative||w.isWebWorker&&w.globals.origin===`${L.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?C.with({scheme:L.vscodeFileResource,authority:C.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(g,S){const C=this.toUri(g,S);return C.scheme===L.vscodeFileResource?C.with({scheme:L.file,authority:C.authority!==k.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(g,S){return n.URI.isUri(g)?g:n.URI.parse(S.toUrl(g))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(Z[17],x([0,1,28,10,7,2,27,8]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(p){return(0,b.uriToFsPath)(p,!0)}e.originalFSPath=g;class S{constructor(t){this._ignorePathCasing=t}compare(t,d,m=!1){return t===d?0:(0,k.compare)(this.getComparisonKey(t,m),this.getComparisonKey(d,m))}isEqual(t,d,m=!1){return t===d?!0:!t||!d?!1:this.getComparisonKey(t,m)===this.getComparisonKey(d,m)}getComparisonKey(t,d=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,d,m=!1){if(t.scheme===d.scheme){if(t.scheme===n.Schemas.file)return w.isEqualOrParent(g(t),g(d),this._ignorePathCasing(t))&&t.query===d.query&&(m||t.fragment===d.fragment);if((0,e.isEqualAuthority)(t.authority,d.authority))return w.isEqualOrParent(t.path,d.path,this._ignorePathCasing(t),"/")&&t.query===d.query&&(m||t.fragment===d.fragment)}return!1}joinPath(t,...d){return b.URI.joinPath(t,...d)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return L.posix.basename(t.path)}extname(t){return L.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let d;return t.scheme===n.Schemas.file?d=b.URI.file(L.dirname(g(t))).path:(d=L.posix.dirname(t.path),t.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),d="/")),t.with({path:d})}normalizePath(t){if(!t.path.length)return t;let d;return t.scheme===n.Schemas.file?d=b.URI.file(L.normalize(g(t))).path:d=L.posix.normalize(t.path),t.with({path:d})}relativePath(t,d){if(t.scheme!==d.scheme||!(0,e.isEqualAuthority)(t.authority,d.authority))return;if(t.scheme===n.Schemas.file){const M=L.relative(g(t),g(d));return D.isWindows?w.toSlashes(M):M}let m=t.path||"/",v=d.path||"/";if(this._ignorePathCasing(t)){let M=0;for(const h=Math.min(m.length,v.length);M<h&&!(m.charCodeAt(M)!==v.charCodeAt(M)&&m.charAt(M).toLowerCase()!==v.charAt(M).toLowerCase());M++);m=v.substr(0,M)+m.substr(M)}return L.posix.relative(m,v)}resolvePath(t,d){if(t.scheme===n.Schemas.file){const m=b.URI.file(L.resolve(g(t),d));return t.with({authority:m.authority,path:m.path})}return d=w.toPosixPath(d),t.with({path:L.posix.resolve(t.path,d)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,d){return t===d||t!==void 0&&d!==void 0&&(0,k.equalsIgnoreCase)(t,d)}hasTrailingPathSeparator(t,d=L.sep){if(t.scheme===n.Schemas.file){const m=g(t);return m.length>w.getRoot(m).length&&m[m.length-1]===d}else{const m=t.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,d=L.sep){return(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,d=L.sep){let m=!1;if(t.scheme===n.Schemas.file){const v=g(t);m=v!==void 0&&v.length===w.getRoot(v).length&&v[v.length-1]===d}else{d="/";const v=t.path;m=v.length===1&&v.charCodeAt(v.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(t,d)?t.with({path:t.path+"/"}):t}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(p=>p.scheme===n.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new S(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(p,t){const d=[];for(let m=0;m<p.length;m++){const v=t(p[m]);p.some((M,h)=>h===m?!1:(0,e.isEqualOrParent)(v,t(M)))||d.push(p[m])}return d}e.distinctParents=C;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function t(d){const m=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(h=>{const[l,c]=h.split(":");l&&c&&m.set(l,c)});const M=d.path.substring(0,d.path.indexOf(";"));return M&&m.set(p.META_DATA_MIME,M),m}p.parseMetaData=t})(E=e.DataUri||(e.DataUri={}));function I(p,t,d){if(t){let m=p.path;return m&&m[0]!==L.posix.sep&&(m=L.posix.sep+m),p.with({scheme:d,authority:t,path:m})}return p.with({scheme:d})}e.toLocalResource=I}),define(Z[9],x([0,1,23,15,4,3,17,2]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function g(T){return!!T&&typeof T.then=="function"}e.isThenable=g;function S(T){const A=new w.CancellationTokenSource,O=T(A.token),_=new Promise((j,ie)=>{const ae=A.token.onCancellationRequested(()=>{ae.dispose(),A.dispose(),ie(new n.CancellationError)});Promise.resolve(O).then(ce=>{ae.dispose(),A.dispose(),j(ce)},ce=>{ae.dispose(),A.dispose(),ie(ce)})});return new class{cancel(){A.cancel()}then(j,ie){return _.then(j,ie)}catch(j){return this.then(void 0,j)}finally(j){return _.finally(j)}}}e.createCancelablePromise=S;function C(T,A,O){return new Promise((_,j)=>{const ie=A.onCancellationRequested(()=>{ie.dispose(),_(O)});T.then(_,j).finally(()=>ie.dispose())})}e.raceCancellation=C;function E(T,A){return new Promise((O,_)=>{const j=A.onCancellationRequested(()=>{j.dispose(),_(new n.CancellationError)});T.then(O,_).finally(()=>j.dispose())})}e.raceCancellationError=E;async function I(T){let A=-1;const O=T.map((j,ie)=>j.then(ae=>(A=ie,ae))),_=await Promise.race(O);return T.forEach((j,ie)=>{ie!==A&&j.cancel()}),_}e.raceCancellablePromises=I;function p(T,A,O){let _;const j=setTimeout(()=>{_?.(void 0),O?.()},A);return Promise.race([T.finally(()=>clearTimeout(j)),new Promise(ie=>_=ie)])}e.raceTimeout=p;function t(T){return new Promise((A,O)=>{const _=T();g(_)?_.then(A,O):A(_)})}e.asPromise=t;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(O,O).then(_)})}return new Promise((O,_)=>{this.queuedPromise.then(O,_)})}return this.activePromise=A(),new Promise((O,_)=>{this.activePromise.then(j=>{this.activePromise=null,O(j)},j=>{this.activePromise=null,_(j)})})}}e.Throttler=d;class m{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=m;class v{constructor(){this.promiseMap=new Map}queue(A,O){const j=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(A)===j&&this.promiseMap.delete(A)});return this.promiseMap.set(A,j),j}}e.SequencerByKey=v;const M=(T,A)=>{let O=!0;const _=setTimeout(()=>{O=!1,A()},T);return{isTriggered:()=>O,dispose:()=>{clearTimeout(_),O=!1}}},h=T=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,T())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,O=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,ie)=>{this.doResolve=j,this.doReject=ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?h(_):M(O,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class c{constructor(A){this.delayer=new l(A),this.throttler=new d}trigger(A,O){return this.delayer.trigger(()=>this.throttler.queue(A),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class a{constructor(){this._isOpen=!1,this._promise=new Promise((A,O)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class f extends a{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function s(T,A){return A?new Promise((O,_)=>{const j=setTimeout(()=>{ie.dispose(),O()},T),ie=A.onCancellationRequested(()=>{clearTimeout(j),ie.dispose(),_(new n.CancellationError)})}):S(O=>s(T,O))}e.timeout=s;function i(T,A=0){const O=setTimeout(T,A);return(0,D.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=i;function r(T){const A=[];let O=0;const _=T.length;function j(){return O<_?T[O++]():null}function ie(ae){ae!=null&&A.push(ae);const ce=j();return ce?ce.then(ie):Promise.resolve(A)}return Promise.resolve(null).then(ie)}e.sequence=r;function o(T,A=_=>!!_,O=null){let _=0;const j=T.length,ie=()=>{if(_>=j)return Promise.resolve(O);const ae=T[_++];return Promise.resolve(ae()).then(ne=>A(ne)?Promise.resolve(ne):ie())};return ie()}e.first=o;function u(T,A=_=>!!_,O=null){if(T.length===0)return Promise.resolve(O);let _=T.length;const j=()=>{_=-1;for(const ie of T)ie.cancel?.()};return new Promise((ie,ae)=>{for(const ce of T)ce.then(ne=>{--_>=0&&A(ne)?(j(),ie(ne)):_===0&&ie(O)}).catch(ne=>{--_>=0&&(j(),ae(ne))})})}e.firstParallel=u;class y{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(A){return this._size++,new Promise((O,_)=>{this.outstandingPromises.push({factory:A,c:O,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const O=A.factory();O.then(A.c,A.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=y;class P extends y{constructor(){super(1)}}e.Queue=P;class R{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new $;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,O=k.extUri){const _=O.getComparisonKey(A);let j=this.queues.get(_);return j||(j=new P,L.Event.once(j.onFinished)(()=>{j?.dispose(),this.queues.delete(_),this.onDidQueueFinish()}),this.queues.set(_,j)),j}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=R;class W{constructor(A,O){this._token=-1,typeof A=="function"&&typeof O=="number"&&this.setIfNotSet(A,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},O)}setIfNotSet(A,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},O))}}e.TimeoutTimer=W;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setInterval(()=>{A()},O)}}e.IntervalTimer=U;class G{constructor(A,O){this.timeoutToken=-1,this.runner=A,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=G;class ee{constructor(A,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=ee;class X extends G{constructor(A,O){super(A,O);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X;class J extends D.Disposable{constructor(A,O){super();this.options=A,this.handler=O,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new G(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=T=>{(0,b.setTimeout0)(()=>{if(A)return;const O=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(T,A)=>{const O=requestIdleCallback(T,typeof A=="number"?{timeout:A}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(O))}}}}();class H{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=H;async function B(T,A,O){let _;for(let j=0;j<O;j++)try{return await T()}catch(ie){_=ie,await s(A)}throw _}e.retry=B;class Y{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,O,_){return this._pending={taskId:A,cancel:()=>_?.(),promise:O},O.then(()=>this.donePending(A),()=>this.donePending(A)),O}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let O,_;const j=new Promise((ie,ae)=>{O=ie,_=ae});this._next={run:A,promise:j,promiseResolve:O,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=Y;class se{constructor(A,O=()=>Date.now()){this.interval=A,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=se;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,O)=>{this.completeCallback=A,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(O=>{this.completeCallback(A),this.resolved=!0,O()})}error(A){return new Promise(O=>{this.errorCallback(A),this.rejected=!0,O()})}cancel(){new Promise(A=>{this.errorCallback(new n.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=$;var q;(function(T){async function A(_){let j;const ie=await Promise.all(_.map(ae=>ae.then(ce=>ce,ce=>{j||(j=ce)})));if(typeof j!="undefined")throw j;return ie}T.settled=A;function O(_){return new Promise(async(j,ie)=>{try{await _(j,ie)}catch(ae){ie(ae)}})}T.withAsyncBody=O})(q=e.Promises||(e.Promises={}));var Q;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(Q||(Q={}));class z{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const O={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(A(O)),this.resolve()}catch(_){this.reject(_)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(A){return new z(O=>{O.emitMany(A)})}static fromPromise(A){return new z(async O=>{O.emitMany(await A)})}static fromPromises(A){return new z(async O=>{await Promise.all(A.map(async _=>O.emitOne(await _)))})}static merge(A){return new z(async O=>{await Promise.all(A.map(async _=>{for await(const j of _)O.emitOne(j)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,O){return new z(async _=>{for await(const j of A)_.emitOne(O(j))})}map(A){return z.map(this,A)}static filter(A,O){return new z(async _=>{for await(const j of A)O(j)&&_.emitOne(j)})}filter(A){return z.filter(this,A)}static coalesce(A){return z.filter(A,O=>!!O)}coalesce(){return z.coalesce(this)}static async toPromise(A){const O=[];for await(const _ of A)O.push(_);return O}toPromise(){return z.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class F extends z{constructor(A,O){super(O);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=F;function N(T){const A=new w.CancellationTokenSource,O=T(A.token);return new F(A,async _=>{const j=A.token.onCancellationRequested(()=>{j.dispose(),A.dispose(),_.reject(new n.CancellationError)});try{for await(const ie of O){if(A.token.isCancellationRequested)return;_.emitOne(ie)}j.dispose(),A.dispose()}catch(ie){j.dispose(),A.dispose(),_.reject(ie)}})}e.createCancelableAsyncIterable=N}),define(Z[116],x([0,1,9,28,35,7,2,27]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function g(){return Object.create(null)}e.getEmptyExpression=g,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const S="[/\\\\]",C="[^/\\\\]",E=/\//g;function I($){switch($){case 0:return"";case 1:return`${C}*?`;default:return`(?:${S}|${C}+${S}|${S}${C}+)*?`}}function p($,q){if(!$)return[];const Q=[];let z=!1,F=!1,N="";for(const T of $){switch(T){case q:if(!z&&!F){Q.push(N),N="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":F=!0;break;case"]":F=!1;break}N+=T}return N&&Q.push(N),Q}e.splitGlobAware=p;function t($){if(!$)return"";let q="";const Q=p($,e.GLOB_SPLIT);if(Q.every(z=>z===e.GLOBSTAR))q=".*";else{let z=!1;Q.forEach((F,N)=>{if(F===e.GLOBSTAR){z||(q+=I(2),z=!0);return}let T=!1,A="",O=!1,_="";for(const j of F){if(j!=="}"&&T){A+=j;continue}if(O&&(j!=="]"||!_)){let ie;j==="-"?ie=j:(j==="^"||j==="!")&&!_?ie="^":j===e.GLOB_SPLIT?ie="":ie=(0,b.escapeRegExpCharacters)(j),_+=ie;continue}switch(j){case"{":T=!0;continue;case"[":O=!0;continue;case"}":{q+=`(?:${p(A,",").map(ce=>t(ce)).join("|")})`,T=!1,A="";break}case"]":q+="["+_+"]",O=!1,_="";break;case"?":q+=C;continue;case"*":q+=I(1);continue;default:q+=(0,b.escapeRegExpCharacters)(j)}}N<Q.length-1&&(Q[N+1]!==e.GLOBSTAR||N+2<Q.length)&&(q+=S),z=!1})}return q}const d=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,M=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new L.LRUCache(1e4),a=function(){return!1},f=function(){return null};function s($,q){if(!$)return f;let Q;typeof $!="string"?Q=$.pattern:Q=$,Q=Q.trim();const z=`${Q}_${!!q.trimForExclusions}`;let F=c.get(z);if(F)return i(F,$);let N;if(d.test(Q)){const T=Q.substr(4);F=function(A,O){return typeof A=="string"&&A.endsWith(T)?Q:null}}else(N=m.exec(r(Q,q)))?F=o(N[1],Q):(q.trimForExclusions?M:v).test(Q)?F=u(Q,q):(N=h.exec(r(Q,q)))?F=y(N[1].substr(1),Q,!0):(N=l.exec(r(Q,q)))?F=y(N[1],Q,!1):F=P(Q);return c.set(z,F),i(F,$)}function i($,q){return typeof q=="string"?$:function(Q,z){return(0,n.isEqualOrParent)(Q,q.base,!k.isLinux)?$(Q.substr(q.base.length+1),z):null}}function r($,q){return q.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function o($,q){const Q=`/${$}`,z=`\\${$}`,F=function(T,A){return typeof T!="string"?null:A?A===$?q:null:T===$||T.endsWith(Q)||T.endsWith(z)?q:null},N=[$];return F.basenames=N,F.patterns=[q],F.allBasenames=N,F}function u($,q){const Q=se($.slice(1,-1).split(",").map(A=>s(A,q)).filter(A=>A!==f),$),z=Q.length;if(!z)return f;if(z===1)return Q[0];const F=function(A,O){for(let _=0,j=Q.length;_<j;_++)if(Q[_](A,O))return $;return null},N=Q.find(A=>!!A.allBasenames);N&&(F.allBasenames=N.allBasenames);const T=Q.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return T.length&&(F.allPaths=T),F}function y($,q,Q){const z=D.sep===D.posix.sep,F=z?$:$.replace(E,D.sep),N=D.sep+F,T=D.posix.sep+$,A=Q?function(O,_){return typeof O=="string"&&(O===F||O.endsWith(N)||!z&&(O===$||O.endsWith(T)))?q:null}:function(O,_){return typeof O=="string"&&(O===F||!z&&O===$)?q:null};return A.allPaths=[(Q?"*/":"./")+$],A}function P($){try{const q=new RegExp(`^${t($)}$`);return function(Q){return q.lastIndex=0,typeof Q=="string"&&q.test(Q)?$:null}}catch{return f}}function R($,q,Q){return!$||typeof q!="string"?!1:W($)(q,void 0,Q)}e.match=R;function W($,q={}){if(!$)return a;if(typeof $=="string"||X($)){const Q=s($,q);if(Q===f)return a;const z=function(F,N){return!!Q(F,N)};return Q.allBasenames&&(z.allBasenames=Q.allBasenames),Q.allPaths&&(z.allPaths=Q.allPaths),z}return B($,q)}e.parse=W;function U($){if(!$)return;let q;return Q=>(q||(q=($()||Promise.resolve([])).then(z=>z?ee(z):{})),q.then(z=>!!z[Q]))}e.hasSiblingPromiseFn=U;function G($){if(!$)return;let q;return Q=>{if(!q){const z=$();q=z?ee(z):{}}return!!q[Q]}}e.hasSiblingFn=G;function ee($){const q={};for(const Q of $)q[Q]=!0;return q}function X($){const q=$;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=X;function J($){return $.allBasenames||[]}e.getBasenameTerms=J;function H($){return $.allPaths||[]}e.getPathTerms=H;function B($,q){const Q=se(Object.getOwnPropertyNames($).map(A=>Y(A,$[A],q)).filter(A=>A!==f)),z=Q.length;if(!z)return f;if(!Q.some(A=>!!A.requiresSiblings)){if(z===1)return Q[0];const A=function(j,ie){for(let ae=0,ce=Q.length;ae<ce;ae++){const ne=Q[ae](j,ie);if(ne)return ne}return null},O=Q.find(j=>!!j.allBasenames);O&&(A.allBasenames=O.allBasenames);const _=Q.reduce((j,ie)=>ie.allPaths?j.concat(ie.allPaths):j,[]);return _.length&&(A.allPaths=_),A}const F=function(A,O,_){let j;for(let ie=0,ae=Q.length;ie<ae;ie++){const ce=Q[ie];ce.requiresSiblings&&_&&(O||(O=(0,D.basename)(A)),j||(j=O.substr(0,O.length-(0,D.extname)(A).length)));const ne=ce(A,O,j,_);if(ne)return ne}return null},N=Q.find(A=>!!A.allBasenames);N&&(F.allBasenames=N.allBasenames);const T=Q.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return T.length&&(F.allPaths=T),F}function Y($,q,Q){if(q===!1)return f;const z=s($,Q);if(z===f)return f;if(typeof q=="boolean")return z;if(q){const F=q.when;if(typeof F=="string"){const N=(T,A,O,_)=>{if(!_||!z(T,A))return null;const j=F.replace("$(basename)",O),ie=_(j);return(0,w.isThenable)(ie)?ie.then(ae=>ae?$:null):ie?$:null};return N.requiresSiblings=!0,N}}return z}function se($,q){const Q=$.filter(A=>!!A.basenames);if(Q.length<2)return $;const z=Q.reduce((A,O)=>{const _=O.basenames;return _?A.concat(_):A},[]);let F;if(q){F=[];for(let A=0,O=z.length;A<O;A++)F.push(q)}else F=Q.reduce((A,O)=>{const _=O.patterns;return _?A.concat(_):A},[]);const N=function(A,O){if(typeof A!="string")return null;if(!O){let j;for(j=A.length;j>0;j--){const ie=A.charCodeAt(j-1);if(ie===47||ie===92)break}O=A.substr(j)}const _=z.indexOf(O);return _!==-1?F[_]:null};N.basenames=z,N.patterns=F,N.allBasenames=z;const T=$.filter(A=>!A.basenames);return T.push(N),T}}),define(Z[33],x([0,1,28,10,7,2,17,27,8]),function(V,e,w,n,L,D,k,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function S(i,r,o){if(typeof i=="string"&&(i=g.URI.file(i)),o){const y=o.getWorkspaceFolder(i);if(y){const P=o.getWorkspace().folders.length>1;let R;if((0,k.isEqual)(y.uri,i)?R="":R=(0,k.relativePath)(y.uri,i),P){const W=y.name?y.name:(0,k.basename)(y.uri);R=R?W+" \u2022 "+R:W}return R}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(i.fsPath))return(0,L.normalize)(E(i.fsPath));let u=(0,L.normalize)(i.fsPath);return!D.isWindows&&r?.userHome&&(u=p(u,r.userHome.fsPath)),u}e.getPathLabel=S;function C(i){if(!i)return;typeof i=="string"&&(i=g.URI.file(i));const r=(0,k.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return D.isWindows&&(0,w.isRootOrDriveLetter)(r)?E(r):r}e.getBaseLabel=C;function E(i,r){return(0,w.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=E;let I=Object.create(null);function p(i,r){if(D.isWindows||!i||!r)return i;let o=I.original===r?I.normalized:void 0;return o||(o=`${(0,b.rtrim)(r,L.posix.sep)}${L.posix.sep}`,I={original:r,normalized:o}),(D.isLinux?i.startsWith(o):(0,b.startsWithIgnoreCase)(i,o))&&(i=`~/${i.substr(o.length)}`),i}e.tildify=p;function t(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=t;const d="\u2026",m="\\\\",v="~";function M(i,r=L.sep){const o=new Array(i.length);let u=!1;for(let y=0;y<i.length;y++){let P=i[y];if(P===""){o[y]=`.${r}`;continue}if(!P){o[y]=P;continue}u=!0;let R="";P.indexOf(m)===0?(R=P.substr(0,P.indexOf(m)+m.length),P=P.substr(P.indexOf(m)+m.length)):P.indexOf(r)===0?(R=P.substr(0,P.indexOf(r)+r.length),P=P.substr(P.indexOf(r)+r.length)):P.indexOf(v)===0&&(R=P.substr(0,P.indexOf(v)+v.length),P=P.substr(P.indexOf(v)+v.length));const W=P.split(r);for(let U=1;u&&U<=W.length;U++)for(let G=W.length-U;u&&G>=0;G--){u=!1;let ee=W.slice(G,G+U).join(r);for(let X=0;!u&&X<i.length;X++)if(X!==y&&i[X]&&i[X].indexOf(ee)>-1){const J=G+U===W.length,H=G>0&&i[X].indexOf(r)>-1?r+ee:ee,B=i[X].endsWith(H);u=!J||B}if(!u){let X="";(W[0].endsWith(":")||R!=="")&&(G===1&&(G=0,U++,ee=W[0]+r+ee),G>0&&(X=W[0]+r),X=R+X),G>0&&(X=X+d+r),X=X+ee,G+U<W.length&&(X=X+r+d),o[y]=X}}u&&(o[y]=P)}return o}e.shorten=M;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function l(i,r=Object.create(null)){const o=[];let u=!1,y="";for(const P of i)if(P==="$"||u&&P==="{")y&&o.push({value:y,type:h.TEXT}),y="",u=!0;else if(P==="}"&&u){const R=r[y];if(typeof R=="string")R.length&&o.push({value:R,type:h.VARIABLE});else if(R){const W=o[o.length-1];(!W||W.type!==h.SEPARATOR)&&o.push({value:R.label,type:h.SEPARATOR})}y="",u=!1}else y+=P;return y&&!u&&o.push({value:y,type:h.TEXT}),o.filter((P,R)=>{if(P.type===h.SEPARATOR){const W=o[R-1],U=o[R+1];return[W,U].every(G=>G&&(G.type===h.VARIABLE||G.type===h.TEXT)&&G.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=l;function c(i,r){return D.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function a(i,r){return D.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):D.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function f(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=f;function s(i){const r=i.indexOf("/")!==-1?L.posix:L.win32,o=r.basename(i),u=r.dirname(i);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=s}),define(Z[117],x([0,1,8]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(C){return C.toJSON()}class L{constructor(E){this._uriTransformer=E}transformIncoming(E){const I=this._uriTransformer.transformIncoming(E);return I===E?E:n(w.URI.from(I))}transformOutgoing(E){const I=this._uriTransformer.transformOutgoing(E);return I===E?E:n(w.URI.from(I))}transformOutgoingURI(E){const I=this._uriTransformer.transformOutgoing(E);return I===E?E:w.URI.from(I)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function D(C,E,I){if(!C||I>200)return null;if(typeof C=="object"){if(C instanceof w.URI)return E.transformOutgoing(C);for(let p in C)if(Object.hasOwnProperty.call(C,p)){const t=D(C[p],E,I+1);t!==null&&(C[p]=t)}}return null}function k(C,E){const I=D(C,E,0);return I===null?C:I}e.transformOutgoingURIs=k;function b(C,E,I,p){if(!C||p>200)return null;if(typeof C=="object"){if(C.$mid===1)return I?w.URI.revive(E.transformIncoming(C)):E.transformIncoming(C);for(let t in C)if(Object.hasOwnProperty.call(C,t)){const d=b(C[t],E,I,p+1);d!==null&&(C[t]=d)}}return null}function g(C,E){const I=b(C,E,!1,0);return I===null?C:I}e.transformIncomingURIs=g;function S(C,E){const I=b(C,E,!0,0);return I===null?C:I}e.transformAndReviveIncomingURIs=S}),define(Z[31],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(g){return w.test(g)}e.isUUID=n;const L=new Uint8Array(16),D=[];for(let g=0;g<256;g++)D.push(g.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(g){for(let S=0;S<g.length;S++)g[S]=Math.floor(Math.random()*256);return g};function b(){k(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let g=0,S="";return S+=D[L[g++]],S+=D[L[g++]],S+=D[L[g++]],S+=D[L[g++]],S+="-",S+=D[L[g++]],S+=D[L[g++]],S+="-",S+=D[L[g++]],S+=D[L[g++]],S+="-",S+=D[L[g++]],S+=D[L[g++]],S+="-",S+=D[L[g++]],S+=D[L[g++]],S+=D[L[g++]],S+=D[L[g++]],S+=D[L[g++]],S+=D[L[g++]],S}e.generateUuid=b}),define(Z[118],x([0,1,15,4,3,2,14,27]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const g="$initialize";let S=!1;function C(s){!D.isWeb||(S||(S=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(s.message))}e.logOnceWebWorkerWarning=C;var E;(function(s){s[s.Request=0]="Request",s[s.Reply=1]="Reply",s[s.SubscribeEvent=2]="SubscribeEvent",s[s.Event=3]="Event",s[s.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class I{constructor(i,r,o,u){this.vsWorker=i,this.req=r,this.method=o,this.args=u,this.type=0}}class p{constructor(i,r,o,u){this.vsWorker=i,this.seq=r,this.res=o,this.err=u,this.type=1}}class t{constructor(i,r,o,u){this.vsWorker=i,this.req=r,this.eventName=o,this.arg=u,this.type=2}}class d{constructor(i,r,o){this.vsWorker=i,this.req=r,this.event=o,this.type=3}}class m{constructor(i,r){this.vsWorker=i,this.req=r,this.type=4}}class v{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,r){const o=String(++this._lastSentReq);return new Promise((u,y)=>{this._pendingReplies[o]={resolve:u,reject:y},this._send(new I(this._workerId,o,i,r))})}listen(i,r){let o=null;const u=new n.Emitter({onFirstListenerAdd:()=>{o=String(++this._lastSentReq),this._pendingEmitters.set(o,u),this._send(new t(this._workerId,o,i,r))},onLastListenerRemove:()=>{this._pendingEmitters.delete(o),this._send(new m(this._workerId,o)),o=null}});return u.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let r=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let o=i.err;i.err.$isError&&(o=new Error,o.name=i.err.name,o.message=i.err.message,o.stack=i.err.stack),r.reject(o);return}r.resolve(i.res)}_handleRequestMessage(i){let r=i.req;this._handler.handleMessage(i.method,i.args).then(u=>{this._send(new p(this._workerId,r,u,void 0))},u=>{u.detail instanceof Error&&(u.detail=(0,w.transformErrorForSerialization)(u.detail)),this._send(new p(this._workerId,r,void 0,(0,w.transformErrorForSerialization)(u)))})}_handleSubscribeEventMessage(i){const r=i.req,o=this._handler.handleEvent(i.eventName,i.arg)(u=>{this._send(new d(this._workerId,r,u))});this._pendingEvents.set(r,o)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let r=[];if(i.type===0)for(let o=0;o<i.args.length;o++)i.args[o]instanceof ArrayBuffer&&r.push(i.args[o]);else i.type===1&&i.res instanceof ArrayBuffer&&r.push(i.res);this._handler.sendMessage(i,r)}}class M extends L.Disposable{constructor(i,r,o){super();let u=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",U=>{this._protocol.handleMessage(U)},U=>{u&&u(U)})),this._protocol=new v({sendMessage:(U,G)=>{this._worker.postMessage(U,G)},handleMessage:(U,G)=>{if(typeof o[U]!="function")return Promise.reject(new Error("Missing method "+U+" on main thread host."));try{return Promise.resolve(o[U].apply(o,G))}catch(ee){return Promise.reject(ee)}},handleEvent:(U,G)=>{if(l(U)){const ee=o[U].call(o,G);if(typeof ee!="function")throw new Error(`Missing dynamic event ${U} on main thread host.`);return ee}if(h(U)){const ee=o[U];if(typeof ee!="function")throw new Error(`Missing event ${U} on main thread host.`);return ee}throw new Error(`Malformed event name ${U}`)}}),this._protocol.setWorkerId(this._worker.getId());let y=null;typeof D.globals.require!="undefined"&&typeof D.globals.require.getConfig=="function"?y=D.globals.require.getConfig():typeof D.globals.requirejs!="undefined"&&(y=D.globals.requirejs.s.contexts._.config);const P=k.getAllMethodNames(o);this._onModuleLoaded=this._protocol.sendMessage(g,[this._worker.getId(),JSON.parse(JSON.stringify(y)),r,P]);const R=(U,G)=>this._request(U,G),W=(U,G)=>this._protocol.listen(U,G);this._lazyProxy=new Promise((U,G)=>{u=G,this._onModuleLoaded.then(ee=>{U(c(ee,R,W))},ee=>{G(ee),this._onError("Worker failed to load "+r,ee)})})}getProxyObject(){return this._lazyProxy}_request(i,r){return new Promise((o,u)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,r).then(o,u)},u)})}_onError(i,r){console.error(i),console.info(r)}}e.SimpleWorkerClient=M;function h(s){return s[0]==="o"&&s[1]==="n"&&b.isUpperAsciiLetter(s.charCodeAt(2))}function l(s){return/^onDynamic/.test(s)&&b.isUpperAsciiLetter(s.charCodeAt(9))}function c(s,i,r){const o=P=>function(){const R=Array.prototype.slice.call(arguments,0);return i(P,R)},u=P=>function(R){return r(P,R)};let y={};for(const P of s){if(l(P)){y[P]=u(P);continue}if(h(P)){y[P]=r(P,void 0);continue}y[P]=o(P)}return y}class a{constructor(i,r){this._requestHandlerFactory=r,this._requestHandler=null,this._protocol=new v({sendMessage:(o,u)=>{i(o,u)},handleMessage:(o,u)=>this._handleMessage(o,u),handleEvent:(o,u)=>this._handleEvent(o,u)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,r){if(i===g)return this.initialize(r[0],r[1],r[2],r[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,r))}catch(o){return Promise.reject(o)}}_handleEvent(i,r){if(!this._requestHandler)throw new Error("Missing requestHandler");if(l(i)){const o=this._requestHandler[i].call(this._requestHandler,r);if(typeof o!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return o}if(h(i)){const o=this._requestHandler[i];if(typeof o!="function")throw new Error(`Missing event ${i} on request handler.`);return o}throw new Error(`Malformed event name ${i}`)}initialize(i,r,o,u){this._protocol.setWorkerId(i);const R=c(u,(W,U)=>this._protocol.sendMessage(W,U),(W,U)=>this._protocol.listen(W,U));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve(k.getAllMethodNames(this._requestHandler))):(r&&(typeof r.baseUrl!="undefined"&&delete r.baseUrl,typeof r.paths!="undefined"&&typeof r.paths.vs!="undefined"&&delete r.paths.vs,typeof r.trustedTypesPolicy!==void 0&&delete r.trustedTypesPolicy,r.catchError=!0,D.globals.require.config(r)),new Promise((W,U)=>{(D.globals.require||V)([o],ee=>{if(this._requestHandler=ee.create(R),!this._requestHandler){U(new Error("No RequestHandler!"));return}W(k.getAllMethodNames(this._requestHandler))},U)}))}}e.SimpleWorkerServer=a;function f(s){return new a(s,null)}e.create=f}),define(Z[119],x([0,1,60,29,43]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function D(k,b){if(await new Promise((C,E)=>{const I=n.createReadStream(k),p=w.createHash("sha1");I.pipe(p);const t=(0,L.once)((d,m)=>{I.removeAllListeners(),p.removeAllListeners(),d?E(d):C(m)});I.once("error",t),I.once("end",t),p.once("error",t),p.once("data",d=>t(void 0,d.toString("hex")))})!==b)throw new Error("Hash mismatch")}e.checksum=D}),define(Z[120],x([0,1,249]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(D="utf8"){this.stringDecoder=new w.StringDecoder(D),this.remaining=null}write(D){const k=[],b=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(b.length<1)return k;let g=0,S,C=g;for(;C<b.length;)if(S=b.charCodeAt(C),S===13||S===10){if(k.push(b.substring(g,C)),C++,C<b.length){const E=S;S=b.charCodeAt(C),(E===13&&S===10||E===10&&S===13)&&C++}g=C}else C++;return this.remaining=g<b.length?b.substr(g):null,k}end(){return this.remaining}}e.LineDecoder=n}),define(Z[121],x([0,1,26]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(k){const b=k.replace(/\-/g,":").toLowerCase();return!n.has(b)}function D(){const k=(0,w.networkInterfaces)();for(let b in k){const g=k[b];if(g){for(const{mac:S}of g)if(L(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(Z[71],x([0,1,26,15,35,31,121]),function(V,e,w,n,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,E=0;const I=(0,w.networkInterfaces)();for(let p in I){const t=I[p];if(t)for(const{mac:d,internal:m}of t)m||(E+=1,this._isVirtualMachineMacAddress(d.toUpperCase())&&(C+=1))}this._value=E>0?C/E:0}return this._value}};let b;async function g(){return b||(b=(async()=>await S()||D.generateUuid())()),b}e.getMachineId=g;async function S(){try{const C=await new Promise((I,p)=>{V(["crypto"],I,p)}),E=(0,k.getMac)();return C.createHash("sha256").update(E,"utf8").digest("hex")}catch(C){n.onUnexpectedError(C);return}}}),define(Z[24],x([0,1,29,26,122,9,28,70,7,2,17,8]),function(V,e,w,n,L,D,k,b,g,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var I;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})(I=e.RimRafMode||(e.RimRafMode={}));async function p(J,H=I.UNLINK){if((0,k.isRootOrDriveLetter)(J))throw new Error("rimraf - will refuse to recursively delete root");return H===I.UNLINK?d(J):t(J)}async function t(J){try{const H=(0,k.randomPath)((0,n.tmpdir)());try{await w.promises.rename(J,H)}catch{return d(J)}d(H).catch(B=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function d(J){return(0,L.promisify)(w.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function m(J){if((0,k.isRootOrDriveLetter)(J))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function v(J,H){return l(await(H?M(J):(0,L.promisify)(w.readdir)(J)))}async function M(J){try{return await(0,L.promisify)(w.readdir)(J,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const H=[],B=await v(J);for(const Y of B){let se=!1,$=!1,q=!1;try{const Q=await e.Promises.lstat((0,g.join)(J,Y));se=Q.isFile(),$=Q.isDirectory(),q=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}H.push({name:Y,isFile:()=>se,isDirectory:()=>$,isSymbolicLink:()=>q})}return H}function h(J){return l(w.readdirSync(J))}e.readdirSync=h;function l(J){return J.map(H=>typeof H=="string"?S.isMacintosh?(0,b.normalizeNFC)(H):H:(H.name=S.isMacintosh?(0,b.normalizeNFC)(H.name):H.name,H))}async function c(J){const H=await v(J),B=[];for(const Y of H)await f.existsDirectory((0,g.join)(J,Y))&&B.push(Y);return B}function a(J,H=1e3){return new Promise(B=>{let Y=!1;const se=setInterval(()=>{Y||(Y=!0,w.access(J,$=>{Y=!1,$&&(clearInterval(se),B(void 0))}))},H)})}e.whenDeleted=a;var f;(function(J){async function H(se){let $;try{if($=await e.Promises.lstat(se),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(se),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(S.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(se)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw Q}throw q}}J.stat=H;async function B(se){try{const{stat:$,symbolicLink:q}=await J.stat(se);return $.isFile()&&q?.dangling!==!0}catch{}return!1}J.existsFile=B;async function Y(se){try{const{stat:$,symbolicLink:q}=await J.stat(se);return $.isDirectory()&&q?.dangling!==!0}catch{}return!1}J.existsDirectory=Y})(f=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new D.ResourceQueue;function i(J,H,B){return s.queueFor(E.URI.file(J),C.extUriBiasedIgnorePathCase).queue(()=>{const Y=y(B);return new Promise((se,$)=>o(J,H,Y,q=>q?$(q):se()))})}let r=!0;function o(J,H,B,Y){if(!r)return w.writeFile(J,H,{mode:B.mode,flag:B.flag},Y);w.open(J,B.flag,B.mode,(se,$)=>{if(se)return Y(se);w.writeFile($,H,q=>{if(q)return w.close($,()=>Y(q));w.fdatasync($,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),r=!1),w.close($,z=>Y(z))))})})}function u(J,H,B){const Y=y(B);if(!r)return w.writeFileSync(J,H,{mode:Y.mode,flag:Y.flag});const se=w.openSync(J,Y.flag,Y.mode);try{w.writeFileSync(se,H);try{w.fdatasyncSync(se)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),r=!1}}finally{w.closeSync(se)}}e.writeFileSync=u;function y(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function P(J,H){if(J!==H)try{await e.Promises.rename(J,H)}catch(B){if(J.toLowerCase()!==H.toLowerCase()&&B.code==="EXDEV"||J.endsWith("."))await R(J,H,{preserveSymlinks:!1}),await p(J,I.MOVE);else throw B}}async function R(J,H,B){return U(J,H,{root:{source:J,target:H},options:B,handledSourcePaths:new Set})}const W=511;async function U(J,H,B){if(B.handledSourcePaths.has(J))return;B.handledSourcePaths.add(J);const{stat:Y,symbolicLink:se}=await f.stat(J);if(se){if(B.options.preserveSymlinks)try{return await X(J,H,B)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(se.dangling)return}return Y.isDirectory()?G(J,H,Y.mode&W,B):ee(J,H,Y.mode&W)}async function G(J,H,B,Y){await e.Promises.mkdir(H,{recursive:!0,mode:B});const se=await v(J);for(const $ of se)await U((0,g.join)(J,$),(0,g.join)(H,$),Y)}async function ee(J,H,B){await e.Promises.copyFile(J,H),await e.Promises.chmod(H,B)}async function X(J,H,B){let Y=await e.Promises.readlink(J);(0,k.isEqualOrParent)(Y,B.root.source,!S.isLinux)&&(Y=(0,g.join)(B.root.target,Y.substr(B.root.source.length+1))),await e.Promises.symlink(Y,H)}e.Promises=new class{get access(){return(0,L.promisify)(w.access)}get stat(){return(0,L.promisify)(w.stat)}get lstat(){return(0,L.promisify)(w.lstat)}get utimes(){return(0,L.promisify)(w.utimes)}get read(){return(J,H,B,Y,se)=>new Promise(($,q)=>{w.read(J,H,B,Y,se,(Q,z,F)=>Q?q(Q):$({bytesRead:z,buffer:F}))})}get readFile(){return(0,L.promisify)(w.readFile)}get write(){return(J,H,B,Y,se)=>new Promise(($,q)=>{w.write(J,H,B,Y,se,(Q,z,F)=>Q?q(Q):$({bytesWritten:z,buffer:F}))})}get appendFile(){return(0,L.promisify)(w.appendFile)}get fdatasync(){return(0,L.promisify)(w.fdatasync)}get truncate(){return(0,L.promisify)(w.truncate)}get rename(){return(0,L.promisify)(w.rename)}get copyFile(){return(0,L.promisify)(w.copyFile)}get open(){return(0,L.promisify)(w.open)}get close(){return(0,L.promisify)(w.close)}get symlink(){return(0,L.promisify)(w.symlink)}get readlink(){return(0,L.promisify)(w.readlink)}get chmod(){return(0,L.promisify)(w.chmod)}get mkdir(){return(0,L.promisify)(w.mkdir)}get unlink(){return(0,L.promisify)(w.unlink)}get rmdir(){return(0,L.promisify)(w.rmdir)}get realpath(){return(0,L.promisify)(w.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return p}get move(){return P}get copy(){return R}}}),define(Z[86],x([0,1,29,7,2,27,24]),function(V,e,w,n,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(I){if(L.isLinux)return I;const p=(0,n.dirname)(I);if(I===p)return I;const t=((0,n.basename)(I)||I).toLowerCase();try{const m=(0,k.readdirSync)(p).filter(v=>v.toLowerCase()===t);if(m.length===1){const v=b(p);if(v)return(0,n.join)(v,m[0])}else if(m.length>1){const v=m.indexOf(t);if(v>=0){const M=b(p);if(M)return(0,n.join)(M,m[v])}}}catch{}return null}e.realcaseSync=b;async function g(I){if(L.isLinux)return I;const p=(0,n.dirname)(I);if(I===p)return I;const t=((0,n.basename)(I)||I).toLowerCase();try{const m=(await k.Promises.readdir(p)).filter(v=>v.toLowerCase()===t);if(m.length===1){const v=await g(p);if(v)return(0,n.join)(v,m[0])}else if(m.length>1){const v=m.indexOf(t);if(v>=0){const M=await g(p);if(M)return(0,n.join)(M,m[v])}}}catch{}return null}e.realcase=g;async function S(I){try{return await k.Promises.realpath(I)}catch{const t=E(I);return await k.Promises.access(t,w.constants.R_OK),t}}e.realpath=S;function C(I){try{return w.realpathSync(I)}catch{const t=E(I);return w.accessSync(t,w.constants.R_OK),t}}e.realpathSync=C;function E(I){return(0,D.rtrim)((0,n.normalize)(I),n.sep)}}),define(Z[123],x([0,1,61]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(b,g,S,C=1){let E=!1;return new Promise(I=>{const p=setTimeout(()=>{if(!E)return E=!0,I(0)},S);L(b,g,C,t=>{if(!E)return E=!0,clearTimeout(p),I(t)})})}e.findFreePort=n;function L(b,g,S,C){if(g===0)return C(0);const E=new w.Socket;E.once("connect",()=>(k(E),L(b+S,g-1,S,C))),E.once("data",()=>{}),E.once("error",I=>(k(E),I.code!=="ECONNREFUSED"?L(b+S,g-1,S,C):C(b))),E.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(b,g,S){let C=!1,E,I=1;const p=w.createServer({pauseOnConnect:!0});function t(d,m){C||(C=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),m(d))}return new Promise(d=>{E=setTimeout(()=>{t(0,d)},S),p.on("listening",()=>{t(b,d)}),p.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&I<g?(b++,I++,p.listen(b,"127.0.0.1")):t(0,d)}),p.on("close",()=>{t(0,d)}),p.listen(b,"127.0.0.1")})}e.findFreePortFaster=D;function k(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(g){console.error(g)}}}),define(Z[124],x([0,1,26,7,24]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,k=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var g;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(g||(g={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class E{constructor(c,a,f){this.exePath=c,this.displayName=a,this.knownToExist=f}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function I({useAlternateBitness:l=!1}={}){return l?S===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:l=!1,findPreview:c=!1}={}){const a=I({useAlternateBitness:l});if(!a)return null;const f=n.join(a,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(f))return null;let s=-1,i=null;for(const u of await L.Promises.readdir(f)){let y=-1;if(c){const R=u.indexOf("-");if(R<0)continue;const W=u.substring(0,R);if(!D.test(W)||u.substring(R+1)!=="preview")continue;y=parseInt(W,10)}else{if(!D.test(u))continue;y=parseInt(u,10)}if(y<=s)continue;const P=n.join(f,u,"pwsh.exe");!await L.SymlinkSupport.existsFile(P)||(i=P,s=y)}if(!i)return null;const r=a.includes("x86")?" (x86)":"",o=c?" Preview":"";return new E(i,`PowerShell${o}${r}`,!0)}async function t({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:a,pwshMsixName:f}=l?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const s of await L.Promises.readdir(c))if(a.test(s)){const i=n.join(c,s,"pwsh.exe");return new E(i,f)}return null}function d(){const l=n.join(w.homedir(),".dotnet","tools","pwsh.exe");return new E(l,".NET Core PowerShell Global Tool")}function m(){const l=n.join(process.env.windir,S===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(l,"Windows PowerShell",!0)}async function*v(){let l=await p();l&&(yield l),l=await p({useAlternateBitness:!0}),l&&(yield l),l=await t(),l&&(yield l),l=d(),l&&(yield l),l=await p({findPreview:!0}),l&&(yield l),l=await t({findPreview:!0}),l&&(yield l),l=await p({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=m(),l&&(yield l)}async function*M(){for await(const l of v())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=M;async function h(){for await(const l of M())return l;return null}e.getFirstAvailablePowerShellInstallation=h}),define(Z[87],x([0,1,45,10]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(k){return new Promise((b,g)=>{let S;const C=new Map;function E(p,t,d,m,v){const M=C.get(t);if(p===k||M){const h={name:I(d),cmd:d,pid:p,ppid:t,load:m,mem:v};C.set(p,h),p===k&&(S=h),M&&(M.children||(M.children=[]),M.children.push(h),M.children.length>1&&(M.children=M.children.sort((l,c)=>l.pid-c.pid)))}}function I(p){const t=/--vscode-window-kind=shared-process/,d=/--vscode-window-kind=issue-reporter/,m=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,M=/--crashes-directory/,h=/\\pipe\\winpty-control/,l=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(M.exec(p))return"electron-crash-reporter";if(h.exec(p))return"winpty-process";if(l.exec(p))return"console-window-host (Windows internal process)";let a=c.exec(p);if(a&&a.length===2)return a[1]==="renderer"?t.exec(p)?"shared-process":d.exec(p)?"issue-reporter":m.exec(p)?"process-explorer":"window":a[1]==="utility"&&v.exec(p)?"utility-network-service":a[1];const f=/[a-zA-Z-]+\.js/g;let s="";do a=f.exec(p),a&&(s+=a+" ");while(a);return s&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${s}`:p}if(process.platform==="win32"){const p=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,d)=>{V(["windows-process-tree"],t,d)}).then(t=>{t.getProcessList(k,d=>{t.getProcessCpuUsage(d,m=>{const v=new Map;m.forEach(M=>{const h=p(M.commandLine||"");v.set(M.pid,{name:I(h),cmd:h,pid:M.pid,ppid:M.ppid,load:M.cpu||0,mem:M.memory||0})}),S=v.get(k),S?(v.forEach(M=>{const h=v.get(M.ppid);h&&(h.children||(h.children=[]),h.children.push(M))}),v.forEach(M=>{M.children&&(M.children=M.children.sort((h,l)=>h.pid-l.pid))}),b(S)):g(new Error(`Root process ${k} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let p=function(){let t=[S];const d=[];for(;t.length;){const v=t.shift();v&&(d.push(v.pid),v.children&&(t=t.concat(v.children)))}let m=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);m+=" "+d.join(" "),(0,w.exec)(m,{},(v,M,h)=>{if(v||h)g(v||new Error(h.toString()));else{const l=M.toString().split(`
`);for(let c=0;c<d.length;c++){const a=C.get(d[c]);a.load=parseFloat(l[c])}if(!S){g(new Error(`Root process ${k} not found`));return}b(S)}})};(0,w.exec)("which ps",{},(t,d,m)=>{if(t||m)if(process.platform!=="linux")g(t||new Error(m.toString()));else{const v=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,w.exec)(v,{},(M,h,l)=>{M||l?g(M||new Error(l.toString())):(D(h,E),p())})}else{const v=d.toString().trim(),M="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${v} ${M}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,l,c)=>{h||c&&!c.includes("screen size is bogus")?g(h||new Error(c.toString())):(D(l,E),process.platform==="linux"?p():S?b(S):g(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=L;function D(k,b){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=k.toString().split(`
`);for(const C of S){const E=g.exec(C.trim());E&&E.length===6&&b(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(Z[125],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[126],x([0,1,12,14,125]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){w.ipcMain.on(L.CONTEXT_MENU_CHANNEL,(b,g,S,C,E)=>{const I=k(b,C,S);I.popup({window:(0,n.withNullAsUndefined)(w.BrowserWindow.fromWebContents(b.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{I&&b.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,g)}})})}e.registerContextMenuListener=D;function k(b,g,S){const C=new w.Menu;return S.forEach(E=>{let I;E.type==="separator"?I=new w.MenuItem({type:E.type}):Array.isArray(E.submenu)?I=new w.MenuItem({submenu:k(b,g,E.submenu),label:E.label}):I=new w.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(p,t,d)=>b.sender.send(g,E.id,d)}),C.append(I)}),C}});var ue=this&&this.__decorate||function(V,e,w,n){var L=arguments.length,D=L<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,w):n,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(V,e,w,n);else for(var b=V.length-1;b>=0;b--)(k=V[b])&&(D=(L<3?k(D):L>3?k(e,w,D):k(e,w))||D);return L>3&&D&&Object.defineProperty(e,w,D),D};define(Z[37],x([0,1,30,9,16,23,46,15,4,3,115,27,14]),function(V,e,w,n,L,D,k,b,g,S,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function t($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function m($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(v||(v={}));class M{constructor(q){this.buffer=q,this.pos=0}read(q){const Q=this.buffer.slice(this.pos,this.pos+q);return this.pos+=Q.byteLength,Q}}class h{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var l;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(l||(l={}));function c($){const q=L.VSBuffer.alloc(4);return q.writeUInt32BE($,0),q}function a($){return $.read(4).readUInt32BE(0)}function f($){const q=L.VSBuffer.alloc(1);return q.writeUInt8($,0),q}const s={Undefined:f(l.Undefined),String:f(l.String),Buffer:f(l.Buffer),VSBuffer:f(l.VSBuffer),Array:f(l.Array),Object:f(l.Object)},i=typeof Buffer!="undefined";function r($,q){if(typeof q=="undefined")$.write(s.Undefined);else if(typeof q=="string"){const Q=L.VSBuffer.fromString(q);$.write(s.String),$.write(c(Q.byteLength)),$.write(Q)}else if(i&&Buffer.isBuffer(q)){const Q=L.VSBuffer.wrap(q);$.write(s.Buffer),$.write(c(Q.byteLength)),$.write(Q)}else if(q instanceof L.VSBuffer)$.write(s.VSBuffer),$.write(c(q.byteLength)),$.write(q);else if(Array.isArray(q)){$.write(s.Array),$.write(c(q.length));for(const Q of q)r($,Q)}else{const Q=L.VSBuffer.fromString(JSON.stringify(q));$.write(s.Object),$.write(c(Q.byteLength)),$.write(Q)}}function o($){switch($.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return $.read(a($)).toString();case l.Buffer:return $.read(a($)).buffer;case l.VSBuffer:return $.read(a($));case l.Array:{const Q=a($),z=[];for(let F=0;F<Q;F++)z.push(o($));return z}case l.Object:return JSON.parse($.read(a($)).toString())}}class u{constructor(q,Q,z=null,F=1e3){this.protocol=q,this.ctx=Q,this.logger=z,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(q,Q){this.channels.set(q,Q),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const Q=this.send([q.type]);this.logger?.logOutgoing(Q,0,1,m(q.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(Q,q.id,1,m(q.type),q.data);return}}}send(q,Q=void 0){const z=new h;return r(z,q),r(z,Q),this.sendBuffer(z.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const Q=new M(q),z=o(Q),F=o(Q),N=z[0];switch(N){case 100:return this.logger?.logIncoming(q.byteLength,z[1],1,`${t(N)}: ${z[2]}.${z[3]}`,F),this.onPromise({type:N,id:z[1],channelName:z[2],name:z[3],arg:F});case 102:return this.logger?.logIncoming(q.byteLength,z[1],1,`${t(N)}: ${z[2]}.${z[3]}`,F),this.onEventListen({type:N,id:z[1],channelName:z[2],name:z[3],arg:F});case 101:return this.logger?.logIncoming(q.byteLength,z[1],1,`${t(N)}`),this.disposeActiveRequest({type:N,id:z[1]});case 103:return this.logger?.logIncoming(q.byteLength,z[1],1,`${t(N)}`),this.disposeActiveRequest({type:N,id:z[1]})}}onPromise(q){const Q=this.channels.get(q.channelName);if(!Q){this.collectPendingRequest(q);return}const z=new D.CancellationTokenSource;let F;try{F=Q.call(this.ctx,q.name,q.arg,z.token)}catch(A){F=Promise.reject(A)}const N=q.id;F.then(A=>{this.sendResponse({id:N,data:A,type:201}),this.activeRequests.delete(q.id)},A=>{A instanceof Error?this.sendResponse({id:N,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:N,data:A,type:203}),this.activeRequests.delete(q.id)});const T=(0,S.toDisposable)(()=>z.cancel());this.activeRequests.set(q.id,T)}onEventListen(q){const Q=this.channels.get(q.channelName);if(!Q){this.collectPendingRequest(q);return}const z=q.id,N=Q.listen(this.ctx,q.name,q.arg)(T=>this.sendResponse({id:z,data:T,type:204}));this.activeRequests.set(q.id,N)}disposeActiveRequest(q){const Q=this.activeRequests.get(q.id);Q&&(Q.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let Q=this.pendingRequests.get(q.channelName);Q||(Q=[],this.pendingRequests.set(q.channelName,Q));const z=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:q,timeoutTimer:z})}flushPendingRequests(q){const Q=this.pendingRequests.get(q);if(Q){for(const z of Q)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var y;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class P{constructor(q,Q=null){this.protocol=q,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=Q}getChannel(q){const Q=this;return{call(z,F,N){return Q.isDisposed?Promise.reject(b.canceled()):Q.requestPromise(q,z,F,N)},listen(z,F){return Q.isDisposed?g.Event.None:Q.requestEvent(q,z,F)}}}requestPromise(q,Q,z,F=D.CancellationToken.None){const N=this.lastRequestId++,A={id:N,type:100,channelName:q,name:Q,arg:z};if(F.isCancellationRequested)return Promise.reject(b.canceled());let O;return new Promise((j,ie)=>{if(F.isCancellationRequested)return ie(b.canceled());const ae=()=>{const he=we=>{switch(we.type){case 201:this.handlers.delete(N),j(we.data);break;case 202:{this.handlers.delete(N);const be=new Error(we.data.message);be.stack=we.data.stack,be.name=we.data.name,ie(be);break}case 203:this.handlers.delete(N),ie(we.data);break}};this.handlers.set(N,he),this.sendRequest(A)};let ce=null;this.state===v.Idle?ae():(ce=(0,n.createCancelablePromise)(he=>this.whenInitialized()),ce.then(()=>{ce=null,ae()}));const ne=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:N,type:101}),ie(b.canceled())},le=F.onCancellationRequested(ne);O=(0,S.combinedDisposable)((0,S.toDisposable)(ne),le),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(q,Q,z){const F=this.lastRequestId++,T={id:F,type:102,channelName:q,name:Q,arg:z};let A=null;const O=new g.Emitter({onFirstListenerAdd:()=>{A=(0,n.createCancelablePromise)(j=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(O),this.sendRequest(T)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(O),this.sendRequest({id:F,type:103}))}}),_=j=>O.fire(j.data);return this.handlers.set(F,_),O.event}sendRequest(q){switch(q.type){case 100:case 102:{const Q=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(Q,q.id,0,`${t(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Q=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(Q,q.id,0,t(q.type));return}}}send(q,Q=void 0){const z=new h;return r(z,q),r(z,Q),this.sendBuffer(z.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const Q=new M(q),z=o(Q),F=o(Q),N=z[0];switch(N){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,m(N)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,z[1],0,m(N),F),this.onResponse({type:z[0],id:z[1],data:F})}}onResponse(q){if(q.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const Q=this.handlers.get(q.id);Q&&Q(q)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,S.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ue([k.memoize],P.prototype,"onDidInitializePromise",null),e.ChannelClient=P;class R{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:Q,onDidClientDisconnect:z})=>{g.Event.once(Q.onMessage)(N=>{const T=new M(N),A=o(T),O=new u(Q,A),_=new P(Q);this.channels.forEach((ie,ae)=>O.registerChannel(ae,ie));const j={channelServer:O,channelClient:_,ctx:A};this._connections.add(j),this._onDidAddConnection.fire(j),z(()=>{O.dispose(),_.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const q=[];return this._connections.forEach(Q=>q.push(Q)),q}getChannel(q,Q){const z=this;return{call(F,N,T){let A;if((0,I.isFunction)(Q)){let _=(0,w.getRandomElement)(z.connections.filter(Q));A=_?Promise.resolve(_):g.Event.toPromise(g.Event.filter(z.onDidAddConnection,Q))}else A=Q.routeCall(z,F,N);const O=A.then(_=>_.channelClient.getChannel(q));return U(O).call(F,N,T)},listen(F,N){if((0,I.isFunction)(Q))return z.getMulticastEvent(q,Q,F,N);const T=Q.routeEvent(z,F,N).then(A=>A.channelClient.getChannel(q));return U(T).listen(F,N)}}}getMulticastEvent(q,Q,z,F){const N=this;let T=new S.DisposableStore;const A=new g.Emitter({onFirstListenerAdd:()=>{T=new S.DisposableStore;const O=new g.EventMultiplexer,_=new Map,j=ae=>{const ne=ae.channelClient.getChannel(q).listen(z,F),le=O.add(ne);_.set(ae,le)},ie=ae=>{const ce=_.get(ae);!ce||(ce.dispose(),_.delete(ae))};N.connections.filter(Q).forEach(j),g.Event.filter(N.onDidAddConnection,Q)(j,void 0,T),N.onDidRemoveConnection(ie,void 0,T),O.event(A.fire,A,T),T.add(O)},onLastListenerRemove:()=>{T.dispose()}});return A.event}registerChannel(q,Q){this.channels.set(q,Q),this._connections.forEach(z=>{z.channelServer.registerChannel(q,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class W{constructor(q,Q,z=null){const F=new h;r(F,Q),q.send(F.buffer),this.channelClient=new P(q,z),this.channelServer=new u(q,Q,z)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,Q){this.channelServer.registerChannel(q,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function U($){return{call(q,Q,z){return $.then(F=>F.call(q,Q,z))},listen(q,Q){const z=new g.Relay;return $.then(F=>z.input=F.listen(q,Q)),z.event}}}e.getDelayedChannel=U;function G($){let q=!1;return{call(Q,z,F){return q?$.call(Q,z,F):(0,n.timeout)(0).then(()=>q=!0).then(()=>$.call(Q,z,F))},listen(Q,z){if(q)return $.listen(Q,z);const F=new g.Relay;return(0,n.timeout)(0).then(()=>q=!0).then(()=>F.input=$.listen(Q,z)),F.event}}}e.getNextTickChannel=G;class ee{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const Q of q.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await g.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=ee;var X;(function($){function q(N,T){const A=N,O=T&&T.disableMarshalling,_=new Map;for(const j in A)z(j)&&_.set(j,g.Event.buffer(A[j],!0));return new class{listen(j,ie,ae){const ce=_.get(ie);if(ce)return ce;if(F(ie)){const ne=A[ie];if(typeof ne=="function")return ne.call(A,ae)}throw new Error(`Event not found: ${ie}`)}call(j,ie,ae){const ce=A[ie];if(typeof ce=="function"){if(!O&&Array.isArray(ae))for(let ne=0;ne<ae.length;ne++)ae[ne]=(0,C.revive)(ae[ne]);return ce.apply(A,ae)}throw new Error(`Method not found: ${ie}`)}}}$.fromService=q;function Q(N,T){const A=T&&T.disableMarshalling;return new Proxy({},{get(O,_){if(typeof _=="string")return T?.properties?.has(_)?T.properties.get(_):F(_)?function(j){return N.listen(_,j)}:z(_)?N.listen(_):async function(...j){let ie;T&&!(0,I.isUndefinedOrNull)(T.context)?ie=[T.context,...j]:ie=j;const ae=await N.call(_,ie);return A?ae:(0,C.revive)(ae)};throw new Error(`Property not found: ${String(_)}`)}})}$.toService=Q;function z(N){return N[0]==="o"&&N[1]==="n"&&E.isUpperAsciiLetter(N.charCodeAt(2))}function F(N){return/^onDynamic/.test(N)&&E.isUpperAsciiLetter(N.charCodeAt(9))}})(X=e.ProxyChannel||(e.ProxyChannel={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){let q=$.toString();if(q!=="[object Object]")return q}return $}function B($){return Array.isArray($)?$.map(H):H($)}function Y($,q,Q,z,F,N,T){T=B(T);const A=J[F],O=A[z%A.length];let _=[`%c[${$}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(N)?(_=_.concat(T),_.push(")")):_.push(T),console.log.apply(console,_)}e.logWithColors=Y;class se{constructor(q,Q){this._outgoingPrefix=q,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,Q,z,F,N){this._totalOutgoing+=q,Y(this._outgoingPrefix,this._totalOutgoing,q,Q,z,F,N)}logIncoming(q,Q,z,F,N){this._totalIncoming+=q,Y(this._incomingPrefix,this._totalIncoming,q,Q,z,F,N)}}e.IPCLogger=se}),define(Z[127],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(L,D){this.sender=L,this.onMessage=D}send(L){try{this.sender.send("vscode:message",L.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(Z[128],x([0,1,16,4,37]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class D{constructor(g){this.port=g,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",S=>w.VSBuffer.wrap(S.data)),g.start()}send(g){this.port.postMessage(g.buffer)}disconnect(){this.port.close()}}e.Protocol=D;class k extends L.IPCClient{constructor(g,S){const C=new D(g);super(C,S);this.protocol=C}dispose(){this.protocol.disconnect()}}e.Client=k}),define(Z[88],x([0,1,16,4,3,37]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let o=0;function u(P,R){if(!r.has(P)){const W=String(++o);r.set(P,W)}return r.get(P)}function y(P,R,W,U){if(!i.enableDiagnostics)return;const G=u(P,R);if(U instanceof w.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const ee=w.VSBuffer.alloc(U.byteLength);ee.set(U),i.records.push({timestamp:Date.now(),id:G,label:R,type:W,buff:ee})}else i.records.push({timestamp:Date.now(),id:G,label:R,type:W,data:U})}i.traceSocketEvent=y})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var g;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(g=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function C(){return S||(S=w.VSBuffer.alloc(0)),S}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,o){if(r===0)return C();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const R=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=r),R}if(this._chunks[0].byteLength>r){const R=this._chunks[0].slice(0,r);return o&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),R}let u=w.VSBuffer.alloc(r),y=0,P=0;for(;r>0;){const R=this._chunks[P];if(R.byteLength>r){const W=R.slice(0,r);u.set(W,y),y+=r,o&&(this._chunks[P]=R.slice(r),this._totalLength-=r),r-=r}else u.set(R,y),y+=R.byteLength,o?(this._chunks.shift(),this._totalLength-=R.byteLength):P++,r-=R.byteLength}return u}}e.ChunkStream=E;var I;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(I||(I={}));function p(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,o,u,y){this.type=r,this.id=o,this.ack=u,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends L.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,y=this._state.id,P=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new d(u,y,P,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=w.VSBuffer.alloc(13);o.writeUInt8(r.type,0),o.writeUInt32BE(r.id,1),o.writeUInt32BE(r.ack,5),o.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(o,r.data)}_bufferAdd(r,o){const u=this._totalLength===0;return this._data.push(r,o),this._totalLength+=r.byteLength+o.byteLength,u}_bufferTake(){const r=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,o){this._bufferAdd(r,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class M extends L.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=M;class h extends D.IPCClient{constructor(r,o,u=null){super(r,o,u);this.protocol=r}static fromSocket(r,o){return new h(new M(r),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=h;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class c{constructor(r){this.data=r,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],o=0,u=this._first;for(;u;)r[o++]=u.data,u=u.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const o=new c(r);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class f{constructor(){this.lastRuns=[];const r=Date.now();for(let o=0;o<f._HISTORY_LENGTH;o++)this.lastRuns[o]=r-1e3*o;setInterval(()=>{for(let o=f._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return f._INSTANCE||(f._INSTANCE=new f),f._INSTANCE}load(){const r=Date.now(),o=(1+f._HISTORY_LENGTH)*1e3;let u=0;for(let y=0;y<f._HISTORY_LENGTH;y++)r-this.lastRuns[y]<=o&&u++;return 1-u/f._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}f._HISTORY_LENGTH=10,f._INSTANCE=null;class s{constructor(r,o=null,u=f.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(y=>this._receiveMessage(y))),this._socketDisposables.push(this._socket.onClose(y=>this._onSocketClose.fire(y))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,C());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new d(7,0,0,C());this._socketWriter.write(r)}sendResume(){const r=new d(8,0,0,C());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,o){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,C());this._socketWriter.write(r);const o=this._outgoingUnackMsg.toArray();for(let u=0,y=o.length;u<y;u++)this._socketWriter.write(o[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new d(6,0,0,C())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let u=0,y=o.length;u<y;u++)this._socketWriter.write(o[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new d(1,o,this._incomingAckId,r);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(r){const o=new d(2,0,0,r);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),o=Date.now()-r.writtenTime,u=Date.now()-this._socketReader.lastReadTime,y=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&u>=2e4&&y>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const P=Math.max(2e4-o,2e4-u,2e4-y,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},P)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,C());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(Z[129],x([0,1,12,16,4,3,37,127]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(C,E){const I=L.Event.fromNodeEventEmitter(w.ipcMain,E,(t,d)=>({event:t,message:d})),p=L.Event.filter(I,({event:t})=>t.sender.id===C);return L.Event.map(p,({message:t})=>t&&n.VSBuffer.wrap(t))}class S extends k.IPCServer{constructor(){super(S.getOnDidClientConnect())}static getOnDidClientConnect(){const E=L.Event.fromNodeEventEmitter(w.ipcMain,"vscode:hello",({sender:I})=>I);return L.Event.map(E,I=>{const p=I.id,t=S.Clients.get(p);t&&t.dispose();const d=new L.Emitter;S.Clients.set(p,(0,D.toDisposable)(()=>d.fire()));const m=g(p,"vscode:message"),v=L.Event.any(L.Event.signal(g(p,"vscode:disconnect")),d.event);return{protocol:new b.Protocol(I,m),onDidClientDisconnect:v}})}}e.Server=S,S.Clients=new Map}),define(Z[89],x([0,1,12,4,31,128]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class k extends D.Client{constructor(S,C){super({addEventListener:(E,I)=>S.addListener(E,I),removeEventListener:(E,I)=>S.removeListener(E,I),postMessage:E=>S.postMessage(E),start:()=>S.start(),close:()=>S.close()},C)}}e.Client=k;async function b(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const S=(0,L.generateUuid)();g.webContents.send("vscode:createMessageChannel",S);const C=n.Event.fromNodeEventEmitter(w.ipcMain,"vscode:createMessageChannelResult",(I,p)=>({nonce:p,port:I.ports[0]})),{port:E}=await n.Event.toPromise(n.Event.once(n.Event.filter(C,I=>I.nonce===S)));return E}e.connect=b}),define(Z[90],x([0,1,9,4,3,14]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function b(E){const I=E;return I?.changed instanceof Map||I?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var g;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(g||(g={}));class S extends L.Disposable{constructor(I,p=Object.create(null)){super();this.database=I,this.options=p,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=g.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){I.changed?.forEach((p,t)=>this.accept(t,p)),I.deleted?.forEach(p=>this.accept(p,void 0))}accept(I,p){if(this.state===g.Closed)return;let t=!1;(0,D.isUndefinedOrNull)(p)?t=this.cache.delete(I):this.cache.get(I)!==p&&(this.cache.set(I,p),t=!0),t&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===g.None&&(this.state=g.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,p){const t=this.cache.get(I);return(0,D.isUndefinedOrNull)(t)?p:t}getBoolean(I,p){const t=this.get(I);return(0,D.isUndefinedOrNull)(t)?p:t==="true"}getNumber(I,p){const t=this.get(I);return(0,D.isUndefinedOrNull)(t)?p:parseInt(t,10)}async set(I,p){if(this.state===g.Closed)return;if((0,D.isUndefinedOrNull)(p))return this.delete(I);const t=String(p);if(this.cache.get(I)!==t)return this.cache.set(I,t),this.pendingInserts.set(I,t),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async delete(I){if(!(this.state===g.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=g.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(I){if(!!this.hasPending)return this.doFlush(I)}async doFlush(I){return this.flushDelayer.trigger(()=>this.flushPending(),I)}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((p,t)=>this.items.set(t,p)),I.delete&&I.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=C}),define(Z[130],x([0,1,9,4,35,7,24,2]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class g{constructor(E,I=Object.create(null)){this.path=E,this.options=I,this.name=(0,D.basename)(this.path),this.logger=new S(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const E=await this.whenConnected,I=new Map;return(await this.all(E,"SELECT * FROM ItemTable")).forEach(t=>I.set(t.key,t.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(E){const I=await this.whenConnected;return this.doUpdateItems(I,E)}doUpdateItems(E,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,L.mapToString)(I.insert):"0"}), delete(${I.delete?(0,L.setToString)(I.delete):"0"})`),this.transaction(E,()=>{const p=I.insert,t=I.delete;if(p&&p.size>0){const d=[];d.push([]);let m=0;p.forEach((v,M)=>{let h=d[m];h.length>g.MAX_HOST_PARAMETERS&&(m++,h=[],d.push(h)),h.push(M,v)}),d.forEach(v=>{this.prepare(E,`INSERT INTO ItemTable VALUES ${new Array(v.length/2).fill("(?,?)").join(",")}`,M=>M.run(v),()=>{const M=[];let h=0;return p.forEach((l,c)=>{M.push(c),h+=l.length}),`Keys: ${M.join(", ")} Length: ${h}`})})}if(t&&t.size){const d=[];d.push([]);let m=0;t.forEach(v=>{let M=d[m];M.length>g.MAX_HOST_PARAMETERS&&(m++,M=[],d.push(M)),M.push(v)}),d.forEach(v=>{this.prepare(E,`DELETE FROM ItemTable WHERE key IN (${new Array(v.length).fill("?").join(",")})`,M=>M.run(v),()=>{const M=[];return t.forEach(h=>{M.push(h)}),`Keys: ${M.join(", ")}`})})}})}async close(E){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,E)}doClose(E,I){return new Promise((p,t)=>{E.db.close(d=>(d&&this.handleSQLiteError(E,`[storage ${this.name}] close(): ${d}`),this.path===g.IN_MEMORY_PATH?p():!E.isErroneous&&!E.isInMemory?this.backup().then(p,m=>(this.logger.error(`[storage ${this.name}] backup(): ${m}`),p())):typeof I=="function"?k.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(m=>{const v=()=>this.doClose(m,void 0);return this.doUpdateItems(m,{insert:I()}).then(()=>v(),M=>(v(),Promise.reject(M)))})).then(p,t):t(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const E=this.toBackupPath(this.path);return k.Promises.copy(this.path,E,{preserveSymlinks:!1})}toBackupPath(E){return`${E}.backup`}async checkIntegrity(E){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${E})`);const I=await this.whenConnected,p=await this.get(I,E?"PRAGMA integrity_check":"PRAGMA quick_check"),t=E?p.integrity_check:p.quick_check;return I.isErroneous?`${t} (last error: ${I.lastError})`:I.isInMemory?`${t} (in-memory!)`:t}async connect(E,I=!0){this.logger.trace(`[storage ${this.name}] open(${E}, retryOnBusy: ${I})`),this.logger.trace(`[storage ${this.name}] open - source: ${new Error().stack}`);try{return await this.doConnect(E)}catch(p){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&I)return await(0,w.timeout)(g.BUSY_OPEN_TIMEOUT),this.connect(E,!1);try{await k.Promises.unlink(E);try{await k.Promises.rename(this.toBackupPath(E),E)}catch{}return await this.doConnect(E)}catch(t){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${t}`),this.doConnect(g.IN_MEMORY_PATH)}}}handleSQLiteError(E,I){E.isErroneous=!0,E.lastError=I,this.logger.error(I)}doConnect(E){return new Promise((I,p)=>{new Promise((t,d)=>{V(["@vscode/sqlite3"],t,d)}).then(t=>{const d={db:new(this.logger.isTracing?t.verbose().Database:t.Database)(E,m=>m?d.db?d.db.close(()=>p(m)):p(m):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(d),v=>d.db.close(()=>p(v)))),isInMemory:E===g.IN_MEMORY_PATH};d.db.on("error",m=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${m}`)),this.logger.isTracing&&d.db.on("trace",m=>this.logger.trace(`[storage ${this.name}] Trace (event): ${m}`))},p)})}exec(E,I){return new Promise((p,t)=>{E.db.exec(I,d=>d?(this.handleSQLiteError(E,`[storage ${this.name}] exec(): ${d}`),t(d)):p())})}get(E,I){return new Promise((p,t)=>{E.db.get(I,(d,m)=>d?(this.handleSQLiteError(E,`[storage ${this.name}] get(): ${d}`),t(d)):p(m))})}all(E,I){return new Promise((p,t)=>{E.db.all(I,(d,m)=>d?(this.handleSQLiteError(E,`[storage ${this.name}] all(): ${d}`),t(d)):p(m))})}transaction(E,I){return new Promise((p,t)=>{E.db.serialize(()=>{E.db.run("BEGIN TRANSACTION"),I(),E.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(E,`[storage ${this.name}] transaction(): ${d}`),t(d)):p())})})}prepare(E,I,p,t){const d=E.db.prepare(I),m=v=>{this.handleSQLiteError(E,`[storage ${this.name}] prepare(): ${v} (${I}). Details: ${t()}`)};d.on("error",m),p(d),d.finalize(v=>{v&&m(v),d.removeListener("error",m)})}}e.SQLiteStorageDatabase=g,g.IN_MEMORY_PATH=":memory:",g.BUSY_OPEN_TIMEOUT=2e3,g.MAX_HOST_PARAMETERS=256;class S{constructor(E){E&&typeof E.logTrace=="function"&&(process.env[S.VSCODE_TRACE_STORAGE]||b.isCI)&&(this.logTrace=E.logTrace),E&&typeof E.logError=="function"&&(this.logError=E.logError)}get isTracing(){return!!this.logTrace}trace(E){this.logTrace&&this.logTrace(E)}error(E){this.logError&&this.logError(E)}}S.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[131],x([13,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(Z[132],x([0,1,131]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,L=n*60,D=L*24,k=D*7,b=D*30,g=D*365;function S(E,I,p){typeof E!="number"&&(E=E.getTime());const t=Math.round((new Date().getTime()-E)/1e3);if(t<-30)return(0,w.localize)(0,null,S(new Date().getTime()+t*1e3,!1));if(t<30)return(0,w.localize)(1,null);let d;return t<n?(d=t,I?d===1?p?(0,w.localize)(2,null,d):(0,w.localize)(3,null,d):p?(0,w.localize)(4,null,d):(0,w.localize)(5,null,d):d===1?p?(0,w.localize)(6,null,d):(0,w.localize)(7,null,d):p?(0,w.localize)(8,null,d):(0,w.localize)(9,null,d)):t<L?(d=Math.floor(t/n),I?d===1?p?(0,w.localize)(10,null,d):(0,w.localize)(11,null,d):p?(0,w.localize)(12,null,d):(0,w.localize)(13,null,d):d===1?p?(0,w.localize)(14,null,d):(0,w.localize)(15,null,d):p?(0,w.localize)(16,null,d):(0,w.localize)(17,null,d)):t<D?(d=Math.floor(t/L),I?d===1?p?(0,w.localize)(18,null,d):(0,w.localize)(19,null,d):p?(0,w.localize)(20,null,d):(0,w.localize)(21,null,d):d===1?p?(0,w.localize)(22,null,d):(0,w.localize)(23,null,d):p?(0,w.localize)(24,null,d):(0,w.localize)(25,null,d)):t<k?(d=Math.floor(t/D),I?d===1?(0,w.localize)(26,null,d):(0,w.localize)(27,null,d):d===1?(0,w.localize)(28,null,d):(0,w.localize)(29,null,d)):t<b?(d=Math.floor(t/k),I?d===1?p?(0,w.localize)(30,null,d):(0,w.localize)(31,null,d):p?(0,w.localize)(32,null,d):(0,w.localize)(33,null,d):d===1?p?(0,w.localize)(34,null,d):(0,w.localize)(35,null,d):p?(0,w.localize)(36,null,d):(0,w.localize)(37,null,d)):t<g?(d=Math.floor(t/b),I?d===1?p?(0,w.localize)(38,null,d):(0,w.localize)(39,null,d):p?(0,w.localize)(40,null,d):(0,w.localize)(41,null,d):d===1?p?(0,w.localize)(42,null,d):(0,w.localize)(43,null,d):p?(0,w.localize)(44,null,d):(0,w.localize)(45,null,d)):(d=Math.floor(t/g),I?d===1?p?(0,w.localize)(46,null,d):(0,w.localize)(47,null,d):p?(0,w.localize)(48,null,d):(0,w.localize)(49,null,d):d===1?p?(0,w.localize)(50,null,d):(0,w.localize)(51,null,d):p?(0,w.localize)(52,null,d):(0,w.localize)(53,null,d))}e.fromNow=S;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(Z[133],x([13,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(Z[39],x([0,1,30,14,133]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(E,I){return I&&(E.stack||E.stacktrace)?L.localize(0,null,b(E),k(E.stack)||k(E.stacktrace)):b(E)}function k(E){return Array.isArray(E)?E.join(`
`):E}function b(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function g(E=null,I=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const p=w.coalesce(E),t=g(p[0],I);return p.length>1?L.localize(4,null,t,p.length):t}if(n.isString(E))return E;if(E.detail){const p=E.detail;if(p.error)return D(p.error,I);if(p.exception)return D(p.exception,I)}return E.stack?D(E,I):E.message?E.message:L.localize(5,null)}e.toErrorMessage=g;function S(E){const I=E;return I instanceof Error&&Array.isArray(I.actions)}e.isErrorWithActions=S;function C(E,I=Object.create(null)){const p=new Error(E);return I.actions&&(p.actions=I.actions),p}e.createErrorWithActions=C}),define(Z[134],x([13,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(Z[135],x([0,1,134]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(k,b,g=b){this.modifierLabels=[null],this.modifierLabels[2]=k,this.modifierLabels[1]=b,this.modifierLabels[3]=g}toLabel(k,b,g){if(b.length===0)return null;const S=[];for(let C=0,E=b.length;C<E;C++){const I=b[C],p=g(I);if(p===null)return null;S[C]=L(I,p,this.modifierLabels[k])}return S.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:w.localize(0,null),shiftKey:w.localize(1,null),altKey:w.localize(2,null),metaKey:w.localize(3,null),separator:"+"},{ctrlKey:w.localize(4,null),shiftKey:w.localize(5,null),altKey:w.localize(6,null),metaKey:w.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:w.localize(8,null),shiftKey:w.localize(9,null),altKey:w.localize(10,null),metaKey:w.localize(11,null),separator:"+"},{ctrlKey:w.localize(12,null),shiftKey:w.localize(13,null),altKey:w.localize(14,null),metaKey:w.localize(15,null),separator:"+"},{ctrlKey:w.localize(16,null),shiftKey:w.localize(17,null),altKey:w.localize(18,null),metaKey:w.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function L(D,k,b){if(k===null)return"";const g=[];return D.ctrlKey&&g.push(b.ctrlKey),D.shiftKey&&g.push(b.shiftKey),D.altKey&&g.push(b.altKey),D.metaKey&&g.push(b.metaKey),k!==""&&g.push(k),g.join(b.separator)}}),define(Z[136],x([13,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(Z[72],x([0,1,45,28,10,49,7,2,36,84,14,120,24,136]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return S.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return S.TerminateResponseCode}});function t(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(a,f){if(b.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};f&&(s.cwd=f);const i=w.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],s);return new Promise(r=>{i.once("error",o=>{r({success:!1,error:o})}),i.once("exit",(o,u)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(b.isLinux||b.isMacintosh)try{const s=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(i=>{w.execFile(s,[a.pid.toString()],{encoding:"utf8",shell:!0},(r,o,u)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function m(a){!a||(delete a.DEBUG,b.isMacintosh&&delete a.DYLD_LIBRARY_PATH,b.isLinux&&delete a.LD_PRELOAD)}e.removeDangerousEnvVariables=m;function v(a=g.env){return a.comspec||"cmd.exe"}e.getWindowsShell=v;class M{constructor(f,s,i,r){if(s!==void 0&&i!==void 0&&r!==void 0)this.cmd=f,this.args=s,this.shell=i,this.options=r;else{const o=f;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(g.env).forEach(u=>{o[u]=g.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let f=this.cmd.toLowerCase();const s=f.lastIndexOf(k.sep);return s!==-1&&(f=f.substring(s+1)),M.WellKnowCommands[f]?f:"other"}start(f){return b.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(g.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(s=>{let i,r;const o=new Promise((u,y)=>{i=u,r=y});if(s){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=w.exec(u,this.options,(y,P,R)=>{this.childProcess=null;const W=y;W&&W.killed?r({killed:this.terminateRequested,stdout:P.toString(),stderr:R.toString()}):this.handleExec(i,f,y,P,R)})}else{let u=null;const y=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,i,f,r);const R={terminated:this.terminateRequested};C.isNumber(P)&&(R.cmdCode=P),i(R)};if(this.shell&&b.isWindows){const P=D.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let R=!1,W=!1;const U=[];let G=this.ensureQuotes(this.cmd);U.push(G.value),R=G.quoted,this.args&&this.args.forEach(X=>{G=this.ensureQuotes(X),U.push(G.value),W=W&&G.quoted});const ee=["/s","/c"];R?W?ee.push('"'+U.join(" ")+'"'):U.length>1?ee.push('"'+U[0]+'" '+U.slice(1).join(" ")):ee.push('"'+U[0]+'"'):ee.push(U.join(" ")),u=w.spawn(v(),ee,P)}else this.cmd&&(u=w.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(C.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",P=>{this.childProcess=null,r({terminated:this.terminateRequested,error:P})}),u.pid&&(this.childProcess.on("close",y),this.handleSpawn(u,i,f,r,!0)))}return o})}handleClose(f,s,i,r){}ensureQuotes(f){return M.regexp.test(f)?{value:'"'+f+'"',quoted:!0}:{value:f,quoted:f.length>0&&f[0]==='"'&&f[f.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(f=>f.pid,f=>-1):new Promise(f=>{this.pidResolve=f})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(f=>(this.terminateRequested=!0,d(f,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),f=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(f=>{if(!this.shell||!b.isWindows)return f(!1);const s=w.spawn(v(),["/s","/c"]);s.on("error",i=>f(!0)),s.on("exit",i=>f(!1))})}}e.AbstractProcess=M,M.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},M.regexp=/^[^"].* .*[^"]/;class h extends M{constructor(f,s,i,r){super(f,s,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(f,s,i,r,o){[r,o].forEach((u,y)=>{const P=new E.LineDecoder;P.write(u).forEach(U=>{s({line:U,source:y===0?0:1})});const W=P.end();W&&s({line:W,source:y===0?0:1})}),f({terminated:this.terminateRequested,error:i})}handleSpawn(f,s,i,r,o){const u=new E.LineDecoder,y=new E.LineDecoder;f.stdout.on("data",P=>{u.write(P).forEach(W=>i({line:W,source:0}))}),f.stderr.on("data",P=>{y.write(P).forEach(W=>i({line:W,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=y}handleClose(f,s,i,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&i({line:u,source:1})}}e.LineProcess=h;function l(a){let f=[],s=!1;const i=function(r){if(s){f.push(r);return}(!a.send(r,u=>{if(u&&console.error(u),s=!1,f.length>0){const y=f.slice(0);f=[],y.forEach(P=>i(P))}})||b.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=l;var c;(function(a){async function f(s,i,r){if(k.isAbsolute(s))return s;if(i===void 0&&(i=g.cwd()),k.dirname(s)!=="."||(r===void 0&&C.isString(g.env.PATH)&&(r=g.env.PATH.split(k.delimiter)),r===void 0||r.length===0))return k.join(i,s);async function u(y){if(await I.Promises.exists(y)){let P;try{P=await I.Promises.stat(y)}catch(R){R.message.startsWith("EACCES")&&(P=await I.Promises.lstat(y))}return P?!P.isDirectory():!1}return!1}for(let y of r){let P;if(k.isAbsolute(y)?P=k.join(y,s):P=k.join(i,y,s),await u(P))return P;let R=P+".com";if(await u(R)||(R=P+".exe",await u(R)))return R}return k.join(i,s)}a.findExecutable=f})(c=e.win32||(e.win32={}))}),define(Z[137],x([0,1,26,2,124,72]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(p,t){return p===1?n.isWindows?E():D.getWindowsShell(t):S(p,t)}e.getSystemShell=k;function b(p,t){return p===1?n.isWindows?I(t):D.getWindowsShell(t):S(p,t)}e.getSystemShellSync=b;let g=null;function S(p,t){if(n.isLinux&&p===2||n.isMacintosh&&p===3)return"/bin/bash";if(!g){let d;if(n.isWindows)d="/bin/bash";else{if(d=t.SHELL,!d)try{d=(0,w.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}g=d}return g}let C=null;async function E(){return C||(C=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),C}function I(p){if(C)return C;const t=n.isWindows&&parseFloat((0,w.release)())>=10,d=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${p.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?m:D.getWindowsShell(p)}}),define(Z[138],x([0,1,45,9,16,23,114,15,4,3,49,72,37]),function(V,e,w,n,L,D,k,b,g,S,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends I.ChannelServer{constructor(m){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",v=>L.VSBuffer.wrap(Buffer.from(v,"base64")))},m);process.once("disconnect",()=>this.dispose())}}e.Server=p;class t{constructor(m,v){this.modulePath=m,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new g.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const M=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new n.Delayer(M),this.child=null,this._client=null}getChannel(m){const v=this;return{call(M,h,l){return v.requestPromise(m,M,h,l)},listen(M,h){return v.requestEvent(m,M,h)}}}requestPromise(m,v,M,h=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(m),c=(0,n.createCancelablePromise)(s=>l.call(v,M,s)),a=h.onCancellationRequested(()=>c.cancel()),f=(0,S.toDisposable)(()=>c.cancel());return this.activeRequests.add(f),c.finally(()=>{a.dispose(),this.activeRequests.delete(f),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(m,v,M){if(!this.disposeDelayer)return g.Event.None;this.disposeDelayer.cancel();let h;const l=new g.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(m).listen(v,M)(l.fire,l),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,E.removeDangerousEnvVariables)(v.env),this.child=(0,w.fork)(this.modulePath,m,v);const M=new g.Emitter;g.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,k.isRemoteConsoleLog)(i)){(0,k.log)(i,`IPC Library: ${this.options.serverName}`);return}M.fire(L.VSBuffer.wrap(Buffer.from(i,"base64")))});const l=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,c=i=>this.child&&this.child.connected&&l.send(i.buffer.toString("base64")),a=M.event,f={send:c,onMessage:a};this._client=new I.ChannelClient(f);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(o=>(0,S.dispose)(o)),this.activeRequests.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:r})})}return this._client}getCachedChannel(m){let v=this.channels.get(m);return v||(v=this.client.getChannel(m),this.channels.set(m,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Z[139],x([13,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(Z[140],x([13,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[141],x([13,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[142],x([13,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(Z[143],x([13,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(Z[144],x([13,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[145],x([13,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(Z[146],x([13,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(Z[147],x([13,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(Z[148],x([13,11]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[149],x([13,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[150],x([13,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[151],x([13,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[152],x([13,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[153],x([13,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(Z[154],x([13,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[155],x([13,11]),function(V,e){return V.create("vs/platform/terminal/node/shellEnv",e)}),define(Z[156],x([13,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[157],x([13,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(Z[158],x([13,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[159],x([13,11]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(Z[160],x([13,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[161],x([13,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[162],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function w(L){return L&&L.hasOwnProperty("folderUri")}e.isFolderBackupInfo=w;function n(L){return L&&L.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=n}),define(Z[163],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function w(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=w}),define(Z[164],x([0,1,4,3]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class L{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(b,g,S){switch(g){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:S[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:S[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:S[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:S[0],port:S[1],subId:S[2]}))}throw new Error("Method not implemented.")}listen(b,g,S){switch(g){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=L,L.ChannelName="extensionhostdebugservice";class D extends n.Disposable{constructor(b){super();this.channel=b}reload(b){this.channel.call("reload",[b])}get onReload(){return this.channel.listen("reload")}close(b){this.channel.call("close",[b])}get onClose(){return this.channel.listen("close")}attachSession(b,g,S){this.channel.call("attach",[b,g,S])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(b,g){this.channel.call("terminate",[b,g])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(b,g){return this.channel.call("openExtensionDevelopmentHostWindow",[b,g])}}e.ExtensionHostDebugChannelClient=D}),define(Z[165],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class w{constructor(k){this.driver=k}listen(k,b){throw new Error(`No event found: ${b}`)}call(k,b,g){switch(b){case"click":return this.driver.click(g[0],g[1],g[2]);case"doubleClick":return this.driver.doubleClick(g);case"setValue":return this.driver.setValue(g[0],g[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(g);case"getElements":return this.driver.getElements(g[0],g[1]);case"getElementXY":return this.driver.getElementXY(g[0],g[1],g[2]);case"typeInEditor":return this.driver.typeInEditor(g[0],g[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(g);case"writeInTerminal":return this.driver.writeInTerminal(g[0],g[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${b}`)}}e.WindowDriverChannel=w;class n{constructor(k){this.channel=k}click(k,b,g){return this.channel.call("click",[k,b,g])}doubleClick(k){return this.channel.call("doubleClick",k)}setValue(k,b){return this.channel.call("setValue",[k,b])}getTitle(){return this.channel.call("getTitle")}isActiveElement(k){return this.channel.call("isActiveElement",k)}getElements(k,b){return this.channel.call("getElements",[k,b])}getElementXY(k,b,g){return this.channel.call("getElementXY",[k,b,g])}typeInEditor(k,b){return this.channel.call("typeInEditor",[k,b])}getTerminalBuffer(k){return this.channel.call("getTerminalBuffer",k)}writeInTerminal(k,b){return this.channel.call("writeInTerminal",[k,b])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class L{constructor(k){this.channel=k}registerWindowDriver(k){return this.channel.call("registerWindowDriver",k)}reloadWindowDriver(k){return this.channel.call("reloadWindowDriver",k)}}e.WindowDriverRegistryChannelClient=L}),define(Z[166],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class w{constructor(L){this.machineId=L}encryption(){return new Promise((L,D)=>V(["vscode-encrypt"],L,D))}async encrypt(L){try{return(await this.encryption()).encrypt(this.machineId,L)}catch{return L}}async decrypt(L){try{return(await this.encryption()).decrypt(this.machineId,L)}catch{return L}}}e.EncryptionMainService=w}),define(Z[167],x([0,1,132,46,10,7,36,17,8]),function(V,e,w,n,L,D,k,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class S{constructor(d,m,v){this._args=d,this.paths=m,this.productService=v}get appRoot(){return(0,D.dirname)(L.FileAccess.asFileUri("",V).fsPath)}get userHome(){return g.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return g.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.paths.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(g.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return g.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return g.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=k.env.VSCODE_PORTABLE;return d?g.URI.file((0,D.join)(d,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,b.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,D.resolve)(d):(0,D.normalize)((0,D.join)(L.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,D.resolve)(d):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,D.resolve)(d);const m=k.env.VSCODE_EXTENSIONS;if(m)return m;const v=k.env.VSCODE_PORTABLE;return v?(0,D.join)(v,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?g.URI.parse(m):g.URI.file((0,D.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?g.URI.parse(d):g.URI.file((0,D.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return g.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([n.memoize],S.prototype,"appRoot",null),ue([n.memoize],S.prototype,"userHome",null),ue([n.memoize],S.prototype,"userDataPath",null),ue([n.memoize],S.prototype,"appSettingsHome",null),ue([n.memoize],S.prototype,"tmpDir",null),ue([n.memoize],S.prototype,"cacheHome",null),ue([n.memoize],S.prototype,"userRoamingDataHome",null),ue([n.memoize],S.prototype,"settingsResource",null),ue([n.memoize],S.prototype,"userDataSyncHome",null),ue([n.memoize],S.prototype,"userDataSyncLogResource",null),ue([n.memoize],S.prototype,"sync",null),ue([n.memoize],S.prototype,"machineSettingsResource",null),ue([n.memoize],S.prototype,"globalStorageHome",null),ue([n.memoize],S.prototype,"workspaceStorageHome",null),ue([n.memoize],S.prototype,"keybindingsResource",null),ue([n.memoize],S.prototype,"keyboardLayoutResource",null),ue([n.memoize],S.prototype,"argvResource",null),ue([n.memoize],S.prototype,"snippetsHome",null),ue([n.memoize],S.prototype,"isExtensionDevelopment",null),ue([n.memoize],S.prototype,"untitledWorkspacesHome",null),ue([n.memoize],S.prototype,"installSourcePath",null),ue([n.memoize],S.prototype,"builtinExtensionsPath",null),ue([n.memoize],S.prototype,"extensionsPath",null),ue([n.memoize],S.prototype,"extensionDevelopmentLocationURI",null),ue([n.memoize],S.prototype,"extensionDevelopmentKind",null),ue([n.memoize],S.prototype,"extensionTestsLocationURI",null),ue([n.memoize],S.prototype,"debugExtensionHost",null),ue([n.memoize],S.prototype,"serviceMachineIdResource",null),ue([n.memoize],S.prototype,"telemetryLogResource",null),ue([n.memoize],S.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=S;function C(t,d){return p(t["inspect-extensions"],t["inspect-brk-extensions"],5870,d,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=C;function E(t,d){return p(t["inspect-search"],t["inspect-brk-search"],5876,d,t.extensionEnvironment)}e.parseSearchPort=E;function I(t,d){return p(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,d,t.extensionEnvironment)}e.parsePtyHostPort=I;function p(t,d,m,v,M,h){const c=Number(d||t)||(v?null:m),a=c?Boolean(!!d):!1;let f;if(h)try{f=JSON.parse(h)}catch{}return{port:c,break:a,debugId:M,env:f}}}),define(Z[91],x([0,1,250,2,142]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function b(t,d,m=k){const v={},M=[],h=[];for(let f in d){const s=d[f];s.alias&&(v[f]=s.alias),s.type==="string"||s.type==="string[]"?(M.push(f),s.deprecates&&M.push(...s.deprecates)):s.type==="boolean"&&(h.push(f),s.deprecates&&h.push(...s.deprecates))}const l=w(t,{string:M,boolean:h,alias:v}),c={},a=l;c._=l._.map(f=>String(f)).filter(f=>f.length>0),delete a._;for(let f in d){const s=d[f];s.alias&&delete a[s.alias];let i=a[f];if(s.deprecates)for(const r of s.deprecates)a.hasOwnProperty(r)&&(i||(i=a[r],i&&m.onDeprecatedOption(r,s.deprecationMessage||(0,L.localize)(33,null))),delete a[r]);typeof i!="undefined"&&(s.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):s.type==="string"&&Array.isArray(i)&&(i=i.pop(),m.onMultipleValues(f,i)),c[f]=i,s.deprecationMessage&&m.onDeprecatedOption(f,s.deprecationMessage)),delete a[f]}for(let f in a)m.onUnknownOption(f);return c}e.parseArgs=b;function g(t,d){let m="";return d.args&&(Array.isArray(d.args)?m=` <${d.args.join("> <")}>`:m=` <${d.args}>`),d.alias?`-${d.alias} --${t}${m}`:`--${t}${m}`}function S(t,d){let m=0,v=[];for(const c in t){const a=t[c],f=g(c,a);m=Math.max(m,f.length),v.push([f,a.description])}let M=m+2+1;if(d-M<25)return v.reduce((c,a)=>c.concat([`  ${a[0]}`,`      ${a[1]}`]),[]);let h=d-M-1,l=[];for(const c of v){let a=c[0],f=E(c[1],h),s=C(M-a.length-2);l.push("  "+a+s+f[0]);for(let i=1;i<f.length;i++)l.push(C(M)+f[i])}return l}e.formatOptions=S;function C(t){return" ".repeat(t)}function E(t,d){let m=[];for(;t.length;){let v=t.length<d?t.length:t.lastIndexOf(" ",d),M=t.slice(0,v).trim();t=t.slice(v),m.push(M)}return m}function I(t,d,m,v,M){const h=process.stdout.isTTY&&process.stdout.columns||80,l=M?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",c=[`${t} ${m}`];c.push(""),c.push(`${(0,L.localize)(35,null)}: ${d} [${(0,L.localize)(36,null)}]${l}`),c.push(""),M?.noPipe!==!0&&(n.isWindows?c.push((0,L.localize)(37,null,d)):c.push((0,L.localize)(38,null,d)),c.push(""));const a={};for(const f in v){const s=v[f];if(s.description&&s.cat){let i=a[s.cat];i||(a[s.cat]=i={}),i[f]=s}}for(let f in a){const s=f;let i=a[s];i&&(c.push(D[s]),c.push(...S(i,h)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=I;function p(t,d){return`${t||(0,L.localize)(39,null)}
${d||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=p}),define(Z[168],x([0,1,61,164,91]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class D extends n.ExtensionHostDebugBroadcastChannel{constructor(b){super();this.windowsMainService=b}call(b,g,S){return g==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(S[0],S[1]):super.call(b,g,S)}async openExtensionDevelopmentHostWindow(b,g){const S=(0,L.parseArgs)(b,L.OPTIONS);S.debugRenderer=g;const C=S.extensionDevelopmentPath;if(!C)return{success:!1};const[E]=this.windowsMainService.openExtensionDevelopmentHostWindow(C,{context:5,cli:S});if(!g)return{success:!0};const I=E.win;if(!I)return{success:!0};const p=I.webContents.debugger;let t=p.isAttached()?1/0:0;const d=(0,w.createServer)(m=>{t++==0&&p.attach();let v=!1;const M=c=>{v||m.write(JSON.stringify(c)+"\0")},h=(c,a,f,s)=>M({method:a,params:f,sessionId:s});I.on("close",()=>{p.removeListener("message",h),m.end(),v=!0}),p.addListener("message",h);let l=Buffer.alloc(0);m.on("data",c=>{l=Buffer.concat([l,c]);for(let a=l.indexOf(0);a!==-1;a=l.indexOf(0)){let f;try{const s=l.slice(0,a).toString("utf8");l=l.slice(a+1),f=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}p.sendCommand(f.method,f.params,f.sessionId).then(s=>M({id:f.id,sessionId:f.sessionId,result:s})).catch(s=>M({id:f.id,sessionId:f.sessionId,error:{code:0,message:s.message}}))}}),m.on("error",c=>{console.error("error on cdp pipe:",c)}),m.on("close",()=>{v=!0,--t==0&&p.detach()})});return await new Promise(m=>d.listen(0,m)),I.on("close",()=>d.close()),{rendererDebugPort:d.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=D}),define(Z[50],x([0,1,251,143,91]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const D=2048;function k(I,p){const t={onUnknownOption:m=>{console.warn((0,n.localize)(0,null,m))},onMultipleValues:(m,v)=>{console.warn((0,n.localize)(1,null,m,v))},onDeprecatedOption:(m,v)=>{console.warn((0,n.localize)(2,null,m,v))}},d=(0,L.parseArgs)(I,L.OPTIONS,p?t:void 0);return d.goto&&d._.forEach(m=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(m),(0,n.localize)(3,null))),d["max-memory"]&&w(parseInt(d["max-memory"])>=D,`The max-memory argument cannot be specified lower than ${D} MB.`),d}function b(I){const p=I.findIndex(t=>!/^-/.test(t));if(p>-1)return[...I.slice(0,p),...I.slice(p+1)]}function g(I){let[,...p]=I;process.env.VSCODE_DEV&&(p=b(p)||[]);const t=!E(process.env);return k(p,t)}e.parseMainProcessArgv=g;function S(I){const[,,...p]=I;return k(p,!0)}e.parseCLIProcessArgv=S;function C(I,...p){const t=I.indexOf("--");return t===-1?I.push(...p):I.splice(t,0,...p),I}e.addArg=C;function E(I){return I.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function V(e,w,n,L){function D(b){const g=k(b),S=[g];return e.isAbsolute(g)||S.unshift(L),e.resolve(...S)}function k(b){const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,n);const C=b["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(E,"AppData","Roaming")}break;case"darwin":S=e.join(w.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,n)}return{getUserDataPath:D}}if(typeof define=="function")define(Z[169],x([0,252,26,10,17,36]),function(e,w,n,L,D,k){const b=D.dirname(L.FileAccess.asFileUri("",e)),g=e.__$__nodeRequire(D.joinPath(b,"package.json").fsPath);return V(w,n,g.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),n=require("os");module.exports=V(w,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[170],x([0,1,26,167,169]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends n.AbstractNativeEnvironmentService{constructor(b,g){super(b,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,L.getUserDataPath)(b)},g)}}e.NativeEnvironmentService=D}),define(Z[171],x([0,1,29,26,28]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function D(k){const b=(0,L.randomPath)((0,n.tmpdir)());try{return(0,w.writeFileSync)(b,""),k&&console.log(`Marker file for --wait created: ${b}`),b}catch(g){k&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFile=D}),define(Z[172],x([0,1,16,31]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(D,k,b){let g=b&&b.get("storage.serviceMachineId",0)||null;if(g)return g;try{const C=(await k.readFile(D.serviceMachineIdResource)).value.toString();g=(0,n.isUUID)(C)?C:null}catch{g=null}if(!g){g=(0,n.generateUuid)();try{await k.writeFile(D.serviceMachineIdResource,w.VSBuffer.fromString(g))}catch{}}return b&&b.store("storage.serviceMachineId",g,0,1),g}e.getServiceMachineId=L}),define(Z[73],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(L,D=[],k=!1){this.ctor=L,this.staticArguments=D,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=w}),define(Z[173],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=w;class n{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let k of this._nodes.values())k.outgoing.size===0&&D.push(k);return D}insertEdge(D,k){const b=this.lookupOrInsertNode(D),g=this.lookupOrInsertNode(k);b.outgoing.set(this._hashFn(k),g),g.incoming.set(this._hashFn(D),b)}removeNode(D){const k=this._hashFn(D);this._nodes.delete(k);for(let b of this._nodes.values())b.outgoing.delete(k),b.incoming.delete(k)}lookupOrInsertNode(D){const k=this._hashFn(D);let b=this._nodes.get(k);return b||(b=new w(D),this._nodes.set(k,b)),b}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[k,b]of this._nodes)D.push(`${k}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,k]of this._nodes){const b=new Set([D]),g=this._findCycle(k,b);if(g)return g}}_findCycle(D,k){for(let[b,g]of D.outgoing){if(k.has(b))return[...k,b].join(" -> ");k.add(b);const S=this._findCycle(g,k);if(S)return S;k.delete(b)}}}e.Graph=n}),define(Z[5],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function b(g){return g[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=b})(w=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function n(k,b,g){b[w.DI_TARGET]===b?b[w.DI_DEPENDENCIES].push({id:k,index:g}):(b[w.DI_DEPENDENCIES]=[{id:k,index:g}],b[w.DI_TARGET]=b)}function L(k){if(w.serviceIds.has(k))return w.serviceIds.get(k);const b=function(g,S,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(b,g,C)};return b.toString=()=>k,w.serviceIds.set(k,b),b}e.createDecorator=L;function D(k){return k}e.refineServiceDecorator=D}),define(Z[51],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService")}),define(Z[19],x([0,1,14,8,5]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function D(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof n.URI)}e.isConfigurationOverrides=D;function k(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||w.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=k;var b;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=g;function S(m,v){const M=Object.create(null);for(let h in m)C(M,h,m[h],v);return M}e.toValuesTree=S;function C(m,v,M,h){const l=v.split("."),c=l.pop();let a=m;for(let f=0;f<l.length;f++){let s=l[f],i=a[s];switch(typeof i){case"undefined":i=a[s]=Object.create(null);break;case"object":break;default:h(`Ignoring ${v} as ${l.slice(0,f+1).join(".")} is ${JSON.stringify(i)}`);return}a=i}if(typeof a=="object"&&a!==null)try{a[c]=M}catch{h(`Ignoring ${v} as ${l.join(".")} is ${JSON.stringify(a)}`)}else h(`Ignoring ${v} as ${l.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=C;function E(m,v){const M=v.split(".");I(m,M)}e.removeFromValueTree=E;function I(m,v){const M=v.shift();if(v.length===0){delete m[M];return}if(Object.keys(m).indexOf(M)!==-1){const h=m[M];typeof h=="object"&&!Array.isArray(h)&&(I(h,v),Object.keys(h).length===0&&delete m[M])}}function p(m,v,M){function h(a,f){let s=a;for(const i of f){if(typeof s!="object"||s===null)return;s=s[i]}return s}const l=v.split("."),c=h(m,l);return typeof c=="undefined"?M:c}e.getConfigurationValue=p;function t(m,v,M){Object.keys(v).forEach(h=>{h!=="__proto__"&&(h in m?w.isObject(m[h])&&w.isObject(v[h])?t(m[h],v[h],M):M&&(m[h]=v[h]):m[h]=v[h])})}e.merge=t;function d(m,v,M){const h=m.inspect(v),l=m.inspect(M);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:h.defaultValue}e.getMigratedSettingValue=d}),define(Z[74],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,w.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");class n{constructor(){this.secretVault={}}async getPassword(D,k){return this.secretVault[D]?.[k]??null}async setPassword(D,k,b){this.secretVault[D]=this.secretVault[D]??{},this.secretVault[D][k]=b}async deletePassword(D,k){return this.secretVault[D]?.[k]?(delete this.secretVault[D][k],Object.keys(this.secretVault[D]).length===0&&delete this.secretVault[D],!0):!1}async findPassword(D){return JSON.stringify(this.secretVault[D])??null}async findCredentials(D){const k=[];for(const b of Object.keys(this.secretVault[D]||{}))k.push({account:b,password:this.secretVault[D][b]});return k}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=n}),define(Z[75],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n}),define(Z[92],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService")}),define(Z[52],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[174],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(Z[175],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,w.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[93],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(Z[176],x([0,1,45,10,7,2,84,24,72,144,93]),function(V,e,w,n,L,D,k,b,g,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=S.localize(0,null);class I{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends I{openTerminal(l,c){return this.spawnTerminal(w,l,g.getWindowsShell(),c)}spawnTerminal(l,c,a,f){const s=c.windowsExec||p.getDefaultTerminalWindows();f&&f[1]===":"&&(f=f[0].toUpperCase()+f.substr(1));const i=L.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return l.spawn(s,f?[f]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((o,u)=>{const y=m(process),P=l.spawn(a,r,{cwd:f,env:y});P.on("error",u),P.on("exit",()=>o())})}runInTerminal(l,c,a,f,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:p.getDefaultTerminalWindows();return new Promise((r,o)=>{const u=`"${c} - ${E}"`,y=`""${a.join('" "')}" & pause"`,P=["/c","start",u,"/wait",i,"/c",y],R=Object.assign({},m(process),f);Object.keys(R).filter(G=>R[G]===null).forEach(G=>delete R[G]);const W={cwd:c,env:R,windowsVerbatimArguments:!0};w.spawn(p.CMD,P,W).on("error",G=>{o(v(G))}),r(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const l=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${l?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class t extends I{openTerminal(l,c){return this.spawnTerminal(w,l,c)}runInTerminal(l,c,a,f,s){const i=s.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{if(i===C.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const u=i===C.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",P=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,V).fsPath,"-t",l||E,"-w",c];for(let U of a)P.push("-a"),P.push(U);if(f){const U=Object.assign({},m(process),f);for(let G in U){const ee=U[G];ee===null?(P.push("-u"),P.push(G)):(P.push("-e"),P.push(`${G}=${ee}`))}}let R="";const W=w.spawn(t.OSASCRIPT,P);W.on("error",U=>{o(v(U))}),W.stderr.on("data",U=>{R+=U.toString()}),W.on("exit",U=>{if(U===0)r(void 0);else if(R){const G=R.split(`
`,1);o(new Error(G[0]))}else o(new Error(S.localize(1,null,u,U)))})}else o(new Error(S.localize(2,null,i)))})}spawnTerminal(l,c,a){const f=c.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const r=["-a",f];a&&r.push(a);const o=m(process),u=l.spawn("/usr/bin/open",r,{cwd:a,env:o});u.on("error",i),u.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class d extends I{openTerminal(l,c){return this.spawnTerminal(w,l,c)}runInTerminal(l,c,a,f,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{let u=[];i.then(y=>{y.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const P=`${M(a)}; echo; read -p "${d.WAIT_MESSAGE}" -n1;`;u.push(`''${P}''`);const R=Object.assign({},m(process),f);Object.keys(R).filter(ee=>R[ee]===null).forEach(ee=>delete R[ee]);const W={cwd:c,env:R};let U="";const G=w.spawn(y,u,W);G.on("error",ee=>{o(v(ee))}),G.stderr.on("data",ee=>{U+=ee.toString()}),G.on("exit",ee=>{if(ee===0)r(void 0);else if(U){const X=U.split(`
`,1);o(new Error(X[0]))}else o(new Error(S.localize(4,null,y,ee)))})})})}static async getDefaultTerminalLinuxReady(){if(!d._DEFAULT_TERMINAL_LINUX_READY)if(!D.isLinux)d._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const l=await b.Promises.exists("/etc/debian_version");d._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{l?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return d._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(l,c,a){const f=c.linuxExec?Promise.resolve(c.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{f.then(r=>{const o=m(process),u=l.spawn(r,[],{cwd:a,env:o});u.on("error",i),u.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=d,d.WAIT_MESSAGE=S.localize(3,null);function m(h){const l={...h.env};return(0,k.sanitizeProcessEnvironment)(l),l}function v(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(S.localize(5,null,h.path)):h}function M(h){let l="";for(let c of h)c.indexOf(" ")>=0?l+='"'+c+'"':l+=c,l+=" ";return l}}),define(Z[20],x([0,1,35,7,27,14,8,146,5]),function(V,e,w,n,L,D,k,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,g.createDecorator)("fileService");function S(B){return B.create===!0}e.isFileOpenForWriteOptions=S;var C;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var E;(function(B){B[B.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var I;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=p;function t(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=t;function d(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function m(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=m;function v(B){return p(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var M;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(M=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(Y,se){super(Y);this.code=se}}e.FileSystemProviderError=h;function l(B,Y){const se=new h(B.toString(),Y);return a(se,Y),se}e.createFileSystemProviderError=l;function c(B){return B||l((0,b.localize)(0,null),M.Unknown)}e.ensureFileSystemProviderError=c;function a(B,Y){return B.name=Y?`${Y} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=a;function f(B){if(!B)return M.Unknown;if(B instanceof h)return B.code;const Y=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!Y)return M.Unknown;switch(Y[1]){case M.FileExists:return M.FileExists;case M.FileIsADirectory:return M.FileIsADirectory;case M.FileNotADirectory:return M.FileNotADirectory;case M.FileNotFound:return M.FileNotFound;case M.FileExceedsMemoryLimit:return M.FileExceedsMemoryLimit;case M.FileTooLarge:return M.FileTooLarge;case M.FileWriteLocked:return M.FileWriteLocked;case M.NoPermissions:return M.NoPermissions;case M.Unavailable:return M.Unavailable}return M.Unknown}e.toFileSystemProviderErrorCode=f;function s(B){if(B instanceof P)return B.fileOperationResult;switch(f(B)){case M.FileNotFound:return 1;case M.FileIsADirectory:return 0;case M.FileNotADirectory:return 10;case M.FileWriteLocked:return 5;case M.NoPermissions:return 6;case M.FileExists:return 4;case M.FileExceedsMemoryLimit:return 9;case M.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(Y,se,$){this.resource=Y,this.operation=se,this.target=$}isOperation(Y){return this.operation===Y}}e.FileOperationEvent=r;var o;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class u{constructor(Y,se){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Y;const $=new Map;for(const q of Y){const Q=$.get(q.type);switch(Q?Q.push([q.resource,q]):$.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,Q]of $)switch(q){case 1:this.added=w.TernarySearchTree.forUris(()=>se),this.added.fill(Q);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>se),this.updated.fill(Q);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>se),this.deleted.fill(Q);break}}contains(Y,...se){return this.doContains(Y,{includeChildren:!1},...se)}affects(Y,...se){return this.doContains(Y,{includeChildren:!0},...se)}doContains(Y,se,...$){if(!Y)return!1;const q=$.length>0;return!!((!q||$.includes(1))&&(this.added?.get(Y)||se.includeChildren&&this.added?.findSuperstr(Y))||(!q||$.includes(0))&&(this.updated?.get(Y)||se.includeChildren&&this.updated?.findSuperstr(Y))||(!q||$.includes(2))&&(this.deleted?.findSubstr(Y)||se.includeChildren&&this.deleted?.findSuperstr(Y)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=u;function y(B,Y,se){return!B||!Y||B===Y||Y.length>B.length?!1:(Y.charAt(Y.length-1)!==n.sep&&(Y+=n.sep),se?(0,L.startsWithIgnoreCase)(B,Y):B.indexOf(Y)===0)}e.isParent=y;class P extends Error{constructor(Y,se,$){super(Y);this.fileOperationResult=se,this.options=$}}e.FileOperationError=P;class R extends P{constructor(Y,se,$){super(Y,2,$);this.stat=se}}e.NotModifiedSinceFileOperationError=R;var W;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=G;async function ee(B,Y){if(!Y.hasProvider(k.URI.from({scheme:B.scheme})))return new Promise(se=>{const $=Y.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===B.scheme&&q.added&&($.dispose(),se())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class X{static formatSize(Y){return(0,D.isNumber)(Y)||(Y=0),Y<X.KB?(0,b.localize)(1,null,Y.toFixed(0)):Y<X.MB?(0,b.localize)(2,null,(Y/X.KB).toFixed(2)):Y<X.GB?(0,b.localize)(3,null,(Y/X.MB).toFixed(2)):Y<X.TB?(0,b.localize)(4,null,(Y/X.GB).toFixed(2)):(0,b.localize)(5,null,(Y/X.TB).toFixed(2))}}e.ByteSize=X,X.KB=1024,X.MB=X.KB*X.KB,X.GB=X.MB*X.KB,X.TB=X.GB*X.KB;var J;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(J=e.Arch||(e.Arch={}));function H(B){return{maxFileSize:B===0?300*X.MB:16*X.GB,maxHeapSize:B===0?700*X.MB:2*700*X.MB}}e.getPlatformLimits=H}),define(Z[177],x([0,1,16,39,15,4,3,48,8,31,20]),function(V,e,w,n,L,D,k,b,g,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends k.Disposable{constructor(p,t){super();this.channel=p,this.extraCapabilities=t,this.onDidChangeCapabilities=D.Event.None,this._onDidChange=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,S.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,t){const{buffer:d}=await this.channel.call("readFile",[p,t]);return d}readFileStream(p,t,d){const m=(0,b.newWriteableStream)(M=>w.VSBuffer.concat(M.map(h=>w.VSBuffer.wrap(h))).buffer),v=this.channel.listen("readFileStream",[p,t])(M=>{if(M instanceof w.VSBuffer)m.write(M.buffer);else{if(M==="end")m.end();else{let h=M;h instanceof Error||(h=(0,C.createFileSystemProviderError)((0,n.toErrorMessage)(h),C.FileSystemProviderErrorCode.Unknown)),m.error(h),m.end()}v.dispose()}});return d.onCancellationRequested(()=>{m.error((0,L.canceled)()),m.end(),v.dispose()}),m}writeFile(p,t,d){return this.channel.call("writeFile",[p,w.VSBuffer.wrap(t),d])}open(p,t){return this.channel.call("open",[p,t])}close(p){return this.channel.call("close",[p])}async read(p,t,d,m,v){const[M,h]=await this.channel.call("read",[p,t,v]);return d.set(M.buffer.slice(0,h),m),h}write(p,t,d,m,v){return this.channel.call("write",[p,t,w.VSBuffer.wrap(d),m,v])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,t){return this.channel.call("delete",[p,t])}rename(p,t,d){return this.channel.call("rename",[p,t,d])}copy(p,t,d){return this.channel.call("copy",[p,t,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const t=p;this._onDidChange.fire(t.map(d=>({resource:g.URI.revive(d.resource),type:d.type})))}else{const t=p;this._onDidWatchError.fire(t)}}))}watch(p,t){const d=(0,S.generateUuid)();return this.channel.call("watch",[this.sessionId,d,p,t]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,d]))}}e.DiskFileSystemProviderClient=E}),define(Z[94],x([0,1,16,15,147,20]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(C,E,I,p,t,d){let m;try{await b(C,E,I,p,t,d)}catch(v){m=v}finally{m&&t.errorTransformer&&(m=t.errorTransformer(m)),typeof m!="undefined"&&I.error(m),I.end()}}e.readFileIntoStream=k;async function b(C,E,I,p,t,d){g(d);const m=await C.open(E,{create:!1});try{g(d);let v=0,M=0,h=t&&typeof t.length=="number"?t.length:void 0,l=w.VSBuffer.alloc(Math.min(t.bufferSize,typeof h=="number"?h:t.bufferSize)),c=t&&typeof t.position=="number"?t.position:0,a=0;do M=await C.read(m,c,l.buffer,a,l.byteLength-a),c+=M,a+=M,v+=M,typeof h=="number"&&(h-=M),a===l.byteLength&&(await I.write(p(l)),l=w.VSBuffer.alloc(Math.min(t.bufferSize,typeof h=="number"?h:t.bufferSize)),a=0);while(M>0&&(typeof h!="number"||h>0)&&g(d)&&S(v,t));if(a>0){let f=a;typeof h=="number"&&(f=Math.min(a,h)),I.write(p(l.slice(0,f)))}}catch(v){throw(0,D.ensureFileSystemProviderError)(v)}finally{await C.close(m)}}function g(C){if(C.isCancellationRequested)throw(0,n.canceled)();return!0}function S(C,E){if(E?.limits){if(typeof E.limits.memory=="number"&&C>E.limits.memory)throw(0,D.createFileSystemProviderError)((0,L.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&C>E.limits.size)throw(0,D.createFileSystemProviderError)((0,L.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[62],x([0,1,3,2,8,20]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function k(p){return p.recursive===!0}e.isRecursiveWatchRequest=k;class b extends w.Disposable{constructor(t,d,m,v){super();this.onFileChanges=t,this.onLogMessage=d,this.verboseLogging=m,this.options=v,this.watcherDisposables=this._register(new w.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new w.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),t.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),t.add(this.watcher.onDidError(d=>this.onError(d)))}onError(t){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${t}`):this.error(t)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class g extends b{constructor(t,d,m){super(t,d,m,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=g;class S extends b{constructor(t,d,m){super(t,d,m,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function C(p){return p.map(t=>({type:t.type,resource:L.URI.file(t.path)}))}e.toFileChanges=C;function E(p){const t=new I;for(const d of p)t.processEvent(d);return t.coalesce()}e.coalesceEvents=E;class I{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return n.isLinux?t.path:t.path.toLowerCase()}processEvent(t){const d=this.mapPathToChange.get(this.toKey(t));let m=!1;if(d){const v=d.type,M=t.type;d.path!==t.path&&(t.type===2||t.type===1)?m=!0:v===1&&M===2?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(d)):v===2&&M===1?d.type=0:v===1&&M===0||(d.type=M)}else m=!0;m&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],d=[];return Array.from(this.coalesced).filter(m=>m.type!==2?(t.push(m),!1):!0).sort((m,v)=>m.path.length-v.path.length).filter(m=>d.some(v=>(0,D.isParent)(m.path,v,!n.isLinux))?!1:(d.push(m.path),!0)).concat(t)}}}),define(Z[178],x([0,1,29,9,23,28,116,3,70,7,2,86,24,62]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class t extends b.Disposable{constructor(v,M,h,l){super();this.request=v,this.onDidFilesChange=M,this.onLogMessage=h,this.verboseLogging=l,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,k.parse)(c)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const v=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const M=await I.Promises.stat(v);this._register(await this.doWatch(v,M.isDirectory()))}catch(v){v.code!=="ENOENT"?this.error(v):this.trace(v)}}async normalizePath(v){let M=v.path;try{M=await I.Promises.realpath(v.path),v.path===M&&(M=await(0,E.realcase)(v.path)??v.path),v.path!==M&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${M})`)}catch{}return M}async doWatch(v,M){if(C.isMacintosh&&(0,D.isEqualOrParent)(v,"/Volumes/",!0))return this.error(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),b.Disposable.None;const h=new L.CancellationTokenSource(this.cts.token);let l=new b.DisposableStore;try{const c=(0,S.basename)(v),a=(0,w.watch)(v);l.add((0,b.toDisposable)(()=>{a.removeAllListeners(),a.close()})),this.trace(`Started watching: '${v}'`);const f=new Set;if(M)try{for(const i of await I.Promises.readdir(v))f.add(i)}catch(i){this.error(i)}const s=new Map;l.add((0,b.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),a.on("error",(i,r)=>{this.error(`Failed to watch ${v} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),a.on("change",(i,r)=>{if(h.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${r}`);let o="";if(r&&(o=r.toString(),C.isMacintosh&&(o=(0,g.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(M)if(i==="rename"){s.get(o)?.dispose();const u=setTimeout(async()=>{if(s.delete(o),o===c&&!await I.Promises.exists(v)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const y=await this.existsChildStrictCase((0,S.join)(v,o));if(h.token.isCancellationRequested)return;let P;y?f.has(o)?P=0:(P=1,f.add(o)):(f.delete(o),P=2),this.onFileChange({path:(0,S.join)(this.request.path,o),type:P})},t.FILE_DELETE_HANDLER_DELAY);s.set(o,(0,b.toDisposable)(()=>clearTimeout(u)))}else{let u;f.has(o)?u=0:(u=1,f.add(o)),this.onFileChange({path:(0,S.join)(this.request.path,o),type:u})}else if(i==="rename"||o!==c){const u=setTimeout(async()=>{const y=await I.Promises.exists(v);h.token.isCancellationRequested||(y?(this.onFileChange({path:this.request.path,type:0},!0),l.add(await this.doWatch(v,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},t.FILE_DELETE_HANDLER_DELAY);l.clear(),l.add((0,b.toDisposable)(()=>clearTimeout(u)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await I.Promises.exists(v)&&!h.token.isCancellationRequested&&this.error(`Failed to watch ${v} for changes using fs.watch() (${c.toString()})`)}return(0,b.toDisposable)(()=>{h.dispose(!0),l.dispose()})}async onFileChange(v,M=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!M&&this.excludes.some(h=>h(v.path))?this.verboseLogging&&this.trace(` >> ignored ${v.path}`):this.fileChangesBuffer.push(v);try{await this.fileChangesDelayer.trigger(async()=>{const h=this.fileChangesBuffer;this.fileChangesBuffer=[];const l=(0,p.coalesceEvents)(h);if(l.length>0){if(this.verboseLogging)for(const a of l)this.trace(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);this.throttledFileChangesWorker.work(l)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(v){if(C.isLinux)return I.Promises.exists(v);try{const M=(0,S.basename)(v);return(await I.Promises.readdir((0,S.dirname)(v))).some(l=>l===M)}catch(M){return this.trace(M),!1}}setVerboseLogging(v){this.verboseLogging=v}error(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}warn(v){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}trace(v){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=t,t.FILE_DELETE_HANDLER_DELAY=100,t.FILE_CHANGES_HANDLER_DELAY=50;async function d(m,v,M,h,l=512){const c=await I.Promises.open(m,"r"),a=Buffer.allocUnsafe(l),f=new L.CancellationTokenSource(h);let s,i=!1;const r={path:m,excludes:[],recursive:!1},o=new t(r,u=>{(async()=>{for(const{type:y}of u)if(y===0){if(i)return;i=!0;try{for(;!f.token.isCancellationRequested;){const{bytesRead:P}=await I.Promises.read(c,a,0,l,null);if(!P||f.token.isCancellationRequested)break;v(a.slice(0,P))}}catch(P){s=new Error(P),f.dispose(!0)}finally{i=!1}}})()});return await o.ready,M(),new Promise((u,y)=>{f.token.onCancellationRequested(async()=>{o.dispose();try{await I.Promises.close(c)}catch(P){s=new Error(P)}s?y(s):u()})})}e.watchFileContents=d}),define(Z[179],x([0,1,30,4,3,2,178]),function(V,e,w,n,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(S){const C=this.normalizeRequests(S),E=C.filter(p=>{const t=this.watchers.get(p.path);return t?!(0,w.equals)(t.request.excludes,p.excludes):!0}),I=Array.from(this.watchers.values()).filter(({request:p})=>!C.find(t=>t.path===p.path&&(0,w.equals)(t.excludes,p.excludes))).map(({request:p})=>p.path);E.length&&this.trace(`Request to start watching: ${E.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"})`).join(",")}`),I.length&&this.trace(`Request to stop watching: ${I.join(",")}`);for(const p of I)this.stopWatching(p);for(const p of E)this.startWatching(p)}startWatching(S){const C=new k.NodeJSFileWatcherLibrary(S,I=>this._onDidChangeFile.fire(I),I=>this._onDidLogMessage.fire(I),this.verboseLogging),E={request:S,instance:C};this.watchers.set(S.path,E)}async stop(){for(const[S]of this.watchers)this.stopWatching(S);this.watchers.clear()}stopWatching(S){const C=this.watchers.get(S);C&&(this.watchers.delete(S),C.instance.dispose())}normalizeRequests(S){const C=new Map;for(const E of S){const I=D.isLinux?E.path:E.path.toLowerCase();C.set(I,E)}return Array.from(C.values())}async setVerboseLogging(S){this.verboseLogging=S;for(const[,C]of this.watchers)C.instance.setVerboseLogging(S)}trace(S){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(S)})}toMessage(S,C){return C?`[File Watcher (node.js)] ${S} (path: ${C.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=b}),define(Z[180],x([0,1,62,179]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends w.AbstractNonRecursiveWatcherClient{constructor(k,b,g){super(k,b,g);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(Z[181],x([0,1,10,37,138,62]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends D.AbstractUniversalWatcherClient{constructor(g,S,C){super(g,S,C);this.init()}createWatcher(g){const S=g.add(new L.Client(w.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(S.onDidProcessExit(({code:C,signal:E})=>this.onError(`terminated by itself with code ${C}, signal: ${E}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(Z[76],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...L){this._entries=new Map;for(let[D,k]of L)this.set(D,k)}set(L,D){const k=this._entries.get(L);return this._entries.set(L,D),k}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=w}),define(Z[182],x([0,1,9,15,73,173,5,76]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const g=!1;class S extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class C{constructor(t=new b.ServiceCollection,d=!1,m){this._activeInstantiations=new Set,this._services=t,this._strict=d,this._parent=m,this._services.set(k.IInstantiationService,this)}createChild(t){return new C(t,this._strict,this)}invokeFunction(t,...d){let m=I.traceInvocation(t),v=!1;try{return t({get:h=>{if(v)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(h,m);if(!l)throw new Error(`[invokeFunction] unknown service '${h}'`);return l}},...d)}finally{v=!0,m.stop()}}createInstance(t,...d){let m,v;return t instanceof L.SyncDescriptor?(m=I.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(d),m)):(m=I.traceCreation(t),v=this._createInstance(t,d,m)),m.stop(),v}_createInstance(t,d=[],m){let v=k._util.getServiceDependencies(t).sort((l,c)=>l.index-c.index),M=[];for(const l of v){let c=this._getOrCreateServiceInstance(l.id,m);c||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${l.id}.`,!1),M.push(c)}let h=v.length>0?v[0].index:d.length;if(d.length!==h){console.warn(`[createInstance] First service dependency of ${t.name} at position ${h+1} conflicts with ${d.length} static arguments`);let l=h-d.length;l>0?d=d.concat(new Array(l)):d=d.slice(0,h)}return new t(...[...d,...M])}_setServiceInstance(t,d){if(this._services.get(t)instanceof L.SyncDescriptor)this._services.set(t,d);else if(this._parent)this._parent._setServiceInstance(t,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let d=this._services.get(t);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):d}_getOrCreateServiceInstance(t,d){let m=this._getServiceInstanceOrDescriptor(t);return m instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,m,d.branch(t,!0)):(d.branch(t,!1),m)}_safeCreateAndCacheServiceInstance(t,d,m){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,d,m)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,d,m){const v=new D.Graph(l=>l.id.toString());let M=0;const h=[{id:t,desc:d,_trace:m}];for(;h.length;){const l=h.pop();if(v.lookupOrInsertNode(l),M++>1e3)throw new S(v);for(let c of k._util.getServiceDependencies(l.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(c.id);if(a||this._throwIfStrict(`[createInstance] ${t} depends on ${c.id} which is NOT registered.`,!0),a instanceof L.SyncDescriptor){const f={id:c.id,desc:a,_trace:l._trace.branch(c.id,!0)};v.insertEdge(l,f),h.push(f)}}}for(;;){const l=v.roots();if(l.length===0){if(!v.isEmpty())throw new S(v);break}for(const{data:c}of l){if(this._getServiceInstanceOrDescriptor(c.id)instanceof L.SyncDescriptor){const f=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,f)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,d,m=[],v,M){if(this._services.get(t)instanceof L.SyncDescriptor)return this._createServiceInstance(d,m,v,M);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,d,m,v,M);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(t,d=[],m,v){if(m){const M=new w.IdleValue(()=>this._createInstance(t,d,v));return new Proxy(Object.create(null),{get(h,l){if(l in h)return h[l];let c=M.value,a=c[l];return typeof a!="function"||(a=a.bind(c),h[l]=a),a},set(h,l,c){return M.value[l]=c,!0}})}else return this._createInstance(t,d,v)}_throwIfStrict(t,d){if(d&&console.warn(d),this._strict)throw new Error(t)}}e.InstantiationService=C;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class I{constructor(t,d){this.type=t,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return g?new I(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):I._None}static traceCreation(t){return g?new I(0,t.name):I._None}branch(t,d){let m=new I(2,t.toString());return this._dep.push([t,d,m]),m}stop(){let t=Date.now()-this._start;I._totals+=t;let d=!1;function m(M,h){let l=[],c=new Array(M+1).join("	");for(const[a,f,s]of h._dep)if(f&&s){d=!0,l.push(`${c}CREATES -> ${a}`);let i=m(M+1,s);i&&l.push(i)}else l.push(`${c}uses -> ${a}`);return l.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${I._totals.toFixed(2)}ms)`];(t>2||d)&&console.log(v.join(`
`))}}e.Trace=I,I._None=new class extends I{constructor(){super(-1,null)}stop(){}branch(){return this}},I._totals=0}),define(Z[183],x([0,1,15,135,59]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class D extends L.ResolvedKeybinding{constructor(b,g){super();if(g.length===0)throw(0,w.illegalArgument)("parts");this._os=b,this._parts=g}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,b=>this._getLabel(b))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,b=>this._getAriaLabel(b))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,b=>this._getElectronAccelerator(b))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,b=>this._getUserSettingsLabel(b))}isWYSIWYG(){return this._parts.every(b=>this._isWYSIWYG(b))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(b=>this._getPart(b))}_getPart(b){return new L.ResolvedKeybindingPart(b.ctrlKey,b.shiftKey,b.altKey,b.metaKey,this._getLabel(b),this._getAriaLabel(b))}getDispatchParts(){return this._parts.map(b=>this._getDispatchPart(b))}getSingleModifierDispatchParts(){return this._parts.map(b=>this._getSingleModifierDispatchPart(b))}}e.BaseResolvedKeybinding=D}),define(Z[184],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class w{constructor(D,k,b,g,S,C,E){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=D,this.keypressParts=D?n(D.getDispatchParts()):[],D&&this.keypressParts.length===0&&(this.keypressParts=n(D.getSingleModifierDispatchParts())),this.bubble=k?k.charCodeAt(0)===94:!1,this.command=this.bubble?k.substr(1):k,this.commandArgs=b,this.when=g,this.isDefault=S,this.extensionId=C,this.isBuiltinExtension=E}}e.ResolvedKeybindingItem=w;function n(L){let D=[];for(let k=0,b=L.length;k<b;k++){const g=L[k];if(!g)return D;D.push(g)}return D}e.removeElementsAfterNulls=n}),define(Z[185],x([0,1,83,59,183,184]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends L.BaseResolvedKeybinding{constructor(g,S){super(S,g.parts)}_keyCodeToUILabel(g){if(this._os===2)switch(g){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return w.KeyCodeUtils.toString(g)}_getLabel(g){return g.isDuplicateModifierCase()?"":this._keyCodeToUILabel(g.keyCode)}_getAriaLabel(g){return g.isDuplicateModifierCase()?"":w.KeyCodeUtils.toString(g.keyCode)}_getElectronAccelerator(g){return w.KeyCodeUtils.toElectronAccelerator(g.keyCode)}_getUserSettingsLabel(g){if(g.isDuplicateModifierCase())return"";const S=w.KeyCodeUtils.toUserSettingsUS(g.keyCode);return S&&S.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(g){return k.getDispatchStr(g)}static getDispatchStr(g){if(g.isModifierKey())return null;let S="";return g.ctrlKey&&(S+="ctrl+"),g.shiftKey&&(S+="shift+"),g.altKey&&(S+="alt+"),g.metaKey&&(S+="meta+"),S+=w.KeyCodeUtils.toString(g.keyCode),S}_getSingleModifierDispatchPart(g){return g.keyCode===5&&!g.shiftKey&&!g.altKey&&!g.metaKey?"ctrl":g.keyCode===4&&!g.ctrlKey&&!g.altKey&&!g.metaKey?"shift":g.keyCode===6&&!g.ctrlKey&&!g.shiftKey&&!g.metaKey?"alt":g.keyCode===57&&!g.ctrlKey&&!g.shiftKey&&!g.altKey?"meta":null}static _scanCodeToKeyCode(g){const S=w.IMMUTABLE_CODE_TO_KEY_CODE[g];if(S!==-1)return S;switch(g){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(g){if(!g)return null;if(g instanceof n.SimpleKeybinding)return g;const S=this._scanCodeToKeyCode(g.scanCode);return S===0?null:new n.SimpleKeybinding(g.ctrlKey,g.shiftKey,g.altKey,g.metaKey,S)}static resolveUserBinding(g,S){const C=(0,D.removeElementsAfterNulls)(g.map(E=>this._resolveSimpleUserBinding(E)));return C.length>0?[new k(new n.ChordKeybinding(C),S)]:[]}}e.USLayoutResolvedKeybinding=k}),define(Z[186],x([0,1,9]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function n(L,D){if(L.length===0)return Promise.resolve(!1);const k=[];let b=!1;for(let g of L){if(g===!0)return Promise.resolve(!0);(0,w.isThenable)(g)&&k.push(g.then(S=>{S&&(b=!0)},S=>{D(S),b=!0}))}return w.Promises.settled(k).then(()=>b)}e.handleVetos=n}),define(Z[6],x([0,1,39,4,3,2,5]),function(V,e,w,n,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logCi=e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function b(){return new Date().toISOString()}var g;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(g=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=g.Info;function S(s,i,r){switch(i){case g.Trace:s.trace(r);break;case g.Debug:s.debug(r);break;case g.Info:s.info(r);break;case g.Warning:s.warn(r);break;case g.Error:s.error(r);break;case g.Critical:s.critical(r);break;default:throw new Error("Invalid log level")}}e.log=S;function C(s){let i="";for(let r=0;r<s.length;r++){let o=s[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(r>0?" ":"")+o}return i}e.format=C;class E extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class I extends E{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...r){this.checkLogLevel(g.Trace)&&this.log(g.Trace,C([i,...r]))}debug(i,...r){this.checkLogLevel(g.Debug)&&this.log(g.Debug,C([i,...r]))}info(i,...r){this.checkLogLevel(g.Info)&&this.log(g.Info,C([i,...r]))}warn(i,...r){this.checkLogLevel(g.Warning)&&this.log(g.Warning,C([i,...r]))}error(i,...r){if(this.checkLogLevel(g.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(g.Error,C(o))}else this.log(g.Error,C([i,...r]))}critical(i,...r){this.checkLogLevel(g.Critical)&&this.log(g.Critical,C([i,...r]))}flush(){}}e.AbstractMessageLogger=I;class p extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!D.isWindows}trace(i,...r){this.getLevel()<=g.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,i,...r):console.log(`[main ${b()}]`,i,...r))}debug(i,...r){this.getLevel()<=g.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,i,...r):console.log(`[main ${b()}]`,i,...r))}info(i,...r){this.getLevel()<=g.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,i,...r):console.log(`[main ${b()}]`,i,...r))}warn(i,...r){this.getLevel()<=g.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,i,...r):console.warn(`[main ${b()}]`,i,...r))}error(i,...r){this.getLevel()<=g.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,i,...r):console.error(`[main ${b()}]`,i,...r))}critical(i,...r){this.getLevel()<=g.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,i,...r):console.error(`[main ${b()}]`,i,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class t extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...r){this.getLevel()<=g.Trace&&console.log("%cTRACE","color: #888",i,...r)}debug(i,...r){this.getLevel()<=g.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...r)}info(i,...r){this.getLevel()<=g.Info&&console.log("%c INFO","color: #33f",i,...r)}warn(i,...r){this.getLevel()<=g.Warning&&console.log("%c WARN","color: #993",i,...r)}error(i,...r){this.getLevel()<=g.Error&&console.log("%c  ERR","color: #f33",i,...r)}critical(i,...r){this.getLevel()<=g.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...r)}dispose(){}flush(){}}e.ConsoleLogger=t;class d extends E{constructor(i,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(r)}trace(i,...r){this.getLevel()<=g.Trace&&this.adapter.log(g.Trace,[this.extractMessage(i),...r])}debug(i,...r){this.getLevel()<=g.Debug&&this.adapter.log(g.Debug,[this.extractMessage(i),...r])}info(i,...r){this.getLevel()<=g.Info&&this.adapter.log(g.Info,[this.extractMessage(i),...r])}warn(i,...r){this.getLevel()<=g.Warning&&this.adapter.log(g.Warning,[this.extractMessage(i),...r])}error(i,...r){this.getLevel()<=g.Error&&this.adapter.log(g.Error,[this.extractMessage(i),...r])}critical(i,...r){this.getLevel()<=g.Critical&&this.adapter.log(g.Critical,[this.extractMessage(i),...r])}extractMessage(i){return typeof i=="string"?i:(0,w.toErrorMessage)(i,this.getLevel()<=g.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class m extends E{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const r of this.logServices)r.setLevel(i);super.setLevel(i)}trace(i,...r){for(const o of this.logServices)o.trace(i,...r)}debug(i,...r){for(const o of this.logServices)o.debug(i,...r)}info(i,...r){for(const o of this.logServices)o.info(i,...r)}warn(i,...r){for(const o of this.logServices)o.warn(i,...r)}error(i,...r){for(const o of this.logServices)o.error(i,...r)}critical(i,...r){for(const o of this.logServices)o.critical(i,...r)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=m;class v extends L.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...r){this.logger.trace(i,...r)}debug(i,...r){this.logger.debug(i,...r)}info(i,...r){this.logger.info(i,...r)}warn(i,...r){this.logger.warn(i,...r)}error(i,...r){this.logger.error(i,...r)}critical(i,...r){this.logger.critical(i,...r)}flush(){this.logger.flush()}}e.LogService=v;class M extends L.Disposable{constructor(i,r){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,r){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,r?.always?g.Trace:this.logLevel,r),this.loggers.set(i.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=M;class h{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return g.Info}trace(i,...r){}debug(i,...r){}info(i,...r){}warn(i,...r){}error(i,...r){}critical(i,...r){}dispose(){}flush(){}}e.NullLogService=h;function l(s){if(s.verbose)return g.Trace;if(typeof s.logLevel=="string"){const i=c(s.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function c(s){switch(s){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Critical;case"off":return g.Off}}e.parseLogLevel=c;function a(s){switch(s){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Critical:return"critical";case g.Off:return"off"}}e.LogLevelToString=a;function f(s,i,...r){D.isCI?s.info.call(s,i,...r):s.trace.call(s,i,...r)}e.logCi=f}),define(Z[187],x([0,1,30,9,15,4,3,7,62,6]),function(V,e,w,n,L,D,k,b,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends k.Disposable{constructor(I,p){super();this.logService=I,this.options=p,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(I,p){return p.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(I,p):this.watchNonRecursive(I,p)}watchUniversal(I,p){const t={path:this.toFilePath(I),excludes:p.excludes,recursive:p.recursive},d=(0,w.insert)(this.universalPathsToWatch,t);return this.refreshUniversalWatchers(),(0,k.toDisposable)(()=>{d(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(I=>(0,L.onUnexpectedError)(I))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(p=>this._onDidChangeFile.fire((0,g.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)})));const I=this.options?.watcher?.recursive?.usePolling;if(I===!0)for(const p of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(I))for(const p of this.universalPathsToWatch)(0,g.isRecursiveWatchRequest)(p)&&I.includes(p.path)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(I,p){const t={path:this.toFilePath(I),excludes:p.excludes,recursive:!1},d=(0,w.insert)(this.nonRecursivePathsToWatch,t);return this.refreshNonRecursiveWatchers(),(0,k.toDisposable)(()=>{d(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(I=>(0,L.onUnexpectedError)(I))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(I=>this._onDidChangeFile.fire((0,g.toFileChanges)(I)),I=>this.onWatcherLogMessage(I),this.logService.getLevel()===S.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(I){I.type==="error"&&this._onDidWatchError.fire(I.message),this.logService[I.type](I.message)}toFilePath(I){return(0,b.normalize)(I.fsPath)}}e.AbstractDiskFileSystemProvider=C});var te=this&&this.__param||function(V,e){return function(w,n){e(w,n,V)}};define(Z[188],x([0,1,30,9,16,23,4,69,68,3,35,10,63,17,48,145,20,94,6]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let h=class extends S.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,a){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${c}`);const f=new S.DisposableStore;return this.provider.set(c,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:a}),f.add(a.onDidChangeFile(s=>this._onDidFilesChange.fire(new m.FileChangesEvent(s,!this.isPathCaseSensitive(a))))),typeof a.onDidWatchError=="function"&&f.add(a.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),f.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:c}))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:a}),this.provider.delete(c),(0,S.dispose)(f)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(f){a.push(f)}}),!this.provider.has(c)&&await n.Promises.settled(a)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,a){const f=this.provider.get(c.scheme);return!!(f&&f.capabilities&a)}listCapabilities(){return g.Iterable.map(this.provider,([c,a])=>({scheme:c,capabilities:a.capabilities}))}async withProvider(c){if(!(0,p.isAbsolutePath)(c))throw new m.FileOperationError((0,d.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const a=this.provider.get(c.scheme);if(!a){const f=new Error;throw f.name="ENOPRO",f.message=(0,d.localize)(1,null,c.toString()),f}return a}async withReadProvider(c){const a=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(a)||(0,m.hasReadWriteCapability)(a)||(0,m.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const a=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(a)||(0,m.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,a){try{return await this.doResolveFile(c,a)}catch(f){throw(0,m.toFileSystemProviderErrorCode)(f)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,d.localize)(2,null,this.resourceForError(c)),1):(0,m.ensureFileSystemProviderError)(f)}}async doResolveFile(c,a){const f=await this.withProvider(c),s=this.isPathCaseSensitive(f),i=a?.resolveTo,r=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,u=await f.stat(c);let y;return this.toFileStat(f,c,u,void 0,!!o,(P,R)=>(y||(y=C.TernarySearchTree.forUris(()=>!s),y.set(c,!0),i&&y.fill(!0,i)),y.get(P.resource)||y.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&r?R===1:!1))}async toFileStat(c,a,f,s,i,r){const{providerExtUri:o}=this.getExtUri(c),u={resource:a,name:o.basename(a),isFile:(f.type&m.FileType.File)!=0,isDirectory:(f.type&m.FileType.Directory)!=0,isSymbolicLink:(f.type&m.FileType.SymbolicLink)!=0,mtime:f.mtime,ctime:f.ctime,size:f.size,readonly:Boolean((f.permissions??0)&m.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,m.etag)({mtime:f.mtime,size:f.size}),children:void 0};if(u.isDirectory&&r(u,s)){try{const y=await c.readdir(a),P=await n.Promises.settled(y.map(async([R,W])=>{try{const U=o.joinPath(a,R),G=i?await c.stat(U):{type:W};return await this.toFileStat(c,U,G,y.length,i,r)}catch(U){return this.logService.trace(U),null}}));u.children=(0,w.coalesce)(P)}catch(y){this.logService.trace(y),u.children=[]}return u}return u}async resolveAll(c){return n.Promises.settled(c.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(f){return this.logService.trace(f),{stat:void 0,success:!1}}}))}async stat(c){const a=await this.withProvider(c),f=await a.stat(c);return this.toFileStat(a,c,f,void 0,!0,()=>!1)}async exists(c){const a=await this.withProvider(c);try{return!!await a.stat(c)}catch{return!1}}async canCreateFile(c,a){try{await this.doValidateCreateFile(c,a)}catch(f){return f}return!0}async doValidateCreateFile(c,a){if(!a?.overwrite&&await this.exists(c))throw new m.FileOperationError((0,d.localize)(3,null,this.resourceForError(c)),3,a)}async createFile(c,a=L.VSBuffer.fromString(""),f){await this.doValidateCreateFile(c,f);const s=await this.writeFile(c,a);return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,s)),s}async writeFile(c,a,f){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(s);try{await this.validateWriteFile(s,c,f)||await this.mkdirp(s,i.dirname(c));let o;if((0,m.hasReadWriteCapability)(s)&&!(a instanceof L.VSBuffer))if((0,t.isReadableStream)(a)){const u=await(0,t.peekStream)(a,3);u.ended?o=L.VSBuffer.concat(u.buffer):o=u}else o=(0,t.peekReadable)(a,u=>L.VSBuffer.concat(u),3);else o=a;!(0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s)&&o instanceof L.VSBuffer?await this.doWriteUnbuffered(s,c,f,o):await this.doWriteBuffered(s,c,f,o instanceof L.VSBuffer?(0,L.bufferToReadable)(o):o),this._onDidRunOperation.fire(new m.FileOperationEvent(c,4))}catch(r){throw new m.FileOperationError((0,d.localize)(4,null,this.resourceForError(c),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),f)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,a,f){if(!!f?.unlock&&!(c.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(a)));let i;try{i=await c.stat(a)}catch{return}if((i.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,d.localize)(6,null,this.resourceForError(a)),0,f);if(this.throwIfFileIsReadonly(a,i),typeof f?.mtime=="number"&&typeof f.etag=="string"&&f.etag!==m.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&f.mtime<i.mtime&&f.etag!==(0,m.etag)({mtime:f.mtime,size:i.size}))throw new m.FileOperationError((0,d.localize)(7,null),3,f);return i}async readFile(c,a,f){const s=await this.withReadProvider(c);return a?.atomic?this.doReadFileAtomic(s,c,a,f):this.doReadFile(s,c,a,f)}async doReadFileAtomic(c,a,f,s){return new Promise((i,r)=>{this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(c,a,f,s);i(o)}catch(o){r(o)}})})}async doReadFile(c,a,f,s){const i=await this.doReadFileStream(c,a,{...f,preferUnbuffered:!0},s);return{...i,value:await(0,L.streamToBuffer)(i.value)}}async readFileStream(c,a,f){const s=await this.withReadProvider(c);return this.doReadFileStream(s,c,a,f)}async doReadFileStream(c,a,f,s){const i=new D.CancellationTokenSource(s),r=this.validateReadFile(a,f).then(u=>u,u=>{throw i.cancel(),u});let o;try{return typeof f?.etag=="string"&&f.etag!==m.ETAG_DISABLED&&await r,f?.atomic&&(0,m.hasFileAtomicReadCapability)(c)||!((0,m.hasOpenReadWriteCloseCapability)(c)||(0,m.hasFileReadStreamCapability)(c))||(0,m.hasReadWriteCapability)(c)&&f?.preferUnbuffered?o=this.readFileUnbuffered(c,a,f):(0,m.hasFileReadStreamCapability)(c)?o=this.readFileStreamed(c,a,i.token,f):o=this.readFileBuffered(c,a,i.token,f),{...await r,value:o}}catch(u){o&&await(0,t.consumeStream)(o);const y=(0,d.localize)(8,null,this.resourceForError(a),(0,m.ensureFileSystemProviderError)(u).toString());throw u instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(y,u.stat,f):new m.FileOperationError(y,(0,m.toFileOperationResult)(u),f)}}readFileStreamed(c,a,f,s=Object.create(null)){const i=c.readFileStream(a,s,f);return(0,t.transform)(i,{data:r=>r instanceof L.VSBuffer?r:L.VSBuffer.wrap(r),error:r=>new m.FileOperationError((0,d.localize)(9,null,this.resourceForError(a),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),s)},r=>L.VSBuffer.concat(r))}readFileBuffered(c,a,f,s=Object.create(null)){const i=(0,L.newWriteableBufferStream)();return(0,v.readFileIntoStream)(c,a,i,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new m.FileOperationError((0,d.localize)(10,null,this.resourceForError(a),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),s)},f),i}readFileUnbuffered(c,a,f){const s=(0,t.newWriteableStream)(i=>L.VSBuffer.concat(i));return(async()=>{try{let i;f?.atomic&&(0,m.hasFileAtomicReadCapability)(c)?i=await c.readFile(a,{atomic:!0}):i=await c.readFile(a),typeof f?.position=="number"&&(i=i.slice(f.position)),typeof f?.length=="number"&&(i=i.slice(0,f.length)),this.validateReadFileLimits(a,i.byteLength,f),s.end(L.VSBuffer.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async validateReadFile(c,a){const f=await this.resolve(c,{resolveMetadata:!0});if(f.isDirectory)throw new m.FileOperationError((0,d.localize)(11,null,this.resourceForError(c)),0,a);if(typeof a?.etag=="string"&&a.etag!==m.ETAG_DISABLED&&a.etag===f.etag)throw new m.NotModifiedSinceFileOperationError((0,d.localize)(12,null),f,a);return this.validateReadFileLimits(c,f.size,a),f}validateReadFileLimits(c,a,f){if(f?.limits){let s;if(typeof f.limits.memory=="number"&&a>f.limits.memory&&(s=9),typeof f.limits.size=="number"&&a>f.limits.size&&(s=7),typeof s=="number")throw new m.FileOperationError((0,d.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,a,f){return this.doCanMoveCopy(c,a,"move",f)}async canCopy(c,a,f){return this.doCanMoveCopy(c,a,"copy",f)}async doCanMoveCopy(c,a,f,s){if(c.toString()!==a.toString())try{const i=f==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(i,c,r,a,f,s)}catch(i){return i}return!0}async move(c,a,f){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,c,i,a,"move",!!f),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,r==="move"?2:3,o)),o}async copy(c,a,f){const s=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,c,i,a,"copy",!!f),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,r==="copy"?3:2,o)),o}async doMoveCopy(c,a,f,s,i,r){if(a.toString()===s.toString())return i;const{exists:o,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(c,a,f,s,i,r);if(o&&!u&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(f,this.getExtUri(f).providerExtUri.dirname(s)),i==="copy"){if(c===f&&(0,m.hasFileFolderCopyCapability)(c))await c.copy(a,s,{overwrite:r});else{const y=await this.resolve(a);y.isDirectory?await this.doCopyFolder(c,y,f,s):await this.doCopyFile(c,a,f,s)}return i}else return c===f?(await c.rename(a,s,{overwrite:r}),i):(await this.doMoveCopy(c,a,f,s,"copy",r),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(c,a,f,s){if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(f))return this.doPipeBuffered(c,a,f,s);if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasReadWriteCapability)(f))return this.doPipeBufferedToUnbuffered(c,a,f,s);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(f))return this.doPipeUnbufferedToBuffered(c,a,f,s);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasReadWriteCapability)(f))return this.doPipeUnbuffered(c,a,f,s)}async doCopyFolder(c,a,f,s){await f.mkdir(s),Array.isArray(a.children)&&await n.Promises.settled(a.children.map(async i=>{const r=this.getExtUri(f).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),f,r):this.doCopyFile(c,i.resource,f,r)}))}async doValidateMoveCopy(c,a,f,s,i,r){let o=!1;if(c===f){const{providerExtUri:y,isPathCaseSensitive:P}=this.getExtUri(c);if(P||(o=y.isEqual(a,s)),o&&i==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(a),this.resourceForError(s)));if(!o&&y.isEqualOrParent(s,a))throw new Error((0,d.localize)(15,null,this.resourceForError(a),this.resourceForError(s)))}const u=await this.exists(s);if(u&&!o){if(!r)throw new m.FileOperationError((0,d.localize)(16,null,this.resourceForError(a),this.resourceForError(s)),4);if(c===f){const{providerExtUri:y}=this.getExtUri(c);if(y.isEqualOrParent(a,s))throw new Error((0,d.localize)(17,null,this.resourceForError(a),this.resourceForError(s)))}}return{exists:u,isSameResourceWithDifferentPathCase:o}}getExtUri(c){const a=this.isPathCaseSensitive(c);return{providerExtUri:a?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(a,c);const f=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,f)),f}async mkdirp(c,a){const f=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(a,s.dirname(a));)try{if(((await c.stat(a)).type&m.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(a)));break}catch(i){if((0,m.toFileSystemProviderErrorCode)(i)!==m.FileSystemProviderErrorCode.FileNotFound)throw i;f.push(s.basename(a)),a=s.dirname(a)}for(let i=f.length-1;i>=0;i--){a=s.joinPath(a,f[i]);try{await c.mkdir(a)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,a){try{await this.doValidateDelete(c,a)}catch(f){return f}return!0}async doValidateDelete(c,a){const f=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!a?.useTrash&&!(f.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(c)));let i;try{i=await f.stat(c)}catch{}if(i)this.throwIfFileIsReadonly(c,i);else throw new m.FileOperationError((0,d.localize)(20,null,this.resourceForError(c)),1);if(!!!a?.recursive){const o=await this.resolve(c);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(c)))}return f}async del(c,a){const f=await this.doValidateDelete(c,a),s=!!a?.useTrash,i=!!a?.recursive;await f.delete(c,{recursive:i,useTrash:s}),this._onDidRunOperation.fire(new m.FileOperationEvent(c,1))}watch(c,a={recursive:!1,excludes:[]}){const f=new S.DisposableStore;let s=!1,i=()=>{s=!0};return f.add((0,S.toDisposable)(()=>i())),(async()=>{try{const r=await this.doWatch(c,a);s?(0,S.dispose)(r):i=()=>(0,S.dispose)(r)}catch(r){this.logService.error(r)}})(),f}async doWatch(c,a){const f=await this.withProvider(c),s=(0,b.hash)([this.getExtUri(f).providerExtUri.getComparisonKey(c),a]);let i=this.activeWatchers.get(s);return i||(i={count:0,disposable:f.watch(c,a)},this.activeWatchers.set(s,i)),i.count+=1,(0,S.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,S.dispose)(i.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,S.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,a,f,s){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(a,{create:!0,unlock:f?.unlock??!1});try{(0,t.isReadableStream)(s)||(0,t.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,i,s):await this.doWriteReadableBufferedQueued(c,i,s)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,a,f){let s=0,i;if((0,t.isReadableBufferedStream)(f)){if(f.buffer.length>0){const r=L.VSBuffer.concat(f.buffer);await this.doWriteBuffer(c,a,r,r.byteLength,s,0),s+=r.byteLength}if(f.ended)return;i=f.stream}else i=f;return new Promise((r,o)=>{(0,t.listenStream)(i,{onData:async u=>{i.pause();try{await this.doWriteBuffer(c,a,u,u.byteLength,s,0)}catch(y){return o(y)}s+=u.byteLength,setTimeout(()=>i.resume())},onError:u=>o(u),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,a,f){let s=0,i;for(;(i=f.read())!==null;)await this.doWriteBuffer(c,a,i,i.byteLength,s,0),s+=i.byteLength}async doWriteBuffer(c,a,f,s,i,r){let o=0;for(;o<s;)o+=await c.write(a,i+o,f.buffer,r+o,s-o)}async doWriteUnbuffered(c,a,f,s){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,a,f,s))}async doWriteUnbufferedQueued(c,a,f,s){let i;s instanceof L.VSBuffer?i=s:(0,t.isReadableStream)(s)?i=await(0,L.streamToBuffer)(s):(0,t.isReadableBufferedStream)(s)?i=await(0,L.bufferedStreamToBuffer)(s):i=(0,L.readableToBuffer)(s),await c.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:f?.unlock??!1})}async doPipeBuffered(c,a,f,s){return this.writeQueue.queueFor(s,this.getExtUri(f).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,a,f,s))}async doPipeBufferedQueued(c,a,f,s){let i,r;try{i=await c.open(a,{create:!1}),r=await f.open(s,{create:!0,unlock:!1});const o=L.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,y=0,P=0;do P=await c.read(i,u,o.buffer,y,o.byteLength-y),await this.doWriteBuffer(f,r,o,P,u,y),u+=P,y+=P,y===o.byteLength&&(y=0);while(P>0)}catch(o){throw(0,m.ensureFileSystemProviderError)(o)}finally{await n.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof r=="number"?f.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,a,f,s){return this.writeQueue.queueFor(s,this.getExtUri(f).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,a,f,s))}async doPipeUnbufferedQueued(c,a,f,s){return f.writeFile(s,await c.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,a,f,s){return this.writeQueue.queueFor(s,this.getExtUri(f).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,a,f,s))}async doPipeUnbufferedToBufferedQueued(c,a,f,s){const i=await f.open(s,{create:!0,unlock:!1});try{const r=await c.readFile(a);await this.doWriteBuffer(f,i,L.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await f.close(i)}}async doPipeBufferedToUnbuffered(c,a,f,s){const i=await(0,L.streamToBuffer)(this.readFileBuffered(c,a,D.CancellationToken.None));await this.doWriteUnbuffered(f,s,void 0,i)}throwIfFileSystemIsReadonly(c,a){if(c.capabilities&2048)throw new m.FileOperationError((0,d.localize)(22,null,this.resourceForError(a)),6);return c}throwIfFileIsReadonly(c,a){if((a.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,d.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===E.Schemas.file?c.fsPath:c.toString(!0)}};h=ue([te(0,M.ILogService)],h),e.FileService=h}),define(Z[77],x([0,1,29,253,9,35,16,4,28,3,7,2,17,48,24,149,20,94,187,39,181,180]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M,h,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(w)}catch(f){console.error(`Error enabling graceful-fs: ${(0,h.toErrorMessage)(f)}`)}})();class a extends M.AbstractDiskFileSystemProvider{constructor(s,i){super(s,i);this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new D.ResourceMap(r=>I.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:r}=await t.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(s){try{const i=await t.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async o=>{try{let u;o.isSymbolicLink()?u=(await this.stat((0,I.joinPath)(s,o.name))).type:u=this.toType(o),r.push([o.name,u])}catch(u){this.logService.trace(u)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let r;return i?.dangling?r=m.FileType.Unknown:s.isFile()?r=m.FileType.File:s.isDirectory()?r=m.FileType.Directory:r=m.FileType.Unknown,i&&(r|=m.FileType.SymbolicLink),r}async createResourceLock(s){const i=this.toFilePath(s);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.resourceLocks.get(s);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const o=new L.Barrier;return this.resourceLocks.set(s,o),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,S.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(s)===o&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(s)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(s,i){let r;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),r=await this.createResourceLock(s));const o=this.toFilePath(s);return await t.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{r?.dispose()}}readFileStream(s,i,r){const o=(0,p.newWriteableStream)(u=>k.VSBuffer.concat(u.map(y=>k.VSBuffer.wrap(y))).buffer);return(0,v.readFileIntoStream)(this,s,o,u=>u.buffer,{...i,bufferSize:256*1024},r),o}async writeFile(s,i,r){let o;try{const u=this.toFilePath(s);if(!r.create||!r.overwrite){if(await t.Promises.exists(u)){if(!r.overwrite)throw(0,m.createFileSystemProviderError)((0,d.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,m.createFileSystemProviderError)((0,d.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(s,{create:!0,unlock:r.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(s,u)}finally{typeof o=="number"&&await this.close(o)}}async open(s,i){const r=this.toFilePath(s);let o;(0,m.isFileOpenForWriteOptions)(i)&&(o=await this.createResourceLock(s));let u;try{if((0,m.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:P}=await t.SymlinkSupport.stat(r);P.mode&128||await t.Promises.chmod(r,P.mode|128)}catch(P){this.logService.trace(P)}let y;if((0,m.isFileOpenForWriteOptions)(i)){if(E.isWindows)try{await t.Promises.truncate(r,0),y="r+"}catch(P){P.code!=="ENOENT"&&this.logService.trace(P)}y||(y="w")}else y="r";u=await t.Promises.open(r,y)}catch(y){throw o?.dispose(),(0,m.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,y):this.toFileSystemProviderError(y)}if(this.mapHandleToPos.set(u,0),(0,m.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(u,s),o){const y=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${r})`),this.mapHandleToLock.set(u,o),y&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${r})`),y.dispose())}return u}async close(s){const i=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await t.Promises.fdatasync(s)}catch(r){this.canFlush=!1,this.logService.error(r)}return await t.Promises.close(s)}catch(r){throw this.toFileSystemProviderError(r)}finally{i&&(this.mapHandleToLock.get(s)===i&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,r,o,u){const y=this.normalizePos(s,i);let P=null;try{P=(await t.Promises.read(s,r,o,u,y)).bytesRead}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(s,y,P)}return P}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,r){const o=this.mapHandleToPos.get(s);typeof o=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,o+r):this.mapHandleToPos.delete(s)))}async write(s,i,r,o,u){return(0,L.retry)(()=>this.doWrite(s,i,r,o,u),100,3)}async doWrite(s,i,r,o,u){const y=this.normalizePos(s,i);let P=null;try{P=(await t.Promises.write(s,r,o,u,y)).bytesWritten}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),R)}finally{this.updatePos(s,y,P)}return P}async mkdir(s){try{await t.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const r=this.toFilePath(s);i.recursive?await t.Promises.rm(r,t.RimRafMode.MOVE):await t.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,i,r){const o=this.toFilePath(s),u=this.toFilePath(i);if(o!==u)try{await this.validateTargetDeleted(s,i,"move",r.overwrite),await t.Promises.move(o,u)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,d.localize)(2,null,(0,C.basename)(o),(0,C.basename)((0,C.dirname)(u)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(s,i,r){const o=this.toFilePath(s),u=this.toFilePath(i);if(o!==u)try{await this.validateTargetDeleted(s,i,"copy",r.overwrite),await t.Promises.copy(o,u,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,d.localize)(3,null,(0,C.basename)(o),(0,C.basename)((0,C.dirname)(u)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(s,i,r,o){const u=this.toFilePath(s),y=this.toFilePath(i);let P=!1;if(!!(this.capabilities&1024)||(P=(0,g.isEqual)(u,y,!0)),P&&r==="copy")throw(0,m.createFileSystemProviderError)((0,d.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(!P&&await t.Promises.exists(y)){if(!o)throw(0,m.createFileSystemProviderError)((0,d.localize)(5,null),m.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createUniversalWatcher(s,i,r){return new l.UniversalWatcherClient(o=>s(o),o=>i(o),r)}createNonRecursiveWatcher(s,i,r){return new c.NodeJSWatcherClient(o=>s(o),o=>i(o),r)}toFileSystemProviderError(s){if(s instanceof m.FileSystemProviderError)return s;let i;switch(s.code){case"ENOENT":i=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=m.FileSystemProviderErrorCode.NoPermissions;break;default:i=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(s,i){let r=this.toFileSystemProviderError(i);if(s&&r.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await t.SymlinkSupport.stat(this.toFilePath(s));o.mode&128||(r=(0,m.createFileSystemProviderError)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}e.DiskFileSystemProvider=a}),define(Z[189],x([0,1,4,77,3,16,48,23]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class g extends L.Disposable{constructor(E,I){super();this.provider=E,this.logService=I,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(E,I,p){const t=this.getUriTransformer(E);switch(I){case"stat":return this.stat(t,p[0]);case"readdir":return this.readdir(t,p[0]);case"open":return this.open(t,p[0],p[1]);case"close":return this.close(p[0]);case"read":return this.read(p[0],p[1],p[2]);case"readFile":return this.readFile(t,p[0],p[1]);case"write":return this.write(p[0],p[1],p[2],p[3],p[4]);case"writeFile":return this.writeFile(t,p[0],p[1],p[2]);case"rename":return this.rename(t,p[0],p[1],p[2]);case"copy":return this.copy(t,p[0],p[1],p[2]);case"mkdir":return this.mkdir(t,p[0]);case"delete":return this.delete(t,p[0],p[1]);case"watch":return this.watch(t,p[0],p[1],p[2],p[3]);case"unwatch":return this.unwatch(p[0],p[1])}throw new Error(`IPC Command ${I} not found`)}listen(E,I,p){const t=this.getUriTransformer(E);switch(I){case"fileChange":return this.onFileChange(t,p[0]);case"readFileStream":return this.onReadFileStream(t,p[0],p[1])}throw new Error(`Unknown event ${I}`)}stat(E,I){const p=this.transformIncoming(E,I,!0);return this.provider.stat(p)}readdir(E,I){const p=this.transformIncoming(E,I);return this.provider.readdir(p)}async readFile(E,I,p){const t=this.transformIncoming(E,I,!0),d=await this.provider.readFile(t,p);return D.VSBuffer.wrap(d)}onReadFileStream(E,I,p){const t=this.transformIncoming(E,I,!0),d=new b.CancellationTokenSource,m=new w.Emitter({onLastListenerRemove:()=>{d.cancel()}}),v=this.provider.readFileStream(t,p,d.token);return(0,k.listenStream)(v,{onData:M=>m.fire(D.VSBuffer.wrap(M)),onError:M=>m.fire(M),onEnd:()=>{m.fire("end"),m.dispose(),d.dispose()}}),m.event}writeFile(E,I,p,t){const d=this.transformIncoming(E,I);return this.provider.writeFile(d,p.buffer,t)}open(E,I,p){const t=this.transformIncoming(E,I,!0);return this.provider.open(t,p)}close(E){return this.provider.close(E)}async read(E,I,p){const t=D.VSBuffer.alloc(p),d=0,m=await this.provider.read(E,I,t.buffer,d,p);return[t,m]}write(E,I,p,t,d){return this.provider.write(E,I,p.buffer,t,d)}mkdir(E,I){const p=this.transformIncoming(E,I);return this.provider.mkdir(p)}delete(E,I,p){const t=this.transformIncoming(E,I);return this.provider.delete(t,p)}rename(E,I,p,t){const d=this.transformIncoming(E,I),m=this.transformIncoming(E,p);return this.provider.rename(d,m,t)}copy(E,I,p,t){const d=this.transformIncoming(E,I),m=this.transformIncoming(E,p);return this.provider.copy(d,m,t)}onFileChange(E,I){const p=new w.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(I,this.createSessionFileWatcher(E,p))},onLastListenerRemove:()=>{(0,L.dispose)(this.sessionToWatcher.get(I)),this.sessionToWatcher.delete(I)}});return p.event}async watch(E,I,p,t,d){const m=this.sessionToWatcher.get(I);if(m){const v=this.transformIncoming(E,t),M=m.watch(p,v,d);this.watchRequests.set(I+p,M)}}async unwatch(E,I){const p=E+I,t=this.watchRequests.get(p);t&&((0,L.dispose)(t),this.watchRequests.delete(p))}dispose(){super.dispose();for(const[,E]of this.watchRequests)E.dispose();this.watchRequests.clear();for(const[,E]of this.sessionToWatcher)E.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=g;class S extends L.Disposable{constructor(E,I,p,t){super();this.uriTransformer=E,this.logService=p,this.environmentService=t,this.watcherRequests=new Map,this.fileWatcher=this._register(new n.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(I)}registerListeners(E){const I=this._register(new w.Emitter);this._register(I.event(p=>{E.fire(p.map(t=>({resource:this.uriTransformer.transformOutgoingURI(t.resource),type:t.type})))})),this._register(this.fileWatcher.onDidChangeFile(p=>I.fire(p))),this._register(this.fileWatcher.onDidWatchError(p=>E.fire(p)))}getRecursiveWatcherOptions(E){}getExtraExcludes(E){}watch(E,I,p){const t=this.getExtraExcludes(this.environmentService);return Array.isArray(t)&&(p.excludes=[...p.excludes,...t]),this.watcherRequests.set(E,this.fileWatcher.watch(I,p)),(0,L.toDisposable)(()=>{(0,L.dispose)(this.watcherRequests.get(E)),this.watcherRequests.delete(E)})}dispose(){super.dispose();for(const[,E]of this.watcherRequests)E.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=S}),define(Z[190],x([0,1,12,148,2,8,20,7,189,117]),function(V,e,w,n,L,D,k,b,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class C extends g.AbstractDiskFileSystemProviderChannel{constructor(p,t,d){super(p,t);this.environmentService=d}getUriTransformer(p){return S.DefaultURITransformer}transformIncoming(p,t){return D.URI.revive(t)}async delete(p,t,d){if(!d.useTrash)return super.delete(p,t,d);const m=this.transformIncoming(p,t),v=(0,b.normalize)(m.fsPath);try{await w.shell.trashItem(v)}catch{throw(0,k.createFileSystemProviderError)(L.isWindows?(0,n.localize)(0,null,(0,b.basename)(v)):(0,n.localize)(1,null,(0,b.basename)(v)),k.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(p,t){return new E(p,t,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=C;class E extends g.AbstractSessionFileWatcher{watch(p,t,d){if(d.recursive)throw(0,k.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",k.FileSystemProviderErrorCode.Unavailable);return super.watch(p,t,d)}}}),define(Z[95],x([0,1,6]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(D,k){switch(k){case w.LogLevel.Trace:return D.trace;case w.LogLevel.Debug:return D.debug;case w.LogLevel.Info:return D.info;case w.LogLevel.Warning:return D.warn;case w.LogLevel.Error:return D.error;case w.LogLevel.Critical:return D.critical;default:throw new Error("Invalid log level")}}class L extends w.AbstractLogger{constructor(k=w.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}set logger(k){this._logger=k;for(const{level:b,args:g}of this.buffer)n(k,b).apply(k,g);this.buffer=[]}_log(k,...b){this._logger?n(this._logger,k).apply(this._logger,b):this.getLevel()<=k&&this.buffer.push({level:k,args:b})}trace(k,...b){this._log(w.LogLevel.Trace,k,...b)}debug(k,...b){this._log(w.LogLevel.Debug,k,...b)}info(k,...b){this._log(w.LogLevel.Info,k,...b)}warn(k,...b){this._log(w.LogLevel.Warning,k,...b)}error(k,...b){this._log(w.LogLevel.Error,k,...b)}critical(k,...b){this._log(w.LogLevel.Critical,k,...b)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=L}),define(Z[191],x([0,1,9,16,17,20,5,95,6]),function(V,e,w,n,L,D,k,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const S=5*D.ByteSize.MB;let C=class extends g.AbstractLogger{constructor(p,t,d,m,v){super();this.name=p,this.resource=t,this.donotUseFormatters=m,this.fileService=v,this.backupIndex=1,this.setLevel(d),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=g.LogLevel.Trace&&this._log(g.LogLevel.Trace,(0,g.format)(arguments))}debug(){this.getLevel()<=g.LogLevel.Debug&&this._log(g.LogLevel.Debug,(0,g.format)(arguments))}info(){this.getLevel()<=g.LogLevel.Info&&this._log(g.LogLevel.Info,(0,g.format)(arguments))}warn(){this.getLevel()<=g.LogLevel.Warning&&this._log(g.LogLevel.Warning,(0,g.format)(arguments))}error(){if(this.getLevel()<=g.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=p.stack,this._log(g.LogLevel.Error,(0,g.format)(t))}else this._log(g.LogLevel.Error,(0,g.format)(arguments))}}critical(){this.getLevel()<=g.LogLevel.Critical&&this._log(g.LogLevel.Critical,(0,g.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,t){this.queue.queue(async()=>{await this.initializePromise;let d=await this.loadContent();d.length>S&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(d)),d=""),this.donotUseFormatters?d+=t:d+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(d))})}getCurrentTimestamp(){const p=m=>m<10?`0${m}`:m,t=m=>m<10?`00${m}`:m<100?`0${m}`:m,d=new Date;return`${d.getFullYear()}-${p(d.getMonth()+1)}-${p(d.getDate())} ${p(d.getHours())}:${p(d.getMinutes())}:${p(d.getSeconds())}.${t(d.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,L.joinPath)((0,L.dirname)(this.resource),`${(0,L.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(p){switch(p){case g.LogLevel.Critical:return"critical";case g.LogLevel.Debug:return"debug";case g.LogLevel.Error:return"error";case g.LogLevel.Info:return"info";case g.LogLevel.Trace:return"trace";case g.LogLevel.Warning:return"warning"}return""}};C=ue([te(4,D.IFileService)],C),e.FileLogger=C;let E=class extends g.AbstractLoggerService{constructor(p,t,d){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=t,this.fileService=d}doCreateLogger(p,t,d){const m=new b.BufferLogService(t);return(0,D.whenProviderRegistered)(p,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(C,d?.name||(0,L.basename)(p),p,m.getLevel(),!!d?.donotUseFormatters)),m}};E=ue([te(0,g.ILogService),te(1,k.IInstantiationService),te(2,D.IFileService)],E),e.FileLoggerService=E}),define(Z[192],x([0,1,4,8,6]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class D{constructor(I){this.service=I,this.onDidChangeLogLevel=w.Event.buffer(I.onDidChangeLogLevel,!0)}listen(I,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(I,p,t){switch(p){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=D;class k{constructor(I){this.channel=I}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(I){k.setLevel(this.channel,I)}static setLevel(I,p){return I.call("setLevel",p)}}e.LogLevelChannelClient=k;class b{constructor(I){this.loggerService=I,this.loggers=new Map}listen(I,p){throw new Error(`Event not found: ${p}`)}async call(I,p,t){switch(p){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${p}`)}createLogger(I,p){this.loggers.set(I.toString(),this.loggerService.createLogger(I,p))}consoleLog(I,p){let t=console.log;switch(I){case L.LogLevel.Error:t=console.error;break;case L.LogLevel.Warning:t=console.warn;break;case L.LogLevel.Info:t=console.info;break}t.call(console,...p)}log(I,p){const t=this.loggers.get(I.toString());if(!t)throw new Error("Create the logger before logging");for(const[d,m]of p)(0,L.log)(t,d,m)}}e.LoggerChannel=b;class g extends L.AbstractLoggerService{constructor(I,p,t){super(I,p);this.channel=t}createConsoleMainLogger(){return new L.AdapterLogger({log:(I,p)=>{this.channel.call("consoleLog",[I,p])}})}doCreateLogger(I,p,t){return new S(this.channel,I,p,t)}}e.LoggerChannelClient=g;class S extends L.AbstractMessageLogger{constructor(I,p,t,d){super(d?.always);this.channel=I,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[p,d]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(I,p){const t=[[I,p]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(I){this.channel.call("log",[this.file,I])}}class C extends L.LogService{constructor(I,p){super(p);this.parent=I,this._register(I.onDidChangeLogLevel(t=>p.setLevel(t)))}setLevel(I){super.setLevel(I),this.parent.setLevel(I)}}e.FollowerLogService=C}),define(Z[96],x([0,1,20,6]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function L(b,g,S,C,E){try{const I=await new Promise((t,d)=>{V(["spdlog"],t,d)});I.setFlushOn(n.LogLevel.Trace);const p=await I.createAsyncRotatingLogger(b,g,S,C);return E&&p.clearFormatters(),p}catch(I){console.error(I)}return null}function D(b,g,S){switch(g){case n.LogLevel.Trace:b.trace(S);break;case n.LogLevel.Debug:b.debug(S);break;case n.LogLevel.Info:b.info(S);break;case n.LogLevel.Warning:b.warn(S);break;case n.LogLevel.Error:b.error(S);break;case n.LogLevel.Critical:b.critical(S);break;default:throw new Error("Invalid log level")}}class k extends n.AbstractMessageLogger{constructor(g,S,C,E,I){super();this.buffer=[],this.setLevel(I),this._loggerCreationPromise=this._createSpdLogLogger(g,S,C,E),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}async _createSpdLogLogger(g,S,C,E){const I=C?6:1,p=30/I*w.ByteSize.MB,t=await L(g,S,p,I,E);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:d,message:m}of this.buffer)D(this._logger,d,m);this.buffer=[]}}log(g,S){this._logger?D(this._logger,g,S):this.getLevel()<=g&&this.buffer.push({level:g,message:S})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(Z[193],x([0,1,10,17,31,20,191,6,96]),function(V,e,w,n,L,D,k,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let S=class extends b.AbstractLoggerService{constructor(E,I){super(E.getLevel(),E.onDidChangeLogLevel);this.fileService=I}doCreateLogger(E,I,p){return E.scheme===w.Schemas.file?new g.SpdLogLogger(p?.name||(0,L.generateUuid)(),E.fsPath,!p?.donotRotate,!!p?.donotUseFormatters,I):new k.FileLogger(p?.name??(0,n.basename)(E),E,I,!!p?.donotUseFormatters,this.fileService)}};S=ue([te(0,b.ILogService),te(1,D.IFileService)],S),e.LoggerService=S}),define(Z[194],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(k){return k.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function n(k){return k.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function L(k){return k.uri!==void 0}e.isMenubarMenuItemRecentAction=L;function D(k){return!w(k)&&!n(k)&&!L(k)}e.isMenubarMenuItemAction=D}),define(Z[53],x([0,1,10,2,36,17]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const b=n.globals.vscode.context.configuration();if(b)k=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const b=(0,D.dirname)(w.FileAccess.asFileUri("",V));k=V.__$__nodeRequire((0,D.joinPath)(b,"product.json").fsPath);const g=V.__$__nodeRequire((0,D.joinPath)(b,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),Object.assign(k,{version:g.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(Z[21],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[195],x([0,1,74,4,3,6,2,52,21]),function(V,e,w,n,L,D,k,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=void 0;let S=class gt extends L.Disposable{constructor(E,I,p,t){super();this.isRunningOnServer=E,this.logService=I,this.environmentMainService=p,this.productService=t,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getSecretStoragePrefix(){return`${this.productService.urlProtocol}${this.isRunningOnServer?"-server":""}`}async getPassword(E,I){const p=await this.withKeytar(),t=await p.getPassword(E,I);if(t)try{let{content:d,hasNextChunk:m}=JSON.parse(t);if(!d||!m)return t;let v=1;for(;m;){const M=await p.getPassword(E,`${I}-${v}`),h=JSON.parse(M);d+=h.content,m=h.hasNextChunk,v++}return d}catch{return t}return t}async setPassword(E,I,p){const t=await this.withKeytar(),d=3,m=async(v,M,h)=>{let l=0,c;for(;l<d;)try{await t.setPassword(v,M,h);return}catch(a){c=a,this.logService.warn("Error attempting to set a password: ",a),l++,await new Promise(f=>setTimeout(f,200))}throw c};if(k.isWindows&&p.length>gt.MAX_PASSWORD_LENGTH){let v=0,M=0,h=!0;for(;h;){const l=p.substring(v,v+gt.PASSWORD_CHUNK_SIZE);v+=gt.PASSWORD_CHUNK_SIZE,h=p.length-v>0;const c={content:l,hasNextChunk:h};await m(E,M?`${I}-${M}`:I,JSON.stringify(c)),M++}}else await m(E,I,p);this._onDidChangePassword.fire({service:E,account:I})}async deletePassword(E,I){const t=await(await this.withKeytar()).deletePassword(E,I);return t&&this._onDidChangePassword.fire({service:E,account:I}),t}async findPassword(E){return(await this.withKeytar()).findPassword(E)}async findCredentials(E){return(await this.withKeytar()).findCredentials(E)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new w.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((E,I)=>{V(["keytar"],E,I)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(E){if(!this.isRunningOnServer)throw E;this.logService.warn(`Switching to using in-memory credential store instead because Keytar failed to load: ${E.message}`),this._keytarCache=new w.InMemoryCredentialsProvider}return this._keytarCache}clear(){return this._keytarCache instanceof w.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};S.MAX_PASSWORD_LENGTH=2500,S.PASSWORD_CHUNK_SIZE=S.MAX_PASSWORD_LENGTH-100,S=ue([te(1,D.ILogService),te(2,b.INativeEnvironmentService),te(3,g.IProductService)],S),e.CredentialsMainService=S}),define(Z[196],x([0,1,60,6,21]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let D=class{constructor(b,g){this.productService=b,this.logService=g,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(b,g){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const S=/^(.*)#([^#]+)$/.exec(g);if(!S)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",g),!1;const[,C,E]=S;let I=this.trustedExtensionUrlPublicKeys.get(b);if(!I){if(I=this.productService.trustedExtensionUrlPublicKeys[b],!I||I.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",b),!1;this.trustedExtensionUrlPublicKeys.set(b,[...I])}const p=Buffer.from(decodeURIComponent(E),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",g),!1;const t=p.slice(0,6),d=p.readUIntBE(0,6),m=Date.now()-d;if(m<0||m>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",g),!1;const v=p.slice(6),M=w.createVerify("SHA256");M.write(t),M.write(Buffer.from(C)),M.end();for(let h=0;h<I.length;h++){let l=I[h];if(l!==null){if(typeof l=="string")try{l=w.createPublicKey({key:Buffer.from(l,"base64"),format:"der",type:"spki"}),I[h]=l}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${b}:`,c),I[h]=null;continue}if(M.verify(l,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",g),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",g),!1}};D=ue([te(0,L.IProductService),te(1,n.ILogService)],D),e.ExtensionUrlTrustService=D}),define(Z[54],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(Z[197],x([0,1,12,3,35,10,7,2,8,31,52,6]),function(V,e,w,n,L,D,k,b,g,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let I=class extends n.Disposable{constructor(t,d){super();this.logService=d,this.validRoots=L.TernarySearchTree.forPaths(!b.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(t.appRoot),this.addValidFileRoot(t.extensionsPath),this.addValidFileRoot(t.globalStorageHome.fsPath),this.addValidFileRoot(t.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=w.session;t.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(d,m)=>this.handleResourceRequest(d,m)),t.protocol.interceptFileProtocol(D.Schemas.file,(d,m)=>this.handleFileRequest(d,m)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(t){const d=(0,k.normalize)(t);return this.validRoots.get(d)?n.Disposable.None:(this.validRoots.set(d,!0),(0,n.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(t,d){const m=g.URI.parse(t.url);return this.logService.error(`Refused to load resource ${m.fsPath} from ${D.Schemas.file}: protocol (original URL: ${t.url})`),d({error:-3})}handleResourceRequest(t,d){const m=this.requestToNormalizedFilePath(t);return this.validRoots.findSubstr(m)?d({path:m}):this.validExtensions.has((0,k.extname)(m))?d({path:m}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${m} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),d({error:-3}))}requestToNormalizedFilePath(t){const d=g.URI.parse(t.url),m=D.FileAccess.asFileUri(d);return(0,k.normalize)(m.fsPath)}createIPCObjectUrl(){let t;const d=g.URI.from({scheme:"vscode",path:(0,S.generateUuid)()}),m=d.toString(),v=async()=>t;return w.ipcMain.handle(m,v),this.logService.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:d,update:M=>t=M,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${m}.`),w.ipcMain.removeHandler(m)}}}};I=ue([te(0,C.INativeEnvironmentService),te(1,E.ILogService)],I),e.ProtocolMainService=I}),define(Z[40],x([0,1,106,14]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(k,b){w.ok(n.isString(k)),w.ok(n.isObject(b)),w.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,b)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new L}),define(Z[198],x([0,1,4,40]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class D{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,S){this.schemasById[L(g)]=S,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new D;n.Registry.add(e.Extensions.JSONContribution,k)}),define(Z[55],x([0,1,30,4,14,140,198,40]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var g;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(g=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=b.Registry.as(k.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(c,a=!0){this.registerConfigurations([c],a)}registerConfigurations(c,a=!0){const f=this.doRegisterConfigurations(c,a);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f})}deregisterConfigurations(c){const a=this.doDeregisterConfigurations(c);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:c,remove:a}){const f=[];f.push(...this.doDeregisterConfigurations(a)),f.push(...this.doRegisterConfigurations(c,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,w.distinct)(f)})}registerDefaultConfigurations(c){const a=[],f=[];for(const{overrides:s,source:i}of c)for(const r in s)if(a.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const o={...this.configurationDefaultsOverrides.get(r)?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:o});const u={type:"object",default:o,description:D.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:L.isString(i)?void 0:i};f.push(...t(r)),this.configurationProperties[r]=u,this.defaultLanguageConfigurationOverridesNode.properties[r]=u}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:i});const o=this.configurationProperties[r];o&&(this.updatePropertyDefaultValue(r,o),this.updateSchema(r,o))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(c){const a=[];for(const{overrides:f,source:s}of c)for(const i in f){const r=this.configurationDefaultsOverrides.get(i),o=L.isString(s)?s:s?.id,u=L.isString(r?.source)?r?.source:r?.source?.id;if(o===u)if(a.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const y=this.configurationProperties[i];y&&(this.updatePropertyDefaultValue(i,y),this.updateSchema(i,y))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const a of c)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,a){const f=[];return c.forEach(s=>{f.push(...this.validateAndRegisterProperties(s,a,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),f}doDeregisterConfigurations(c){const a=[],f=s=>{if(s.properties)for(const i in s.properties)a.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i]);s.allOf&&s.allOf.forEach(i=>f(i))};for(const s of c){f(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}return a}validateAndRegisterProperties(c,a=!0,f,s,i=3){i=L.isUndefinedOrNull(c.scope)?i:c.scope;let r=[],o=c.properties;if(o)for(let y in o){if(a&&M(y)){delete o[y];continue}const P=o[y];if(P.source=f,P.defaultDefaultValue=o[y].default,this.updatePropertyDefaultValue(y,P),e.OVERRIDE_PROPERTY_REGEX.test(y)?P.scope=void 0:(P.scope=L.isUndefinedOrNull(P.scope)?i:P.scope,P.restricted=L.isUndefinedOrNull(P.restricted)?!!s?.includes(y):P.restricted),o[y].hasOwnProperty("included")&&!o[y].included){this.excludedConfigurationProperties[y]=o[y],delete o[y];continue}else this.configurationProperties[y]=o[y];!o[y].deprecationMessage&&o[y].markdownDeprecationMessage&&(o[y].deprecationMessage=o[y].markdownDeprecationMessage),r.push(y)}let u=c.allOf;if(u)for(let y of u)r.push(...this.validateAndRegisterProperties(y,a,f,s,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(c){const a=f=>{let s=f.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let i=f.allOf;i&&i.forEach(a)};a(c)}updateSchema(c,a){switch(e.allSettings.properties[c]=a,a.scope){case 1:e.applicationSettings.properties[c]=a;break;case 2:e.machineSettings.properties[c]=a;break;case 6:e.machineOverridableSettings.properties[c]=a;break;case 3:e.windowSettings.properties[c]=a;break;case 4:e.resourceSettings.properties[c]=a;break;case 5:e.resourceSettings.properties[c]=a,this.resourceLanguageSettingsSchema.properties[c]=a;break}}removeFromSchema(c,a){switch(delete e.allSettings.properties[c],a.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c],delete this.resourceLanguageSettingsSchema.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const a=`[${c}]`,f={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,f),e.allSettings.properties[a]=f,e.applicationSettings.properties[a]=f,e.machineSettings.properties[a]=f,e.machineOverridableSettings.properties[a]=f,e.windowSettings.properties[a]=f,e.resourceSettings.properties[a]=f}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const c={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,a){const f=this.configurationDefaultsOverrides.get(c);let s=f?.value,i=f?.source;L.isUndefined(s)&&(s=a.defaultDefaultValue,i=void 0),L.isUndefined(s)&&(s=m(a.type)),a.default=s,a.defaultValueSource=i}}const I="\\[([^\\]]+)\\]",p=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(l){const c=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let a=p.exec(l);for(;a?.length;){const f=a[1].trim();f&&c.push(f),a=p.exec(l)}}return(0,w.distinct)(c)}e.overrideIdentifiersFromKey=t;function d(l){return l.reduce((c,a)=>`${c}[${a}]`,"")}e.keyFromOverrideIdentifiers=d;function m(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const v=new E;b.Registry.add(e.Extensions.Configuration,v);function M(l){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?D.localize(7,null,l):v.getConfigurationProperties()[l]!==void 0?D.localize(8,null,l):null:D.localize(6,null)}e.validateProperty=M;function h(){const l=[],c=v.getConfigurationProperties();for(const a of Object.keys(c))l.push([a,c[a].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=h}),define(Z[199],x([0,1,30,4,44,3,35,49,14,8,19,55,40]),function(V,e,w,n,L,D,k,b,g,S,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(s={},i=[],r=[]){this._contents=s,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,C.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const r=this.getContentsForOverrideIdentifer(i);return r?s?(0,C.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const r of this.overrides)r.identifiers.includes(s)&&i.push(...r.keys);return w.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return w.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=b.deepClone(this.contents),r=b.deepClone(this.overrides),o=[...this.keys];for(const u of s){this.mergeContents(i,u.contents);for(const y of u.overrides){const[P]=r.filter(R=>w.equals(R.identifiers,y.identifiers));P?(this.mergeContents(P.contents,y.contents),P.keys.push(...y.keys),P.keys=w.distinct(P.keys)):r.push(b.deepClone(y))}for(const y of u.keys)o.indexOf(y)===-1&&o.push(y)}return new p(i,o,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const o of w.distinct([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[o],y=i[o];y&&(typeof u=="object"&&typeof y=="object"?(u=b.deepClone(u),this.mergeContents(u,y)):u=y),r[o]=u}return new p(r,this.keys,this.overrides)}mergeContents(s,i){for(const r of Object.keys(i)){if(r in s&&g.isObject(s[r])&&g.isObject(i[r])){this.mergeContents(s[r],i[r]);continue}s[r]=b.deepClone(i[r])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?b.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,r=null;const o=u=>{u&&(r?this.mergeContents(r,u):r=b.deepClone(u))};for(const u of this.overrides)w.equals(u.identifiers,[s])?i=u.contents:u.identifiers.includes(s)&&o(u.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,C.addToValueTree)(this.contents,s,i,r=>{throw new Error(r)})}removeValue(s){this.removeKey(s)&&(0,C.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let r=0;r<i;r++)s.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,s)}removeKey(s){let i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=p;class t extends p{constructor(s={}){const i=I.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),o=Object.create(null),u=[];for(const y in i){const P=s[y],R=P!==void 0?P:i[y].default;(0,C.addToValueTree)(o,y,R,W=>console.error(`Conflict in default settings: ${W}`))}for(const y of Object.keys(o))E.OVERRIDE_PROPERTY_REGEX.test(y)&&u.push({identifiers:(0,E.overrideIdentifiersFromKey)(y),keys:Object.keys(o[y]),contents:(0,C.toValuesTree)(o[y],P=>console.error(`Conflict in default settings file: ${P}`))});super(o,r,u)}}e.DefaultConfigurationModel=t;class d{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!g.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:r,keys:o,overrides:u,restricted:y}=this.doParseRaw(s,i);this._configurationModel=new p(r,o,u),this._restrictedConfigurations=y||[]}doParseContent(s){let i={},r=null,o=[],u=[],y=[];function P(W){Array.isArray(o)?o.push(W):r!==null&&(o[r]=W)}let R={onObjectBegin:()=>{let W={};P(W),u.push(o),o=W,r=null},onObjectProperty:W=>{r=W},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let W=[];P(W),u.push(o),o=W,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:P,onError:(W,U,G)=>{y.push({error:W,offset:U,length:G})}};if(s)try{L.visit(s,R),i=o[0]||{}}catch(W){console.error(`Error while parsing settings file ${this._name}: ${W}`),this._parseErrors=[W]}return i}doParseRaw(s,i){const r=I.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(s,r,!0,i);s=o.raw;const u=(0,C.toValuesTree)(s,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),y=Object.keys(s),P=this.toOverrides(s,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:u,keys:y,overrides:P,restricted:o.restricted}}filter(s,i,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:s,restricted:[]};const u={},y=[];for(let P in s)if(E.OVERRIDE_PROPERTY_REGEX.test(P)&&r){const R=this.filter(s[P],i,!1,o);u[P]=R.raw,y.push(...R.restricted)}else{const R=i[P],W=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&y.push(P),(W===void 0||o.scopes===void 0||o.scopes.includes(W))&&(o.skipRestricted&&R?.restricted||(u[P]=s[P]))}return{raw:u,restricted:y}}toOverrides(s,i){const r=[];for(const o of Object.keys(s))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const u={};for(const y in s[o])u[y]=s[o][y];r.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(u),contents:(0,C.toValuesTree)(u,i)})}return r}}e.ConfigurationModelParser=d;class m extends D.Disposable{constructor(s,i,r,o){super();this.userSettingsResource=s,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(1)||u.isOperation(4))&&r.isEqual(u.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class v{constructor(s,i,r=new p,o=new p,u=new k.ResourceMap,y=new p,P=new k.ResourceMap,R=!0){this._defaultConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=y,this._memoryConfigurationByResource=P,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(s,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(s)}updateValue(s,i,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new p,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(s):o.setValue(s,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,r){const o=this.getConsolidateConfigurationModel(i,r),u=this.getFolderConfigurationModelForResource(i.resource,r),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),R=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),W=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),U=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),G=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,ee=u?i.overrideIdentifier?u.freeze().override(i.overrideIdentifier).getValue(s):u.freeze().getValue(s):void 0,X=i.overrideIdentifier?y.override(i.overrideIdentifier).getValue(s):y.getValue(s),J=o.getValue(s),H=w.distinct(w.flatten(o.overrides.map(B=>B.identifiers))).filter(B=>o.getOverrideValue(s,B)!==void 0);return{defaultValue:P,userValue:R,userLocalValue:W,userRemoteValue:U,workspaceValue:G,workspaceFolderValue:ee,memoryValue:X,value:J,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:G!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ee!==void 0?{value:u?.freeze().getValue(s),override:i.overrideIdentifier?u?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:X!==void 0?{value:y.getValue(s),override:i.overrideIdentifier?y.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const r=[];if(!i){const{added:o,updated:u,removed:y}=c(this._defaultConfiguration,s);i=[...o,...u,...y]}for(const o of i)for(const u of(0,E.overrideIdentifiersFromKey)(o)){const y=this._defaultConfiguration.getKeysForOverrideIdentifier(u),P=s.getKeysForOverrideIdentifier(u),R=[...P.filter(W=>y.indexOf(W)===-1),...y.filter(W=>P.indexOf(W)===-1),...y.filter(W=>!b.equals(this._defaultConfiguration.override(u).getValue(W),s.override(u).getValue(W)))];r.push([u,R])}return this.updateDefaultConfiguration(s),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:r,removed:o,overrides:u}=c(this.localUserConfiguration,s),y=[...i,...r,...o];return y.length&&this.updateLocalUserConfiguration(s),{keys:y,overrides:u}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:r,removed:o,overrides:u}=c(this.remoteUserConfiguration,s);let y=[...i,...r,...o];return y.length&&this.updateRemoteUserConfiguration(s),{keys:y,overrides:u}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:r,removed:o,overrides:u}=c(this.workspaceConfiguration,s);let y=[...i,...r,...o];return y.length&&this.updateWorkspaceConfiguration(s),{keys:y,overrides:u}}compareAndUpdateFolderConfiguration(s,i){const r=this.folderConfigurations.get(s),{added:o,updated:u,removed:y,overrides:P}=c(r,i);let R=[...o,...u,...y];return(R.length||!r)&&this.updateFolderConfiguration(s,i),{keys:R,overrides:P}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:o,removed:u,overrides:y}=c(i,void 0);return{keys:[...r,...o,...u],overrides:y}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,i){let r=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier?r.override(s.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:s},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const o=i.getFolder(s);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const u=this._memoryConfigurationByResource.get(s);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(s);o?(i=r.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=r}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const r=i.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:r,overrides:o,keys:u}=this._folderConfigurations.get(i);return s.push([i,{contents:r,overrides:o,keys:u}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.user),o=this.parseConfigurationModel(s.workspace),u=s.folders.reduce((y,P)=>(y.set(S.URI.revive(P[0]),this.parseConfigurationModel(P[1])),y),new k.ResourceMap);return new v(i,r,new p,o,u,new p,new k.ResourceMap,!1)}static parseConfigurationModel(s){return new p(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=v;function M(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const s=new Set,i=new Map;for(const o of f)o.keys.forEach(u=>s.add(u)),o.overrides.forEach(([u,y])=>{const P=(0,k.getOrSet)(i,u,new Set);y.forEach(R=>P.add(R))});const r=[];return i.forEach((o,u)=>r.push([u,[...o.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=M;class h{constructor(s,i,r,o){this.change=s,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;s.keys.forEach(P=>u.add(P)),s.overrides.forEach(([,P])=>P.forEach(R=>u.add(R))),this.affectedKeys=[...u.values()];const y=new p;this.affectedKeys.forEach(P=>y.setValue(P,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!b.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let r=(0,C.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(s=s[o],!s)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=h;class l extends h{constructor(s,i,r,o){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=l;function c(f,s){const{added:i,removed:r,updated:o}=a(s,f),u=[],y=f?.getAllOverrideIdentifiers()||[],P=s?.getAllOverrideIdentifiers()||[];if(s){const R=P.filter(W=>!y.includes(W));for(const W of R)u.push([W,s.getKeysForOverrideIdentifier(W)])}if(f){const R=y.filter(W=>!P.includes(W));for(const W of R)u.push([W,f.getKeysForOverrideIdentifier(W)])}if(s&&f){for(const R of y)if(P.includes(R)){const W=a({contents:f.getOverrideValue(void 0,R)||{},keys:f.getKeysForOverrideIdentifier(R)},{contents:s.getOverrideValue(void 0,R)||{},keys:s.getKeysForOverrideIdentifier(R)});u.push([R,[...W.added,...W.removed,...W.updated]])}}return{added:i,removed:r,updated:o,overrides:u}}function a(f,s){const i=f?s?f.keys.filter(u=>s.keys.indexOf(u)===-1):[...f.keys]:[],r=s?f?s.keys.filter(u=>f.keys.indexOf(u)===-1):[...s.keys]:[],o=[];if(f&&s){for(const u of s.keys)if(f.keys.indexOf(u)!==-1){const y=(0,C.getConfigurationValue)(s.contents,u),P=(0,C.getConfigurationValue)(f.contents,u);b.equals(y,P)||o.push(u)}}return{added:i,removed:r,updated:o}}}),define(Z[200],x([0,1,9,4,3,17,19,199,55,40]),function(V,e,w,n,L,D,k,b,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends L.Disposable{constructor(I,p){super();this.settingsResource=I,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,p)),this.configuration=new b.Configuration(new b.DefaultConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(S.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const I=await this.userConfiguration.loadConfiguration();this.configuration=new b.Configuration(new b.DefaultConfigurationModel,I)}getConfigurationData(){return this.configuration.toData()}getValue(I,p){const t=typeof I=="string"?I:void 0,d=(0,k.isConfigurationOverrides)(I)?I:(0,k.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(t,d,void 0)}updateValue(I,p,t,d){return Promise.reject(new Error("not supported"))}inspect(I){return this.configuration.inspect(I,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const I=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(I)}onDidChangeUserConfiguration(I){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(I);this.trigger(t,p,1)}onDidDefaultConfigurationChange(I){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new b.DefaultConfigurationModel,I);this.trigger(t,p,6)}trigger(I,p,t){const d=new b.ConfigurationChangeEvent(I,{data:p},this.configuration);d.source=t,d.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(I){switch(I){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(Z[201],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var n;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(k,b=n.Unknown,g){super(k);this._message=k,this._code=b,this._detail=g,this.isHandled=b===n.NotAvailable&&g===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(k){return k instanceof L&&k._code===n.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof L&&k._code===n.NoResolverFound}static isHandled(k){return k instanceof L&&k.isHandled}}e.RemoteAuthorityResolverError=L}),define(Z[202],x([0,1,9,16,23,15,4,3,31,88,201]),function(V,e,w,n,L,D,k,b,g,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var I;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(I=e.ConnectionType||(e.ConnectionType={}));function p(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(z){const F=new L.CancellationTokenSource;return setTimeout(()=>F.cancel(),z),F.token}function d(z,F){if(z.isCancellationRequested||F.isCancellationRequested)return L.CancellationToken.Cancelled;const N=new L.CancellationTokenSource;return z.onCancellationRequested(()=>N.cancel()),F.onCancellationRequested(()=>N.cancel()),N.token}class m{constructor(F){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((N,T)=>{this._resolvePromise=N,this._rejectPromise=T}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function v(z,F){const N=new m(F);return N.registerDisposable(z.onControlMessage(T=>{const A=JSON.parse(T.toString()),O=Y(A);O?N.reject(O):N.resolve(A)})),N.promise}function M(z,F,N,T,A,O,_){const j=new m(_);return F.connect(N,T,A,O,(ie,ae)=>{j.didTimeout?(ie&&z.error(ie),ae?.dispose()):ie||!ae?j.reject(ie):j.resolve(ae)}),j.promise}function h(z,F){const N=new m(F);return z.then(T=>{N.didTimeout||N.resolve(T)},T=>{N.didTimeout||N.reject(T)}),N.promise}async function l(z,F,N,T){const A=q(z,F);z.logService.trace(`${A} 1/6. invoking socketFactory.connect().`);let O;try{O=await M(z.logService,z.socketFactory,z.host,z.port,`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${p(F)}-${z.reconnectionToken}`,T)}catch(ce){throw z.logService.error(`${A} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ce),ce}z.logService.trace(`${A} 2/6. socketFactory.connect() was successful.`);let _,j;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(O,null),_=z.reconnectionProtocol,j=!1):(_=new S.PersistentProtocol(O,null),j=!0),z.logService.trace(`${A} 3/6. sending AuthRequest control message.`);const ie=await h(z.signService.createNewMessage((0,g.generateUuid)()),T),ae={type:"auth",auth:z.connectionToken||"00000000000000000000",data:ie.data};_.sendControl(n.VSBuffer.fromString(JSON.stringify(ae)));try{const ce=await v(_,d(T,t(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(z.logService.trace(`${A} 4/6. received SignRequest control message.`),!await h(z.signService.validate(ie,ce.signedData),T)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const le=await h(z.signService.sign(ce.data),T),he={type:"connectionType",commit:z.commit,signedData:le,desiredConnectionType:F};return N&&(he.args=N),z.logService.trace(`${A} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(n.VSBuffer.fromString(JSON.stringify(he))),{protocol:_,ownsProtocol:j}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(z.logService.error(`${A} the handshake timed out. Error:`),z.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${A} received error control message when negotiating connection. Error:`),z.logService.error(ce)),j&&B(_),ce}}async function c(z,F,N,T){const A=Date.now(),O=q(z,F),{protocol:_,ownsProtocol:j}=await l(z,F,N,T),ie=new m(T);return ie.registerDisposable(_.onControlMessage(ae=>{const ce=JSON.parse(ae.toString()),ne=Y(ce);ne?(z.logService.error(`${O} received error control message when negotiating connection. Error:`),z.logService.error(ne),j&&B(_),ie.reject(ne)):(z.reconnectionProtocol&&z.reconnectionProtocol.endAcceptReconnection(),z.logService.trace(`${O} 6/6. handshake finished, connection is up and running after ${Q(A)}!`),ie.resolve({protocol:_,firstMessage:ce}))})),ie.promise}async function a(z,F){const{protocol:N}=await c(z,1,void 0,F);return{protocol:N}}async function f(z,F,N){const{protocol:T,firstMessage:A}=await c(z,2,F,N),O=A&&A.debugPort;return{protocol:T,debugPort:O}}async function s(z,F,N){const T=Date.now(),A=q(z,3),{protocol:O}=await l(z,3,F,N);return z.logService.trace(`${A} 6/6. handshake finished, connection is up and running after ${Q(T)}!`),O}async function i(z,F,N){const{host:T,port:A,connectionToken:O}=await z.addressProvider.getAddress();return{commit:z.commit,host:T,port:A,connectionToken:O,reconnectionToken:F,reconnectionProtocol:N,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function r(z,F,N){try{const T=(0,g.generateUuid)(),A=await i(z,T,null),{protocol:O}=await a(A,L.CancellationToken.None);return new J(z,F,N,T,O)}catch(T){throw z.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),z.logService.error(T),X.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(T)),T}}e.connectRemoteAgentManagement=r;async function o(z,F){try{const N=(0,g.generateUuid)(),T=await i(z,N,null),{protocol:A,debugPort:O}=await f(T,F,L.CancellationToken.None);return new H(z,F,N,A,O)}catch(N){throw z.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),z.logService.error(N),X.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(N)),N}}e.connectRemoteAgentExtensionHost=o;async function u(z,F,N){const T=await i(z,(0,g.generateUuid)(),null);return await s(T,{host:F,port:N},L.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function y(z){return(0,w.createCancelablePromise)(F=>new Promise((N,T)=>{const A=setTimeout(N,z*1e3);F.onCancellationRequested(()=>{clearTimeout(A),N()})}))}var P;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(P=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class R{constructor(F,N){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=R;class W{constructor(F,N,T,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.durationSeconds=T,this.cancellableTimer=A,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class U{constructor(F,N,T){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=T,this.type=2}}e.ReconnectionRunningEvent=U;class G{constructor(F,N,T){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=T,this.type=4}}e.ConnectionGainEvent=G;class ee{constructor(F,N,T,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=T,this.handled=A,this.type=3}}e.ReconnectionPermanentFailureEvent=ee;class X extends b.Disposable{constructor(F,N,T,A){super();this._connectionType=F,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=N,this.reconnectionToken=T,this.protocol=A,this._isReconnecting=!1,this._onDidStateChange.fire(new G(this.reconnectionToken,0,0)),this._register(A.onSocketClose(O=>{const _=$(this._connectionType,this.reconnectionToken,!0);O?O.type===0?(this._options.logService.info(`${_} received socket close event (hadError: ${O.hadError}).`),O.error&&this._options.logService.error(O.error)):(this._options.logService.info(`${_} received socket close event (wasClean: ${O.wasClean}, code: ${O.code}, reason: ${O.reason}).`),O.event&&this._options.logService.error(O.event)):this._options.logService.info(`${_} received socket close event.`),this._beginReconnecting()})),this._register(A.onSocketTimeout(()=>{const O=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} received socket timeout event.`),this._beginReconnecting()})),X._instances.push(this),X._permanentFailure&&this._gotoPermanentFailure(X._permanentFailureMillisSinceLastIncomingData,X._permanentFailureAttempt,X._permanentFailureHandled)}static triggerPermanentFailure(F,N,T){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=N,this._permanentFailureHandled=T,this._instances.forEach(A=>A._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(F=>F._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(F=>F._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(X._permanentFailure)return;const F=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let T=-1;do{T++;const A=T<N.length?N[T]:N[N.length-1];try{if(A>0){const _=y(A);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A,_)),this._options.logService.info(`${F} waiting for ${A} seconds before reconnecting...`);try{await _}catch{}}if(X._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1)),this._options.logService.info(`${F} resolving connection...`);const O=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${O.host}:${O.port}...`),await this._reconnect(O,t(E)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1));break}catch(O){if(O.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(O),X.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(T>360){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(O),X.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(O)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if((O.code==="ETIMEDOUT"||O.code==="ENETUNREACH"||O.code==="ECONNREFUSED"||O.code==="ECONNRESET")&&O.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if((0,D.isCancellationError)(O)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if(O instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(O),X.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,C.RemoteAuthorityResolverError.isHandled(O));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(O),X.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}}while(!X._permanentFailure)}_gotoPermanentFailure(F,N,T){this._onDidStateChange.fire(new ee(this.reconnectionToken,F,N,T)),B(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=X,X._permanentFailure=!1,X._permanentFailureMillisSinceLastIncomingData=0,X._permanentFailureAttempt=0,X._permanentFailureHandled=!1,X._instances=[];class J extends X{constructor(F,N,T,A,O){super(1,F,A,O);this.client=this._register(new S.Client(O,{remoteAuthority:N,clientId:T},F.ipcLogger))}async _reconnect(F,N){await a(F,N)}}e.ManagementPersistentConnection=J;class H extends X{constructor(F,N,T,A,O){super(2,F,T,A);this._startArguments=N,this.debugPort=O}async _reconnect(F,N){await f(F,this._startArguments,N)}}e.ExtensionHostPersistentConnection=H;function B(z){try{z.acceptDisconnect();const F=z.getSocket();z.dispose(),F.dispose()}catch(F){(0,D.onUnexpectedError)(F)}}function Y(z){if(z&&z.type==="error"){const F=new Error(`Connection error: ${z.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function se(z,F){for(;z.length<F;)z+=" ";return z}function $(z,F,N){return`[remote-connection][${se(p(z),13)}][${F.substr(0,5)}\u2026][${N?"reconnect":"initial"}]`}function q(z,F){return`${$(F,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function Q(z){return`${Date.now()-z} ms`}}),define(Z[78],x([0,1,10]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(D){return D.scheme===w.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=n;function L(D){if(!D)return;const k=D.indexOf("+");return k<0?D:D.substr(0,k)}e.getRemoteName=L}),define(Z[56],x([0,1,16,153,55,5,40]),function(V,e,w,n,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function b(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=b;function g(t){return t.res.statusCode===204}async function S(t){if(!b(t))throw new Error("Server returned "+t.res.statusCode);return g(t)?null:(await(0,w.streamToBuffer)(t.stream)).toString()}e.asText=S;async function C(t){if(!b(t))throw new Error("Server returned "+t.res.statusCode);if(g(t))return null;const m=(await(0,w.streamToBuffer)(t.stream)).toString();try{return JSON.parse(m)}catch(v){throw v.message+=`:
`+m,v}}e.asJson=C;function E(t){p(t)}e.updateProxyConfigurationsScope=E;let I;function p(t){const d=k.Registry.as(L.Extensions.Configuration),m=I;I={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[I],remove:m?[m]:[]})}p(2)}),define(Z[203],x([0,1,204,14]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function L(k,b){return k.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:k.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function D(k,b,g={}){const S=(0,w.parse)(k),C=g.proxyUrl||L(S,b);if(!C)return null;const E=(0,w.parse)(C);if(!/^https?:$/.test(E.protocol||""))return null;const I={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,n.isBoolean)(g.strictSSL)?g.strictSSL:!0};return S.protocol==="http:"?new(await new Promise((p,t)=>{V(["http-proxy-agent"],p,t)}))(I):new(await new Promise((p,t)=>{V(["https-proxy-agent"],p,t)}))(I)}e.getProxyAgent=D}),define(Z[79],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[205],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{constructor(){this.validators=new Map}vsda(){return new Promise((L,D)=>V(["vsda"],L,D))}async createNewMessage(L){try{const D=await this.vsda(),k=new D.validator;if(k){const b=String(w._nextId++);return this.validators.set(b,k),{id:b,data:k.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,D){if(!L.id)return!0;const k=this.validators.get(L.id);if(!k)return!1;this.validators.delete(L.id);try{return k.validate(D)==="ok"}catch{return!1}}async sign(L){try{const D=await this.vsda(),k=new D.signer;if(k)return k.sign(L)}catch{}return L}}e.SignService=w,w._nextId=1}),define(Z[38],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(Z[18],x([0,1,12,9,4,3,2,36,14,5,186,6,38]),function(V,e,w,n,L,D,k,b,g,S,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,S.createDecorator)("lifecycleMainService");var p;(function(m){m[m.QUIT=1]="QUIT",m[m.KILL=2]="KILL"})(p=e.ShutdownReason||(e.ShutdownReason={}));var t;(function(m){m[m.Starting=1]="Starting",m[m.Ready=2]="Ready",m[m.AfterWindowOpen=3]="AfterWindowOpen"})(t=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class mt extends D.Disposable{constructor(v,M){super();this.logService=v,this.stateMainService=M,this._onBeforeShutdown=this._register(new L.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new L.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new L.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new L.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(mt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(mt.QUIT_AND_RESTART_KEY)}registerListeners(){const v=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),k.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};w.app.addListener("before-quit",v);const M=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!k.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",M),w.app.once("will-quit",h=>{this.logService.trace("Lifecycle#app.on(will-quit)"),h.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",v),w.app.removeListener("window-all-closed",M),w.app.quit()})})}fireOnWillShutdown(v){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const M=[];return this._onWillShutdown.fire({reason:v,join(h){M.push(h)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(M)}catch(h){this.logService.error(h)}try{await this.stateMainService.close()}catch(h){this.logService.error(h)}})(),this.pendingWillShutdownPromise}set phase(v){if(v<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===v)return;this.logService.trace(`lifecycle (main): phase changed (value: ${v})`),this._phase=v;const M=this.phaseWhen.get(this._phase);M&&(M.open(),this.phaseWhen.delete(this._phase))}async when(v){if(v<=this._phase)return;let M=this.phaseWhen.get(v);M||(M=new n.Barrier,this.phaseWhen.set(v,M)),await M.wait()}registerWindow(v){const M=new D.DisposableStore;this.windowCounter++,M.add(v.onWillLoad(l=>this._onWillLoadWindow.fire({window:v,workspace:l.workspace,reason:l.reason})));const h=(0,g.assertIsDefined)(v.win);h.on("close",l=>{const c=v.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${v.id}`),l.preventDefault(),this.unload(v,1).then(a=>{if(a){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(v),v.close()})}),h.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${v.id}`),this.windowCounter--,M.dispose(),this.windowCounter===0&&(!k.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(v,M){await this.unload(v,3)||v.reload(M)}async unload(v,M){if(!v.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${v.id}`);const h=this._quitRequested?2:M;let l=await this.onBeforeUnloadWindowInRenderer(v,h);return l?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${v.id})`),this.handleWindowUnloadVeto(l)):(l=await this.onBeforeUnloadWindowInMain(v,h),l?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${v.id})`),this.handleWindowUnloadVeto(l)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${v.id})`),await this.onWillUnloadWindowInRenderer(v,h),!1))}handleWindowUnloadVeto(v){return v?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(v){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(v),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(v,M){return new Promise(h=>{const l=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${l}`,a=`vscode:cancel${l}`;w.ipcMain.once(c,()=>{h(!1)}),w.ipcMain.once(a,()=>{h(!0)}),v.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:a,reason:M})})}onBeforeUnloadWindowInMain(v,M){const h=[];return this._onBeforeUnloadWindow.fire({reason:M,window:v,veto(l){h.push(l)}}),(0,C.handleVetos)(h,l=>this.logService.error(l))}onWillUnloadWindowInRenderer(v,M){return new Promise(h=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;w.ipcMain.once(c,()=>h()),v.send("vscode:onWillUnload",{replyChannel:c,reason:M})})}quit(v){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${v}`),v&&this.stateMainService.setItem(mt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(M=>{this.pendingQuitPromiseResolve=M,this.logService.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}async relaunch(v){this.logService.trace("Lifecycle#relaunch()");const M=process.argv.slice(1);if(v?.addArgs&&M.push(...v.addArgs),v?.removeArgs)for(const c of v.removeArgs){const a=M.indexOf(c);a>=0&&M.splice(a,1)}const h=()=>{try{if(k.isWindows){const c=(0,b.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.logService.error(c)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:M})};w.app.once("quit",h),await this.quit(!0)&&w.app.removeListener("quit",h)}async kill(v){(0,E.logCi)(this.logService,"Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const M of w.BrowserWindow.getAllWindows())if(M&&!M.isDestroyed()){let h;M.webContents&&!M.webContents.isDestroyed()?h=new Promise(l=>M.once("closed",l)):h=Promise.resolve(),(0,E.logCi)(this.logService,"Lifecycle#kill() - window.destroy()"),M.destroy(),await h,(0,E.logCi)(this.logService,"Lifecycle#kill() - window closed")}})()]),(0,E.logCi)(this.logService,`Lifecycle#kill() - app.exit(${v})`),w.app.exit(v)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=ue([te(0,E.ILogService),te(1,I.IStateMainService)],d),e.LifecycleMainService=d}),define(Z[206],x([0,1,4,3,5,18]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,L.createDecorator)("keyboardLayoutMainService");let k=class extends n.Disposable{constructor(S){super();this._onDidChangeKeyboardLayout=this._register(new w.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,S.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const S=await new Promise((C,E)=>{V(["native-keymap"],C,E)});this._keyboardLayoutData=b(S),S.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=b(S),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};k=ue([te(0,D.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function b(g){const S=g.getKeyMap(),C=g.getCurrentKeyboardLayout();return{keyboardMapping:S,keyboardLayoutInfo:C}}}),define(Z[97],x([0,1,9,4,3,63,14,90,5]),function(V,e,w,n,L,D,k,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,g.createDecorator)("storageService");var C;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var I;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class p extends L.Disposable{constructor(v={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,M){M===S?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:M,target:this.getKeyTargets(v)[M]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,M,h){return this.getStorage(M)?.get(v,h)}getBoolean(v,M,h){return this.getStorage(M)?.getBoolean(v,h)}getNumber(v,M,h){return this.getStorage(M)?.getNumber(v,h)}store(v,M,h,l){if((0,k.isUndefinedOrNull)(M)){this.remove(v,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,h,l),this.getStorage(h)?.set(v,M)})}remove(v,M){this.withPausedEmitters(()=>{this.updateKeyTarget(v,M,void 0),this.getStorage(M)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,M){const h=[],l=this.getKeyTargets(v);for(const c of Object.keys(l))l[c]===M&&h.push(c);return h}updateKeyTarget(v,M,h){const l=this.getKeyTargets(M);typeof h=="number"?l[v]!==h&&(l[v]=h,this.getStorage(M)?.set(S,JSON.stringify(l))):typeof l[v]=="number"&&(delete l[v],this.getStorage(M)?.set(S,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const M=this.get(S,v);if(M)try{return JSON.parse(M)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=C.NONE){this._onWillSaveState.fire({reason:v});const M=this.getStorage(0),h=this.getStorage(1);switch(v){case C.NONE:await w.Promises.settled([M?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await w.Promises.settled([M?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,M=this.getStorage(1)?.items??new Map;return d(v,M,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends p{constructor(){super();this.globalStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=t;async function d(m,v,M,h){const l=o=>{try{return JSON.parse(o)}catch{return o}},c=new Map,a=new Map;m.forEach((o,u)=>{c.set(u,o),a.set(u,l(o))});const f=new Map,s=new Map;v.forEach((o,u)=>{f.set(u,o),s.set(u,l(o))}),console.group(`Storage: Global (path: ${M})`);let i=[];c.forEach((o,u)=>{i.push({key:u,value:o})}),console.table(i),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${h})`);let r=[];f.forEach((o,u)=>{r.push({key:u,value:o})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=d}),define(Z[207],x([0,1,2,36,8,31]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(S){if(w.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function b(S,C,E,I,p,t,d,m,v,M){const h=Object.create(null);h["common.machineId"]=d,h.sessionID=(0,D.generateUuid)()+Date.now(),h.commitHash=p,h.version=t,h["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,w.PlatformToString)(w.platform),h["common.nodePlatform"]=n.platform,h["common.nodeArch"]=I,h["common.product"]=M||"desktop";const l=g(m||[]);l&&(h["common.msftInternal"]=l);let c=0;const a=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),w.isLinuxSnap&&(h["common.snap"]="true");const f=k(E);f&&(h["common.platformDetail"]=f);try{const s=await S.readFile(L.URI.file(v));h["common.source"]=s.value.toString().slice(0,30)}catch{}return h}e.resolveCommonProperties=b;function g(S){const C=n.env.USERDNSDOMAIN;if(!C)return!1;const E=C.toLowerCase();return S.some(I=>E===I)}e.verifyMicrosoftInternalDomain=g}),define(Z[32],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[208],x([0,1,26,68,9,44,10,7,2,8,71,24,87,75,20,21,32]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(a,f){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],i=new Map,r=new Map,o=2e4;function u(R,W,U,G){const ee=W.substring(R.length+1);return L.Promises.withAsyncBody(async X=>{let J;try{J=await E.Promises.readdir(W,{withFileTypes:!0})}catch{X();return}if(G.count>=o){G.count+=J.length,G.maxReached=!0,X();return}let H=J.length;if(H===0){X();return}let B=J;G.count+J.length>o&&(G.maxReached=!0,H=o-G.count,B=J.slice(0,H)),G.count+=J.length;for(const Y of B)if(Y.isDirectory()){if(U.includes(Y.name)||await u(R,(0,b.join)(W,Y.name),U,G),--H==0){X();return}}else{const se=Y.name.lastIndexOf(".");if(se>=0){const $=Y.name.substring(se+1);$&&i.set($,(i.get($)??0)+1)}for(const $ of s)$.relativePathPattern?.test(ee)!==!1&&$.filePattern.test(Y.name)&&r.set($.tag,(r.get($.tag)??0)+1);if(--H==0){X();return}}})}const y={count:0,maxReached:!1};await u(a,a,f,y);const P=await l(a);return{configFiles:M(r),fileTypes:M(i),fileCount:y.count,maxFilesReached:y.maxReached,launchConfigFiles:P}}e.collectWorkspaceStats=v;function M(a){return[...n.Iterable.map(a.entries(),([f,s])=>({name:f,count:s}))].sort((f,s)=>s.count-f.count)}function h(){const a={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(C.virtualMachineHint.value()*100)}%`},f=w.cpus();return f&&f.length>0&&(a.cpus=`${f[0].model} (${f.length} x ${f[0].speed})`),a}e.getMachineInfo=h;async function l(a){try{const f=new Map,s=(0,b.join)(a,".vscode","launch.json"),i=await E.Promises.readFile(s),r=[],o=(0,D.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,D.getNodeType)(o)==="object"&&o.configurations)for(const u of o.configurations){const y=u.type;y&&(f.has(y)?f.set(y,f.get(y)+1):f.set(y,1))}return M(f)}catch{return[]}}e.collectLaunchConfigs=l;let c=class{constructor(f,s){this.telemetryService=f,this.productService=s}formatMachineInfo(f){const s=[];return s.push(`OS Version:       ${f.os}`),s.push(`CPUs:             ${f.cpus}`),s.push(`Memory (System):  ${f.memory}`),s.push(`VM:               ${f.vmHint}`),s.join(`
`)}formatEnvironment(f){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const i=w.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(w.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),g.isWindows||s.push(`Load (avg):       ${w.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(C.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${f.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${f.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(f.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(f,s){return Promise.all([(0,I.listProcesses)(f.mainPID),this.formatWorkspaceMetadata(f)]).then(async i=>{let[r,o]=i,u=this.formatProcessList(f,r);return s.forEach(y=>{if((0,p.isRemoteDiagnosticError)(y))u+=`
${y.errorMessage}`,o+=`
${y.errorMessage}`;else if(u+=`

Remote: ${y.hostName}`,y.processes&&(u+=`
${this.formatProcessList(f,y.processes)}`),y.workspaceMetadata){o+=`
|  Remote: ${y.hostName}`;for(const P of Object.keys(y.workspaceMetadata)){const R=y.workspaceMetadata[P];let W=`${R.fileCount} files`;R.maxFilesReached&&(W=`more than ${W}`),o+=`|    Folder (${P}): ${W}`,o+=this.formatWorkspaceStats(R)}}}),{processInfo:u,workspaceInfo:o}})}async getSystemInfo(f,s){const{memory:i,vmHint:r,os:o,cpus:u}=h(),y={os:o,memory:i,cpus:u,vmHint:r,processArgs:`${f.mainArguments.join(" ")}`,gpuStatus:f.gpuFeatureStatus,screenReader:`${f.screenReader?"yes":"no"}`,remoteData:s};return g.isWindows||(y.load=`${w.loadavg().map(P=>Math.round(P)).join(", ")}`),g.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(f,s){const i=[];return(0,I.listProcesses)(f.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(f)),i.push(""),i.push(this.formatProcessList(f,r)),f.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(f))),s.forEach(o=>{if((0,p.isRemoteDiagnosticError)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.formatMachineInfo(o.machineInfo)),o.processes&&i.push(this.formatProcessList(f,o.processes)),o.workspaceMetadata)for(const u of Object.keys(o.workspaceMetadata)){const y=o.workspaceMetadata[u];let P=`${y.fileCount} files`;y.maxFilesReached&&(P=`more than ${P}`),i.push(`Folder (${u}): ${P}`),i.push(this.formatWorkspaceStats(y))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(f){const s=[],i=60;let r=0;const o=(R,W)=>{const U=` ${R}(${W})`;r+U.length>i?(s.push(u),u="|                 ",r=u.length):r+=U.length,u+=U};let u="|      File types:";const y=10;let P=f.fileTypes.length>y?y:f.fileTypes.length;for(let R=0;R<P;R++){const W=f.fileTypes[R];o(W.name,W.count)}if(s.push(u),f.configFiles.length>=0&&(u="|      Conf files:",r=0,f.configFiles.forEach(R=>{o(R.name,R.count)}),s.push(u)),f.launchConfigFiles.length>0){let R="|      Launch Configs:";f.launchConfigFiles.forEach(W=>{R+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(R)}return s.join(`
`)}expandGPUFeatures(f){const s=Math.max(...Object.keys(f).map(i=>i.length));return Object.keys(f).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${f[i]}`).join(`
                  `)}formatWorkspaceMetadata(f){const s=[],i=[];return f.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(o=>{const u=S.URI.revive(o);if(u.scheme===k.Schemas.file){const y=u.fsPath;i.push(v(y,["node_modules",".git"]).then(P=>{let R=`${P.fileCount} files`;P.maxFilesReached&&(R=`more than ${R}`),s.push(`|    Folder (${(0,b.basename)(y)}): ${R}`),s.push(this.formatWorkspaceStats(P))}).catch(P=>{s.push(`|      Error: Unable to collect workspace stats for folder ${y} (${P.toString()})`)}))}else s.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(f,s){const i=new Map;f.windows.forEach(o=>i.set(o.pid,o.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(f.mainPID,i,r,s,0),r.join(`
`)}formatProcessItem(f,s,i,r,o){const u=o===0;let y;u?y=r.pid===f?`${this.productService.applicationName} main`:"remote agent":(y=`${"  ".repeat(o)} ${r.name}`,r.name==="window"&&(y=`${y} (${s.get(r.pid)})`));const P=process.platform==="win32"?r.mem:w.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(P/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(r.children)&&r.children.forEach(R=>this.formatProcessItem(f,s,i,R,o+1))}async reportWorkspaceStats(f){for(const{uri:s}of f.folders){const i=S.URI.revive(s);if(i.scheme!==k.Schemas.file)continue;const r=i.fsPath;try{const o=await v(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":f.telemetryId,rendererSessionId:f.rendererSessionId}),o.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:f.rendererSessionId,type:u.name,count:u.count})}),o.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:f.rendererSessionId,type:u.name,count:u.count})}),o.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:f.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};c=ue([te(0,m.ITelemetryService),te(1,d.IProductService)],c),e.DiagnosticsService=c}),define(Z[209],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(D){this.appenders=D}listen(D,k){throw new Error(`Event not found: ${k}`)}call(D,k,{eventName:b,data:g}){return this.appenders.forEach(S=>S.log(b,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class n{constructor(D){this.channel=D}log(D,k){return this.channel.call("log",{eventName:D,data:k}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(Z[64],x([0,1,49,14,19,32]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,M){return Promise.resolve(void 0)}publicLog2(v,M){return this.publicLog(v,M)}publicLogError(v,M){return Promise.resolve(void 0)}publicLogError2(v,M){return this.publicLogError(v,M)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class b{async publicLog(v,M,h){}async publicLogError(v,M,h){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(m,v){return v.onDidChangeConfiguration(M=>{M.source!==6&&m.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(M.source),configurationKeys:t(M.sourceConfig)})})}e.configurationTelemetry=g;function S(m,v){return!(v.disableTelemetry||!m.enableTelemetry||v.extensionTestsLocationURI)}e.supportsTelemetry=S;function C(m){const v=m.getValue(D.TELEMETRY_SETTING_ID),M=m.getValue("telemetry.enableCrashReporter");if(m.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||M===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=C;function E(m){const v=Object.create(null),M=Object.create(null),h=Object.create(null);p(m,h);for(let l in h){l=l.length>150?l.substr(l.length-149):l;const c=h[l];typeof c=="number"?M[l]=c:typeof c=="boolean"?M[l]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${c.length}`),v[l]=c.substring(0,8191)):typeof c!="undefined"&&c!==null&&(v[l]=c)}return{properties:v,measurements:M}}e.validateTelemetryData=E;function I(m){if(!m)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{m.indexOf(`${h}+`)===0&&(v=h)}),v}e.cleanRemoteAuthority=I;function p(m,v,M=0,h){if(!!m)for(let l of Object.getOwnPropertyNames(m)){const c=m[l],a=h?h+l:l;Array.isArray(c)?v[a]=(0,w.safeStringify)(c):c instanceof Date?v[a]=c.toISOString():(0,n.isObject)(c)?M<2?p(c,v,M+1,a+"."):v[a]=(0,w.safeStringify)(c):v[a]=c}}function t(m){if(!m)return[];const v=[];return d(v,"",m),v}function d(m,v,M){M&&typeof M=="object"&&!Array.isArray(M)?Object.keys(M).forEach(h=>d(m,v?`${v}.${h}`:h,M[h])):m.push(v)}}),define(Z[210],x([0,1,172,64]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(D,k,b,g,S,C){const E={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${k.nameShort})`},I=await(0,w.getServiceMachineId)(b,S,C);return(0,n.supportsTelemetry)(k,b)&&(0,n.getTelemetryLevel)(g)===3&&(E["X-Market-User-Id"]=I),E}e.resolveMarketplaceHeaders=L}),define(Z[211],x([0,1,3,49,2,27,154,19,55,53,40,32,64]),function(V,e,w,n,L,D,k,b,g,S,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(m,v){this._configurationService=v,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appenders=m.appenders,this._commonProperties=m.commonProperties||Promise.resolve({}),this._piiPaths=m.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!m.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let M of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(M),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(m,v){this._experimentProperties[m]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,I.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const m=await this._commonProperties;let v=m.sessionID,M=m["common.machineId"],h=m["common.firstSessionDate"],l=m["common.msftInternal"];return{sessionId:v,machineId:M,firstSessionDate:h,msftInternal:l}}dispose(){this._disposables.dispose()}_log(m,v,M,h){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(l=>{M=(0,n.mixin)(M,l),M=(0,n.mixin)(M,this._experimentProperties),M=(0,n.cloneAndChange)(M,c=>{if(typeof c=="string")return this._cleanupInfo(c,h)}),this._appenders.forEach(c=>c.log(m,M))},l=>{console.error(l)})}publicLog(m,v,M){return this._log(m,3,v,M)}publicLog2(m,v,M){return this.publicLog(m,v,M)}publicLogError(m,v){return this.sendErrorTelemetry?this._log(m,2,v,!0):Promise.resolve(void 0)}publicLogError2(m,v){return this.publicLogError(m,v)}_anonymizeFilePaths(m){let v=m;const M=[];for(let a of this._cleanupPatterns)for(;;){const f=a.exec(m);if(!f)break;M.push([f.index,a.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(v="";;){const a=l.exec(m);if(!a)break;!h.test(a[0])&&M.every(([f,s])=>a.index<f||a.index>=s)&&(v+=m.substring(c,a.index)+"<REDACTED: user-file-path>",c=l.lastIndex)}return c<m.length&&(v+=m.substr(c)),v}_removePropertiesWithPossibleUserInfo(m){if(!m)return m;const v=m.toLowerCase(),M=/@[a-zA-Z0-9-.]+/,h=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,l=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return h.test(v)?"<REDACTED: secret>":M.test(v)?"<REDACTED: email>":l.test(v)?"<REDACTED: token>":m}_cleanupInfo(m,v){let M=m;v&&(M=this._anonymizeFilePaths(M));for(let h of this._cleanupPatterns)M=M.replace(h,"");return M=this._removePropertiesWithPossibleUserInfo(M),M}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ue([te(1,b.IConfigurationService)],p),e.TelemetryService=p;function t(){const d=(0,k.localize)(0,null,S.default.nameLong),m=S.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=L.isWeb?"":(0,k.localize)(3,null),M=(0,k.localize)(4,null),h=(0,k.localize)(5,null),l=(0,k.localize)(6,null),c=(0,k.localize)(7,null),a=`
|       | ${M} | ${h} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,f=(0,k.localize)(8,null);return`
${d} ${m} ${v}

&nbsp;

${c}
${a}

&nbsp;

${f}
`}C.Registry.as(g.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(g.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,k.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,k.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[98],x([0,1,45,7,155,23,39,15,2,31,137,50,9]),function(V,e,w,n,L,D,k,b,g,S,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let t;async function d(v,M,h){return M["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(h)&&!M["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(h)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=I.Promises.withAsyncBody(async(l,c)=>{const a=new D.CancellationTokenSource,f=setTimeout(()=>{a.dispose(!0),c(new Error((0,L.localize)(0,null)))},p);try{l(await m(v,a.token))}catch(s){!(0,b.isCancellationError)(s)&&!a.token.isCancellationRequested?c(new Error((0,L.localize)(1,null,(0,k.toErrorMessage)(s)))):l({})}finally{clearTimeout(f),a.dispose()}})),t)}e.getResolvedShellEnv=d;async function m(v,M){const h=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",h);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",l);const c=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),a=new RegExp(c+"(.*)"+c),f={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",f);const s=await(0,C.getSystemShell)(g.OS,f);return v.trace("getUnixShellEnvironment#shell",s),new Promise((i,r)=>{if(M.isCancellationRequested)return r((0,b.canceled)());const o=(0,n.basename)(s);let u,y;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${P} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,y=["-Login","-Command"]):(u=`'${process.execPath}' ${P} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,o==="tcsh"?y=["-ic"]:y=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),u);const R=(0,w.spawn)(s,[...y,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:f});M.onCancellationRequested(()=>(R.kill(),r((0,b.canceled)()))),R.on("error",G=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(G)),r(G)});const W=[];R.stdout.on("data",G=>W.push(G));const U=[];R.stderr.on("data",G=>U.push(G)),R.on("close",(G,ee)=>{const X=Buffer.concat(W).toString("utf8");v.trace("getUnixShellEnvironment#raw",X);const J=Buffer.concat(U).toString("utf8");if(J.trim()&&v.trace("getUnixShellEnvironment#stderr",J),G||ee)return r(new Error((0,L.localize)(2,null,G,ee)));const H=a.exec(X),B=H?H[1]:"{}";try{const Y=JSON.parse(B);h?Y.ELECTRON_RUN_AS_NODE=h:delete Y.ELECTRON_RUN_AS_NODE,l?Y.ELECTRON_NO_ATTACH_CONSOLE=l:delete Y.ELECTRON_NO_ATTACH_CONSOLE,delete Y.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",Y),i(Y)}catch(Y){v.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(Y)),r(Y)}})})}}),define(Z[212],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(Z[213],x([0,1,107,4,3,5,40,212]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var g;(function(m){function v(M){return M&&typeof M=="object"&&typeof M.id=="string"}m.isThemeColor=v})(g=e.ThemeColor||(e.ThemeColor={}));function S(m){return{id:m}}e.themeColorFromId=S;var C;(function(m){function v(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||g.isThemeColor(i.color))}m.isThemeIcon=v;const M=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function h(i){const r=M.exec(i);if(!r)return;let[,o]=r;return{id:o}}m.fromString=h;function l(i){return{id:i}}m.fromId=l;function c(i,r){let o=i.id;const u=o.lastIndexOf("~");return u!==-1&&(o=o.substring(0,u)),r&&(o=`${o}~${r}`),{id:o}}m.modify=c;function a(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}m.getModifier=a;function f(i,r){return i.id===r.id&&i.color?.id===r.color?.id}m.isEqual=f;function s(i,r){return{id:i.id,color:r?S(r):void 0}}m.asThemeIcon=s,m.asClassNameArray=w.CSSIcon.asClassNameArray,m.asClassName=w.CSSIcon.asClassName,m.asCSSSelector=w.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function E(m){switch(m){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class I{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,L.toDisposable)(()=>{const M=this.themingParticipants.indexOf(v);this.themingParticipants.splice(M,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new I;k.Registry.add(e.Extensions.ThemingContribution,p);function t(m){return p.onColorThemeChange(m)}e.registerThemingParticipant=t;class d extends L.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(M=>this.onThemeChange(M)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,M){let h=this.theme.getColor(v);return h&&M&&(h=M(h,this.theme)),h?h.toString():null}}e.Themable=d}),define(Z[65],x([0,1,12,2,5,38]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const k="#FFFFFF",b="#1E1E1E",g="#000000",S="theme",C="themeBackground",E="windowSplash";e.IThemeMainService=(0,L.createDecorator)("themeMainService");let I=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((n.isWindows||n.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme)return g;let t=this.stateMainService.getItem(C,null);if(!t){let d;(n.isWindows||n.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateMainService.getItem(S,"vs-dark").split(" ")[0],t=d==="hc-black"?g:d==="vs"?k:b}return n.isMacintosh&&t.toUpperCase()===b&&(t="#171717"),t}saveWindowSplash(t,d){this.stateMainService.setItems([{key:S,data:d.baseTheme},{key:C,data:d.colorInfo.background},{key:E,data:d}]),typeof t=="number"&&this.updateBackgroundColor(t,d)}updateBackgroundColor(t,d){for(const m of w.BrowserWindow.getAllWindows())if(m.id===t){m.setBackgroundColor(d.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};I=ue([te(0,D.IStateMainService)],I),e.ThemeMainService=I}),define(Z[99],x([0,1,4,2,5,6]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var k;(function(t){t.Http="http",t.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=E;function I(t,d){return d?d!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=I;let p=class{constructor(d){this.logService=d,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],m=Array.from(this._tunnels.values());for(let v of m){const M=Array.from(v.values());for(let h of M){const l=await h.value;l&&d.push(l)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:m}of d.values())await m.then(v=>v?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,m,v,M,h=!1,l=b.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${v} on local port ${M}.`),!d)return;m||(m="localhost");const a=this.retainOrCreateTunnel(d,m,v,M,h,l,c);return a?a.then(f=>{if(!f){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(f);return(f.tunnelRemoteHost!==m||f.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const m=this._tunnels.get(d.tunnelRemoteHost);if(m){const v=m.get(d.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,v))}}}}async tryDisposeTunnel(d,m,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${m}.`);const M=v.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(m),M}}async closeTunnel(d,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${m} `);const v=this._tunnels.get(d);if(v&&v.has(m)){const M=v.get(m);M.refcount=0,await this.tryDisposeTunnel(d,m,M)}}addTunnelToMap(d,m,v){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(m,{refcount:1,value:v})}async removeEmptyTunnelFromMap(d,m){const v=this._tunnels.get(d);v&&(await v.get(m)||v.delete(m),v.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,m){let v=[d];C(d)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):E(d)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const M=v.map(h=>this._tunnels.get(h));for(const h of M){const l=h?.get(m);if(l)return l}}canTunnel(d){return!!S(d)}createWithProvider(d,m,v,M,h,l,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${v} on local port ${M}.`);const f={elevationRequired:h?I(M===void 0?v:M):!1},s={remoteAddress:{host:m,port:v},localAddressPort:M,privacy:l,public:l!==b.Private,protocol:c},i=d.forwardPort(s,f);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(m,v,i),i}};p=ue([te(0,D.ILogService)],p),e.AbstractTunnelService=p}),define(Z[41],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(n=e.StateType||(e.StateType={}));var L;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(L=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(D,k)=>({type:"idle",updateType:D,error:k}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(Z[214],x([0,1,2,156,55,40]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.Registry.as(L.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[215],x([0,1,4,41]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class L{constructor(b){this.service=b}listen(b,g){switch(g){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${g}`)}call(b,g,S){switch(g){case"checkForUpdates":return this.service.checkForUpdates(S);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=L;class D{constructor(b){this.channel=b,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(g=>this.state=g),this.channel.call("_getInitialState").then(g=>this.state=g)}get state(){return this._state}set state(b){this._state=b,this._onStateChange.fire(b)}checkForUpdates(b){return this.channel.call("checkForUpdates",b)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=D}),define(Z[100],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(Z[216],x([0,1,8]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(b){this.handler=b}listen(b,g){throw new Error(`Event not found: ${g}`)}call(b,g,S){switch(g){case"handleURL":return this.handler.handleURL(w.URI.revive(S[0]),S[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=n;class L{constructor(b){this.channel=b}handleURL(b,g){return this.channel.call("handleURL",[b.toJSON(),g])}}e.URLHandlerChannelClient=L;class D{constructor(b){this.next=b}async routeCall(b,g,S,C){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(S){const E=w.URI.revive(S);if(E&&E.query){const I=/\bwindowId=(\d+)/.exec(E.query);if(I){const p=I[1],t=new RegExp(`window:${p}`),d=b.connections.find(m=>t.test(m.ctx));if(d)return d}}}return this.next.routeCall(b,g,S,C)}routeEvent(b,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=D}),define(Z[217],x([0,1,9,3,8,21]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class k extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(S,C){const E=[...this.handlers.values()];return(0,w.first)(E.map(I=>()=>I.handleURL(S,C)),void 0,!1).then(I=>I||!1)}registerHandler(S){return this.handlers.add(S),(0,n.toDisposable)(()=>this.handlers.delete(S))}}e.AbstractURLService=k;let b=class extends k{constructor(S){super();this.productService=S}create(S){let{authority:C,path:E,query:I,fragment:p}=S||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return C&&E&&E.indexOf("/")!==0&&(E=`/${E}`),L.URI.from({scheme:this.productService.urlProtocol,authority:C,path:E,query:I,fragment:p})}};b=ue([te(0,D.IProductService)],b),e.NativeURLService=b}),define(Z[218],x([0,1,12,9,4,3,2,8]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function g(C){try{return b.URI.parse(C)}catch{return null}}class S{constructor(E,I,p,t,d){if(this.urlService=I,this.uris=[],this.retryCount=0,this.flushDisposable=D.Disposable.None,this.disposables=new D.DisposableStore,this.uris=E,k.isWindows){const M=t.isBuilt?[]:[`"${t.appRoot}"`];M.push("--open-url","--"),w.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,M)}const m=L.Event.map(L.Event.fromNodeEventEmitter(w.app,"open-url",(M,h)=>({event:M,url:h})),({event:M,url:h})=>(M.preventDefault(),h));this.disposables.add(m(M=>{const h=g(M);!h||this.urlService.open(h,{originalUrl:M})})),p.getWindows().filter(M=>M.isReady).length>0?this.flush():L.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const E=[];for(const I of this.uris)await this.urlService.open(I.uri,{originalUrl:I.url})||E.push(I);E.length!==0&&(this.uris=E,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=S}),define(Z[219],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(Z[220],x([0,1,12,3,10,8]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class k extends n.Disposable{constructor(){super();const g=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(L.Schemas.vscodeWebview,g)}handleWebviewRequest(g,S){try{const C=D.URI.parse(g.url),E=k.validWebviewFilePaths.get(C.path);if(typeof E=="string"){const I=`vs/workbench/contrib/webview/browser/pre/${E}`,p=L.FileAccess.asFileUri(I,V);return S(decodeURIComponent(p.fsPath))}else return S({error:-10})}catch{}return S({error:-2})}}e.WebviewProtocolProvider=k,k.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[66],x([0,1,2]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(S){return!!S.workspaceUri}e.isWorkspaceToOpen=n;function L(S){return!!S.folderUri}e.isFolderToOpen=L;function D(S){return!!S.fileUri}e.isFileToOpen=D;function k(S){const C=b(S),E=S.getValue("window.menuBarVisibility");return E==="default"||C==="native"&&E==="compact"||w.isMacintosh&&w.isNative?"classic":E}e.getMenuBarVisibility=k;function b(S){if(w.isWeb)return"custom";const C=S.getValue("window");if(C){if(w.isMacintosh&&C.nativeTabs===!0||w.isMacintosh&&C.nativeFullScreen===!1)return"native";const p=S.getValue("workbench.colorCustomizations");if(p?.["window.activeBorder"]||p?.["window.inactiveBorder"])return"custom";const t=C.titleBarStyle;if(t==="native"||t==="custom")return t}return w.isLinux?"native":"custom"}e.getTitleBarStyle=b;function g(S=0){return Math.pow(1.2,S)}e.zoomLevelToZoomFactor=g}),define(Z[101],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var w;(function(b){b[b.INITIAL=1]="INITIAL",b[b.LOAD=2]="LOAD",b[b.RELOAD=3]="RELOAD"})(w=e.LoadReason||(e.LoadReason={}));var n;(function(b){b[b.CLOSE=1]="CLOSE",b[b.QUIT=2]="QUIT",b[b.RELOAD=3]="RELOAD",b[b.LOAD=4]="LOAD"})(n=e.UnloadReason||(e.UnloadReason={}));const L=function(b=1){return{width:1024,height:768,mode:b}};e.defaultWindowState=L;var D;(function(b){b[b.Maximized=0]="Maximized",b[b.Normal=1]="Normal",b[b.Minimized=2]="Minimized",b[b.Fullscreen=3]="Fullscreen"})(D=e.WindowMode||(e.WindowMode={}));var k;(function(b){b[b.UNRESPONSIVE=1]="UNRESPONSIVE",b[b.CRASHED=2]="CRASHED",b[b.LOAD=3]="LOAD"})(k=e.WindowError||(e.WindowError={}))}),define(Z[34],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,w.createDecorator)("windowsMainService");var n;(function(L){L[L.CLI=0]="CLI",L[L.DOCK=1]="DOCK",L[L.MENU=2]="MENU",L[L.DIALOG=3]="DIALOG",L[L.DESKTOP=4]="DESKTOP",L[L.API=5]="API"})(n=e.OpenContext||(e.OpenContext={}))}),define(Z[221],x([0,1,12,23,4,69,3,31,74,92,6,21,34]),function(V,e,w,n,L,D,k,b,g,S,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let t=class extends k.Disposable{constructor(m,v,M,h,l){super();this.logService=m,this.windowsMainService=v,this.credentialsService=M,this.encryptionMainService=h,this.productService=l,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const m=L.Event.fromNodeEventEmitter(w.app,"login",(v,M,h,l,c)=>({event:v,webContents:M,req:h,authInfo:l,callback:c}));this._register(m(this.onLogin,this))}async onLogin({event:m,authInfo:v,req:M,callback:h}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&M.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let l;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{l=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(l?.username,l?.password)}async resolveProxyCredentials(m){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(m);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(m){this.logService.trace("auth#doResolveProxyCredentials - enter",m);const v=String((0,D.hash)({scheme:m.scheme,host:m.host,port:m.port}));let M,h;try{const f=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(f){const s=JSON.parse(await this.encryptionMainService.decrypt(f));M=s.username,h=s.password}}catch(f){this.logService.error(f)}if(this.state!==p.StoredCredentialsUsed&&typeof M=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:M,password:h};const l=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!l){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${l.id} to handle proxy login`);const c={authInfo:m,username:this.sessionCredentials?.username??M,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,b.generateUuid)()}`};l.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,c),this.state=p.LoginDialogShown;const a=await new Promise(f=>{const s=async(i,r,o)=>{if(r===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${l.id}`),l.win?.webContents.off("ipc-message",s),o){const u={username:o.username,password:o.password};try{if(o.remember){const y=await this.encryptionMainService.encrypt(JSON.stringify(u));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v,y)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(y){this.logService.error(y)}f({username:u.username,password:u.password})}else f(void 0)};l.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=a,a}};t=ue([te(0,C.ILogService),te(1,I.IWindowsMainService),te(2,g.ICredentialsMainService),te(3,S.IEncryptionMainService),te(4,E.IProductService)],t),e.ProxyAuthHandler=t}),define(Z[222],x([0,1,12,4,3,220,34]),function(V,e,w,n,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let b=class extends L.Disposable{constructor(S){super();this.windowsMainService=S,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new D.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(S,C){let E;if(typeof S.windowId=="number"){const{windowId:I}=S,p=this.windowsMainService.getWindowById(I);if(!p?.win)throw new Error(`Invalid windowId: ${I}`);E=p.win.webContents}else{const{webContentsId:I}=S;if(E=w.webContents.fromId(I),!E)throw new Error(`Invalid webContentsId: ${I}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(C)}async findInFrame(S,C,E,I){const t=this.getFrameByName(S,C);if(typeof t.findInFrame=="function"){t.findInFrame(E,{findNext:I.findNext,forward:I.forward});const d=(m,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),t.removeListener("found-in-frame",d))};t.on("found-in-frame",d)}}async stopFindInFrame(S,C,E){const p=this.getFrameByName(S,C);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(E.keepSelection?"keepSelection":"clearSelection")}getFrameByName(S,C){const E=this.windowsMainService.getWindowById(S.windowId);if(!E?.win)throw new Error(`Invalid windowId: ${S}`);const I=E.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===C);if(!I)throw new Error(`Unknown frame: ${C}`);return I}};b=ue([te(0,k.IWindowsMainService)],b),e.WebviewMainService=b}),define(Z[223],x([0,1,9,4,3]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends L.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:g,getActiveWindowId:S}){super();this.disposables=this._register(new L.DisposableStore),n.Event.latch(n.Event.any(b,g))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>S()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=D}),define(Z[25],x([0,1,159,7,35,17,8,5,10]),function(V,e,w,n,L,D,k,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function S(f){const s=f;return typeof s?.id=="string"&&k.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=S;function C(f){if(f.configuration)return{id:f.id,configPath:f.configuration};if(f.folders.length===1)return{id:f.id,uri:f.folders[0].uri}}e.toWorkspaceIdentifier=C;function E(f){const s=f;return typeof s?.id=="string"&&k.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=E;function I(f){const s=f;if(s?.uri)return{id:s.id,uri:k.URI.revive(s.uri)};const i=f;if(i?.configPath)return{id:i.id,configPath:k.URI.revive(i.configPath)};if(f?.id)return{id:f.id}}e.reviveIdentifier=I;var p;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function t(f){const s=f;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=t;function d(f){const s=f;return!!(s&&typeof s=="object"&&k.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=d;class m{constructor(s,i,r,o,u){this._id=s,this._transient=r,this._configuration=o,this._ignorePathCasing=u,this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=i}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s.with({scheme:s.scheme,authority:s.authority,path:s.path}))||null}updateFoldersMap(){this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class v{constructor(s,i){this.raw=i,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,D.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function M(f){return new v({uri:f,index:0,name:(0,D.basenameOrAuthority)(f)},{uri:f.toString()})}e.toWorkspaceFolder=M,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(f,s){return D.extUriBiasedIgnorePathCase.isEqualOrParent(f,s.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function c(f){let s;return k.URI.isUri(f)?s=f:s=f.configuration,s?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=c;function a(f){return(typeof f=="string"?(0,n.extname)(f):(0,D.extname)(f))===h}e.hasWorkspaceFileExtension=a}),define(Z[47],x([0,1,12,9,69,33,3,70,7,2,14,24,141,5,6,38,25]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let v=class bt{constructor(h,l){this.stateMainService=h,this.logService=l,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(h,l){return this.doPick({...h,pickFolders:!0,pickFiles:!0,title:(0,I.localize)(0,null)},l)}pickFolder(h,l){return this.doPick({...h,pickFolders:!0,title:(0,I.localize)(1,null)},l)}pickFile(h,l){return this.doPick({...h,pickFiles:!0,title:(0,I.localize)(2,null)},l)}pickWorkspace(h,l){const c=(0,I.localize)(3,null),a=(0,D.mnemonicButtonLabel)((0,I.localize)(4,null)),f=m.WORKSPACE_FILTER;return this.doPick({...h,pickFiles:!0,title:c,filters:f,buttonLabel:a},l)}async doPick(h,l){const c={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters};c.defaultPath=h.defaultPath||this.stateMainService.getItem(bt.workingDirPickerStorageKey),(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(c.properties=void 0,h.pickFiles&&h.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),S.isMacintosh&&c.properties.push("treatPackageAsDirectory");const a=l||w.BrowserWindow.getFocusedWindow(),f=await this.showOpenDialog(c,(0,C.withNullAsUndefined)(a));if(f&&f.filePaths&&f.filePaths.length>0)return this.stateMainService.setItem(bt.workingDirPickerStorageKey,(0,g.dirname)(f.filePaths[0])),f.filePaths}getWindowDialogQueue(h){if(h){let l=this.windowDialogQueues.get(h.id);return l||(l=new n.Queue,this.windowDialogQueues.set(h.id,l)),l}else return this.noWindowDialogueQueue}showMessageBox(h,l){return this.getWindowDialogQueue(l).queue(async()=>l?w.dialog.showMessageBox(l,h):w.dialog.showMessageBox(h))}async showSaveDialog(h,l){const c=this.acquireFileDialogLock(h,l);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(l).queue(async()=>{let a;return l?a=await w.dialog.showSaveDialog(l,h):a=await w.dialog.showSaveDialog(h),a.filePath=this.normalizePath(a.filePath),a})}finally{(0,k.dispose)(c)}}normalizePath(h){return h&&S.isMacintosh&&(h=(0,b.normalizeNFC)(h)),h}normalizePaths(h){return h.map(l=>this.normalizePath(l))}async showOpenDialog(h,l){h.defaultPath&&(await E.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const c=this.acquireFileDialogLock(h,l);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(l).queue(async()=>{let a;return l?a=await w.dialog.showOpenDialog(l,h):a=await w.dialog.showOpenDialog(h),a.filePaths=this.normalizePaths(a.filePaths),a})}finally{(0,k.dispose)(c)}}acquireFileDialogLock(h,l){if(!l)return k.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",h);let c=this.windowFileDialogLocks.get(l.id);c||(c=new Set,this.windowFileDialogLocks.set(l.id,c));const a=(0,L.hash)(h);if(!c.has(a))return this.logService.trace("[DialogMainService]: new file dialog lock created",h),c.add(a),(0,k.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",h),c?.delete(a),c?.size===0&&this.windowFileDialogLocks.delete(l.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=ue([te(0,d.IStateMainService),te(1,t.ILogService)],v),e.DialogMainService=v}),define(Z[224],x([0,1,4,3,25]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends n.Disposable{constructor(b,g){super();this.logService=b,this.storageMainService=g,this._onDidChangeGlobalStorage=this._register(new w.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(w.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(b,g)=>(b?b.push(g):b=[g],b),D.STORAGE_CHANGE_DEBOUNCE_TIME)(b=>{b.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(b))}))}serializeGlobalStorageEvents(b){const g=new Map,S=new Set;return b.forEach(C=>{const E=this.storageMainService.globalStorage.get(C.key);typeof E=="string"?g.set(C.key,E):S.add(C.key)}),{changed:Array.from(g.entries()),deleted:Array.from(S.values())}}listen(b,g){switch(g){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${g}`)}async call(b,g,S){const C=(0,L.reviveIdentifier)(S.workspace),E=await this.withStorageInitialized(C);switch(g){case"getItems":return Array.from(E.items.entries());case"updateItems":{const I=S;if(I.insert)for(const[p,t]of I.insert)E.set(p,t);I.delete&&I.delete.forEach(p=>E.delete(p));break}case"close":{if(C)return E.close();break}default:throw new Error(`Call not found: ${g}`)}}async withStorageInitialized(b){const g=b?this.storageMainService.workspaceStorage(b):this.storageMainService.globalStorage;try{await g.init()}catch(S){this.logService.error(`StorageIPC#init: Unable to init ${b?"workspace":"global"} storage due to ${S}`)}return g}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[225],x([0,1,9,4,3,7,2,24,90,130,6,97,32,25]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class t extends L.Disposable{constructor(h){super();this.logService=h,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new g.Storage(new g.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new w.DeferredPromise,this.whenInit=this.whenInitPromise.p}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const h=await this.doCreate();this._storage.dispose(),this._storage=h,this._register(h.onDidChangeStorage(c=>this._onDidChangeStorage.fire({key:c}))),await this.doInit(h);const l=h.getBoolean(E.IS_NEW_KEY);l===void 0?h.set(E.IS_NEW_KEY,!0):l&&h.set(E.IS_NEW_KEY,!1)}catch(h){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${h}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:k.isCI?h=>this.logService.info(h):this.logService.getLevel()===C.LogLevel.Trace?h=>this.logService.trace(h):void 0,logError:h=>this.logService.error(h)}}doInit(h){return h.init()}get items(){return this._storage.items}get(h,l){return this._storage.get(h,l)}set(h,l){return this._storage.set(h,l)}delete(h){return this._storage.delete(h)}async close(){this.initializePromise&&await this.initializePromise,await this._storage.close(),this._onDidCloseStorage.fire()}}class d extends t{constructor(h,l,c){super(l);this.options=h,this.environmentService=c}async doCreate(){let h;return this.options.useInMemoryStorage?h=S.SQLiteStorageDatabase.IN_MEMORY_PATH:h=(0,D.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new g.Storage(new S.SQLiteStorageDatabase(h,{logging:this.createLoggingOptions()}))}async doInit(h){await super.doInit(h),this.updateTelemetryState(h)}updateTelemetryState(h){h.get(I.firstSessionDateStorageKey,void 0)===void 0&&h.set(I.firstSessionDateStorageKey,new Date().toUTCString());const c=h.get(I.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();h.set(I.lastSessionDateStorageKey,typeof c=="undefined"?null:c),h.set(I.currentSessionDateStorageKey,a)}async close(){(0,C.logCi)(this.logService,"GlobalStorageMain#close() - begin");try{await super.close()}finally{(0,C.logCi)(this.logService,"GlobalStorageMain#close() - end")}}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class m extends t{constructor(h,l,c,a){super(c);this.workspace=h,this.options=l,this.environmentService=a}async doCreate(){const{storageFilePath:h,wasCreated:l}=await this.prepareWorkspaceStorageFolder();return new g.Storage(new S.SQLiteStorageDatabase(h,{logging:this.createLoggingOptions()}),{hint:l?g.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:S.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const h=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),l=(0,D.join)(h,m.WORKSPACE_STORAGE_NAME);return await b.Promises.exists(h)?{storageFilePath:l,wasCreated:!1}:(await b.Promises.mkdir(h,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(h),{storageFilePath:l,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(h){let l;if((0,p.isSingleFolderWorkspaceIdentifier)(this.workspace)?l={folder:this.workspace.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.workspace)&&(l={workspace:this.workspace.configPath.toString()}),l)try{const c=(0,D.join)(h,m.WORKSPACE_META_NAME);await b.Promises.exists(c)||await b.Promises.writeFile(c,JSON.stringify(l,void 0,2))}catch(c){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${c}`)}}async close(){(0,C.logCi)(this.logService,"WorkspaceStorageMain#close() - begin");try{await super.close()}finally{(0,C.logCi)(this.logService,"WorkspaceStorageMain#close() - end")}}}e.WorkspaceStorageMain=m,m.WORKSPACE_STORAGE_NAME="state.vscdb",m.WORKSPACE_META_NAME="workspace.json";class v extends t{async doCreate(){return new g.Storage(new g.InMemoryStorageDatabase)}}e.InMemoryStorageMain=v}),define(Z[102],x([0,1,17,8,25]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function D(g,S,C){for(const I of g){const p=I.openedWorkspace;if((0,L.isWorkspaceIdentifier)(p)){const t=C(p);if(t){if(t.folders.some(d=>w.extUriBiasedIgnorePathCase.isEqualOrParent(S,d.uri)))return I}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(S,p.configPath))return I}}const E=g.filter(I=>(0,L.isSingleFolderWorkspaceIdentifier)(I.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(S,I.openedWorkspace.uri));if(E.length)return E.sort((I,p)=>-(I.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=D;function k(g,S){for(const C of g)if((0,L.isWorkspaceIdentifier)(C.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.configPath,S)||(0,L.isSingleFolderWorkspaceIdentifier)(C.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.uri,S))return C}e.findWindowOnWorkspaceOrFolder=k;function b(g,S){const C=E=>S.some(I=>w.extUriBiasedIgnorePathCase.isEqual(n.URI.file(I),n.URI.file(E)));for(const E of g)if(E.config?.extensionDevelopmentPath?.some(I=>C(I)))return E}e.findWindowOnExtensionDevelopmentPath=b}),define(Z[226],x([0,1,12,3,2,17,8,19,18,6,38,34,101,25]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let t=class Et extends n.Disposable{constructor(l,c,a,f,s){super();this.windowsMainService=l,this.stateMainService=c,this.lifecycleMainService=a,this.logService=f,this.configurationService=s,this._state=d(this.stateMainService.getItem(Et.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(l=>this.onBeforeCloseWindow(l)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(l=>{l.newCount-l.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(l=>this.onBeforeCloseWindow(l))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const l={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!l.lastActiveWindow){let f=this.windowsMainService.getLastActiveWindow();(!f||f.isExtensionDevelopmentHost)&&(f=this.windowsMainService.getWindows().find(s=>!s.isExtensionDevelopmentHost)),f&&(l.lastActiveWindow=this.toWindowState(f))}const c=this.windowsMainService.getWindows().find(f=>f.isExtensionDevelopmentHost&&!f.isExtensionTestHost);c&&(l.lastPluginDevelopmentHostWindow=this.toWindowState(c)),this.windowsMainService.getWindowCount()>1&&(l.openedWindows=this.windowsMainService.getWindows().filter(f=>!f.isExtensionDevelopmentHost).map(f=>this.toWindowState(f)));const a=v(l);this.stateMainService.setItem(Et.windowsStateStorageKey,a),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",a)}onBeforeCloseWindow(l){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(l);l.isExtensionDevelopmentHost&&!l.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!l.isExtensionDevelopmentHost&&l.openedWorkspace&&this._state.openedWindows.forEach(a=>{const f=(0,p.isWorkspaceIdentifier)(l.openedWorkspace)&&a.workspace?.id===l.openedWorkspace.id,s=(0,p.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)&&a.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(a.folderUri,l.openedWorkspace.uri);(f||s)&&(a.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(l){return{workspace:(0,p.isWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace:void 0,folderUri:(0,p.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace.uri:void 0,backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.serializeWindowState()}}getNewWindowState(l){const c=this.doGetNewWindowState(l),a=this.configurationService.getValue("window");let f;return c.hasDefaultState?f=!!(a?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(a.newWindowDimensions)>=0):(f=!!(this.lifecycleMainService.wasRestarted||a?.restoreFullscreen),f&&L.isMacintosh&&this.windowsMainService.getWindows().some(s=>s.isFullScreen)&&(f=!1)),c.mode===3&&!f&&(c.mode=1),c}doGetNewWindowState(l){const c=this.windowsMainService.getLastActiveWindow();if(!l.extensionTestsPath){if(!!l.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=l.workspace;if((0,p.isWorkspaceIdentifier)(o)){const y=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===o.id).map(P=>P.uiState);if(y.length)return y[0]}if((0,p.isSingleFolderWorkspaceIdentifier)(o)){const y=this.state.openedWindows.filter(P=>P.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(P.folderUri,o.uri)).map(P=>P.uiState);if(y.length)return y[0]}else if(l.backupPath){const y=this.state.openedWindows.filter(P=>P.backupPath===l.backupPath).map(P=>P.uiState);if(y.length)return y[0]}const u=this.lastClosedState||this.state.lastActiveWindow;if(!c&&u)return u.uiState}let a;const f=w.screen.getAllDisplays();if(f.length===1)a=f[0];else{if(L.isMacintosh){const o=w.screen.getCursorScreenPoint();a=w.screen.getDisplayNearestPoint(o)}!a&&c&&(a=w.screen.getDisplayMatching(c.getBounds())),a||(a=w.screen.getPrimaryDisplay()||f[0])}let s=(0,I.defaultWindowState)();s.x=Math.round(a.bounds.x+a.bounds.width/2-s.width/2),s.y=Math.round(a.bounds.y+a.bounds.height/2-s.height/2);const i=this.configurationService.getValue("window");let r=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")s.mode=0,r=!1;else if(i.newWindowDimensions==="fullscreen")s.mode=3,r=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&c){const o=c.serializeWindowState();o.mode===3?s.mode=3:s=o,r=s.mode!==3&&i.newWindowDimensions==="offset"}}return r&&(s=this.ensureNoOverlap(s)),s.hasDefaultState=!0,s}ensureNoOverlap(l){if(this.windowsMainService.getWindows().length===0)return l;l.x=typeof l.x=="number"?l.x:0,l.y=typeof l.y=="number"?l.y:0;const c=this.windowsMainService.getWindows().map(a=>a.getBounds());for(;c.some(a=>a.x===l.x||a.y===l.y);)l.x+=30,l.y+=30;return l}};t.windowsStateStorageKey="windowsState",t=ue([te(0,E.IWindowsMainService),te(1,C.IStateMainService),te(2,g.ILifecycleMainService),te(3,S.ILogService),te(4,b.IConfigurationService)],t),e.WindowsStateHandler=t;function d(h){const l={openedWindows:[]},c=h||{openedWindows:[]};return c.lastActiveWindow&&(l.lastActiveWindow=m(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(l.lastPluginDevelopmentHostWindow=m(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(l.openedWindows=c.openedWindows.map(a=>m(a))),l}e.restoreWindowsState=d;function m(h){const l={uiState:h.uiState};return h.backupPath&&(l.backupPath=h.backupPath),h.remoteAuthority&&(l.remoteAuthority=h.remoteAuthority),h.folder&&(l.folderUri=k.URI.parse(h.folder)),h.workspaceIdentifier&&(l.workspace={id:h.workspaceIdentifier.id,configPath:k.URI.parse(h.workspaceIdentifier.configURIPath)}),l}function v(h){return{lastActiveWindow:h.lastActiveWindow&&M(h.lastActiveWindow),lastPluginDevelopmentHostWindow:h.lastPluginDevelopmentHostWindow&&M(h.lastPluginDevelopmentHostWindow),openedWindows:h.openedWindows.map(l=>M(l))}}e.getWindowsStateStoreData=v;function M(h){return{workspaceIdentifier:h.workspace&&{id:h.workspace.id,configURIPath:h.workspace.configPath.toString()},folder:h.folderUri&&h.folderUri.toString(),backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.uiState}}}),define(Z[80],x([0,1,28,44,109,33,10,7,2,17,8,5,78,25]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function t(P){return P.hasOwnProperty("workspace")}e.isRecentWorkspace=t;function d(P){return P.hasOwnProperty("folderUri")}e.isRecentFolder=d;function m(P){return P.hasOwnProperty("fileUri")}e.isRecentFile=m;function v(P){return M(P)||h(P)}e.isStoredWorkspaceFolder=v;function M(P){const R=P;return typeof R?.path=="string"&&(!R.name||typeof R.name=="string")}function h(P){const R=P;return typeof R?.uri=="string"&&(!R.name||typeof R.name=="string")}function l(P,R,W,U,G=!g.isWindows,ee){if(P.scheme!==U.scheme)return{name:W,uri:P.toString(!0)};let X=R?void 0:ee.relativePath(U,P);if(X!==void 0)X.length===0?X=".":g.isWindows&&P.scheme===k.Schemas.file&&!G&&(X=X.replace(/\//g,"\\"));else if(P.scheme===k.Schemas.file)X=P.fsPath,g.isWindows&&(X=(0,D.normalizeDriveLetter)(X),G&&(X=(0,w.toSlashes)(X)));else{if(!ee.isEqualAuthority(P.authority,U.authority))return{name:W,uri:P.toString(!0)};X=P.path}return{name:W,path:X}}e.getStoredWorkspaceFolder=l;function c(P,R,W){let U=[],G=new Set;const ee=W.dirname(R);for(let X of P){let J;if(M(X))X.path&&(J=W.resolvePath(ee,X.path));else if(h(X))try{J=C.URI.parse(X.uri),J.path[0]!=="/"&&(J=J.with({path:"/"+J.path}))}catch(H){console.warn(H)}if(J){let H=W.getComparisonKey(J);if(!G.has(H)){G.add(H);const B=X.name||W.basenameOrAuthority(J);U.push(new p.WorkspaceFolder({uri:J,name:B,index:U.length},X))}}}return U}e.toWorkspaceFolders=c;function a(P,R,W,U,G){let ee=f(R,P);const X=G.dirname(R),J=G.dirname(U),H=[],B=s(ee.folders);for(const q of ee.folders){const Q=M(q)?G.resolvePath(X,q.path):C.URI.parse(q.uri);let z;W?z=!1:z=!M(q)||(0,b.isAbsolute)(q.path),H.push(l(Q,z,q.name,J,B,G))}const Y={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},se=L.setProperty(P,["folders"],H,Y);let $=L.applyEdits(P,se);return(0,S.isEqualAuthority)(ee.remoteAuthority,(0,I.getRemoteAuthority)(U))&&($=L.applyEdits($,L.removeProperty($,["remoteAuthority"],Y))),$}e.rewriteWorkspaceFileForNewLocation=a;function f(P,R){let W=n.parse(R);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(U=>v(U));else throw new Error(`${P} looks like an invalid workspace file.`);return W}function s(P){return g.isWindows?P.some(R=>M(R)&&R.path.indexOf("/")>=0):!0}e.useSlashForPath=s;function i(P){return P.workspace&&typeof P.workspace=="object"&&typeof P.workspace.id=="string"&&typeof P.workspace.configPath=="string"}function r(P){return typeof P.folderUri=="string"}function o(P){return typeof P.fileUri=="string"}function u(P,R){const W={workspaces:[],files:[]};if(P){const U=function(ee,X){for(let J=0;J<ee.length;J++)try{X(ee[J],J)}catch(H){R.warn(`Error restoring recent entry ${JSON.stringify(ee[J])}: ${H.toString()}. Skip entry.`)}},G=P;if(Array.isArray(G.entries))U(G.entries,ee=>{const X=ee.label,J=ee.remoteAuthority;i(ee)?W.workspaces.push({label:X,remoteAuthority:J,workspace:{id:ee.workspace.id,configPath:C.URI.parse(ee.workspace.configPath)}}):r(ee)?W.workspaces.push({label:X,remoteAuthority:J,folderUri:C.URI.parse(ee.folderUri)}):o(ee)&&W.files.push({label:X,remoteAuthority:J,fileUri:C.URI.parse(ee.fileUri)})});else{const ee=P;Array.isArray(ee.workspaces3)&&U(ee.workspaces3,(X,J)=>{const H=Array.isArray(ee.workspaceLabels)&&ee.workspaceLabels[J]||void 0;typeof X=="object"&&typeof X.id=="string"&&typeof X.configURIPath=="string"?W.workspaces.push({label:H,workspace:{id:X.id,configPath:C.URI.parse(X.configURIPath)}}):typeof X=="string"&&W.workspaces.push({label:H,folderUri:C.URI.parse(X)})}),Array.isArray(ee.files2)&&U(ee.files2,(X,J)=>{const H=Array.isArray(ee.fileLabels)&&ee.fileLabels[J]||void 0;typeof X=="string"&&W.files.push({label:H,fileUri:C.URI.parse(X)})})}}return W}e.restoreRecentlyOpened=u;function y(P){const R={entries:[]};for(const W of P.workspaces)d(W)?R.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):R.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of P.files)R.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return R}e.toStoreData=y}),define(Z[103],x([0,1,60,29,10,2,17]),function(V,e,w,n,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function b(S){function C(){let E=S.scheme===L.Schemas.file?(0,k.originalFSPath)(S):S.toString();return D.isLinux||(E=E.toLowerCase()),(0,w.createHash)("md5").update(E).digest("hex")}return{id:C(),configPath:S}}e.getWorkspaceIdentifier=b;function g(S,C){function E(){if(S.scheme!==L.Schemas.file)return(0,w.createHash)("md5").update(S.toString()).digest("hex");if(!C)try{C=(0,n.statSync)(S.fsPath)}catch{return}let p;return D.isLinux?p=C.ino:D.isMacintosh?p=C.birthtime.getTime():D.isWindows&&(typeof C.birthtimeMs=="number"?p=Math.floor(C.birthtimeMs):p=C.birthtime.getTime()),(0,w.createHash)("md5").update(S.fsPath).update(p?String(p):"").digest("hex")}const I=E();if(typeof I=="string")return{id:I,uri:S}}e.getSingleFolderWorkspaceIdentifier=g}),define(Z[227],x([0,1,15,4,10,6,254,118,18,85]),function(V,e,w,n,L,D,k,b,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class C{constructor(t,d){this._worker=new k.Worker(L.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",V).fsPath),this._worker.on("message",t),this._worker.on("error",d),this.onError=n.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=n.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=n.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(t,d){this._worker.postMessage(t,d)}dispose(){this._worker.terminate()}}let E=class{constructor(t){this._logService=t}async logInfo(t){this._logService.info(t)}};E=ue([te(0,D.ILogService)],E);let I=class{constructor(t,d){this._logService=t,this._shutdown=!1,this._proxy=null;const m={create:(v,M,h)=>{const l=new C(M,h);return l.onError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(c)}),l.onMessageError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(c)}),l.onExit(c=>this._logService.info(`ExtensionHostStarterWorker exited with code ${c}.`)),l.postMessage(v,[]),l}};this._worker=new b.SimpleWorkerClient(m,"vs/platform/extensions/node/extensionHostStarterWorker",new E(this._logService)),this._initialize(),d.onWillShutdown(v=>{this._shutdown=!0,this._proxy&&v.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(t){return this._proxy.onDynamicStdout(t)}onDynamicStderr(t){return this._proxy.onDynamicStderr(t)}onDynamicMessage(t){return this._proxy.onDynamicMessage(t)}onDynamicError(t){return this._proxy.onDynamicError(t)}onDynamicExit(t){return this._proxy.onDynamicExit(t)}async createExtensionHost(){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return t.createExtensionHost()}async start(t,d){const m=S.StopWatch.create(!1),v=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();const M=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),h=await v.start(t,d),l=m.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${l} ms.`),clearTimeout(M),h}async enableInspectPort(t){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return d.enableInspectPort(t)}async kill(t){const d=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return d.kill(t)}};I=ue([te(0,D.ILogService),te(1,g.ILifecycleMainService)],I),e.WorkerMainProcessExtensionHostStarter=I}),define(Z[57],x([0,1,60,61,26,16,15,4,3,7,2,31,37,88,228]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(R,W=""){this.debugLabel=W,this.socket=R,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,k.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(R,W){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,W)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(R){const W=U=>{this.traceSocketEvent("read",U),R(D.VSBuffer.wrap(U))};return this.socket.on("data",W),{dispose:()=>this.socket.off("data",W)}}onClose(R){const W=U=>{this.traceSocketEvent("close",{hadError:U}),R({type:0,hadError:U,error:void 0})};return this.socket.on("close",W),{dispose:()=>this.socket.off("close",W)}}onEnd(R){const W=()=>{this.traceSocketEvent("nodeEndReceived"),R()};return this.socket.on("end",W),{dispose:()=>this.socket.off("end",W)}}write(R){if(!this.socket.destroyed)try{this.traceSocketEvent("write",R),this.socket.write(R.buffer,W=>{if(W){if(W.code==="EPIPE")return;(0,k.onUnexpectedError)(W)}})}catch(W){if(W.code==="EPIPE")return;(0,k.onUnexpectedError)(W)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((R,W)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),R();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),R()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=d;var m;(function(P){P[P.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var v;(function(P){P[P.PeekHeader=1]="PeekHeader",P[P.ReadHeader=2]="ReadHeader",P[P.ReadBody=3]="ReadBody",P[P.Fin=4]="Fin"})(v||(v={}));class M extends g.Disposable{constructor(R,W,U,G){super();this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=R,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:W,inflateBytesLength:U?.byteLength||0,recordInflateBytes:G}),this._flowManager=this._register(new h(this,W,U,G,this._onData,(ee,X)=>this._write(ee,X))),this._register(this._flowManager.onError(ee=>{console.error(ee),(0,k.onUnexpectedError)(ee),this._onClose.fire({type:0,hadError:!0,error:ee})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData(ee=>this._acceptChunk(ee))),this._register(this.socket.onClose(ee=>this._onClose.fire(ee)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(R,W){this.socket.traceSocketEvent(R,W)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this._onData.event(R)}onClose(R){return this._onClose.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){this._flowManager.writeMessage(R)}_write(R,W){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",R);let U=2;R.byteLength<126?U+=0:R.byteLength<2**16?U+=2:U+=8;const G=D.VSBuffer.alloc(U);if(W?G.writeUInt8(194,0):G.writeUInt8(130,0),R.byteLength<126)G.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){G.writeUInt8(126,1);let ee=1;G.writeUInt8(R.byteLength>>>8&255,++ee),G.writeUInt8(R.byteLength>>>0&255,++ee)}else{G.writeUInt8(127,1);let ee=1;G.writeUInt8(0,++ee),G.writeUInt8(0,++ee),G.writeUInt8(0,++ee),G.writeUInt8(0,++ee),G.writeUInt8(R.byteLength>>>24&255,++ee),G.writeUInt8(R.byteLength>>>16&255,++ee),G.writeUInt8(R.byteLength>>>8&255,++ee),G.writeUInt8(R.byteLength>>>0&255,++ee)}this.socket.write(D.VSBuffer.concat([G,R]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(R){if(R.byteLength!==0){for(this._incomingData.acceptChunk(R);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const W=this._incomingData.peek(this._state.readLen),U=W.readUInt8(0),G=(U&128)>>>7,ee=(U&64)>>>6,X=W.readUInt8(1),J=(X&128)>>>7,H=X&127;this._state.state=2,this._state.readLen=2+(J?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=G,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(ee)),this._state.firstFrameOfMessage=Boolean(G),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const W=this._incomingData.read(this._state.readLen),U=W.readUInt8(1),G=(U&128)>>>7;let ee=U&127,X=1;ee===126?ee=W.readUInt8(++X)*2**8+W.readUInt8(++X):ee===127&&(ee=W.readUInt8(++X)*0+W.readUInt8(++X)*0+W.readUInt8(++X)*0+W.readUInt8(++X)*0+W.readUInt8(++X)*2**24+W.readUInt8(++X)*2**16+W.readUInt8(++X)*2**8+W.readUInt8(++X));let J=0;G&&(J=W.readUInt8(++X)*2**24+W.readUInt8(++X)*2**16+W.readUInt8(++X)*2**8+W.readUInt8(++X)),this._state.state=3,this._state.readLen=ee,this._state.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const W=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",W),a(W,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",W),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(W,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await b.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=M;class h extends g.Disposable{constructor(R,W,U,G,ee,X){super();this._tracer=R,this._onData=ee,this._writeFn=X,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new b.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,W?(this._zlibInflateStream=this._register(new l(this._tracer,G,U,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(J=>this._onError.fire(J))),this._register(this._zlibDeflateStream.onError(J=>this._onError.fire(J)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}writeMessage(R){this._writeQueue.push(R),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const R=this._writeQueue.shift();if(this._zlibDeflateStream){const W=await this._deflateMessage(this._zlibDeflateStream,R);this._writeFn(W,!0)}else this._writeFn(R,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(R,W){return new Promise((U,G)=>{R.write(W),R.flush(ee=>U(ee))})}acceptFrame(R,W,U){this._readQueue.push({data:R,isCompressed:W,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const R=this._readQueue.shift();if(this._zlibInflateStream&&R.isCompressed){const W=await this._inflateFrame(this._zlibInflateStream,R.data,R.isLastFrameOfMessage);this._onData.fire(W)}else this._onData.fire(R.data)}this._isProcessingReadQueue=!1}}_inflateFrame(R,W,U){return new Promise((G,ee)=>{R.write(W),U&&R.write(D.VSBuffer.fromByteArray([0,0,255,255])),R.flush(X=>G(X))})}}class l extends g.Disposable{constructor(R,W,U,G){super();this._tracer=R,this._recordInflateBytes=W,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(G),this._zlibInflate.on("error",ee=>{this._tracer.traceSocketEvent("zlibInflateError",{message:ee?.message,code:ee?.code}),this._onError.fire(ee)}),this._zlibInflate.on("data",ee=>{this._tracer.traceSocketEvent("zlibInflateData",ee),this._pendingInflateData.push(D.VSBuffer.wrap(ee))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}write(R){this._recordInflateBytes&&this._recordedInflateBytes.push(R.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",R),this._zlibInflate.write(R.buffer)}flush(R){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const W=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,R(W)})}}class c extends g.Disposable{constructor(R,W){super();this._tracer=R,this._onError=this._register(new b.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(D.VSBuffer.wrap(U))})}write(R){this._tracer.traceSocketEvent("zlibDeflateWrite",R.buffer),this._zlibDeflate.write(R.buffer)}flush(R){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let W=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,W=W.slice(0,W.byteLength-4),R(W)})}}function a(P,R){if(R===0)return;let W=P.byteLength>>>2;for(let H=0;H<W;H++){const B=P.readUInt32BE(H*4);P.writeUInt32BE(B^R,H*4)}let U=W*4,G=P.byteLength-U;const ee=R>>>24&255,X=R>>>16&255,J=R>>>8&255;G>=1&&P.writeUInt8(P.readUInt8(U)^ee,U),G>=2&&P.writeUInt8(P.readUInt8(U+1)^X,U+1),G>=3&&P.writeUInt8(P.readUInt8(U+2)^J,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const f={[2]:107,[1]:103};function s(){const P=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${P}-sock`;let R;return e.XDG_RUNTIME_DIR?R=(0,S.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${P}.sock`):R=(0,S.join)((0,L.tmpdir)(),`vscode-ipc-${P}.sock`),r(R),R}e.createRandomIPCHandle=s;function i(P,R,W){const U=(0,w.createHash)("md5").update(P).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${W}-${R}-sock`;let G;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?G=(0,S.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${W}-${R}.sock`):G=(0,S.join)(P,`${W}-${R}.sock`),r(G),G}e.createStaticIPCHandle=i;function r(P){const R=f[C.platform];typeof R=="number"&&P.length>=R&&console.warn(`WARNING: IPC handle "${P}" is longer than ${R} chars, try a shorter --user-data-dir`)}class o extends I.IPCServer{constructor(R){super(o.toClientConnectionEvent(R));this.server=R}static toClientConnectionEvent(R){const W=b.Event.fromNodeEventEmitter(R,"connection");return b.Event.map(W,U=>({protocol:new p.Protocol(new d(U,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function u(P){return new Promise((R,W)=>{const U=(0,n.createServer)();U.on("error",W),U.listen(P,()=>{U.removeListener("error",W),R(new o(U))})})}e.serve=u;function y(P,R){return new Promise((W,U)=>{const G=(0,n.createConnection)(P,()=>{G.removeListener("error",U),W(p.Client.fromSocket(new d(G,`ipc-client${R}`),R))});G.once("error",U)})}e.connect=y}),define(Z[229],x([0,1,57]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(g){this.driver=g}listen(g,S){throw new Error("No event found")}call(g,S,C){switch(S){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(C);case"startTracing":return this.driver.startTracing(C[0],C[1]);case"stopTracing":return this.driver.stopTracing(C[0],C[1],C[2]);case"reloadWindow":return this.driver.reloadWindow(C);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(C[0],C[1]);case"click":return this.driver.click(C[0],C[1],C[2],C[3]);case"doubleClick":return this.driver.doubleClick(C[0],C[1]);case"setValue":return this.driver.setValue(C[0],C[1],C[2]);case"getTitle":return this.driver.getTitle(C[0]);case"isActiveElement":return this.driver.isActiveElement(C[0],C[1]);case"getElements":return this.driver.getElements(C[0],C[1],C[2]);case"getElementXY":return this.driver.getElementXY(C[0],C[1],C[2]);case"typeInEditor":return this.driver.typeInEditor(C[0],C[1],C[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(C[0],C[1]);case"writeInTerminal":return this.driver.writeInTerminal(C[0],C[1],C[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(C);case"getLocalizedStrings":return this.driver.getLocalizedStrings(C)}throw new Error(`Call not found: ${S}`)}}e.DriverChannel=n;class L{constructor(g){this.channel=g}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(g){return this.channel.call("capturePage",g)}startTracing(g,S){return this.channel.call("startTracing",[g,S])}stopTracing(g,S,C){return this.channel.call("stopTracing",[g,S,C])}reloadWindow(g){return this.channel.call("reloadWindow",g)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(g,S){return this.channel.call("dispatchKeybinding",[g,S])}click(g,S,C,E){return this.channel.call("click",[g,S,C,E])}doubleClick(g,S){return this.channel.call("doubleClick",[g,S])}setValue(g,S,C){return this.channel.call("setValue",[g,S,C])}getTitle(g){return this.channel.call("getTitle",[g])}isActiveElement(g,S){return this.channel.call("isActiveElement",[g,S])}getElements(g,S,C){return this.channel.call("getElements",[g,S,C])}getElementXY(g,S,C,E){return this.channel.call("getElementXY",[g,S,C,E])}typeInEditor(g,S,C){return this.channel.call("typeInEditor",[g,S,C])}getTerminalBuffer(g,S){return this.channel.call("getTerminalBuffer",[g,S])}writeInTerminal(g,S,C){return this.channel.call("writeInTerminal",[g,S,C])}getLocaleInfo(g){return this.channel.call("getLocaleInfo",g)}getLocalizedStrings(g){return this.channel.call("getLocalizedStrings",g)}}e.DriverChannelClient=L;class D{constructor(g){this.registry=g}listen(g,S){throw new Error(`Event not found: ${S}`)}call(g,S,C){switch(S){case"registerWindowDriver":return this.registry.registerWindowDriver(C);case"reloadWindowDriver":return this.registry.reloadWindowDriver(C)}throw new Error(`Call not found: ${S}`)}}e.WindowDriverRegistryChannel=D;async function k(b){const g=await(0,w.connect)(b,"driverClient"),S=g.getChannel("driver"),C=new L(S);return{client:g,driver:C}}e.connect=k}),define(Z[22],x([0,1,46,7,57,52,170,5]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,b.refineServiceDecorator)(D.IEnvironmentService);class g extends k.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,L.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([w.memoize],g.prototype,"cachedLanguagesPath",null),ue([w.memoize],g.prototype,"backupHome",null),ue([w.memoize],g.prototype,"backupWorkspacesPath",null),ue([w.memoize],g.prototype,"mainIPCHandle",null),ue([w.memoize],g.prototype,"mainLockfile",null),ue([w.memoize],g.prototype,"sandbox",null),ue([w.memoize],g.prototype,"driverVerbose",null),ue([w.memoize],g.prototype,"disableUpdates",null),ue([w.memoize],g.prototype,"disableKeytar",null),ue([w.memoize],g.prototype,"codeCachePath",null),ue([w.memoize],g.prototype,"useCodeCache",null),e.EnvironmentMainService=g}),define(Z[230],x([0,1,60,29,28,10,7,2,17,8,24,163,19,22,20,6,162,25]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let M=class{constructor(l,c,a){this.configurationService=c,this.logService=a,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=g.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(f,s)=>(0,L.isEqual)(f,s,!b.isLinux)},this.backupHome=l.backupHome,this.workspacesJsonPath=l.backupWorkspacesPath}async initialize(){let l;try{l=JSON.parse(await C.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{l=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(l.emptyWorkspaceInfos);let c=[];try{Array.isArray(l.rootURIWorkspaces)&&(c=l.rootURIWorkspaces.map(f=>({workspace:{id:f.id,configPath:S.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let a=[];try{Array.isArray(l.folderWorkspaceInfos)?a=l.folderWorkspaceInfos.map(f=>({folderUri:S.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})):Array.isArray(l.folderURIWorkspaces)&&(a=l.folderURIWorkspaces.map(f=>({folderUri:S.URI.parse(f),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(a),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(l,c){this.workspaces.some(f=>l.workspace.id===f.workspace.id)||(this.workspaces.push(l),this.saveSync());const a=this.getBackupPath(l.workspace.id);return c&&this.moveBackupFolderSync(a,c),a}moveBackupFolderSync(l,c){if(n.existsSync(l)&&this.convertToEmptyWindowBackupSync(l),n.existsSync(c))try{n.renameSync(c,l)}catch(a){this.logService.error(`Backup: Could not move backup folder to new location: ${a.toString()}`)}}unregisterWorkspaceBackupSync(l){const c=l.id,a=this.workspaces.findIndex(f=>f.workspace.id===c);a!==-1&&(this.workspaces.splice(a,1),this.saveSync())}registerFolderBackupSync(l){return this.folders.some(c=>this.backupUriComparer.isEqual(l.folderUri,c.folderUri))||(this.folders.push(l),this.saveSync()),this.getBackupPath(this.getFolderHash(l))}unregisterFolderBackupSync(l){const c=this.folders.findIndex(a=>this.backupUriComparer.isEqual(l,a.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(l,c){const a=l||this.getRandomEmptyWindowId();return this.emptyWindows.some(f=>!!f.backupFolder&&this.backupPathComparer.isEqual(f.backupFolder,a))||(this.emptyWindows.push({backupFolder:a,remoteAuthority:c}),this.saveSync()),this.getBackupPath(a)}unregisterEmptyWindowBackupSync(l){const c=this.emptyWindows.findIndex(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,l));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(l){return(0,k.join)(this.backupHome,l)}async validateWorkspaces(l){if(!Array.isArray(l))return[];const c=new Set,a=[];for(let f of l){const s=f.workspace;if(!(0,v.isWorkspaceIdentifier)(s))return[];if(!c.has(s.id)){c.add(s.id);const i=this.getBackupPath(s.id);await this.doHasBackups(i)?s.configPath.scheme!==D.Schemas.file||await C.Promises.exists(s.configPath.fsPath)?a.push(f):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return a}async validateFolders(l){if(!Array.isArray(l))return[];const c=[],a=new Set;for(let f of l){const s=f.folderUri,i=this.backupUriComparer.getComparisonKey(s);if(!a.has(i)){a.add(i);const r=this.getBackupPath(this.getFolderHash(f));await this.doHasBackups(r)?s.scheme!==D.Schemas.file||await C.Promises.exists(s.fsPath)?c.push(f):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return c}async validateEmptyWorkspaces(l){if(!Array.isArray(l))return[];const c=[],a=new Set;for(let f of l){const s=f.backupFolder;if(typeof s!="string")return[];if(!a.has(s)){a.add(s);const i=this.getBackupPath(s);await this.doHasBackups(i)?c.push(f):await this.deleteStaleBackup(i)}}return c}async deleteStaleBackup(l){try{await C.Promises.exists(l)&&await C.Promises.rm(l,C.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(l){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(f=>!!f.backupFolder&&this.backupPathComparer.isEqual(f.backupFolder,c));)c=this.getRandomEmptyWindowId();const a=this.getBackupPath(c);try{await C.Promises.rename(l,a)}catch(f){return this.logService.error(`Backup: Could not rename backup folder: ${f.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(l){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(f=>!!f.backupFolder&&this.backupPathComparer.isEqual(f.backupFolder,c));)c=this.getRandomEmptyWindowId();const a=this.getBackupPath(c);try{n.renameSync(l,a)}catch(f){return this.logService.error(`Backup: Could not rename backup folder: ${f.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const l=[];for(const c of this.workspaces)await this.hasBackups(c)&&l.push(c);for(const c of this.folders)await this.hasBackups(c)&&l.push(c);return l}hasBackups(l){let c;return(0,E.isEmptyWindowBackupInfo)(l)?c=l.backupFolder:(0,m.isFolderBackupInfo)(l)?c=this.getBackupPath(this.getFolderHash(l)):c=this.getBackupPath(l.workspace.id),this.doHasBackups(c)}async doHasBackups(l){try{const c=await C.Promises.readdir(l);for(const a of c)try{if((await C.Promises.readdir((0,k.join)(l,a))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,C.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}async save(){try{await C.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(l=>({id:l.workspace.id,configURIPath:l.workspace.configPath.toString(),remoteAuthority:l.remoteAuthority})),folderWorkspaceInfos:this.folders.map(l=>({folderUri:l.folderUri.toString(),remoteAuthority:l.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(l){const c=l.folderUri;let a;return c.scheme===D.Schemas.file?a=b.isLinux?c.fsPath:c.fsPath.toLowerCase():a=c.toString().toLowerCase(),(0,w.createHash)("md5").update(a).digest("hex")}};M=ue([te(0,p.IEnvironmentMainService),te(1,I.IConfigurationService),te(2,d.ILogService)],M),e.BackupMainService=M}),define(Z[231],x([0,1,9,4,110,59,3,2,37,57,165,229,22,185,18,34,20,8,7,16,6]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function c(s){return s<21}let a=class{constructor(i,r,o,u,y,P,R){this.windowServer=i,this.options=r,this.windowsMainService=o,this.lifecycleMainService=u,this.fileService=y,this.environmentMainService=P,this.logService=R,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(i){return this.logService.info(`[driver] registerWindowDriver(${i})`),this.registeredWindowIds.add(i),this.reloadingWindowIds.delete(i),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(i){this.logService.info(`[driver] reloadWindowDriver(${i})`),this.reloadingWindowIds.add(i)}async getWindowIds(){return this.windowsMainService.getWindows().map(r=>r.id).filter(r=>this.registeredWindowIds.has(r)&&!this.reloadingWindowIds.has(r))}async capturePage(i){const r=this.windowsMainService.getWindowById(i)??this.windowsMainService.getLastActiveWindow();if(!r?.win)throw new Error("Invalid window");return(await r.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(i,r){}async stopTracing(i,r,o){if(!o)return;const u=await this.capturePage(i),y=Buffer.from(u,"base64");await this.fileService.writeFile(v.URI.file((0,M.join)(this.environmentMainService.logsPath,`${r}.png`)),h.VSBuffer.wrap(y))}async reloadWindow(i){this.logService.info(`[driver] reloadWindow(${i})`),await this.whenUnfrozen(i);const r=this.windowsMainService.getWindowById(i);if(!r)throw new Error("Invalid window");this.reloadingWindowIds.add(i),this.lifecycleMainService.reload(r)}exitApplication(){return this.logService.info("[driver] exitApplication()"),this.lifecycleMainService.quit()}async dispatchKeybinding(i,r){await this.whenUnfrozen(i);const o=L.KeybindingParser.parseUserBinding(r);for(let u of o)await this._dispatchKeybinding(i,u)}async _dispatchKeybinding(i,r){if(r instanceof D.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const o=this.windowsMainService.getWindowById(i);if(!o?.win)throw new Error("Invalid window");const u=o.win.webContents,y=new D.SimpleKeybinding(!1,!1,!1,!1,r.keyCode),R=new p.USLayoutResolvedKeybinding(y.toChord(),b.OS).getElectronAccelerator(),W=[];r.ctrlKey&&W.push("ctrl"),r.metaKey&&W.push("meta"),r.shiftKey&&W.push("shift"),r.altKey&&W.push("alt"),u.sendInputEvent({type:"keyDown",keyCode:R,modifiers:W}),c(r.keyCode)||u.sendInputEvent({type:"char",keyCode:R,modifiers:W}),u.sendInputEvent({type:"keyUp",keyCode:R,modifiers:W}),await(0,w.timeout)(100)}async click(i,r,o,u){await(await this.getWindowDriver(i)).click(r,o,u)}async doubleClick(i,r){await(await this.getWindowDriver(i)).doubleClick(r)}async setValue(i,r,o){await(await this.getWindowDriver(i)).setValue(r,o)}async getTitle(i){return await(await this.getWindowDriver(i)).getTitle()}async isActiveElement(i,r){return await(await this.getWindowDriver(i)).isActiveElement(r)}async getElements(i,r,o){return await(await this.getWindowDriver(i)).getElements(r,o)}async getElementXY(i,r,o,u){return await(await this.getWindowDriver(i)).getElementXY(r,o,u)}async typeInEditor(i,r,o){await(await this.getWindowDriver(i)).typeInEditor(r,o)}async getTerminalBuffer(i,r){return await(await this.getWindowDriver(i)).getTerminalBuffer(r)}async writeInTerminal(i,r,o){await(await this.getWindowDriver(i)).writeInTerminal(r,o)}async getLocaleInfo(i){return await(await this.getWindowDriver(i)).getLocaleInfo()}async getLocalizedStrings(i){return await(await this.getWindowDriver(i)).getLocalizedStrings()}async getWindowDriver(i){await this.whenUnfrozen(i);const r=`window:${i}`,o=new g.StaticRouter(y=>y===r),u=this.windowServer.getChannel("windowDriver",o);return new C.WindowDriverChannelClient(u)}async whenUnfrozen(i){for(;this.reloadingWindowIds.has(i);)await n.Event.toPromise(this.onDidReloadingChange.event)}};a=ue([te(2,d.IWindowsMainService),te(3,t.ILifecycleMainService),te(4,m.IFileService),te(5,I.IEnvironmentMainService),te(6,l.ILogService)],a),e.Driver=a;async function f(s,i,r,o){const u=r.driverVerbose,y=o.createInstance(a,s,{verbose:u}),P=new E.WindowDriverRegistryChannel(y);s.registerChannel("windowDriverRegistry",P);const R=await(0,S.serve)(i),W=new E.DriverChannel(y);return R.registerChannel("driver",W),(0,k.combinedDisposable)(R,s)}e.serve=f}),define(Z[232],x([0,1,61,57]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,D,k,b,g){const S=E=>g(E,void 0),C=w.createConnection({host:L,port:D},()=>{C.removeListener("error",S);const E=Buffer.alloc(16);for(let d=0;d<16;d++)E[d]=Math.round(Math.random()*256);const I=E.toString("base64"),p=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${D}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];C.write(p.join(`\r
`)+`\r
\r
`);const t=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",t),g(void 0,new n.NodeSocket(C,b)))};C.on("data",t)});C.setNoDelay(!0),C.once("error",S)}}}),define(Z[233],x([0,1,204,9,16,15,3,14,19,52,98,6,203,228]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends k.Disposable{constructor(m,v,M){super();this.environmentService=v,this.logService=M,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,v){this.logService.trace("RequestService#request",m.url);const{proxyUrl:M,strictSSL:h}=this;let l;try{l=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(f){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",f))}const c={...process.env,...l},a=m.agent?m.agent:await(0,I.getProxyAgent)(m.url||"",c,{proxyUrl:M,strictSSL:h});return m.agent=a,m.strictSSL=h,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this._request(m,v)}async getNodeRequest(m){return((0,w.parse)(m.url).protocol==="https:"?await new Promise((h,l)=>{V(["https"],h,l)}):await new Promise((h,l)=>{V(["http"],h,l)})).request}_request(m,v){return n.Promises.withAsyncBody(async(M,h)=>{let l;const c=(0,w.parse)(m.url),a=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),f={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,b.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(f.auth=m.user+":"+m.password),l=a(f,s=>{const i=(0,b.isNumber)(m.followRedirects)?m.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&i>0&&s.headers.location)this._request({...m,url:s.headers.location,followRedirects:i-1},v).then(M,h);else{let r=s;s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,p.createGunzip)())),M({res:s,stream:(0,L.streamToBufferReadableStream)(r)})}}),l.on("error",h),m.timeout&&l.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&l.write(m.data),l.end(),v.onCancellationRequested(()=>{l.abort(),h((0,D.canceled)())})})}async resolveProxy(m){}};t=ue([te(0,g.IConfigurationService),te(1,S.INativeEnvironmentService),te(2,E.ILogService)],t),e.RequestService=t}),define(Z[234],x([0,1,12,233]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function L(k){return w.net.request}class D extends n.RequestService{request(b,g){return super.request({...b||{},getRawRequest:L},g)}}e.RequestMainService=D}),define(Z[235],x([0,1,12,9,4,3,10,14,89,22,18,6,53,54,65,39]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends D.Disposable{constructor(M,h,l,c,a,f,s){super();this.machineId=M,this.userEnv=h,this.environmentMainService=l,this.lifecycleMainService=c,this.logService=a,this.themeMainService=f,this.protocolMainService=s,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new L.Emitter),this.onDidError=L.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:createSharedProcessMessageChannel",(M,h)=>this.onWindowConnection(M,h)),w.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(M,h)=>this.onWorkerConnection(M,h)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(M,h){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const l=await this.connect();if(M.sender.isDestroyed())return l.close();M.sender.postMessage("vscode:createSharedProcessMessageChannelResult",h,[l])}onWorkerConnection(M,h){this.logService.trace("SharedProcess: onWorkerConnection",h);const l=new D.DisposableStore,c=f=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${f}')`,h),l.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",h))},a=w.BrowserWindow.fromId(h.reply.windowId);if(!a||a.isDestroyed()||a.webContents.isDestroyed()||!h.reply.channel){c("unavailable");return}l.add(L.Event.filter(this.lifecycleMainService.onWillLoadWindow,f=>f.window.win===a)(()=>c("load"))),l.add(L.Event.fromNodeEventEmitter(a,"closed")(()=>c("closed"))),a.webContents.postMessage(h.reply.channel,h.reply.nonce,M.ports)}onWillShutdown(){const M=this.window;!M||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(M.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{M.close()}catch{}this.window=void 0},0))}send(M,...h){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${M}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(M,...h)}catch(l){this.logService.warn(`Error sending IPC message to channel '${M}' of shared process: ${(0,d.toErrorMessage)(l)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(M=>w.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),M()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(M=>w.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),M()}))})()),this._whenIpcReady}createWindow(){const M=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),M.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:I.default}),this.window.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=M=>{this.logService.trace("SharedProcess#close prevented"),M.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(M,h)=>this._onDidError.fire({type:2,details:h})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(M,h,l)=>this._onDidError.fire({type:3,details:{reason:l,exitCode:h}})))}async connect(){await this.whenIpcReady;const M=(0,b.assertIsDefined)(this.window);return(0,g.connect)(M)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const M=this.window;return M?!M.isDestroyed()&&!M.webContents.isDestroyed():!1}};m=ue([te(2,S.IEnvironmentMainService),te(3,C.ILifecycleMainService),te(4,E.ILogService),te(5,t.IThemeMainService),te(6,p.IProtocolMainService)],m),e.SharedProcess=m}),define(Z[236],x([0,1,9,16,7,14,8,22,20,6]),function(V,e,w,n,L,D,k,b,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class C{constructor(p,t,d){this.storagePath=p,this.logService=t,this.fileService=d,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,t){const d=this.storage[p];return(0,D.isUndefinedOrNull)(d)?t:d}setItem(p,t){this.setItems([{key:p,data:t}])}setItems(p){let t=!1;for(const{key:d,data:m}of p)this.storage[d]!==m&&((0,D.isUndefinedOrNull)(m)?(0,D.isUndefined)(this.storage[d])||(this.storage[d]=void 0,t=!0):(this.storage[d]=m,t=!0));t&&this.save()}removeItem(p){(0,D.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=C;let E=class Mt{constructor(p,t,d){this.fileStorage=new C(k.URI.file((0,L.join)(p.userDataPath,Mt.STATE_FILE)),t,d)}async init(){return this.fileStorage.init()}getItem(p,t){return this.fileStorage.getItem(p,t)}setItem(p,t){this.fileStorage.setItem(p,t)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};E.STATE_FILE="storage.json",E=ue([te(0,b.IEnvironmentMainService),te(1,S.ILogService),te(2,g.IFileService)],E),e.StateMainService=E}),define(Z[81],x([0,1,43,3,52,22,5,18,6,97,225]),function(V,e,w,n,L,D,k,b,g,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,k.createDecorator)("storageMainService");let E=class extends n.Disposable{constructor(t,d,m){super();this.logService=t,this.environmentService=d,this.lifecycleMainService=m,this.shutdownReason=void 0,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{(0,g.logCi)(this.logService,"storageMainService#onWillShutdown()"),this.shutdownReason=t.reason,t.join(this.globalStorage.close());for(const[,d]of this.mapWorkspaceToStorage)t.join(d.close())}))}createGlobalStorage(){this.logService.trace("StorageMainService: creating global storage");const t=new C.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,w.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}workspaceStorage(t){let d=this.mapWorkspaceToStorage.get(t.id);return d||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),d=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,d),(0,w.once)(d.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),d}createWorkspaceStorage(t){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService):new C.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}};E=ue([te(0,g.ILogService),te(1,L.IEnvironmentService),te(2,b.ILifecycleMainService)],E),e.StorageMainService=E,e.IGlobalStorageMainService=(0,k.createDecorator)("globalStorageMainService");let I=class extends S.AbstractStorageService{constructor(t,d){super();this.environmentMainService=t,this.storageMainService=d,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};I=ue([te(0,D.IEnvironmentMainService),te(1,e.IStorageMainService)],I),e.GlobalStorageMainService=I}),define(Z[237],x([0,1,61,123,232,9,3,19,6,21,202,99,79]),function(V,e,w,n,L,D,k,b,g,S,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(M,h,l,c,a){let f;for(let s=3;s&&(f&&f.dispose(),f=await new t(M,h,l,c,a).waitForReady(),!(a&&n.BROWSER_RESTRICTED_PORTS[a]||!n.BROWSER_RESTRICTED_PORTS[f.tunnelLocalPort]));s--);return f}class t extends k.Disposable{constructor(h,l,c,a,f){super();this.defaultTunnelHost=l,this.suggestedLocalPort=f,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=h,this._server=w.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=a,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(l=>{l()})}async waitForReady(){let h=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),l=null;return this._server.listen(h,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address(),l||(h=0,this._server.listen(h,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(h){h.pause();const l=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,C.connectRemoteAgentTunnel)(this._options,l,this.tunnelRemotePort),a=c.getSocket().socket,f=c.readEntireBuffer();c.dispose(),f.byteLength>0&&h.write(f.buffer),h.on("end",()=>{h.localAddress&&this._socketsDispose.delete(h.localAddress),a.end()}),h.on("close",()=>a.end()),h.on("error",()=>{h.localAddress&&this._socketsDispose.delete(h.localAddress),a.destroy()}),a.on("end",()=>h.end()),a.on("close",()=>h.end()),a.on("error",()=>{h.destroy()}),h.pipe(a),a.pipe(h),h.localAddress&&this._socketsDispose.set(h.localAddress,()=>{h.end(),a.end()})}}let d=class extends E.AbstractTunnelService{constructor(h,l,c,a,f){super(l);this.socketFactory=h,this.signService=c,this.productService=a,this.configurationService=f}get defaultTunnelHost(){const h=this.configurationService.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(h,l,c,a,f,s,i){const r=this.getTunnelFromMap(l,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,l,c,a,f,s,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${l}:${c} on local port ${a}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:h,signService:this.signService,logService:this.logService,ipcLogger:null},u=p(o,this.defaultTunnelHost,l,c,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(l,c,u),u}}};d=ue([te(1,g.ILogService),te(2,I.ISignService),te(3,S.IProductService),te(4,b.IConfigurationService)],d),e.BaseTunnelService=d;let m=class extends d{constructor(h,l,c,a){super(L.nodeSocketFactory,h,l,c,a)}};m=ue([te(0,g.ILogService),te(1,I.ISignService),te(2,S.IProductService),te(3,b.IConfigurationService)],m),e.TunnelService=m;let v=class extends k.Disposable{constructor(h,l,c,a){super();this.logService=h,this.productService=l,this.signService=c,this.configurationService=a,this._tunnelServices=new Map}async openTunnel(h,l,c,a,f,s,i,r){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${a} on local port ${f}.`),!this._tunnelServices.has(h)){const o=new m(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(h,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(h))})}return this._tunnelServices.get(h).openTunnel(l,c,a,f,s,i,r)}};v=ue([te(0,g.ILogService),te(1,S.IProductService),te(2,I.ISignService),te(3,b.IConfigurationService)],v),e.SharedTunnelsService=v}),define(Z[82],x([0,1,9,23,4,19,22,18,6,21,56,41]),function(V,e,w,n,L,D,k,b,g,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function I(t,d,m){return`${m.updateUrl}/api/update/${t}/${d}/${m.commit}`}e.createUpdateURL=I;let p=class{constructor(d,m,v,M,h,l){this.lifecycleMainService=d,this.configurationService=m,this.environmentMainService=v,this.requestService=M,this.logService=h,this.productService=l,this._state=E.State.Uninitialized,this._onStateChange=new L.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const d=this.getUpdateMode(),m=this.getProductQuality(d);if(!m){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(m),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(E.State.Idle(this.getUpdateType())),d==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}d==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(d){return d==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(d=60*60*1e3){return(0,w.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(d){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};p=ue([te(0,b.ILifecycleMainService),te(1,D.IConfigurationService),te(2,k.IEnvironmentMainService),te(3,C.IRequestService),te(4,g.ILogService),te(5,S.IProductService)],p),e.AbstractUpdateService=p}),define(Z[238],x([0,1,12,46,4,3,19,22,18,6,21,56,32,41,82]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let d=class extends t.AbstractUpdateService{constructor(v,M,h,l,c,a,f){super(v,M,l,c,a,f);this.telemetryService=h,this.disposables=new D.DisposableStore}get onRawError(){return L.Event.fromNodeEventEmitter(w.autoUpdater,"error",(v,M)=>M)}get onRawUpdateNotAvailable(){return L.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return L.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(v,M,h)=>({url:M,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return L.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(v,M,h,l)=>({releaseNotes:M,version:h,productVersion:h,date:l}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(p.State.Idle(1,h))}buildUpdateFeedUrl(v){let M;this.productService.darwinUniversalAssetId?M=this.productService.darwinUniversalAssetId:M=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,t.createUpdateURL)(M,v,this.productService);try{w.autoUpdater.setFeedURL({url:h})}catch(l){this.logService.error("Failed to set update feed URL",l);return}return h}doCheckForUpdates(v){this.setState(p.State.CheckingForUpdates(v)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(p.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([n.memoize],d.prototype,"onRawError",null),ue([n.memoize],d.prototype,"onRawUpdateNotAvailable",null),ue([n.memoize],d.prototype,"onRawUpdateAvailable",null),ue([n.memoize],d.prototype,"onRawUpdateDownloaded",null),d=ue([te(0,g.ILifecycleMainService),te(1,k.IConfigurationService),te(2,I.ITelemetryService),te(3,b.IEnvironmentMainService),te(4,E.IRequestService),te(5,S.ILogService),te(6,C.IProductService)],d),e.DarwinUpdateService=d}),define(Z[239],x([0,1,45,29,9,4,7,22,18,6,32,41]),function(V,e,w,n,L,D,k,b,g,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let I=class{constructor(d,m,v){if(this.lifecycleMainService=d,this.logService=v,this._state=E.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event,m.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(E.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,M=>this.logService.error(M))}get state(){return this._state}setState(d){this.logService.info("update#setState",d.type),this._state=d,this._onStateChange.fire(d)}scheduleCheckForUpdates(d=60*60*1e3){return(0,L.timeout)(d).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(d){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(d)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(d){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(d=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${d}`),!d&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};I=ue([te(0,g.ILifecycleMainService),te(1,b.IEnvironmentMainService),te(2,S.ILogService)],I);let p=class extends I{constructor(d,m,v,M,h,l){super(v,M,h);this.snap=d,this.snapRevision=m,this.telemetryService=l;const c=(0,n.watch)(k.dirname(this.snap)),a=D.Event.fromNodeEventEmitter(c,"change",(r,o)=>o),f=D.Event.filter(a,r=>r==="current"),i=D.Event.debounce(f,(r,o)=>o,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{i.dispose(),c.close()})}doCheckForUpdates(){this.setState(E.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(d=>{d?this.setState(E.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2)))},d=>{this.logService.error(d),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2,d.message||d))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+k.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const d=await new Promise((v,M)=>(0,n.realpath)(`${k.dirname(this.snap)}/current`,(h,l)=>h?M(h):v(l))),m=k.basename(d);return this.snapRevision!==m}isLatestVersion(){return this.isUpdateAvailable().then(void 0,d=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=ue([te(2,g.ILifecycleMainService),te(3,b.IEnvironmentMainService),te(4,S.ILogService),te(5,C.ITelemetryService)],p),e.SnapUpdateService=p}),define(Z[42],x([0,1,12,29,4,44,33,3,10,7,2,17,14,24,161,51,47,22,5,6,21,102,25,80,103]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M,h,l,c,a,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,M.createDecorator)("workspacesManagementMainService");let i=class extends b.Disposable{constructor(o,u,y,P,R){super();this.environmentMainService=o,this.logService=u,this.backupMainService=y,this.dialogMainService=P,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,u=>(0,n.readFileSync)(u,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,u=>p.Promises.readFile(u,"utf8"))}doResolveLocalWorkspace(o,u){if(!!this.isWorkspacePath(o)&&o.scheme===g.Schemas.file)try{const y=u(o.fsPath);return y instanceof Promise?y.then(P=>this.doResolveWorkspace(o,P),P=>{}):this.doResolveWorkspace(o,y)}catch{return}}isWorkspacePath(o){return(0,a.isUntitledWorkspace)(o,this.environmentMainService)||(0,a.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,u){try{const y=this.doParseStoredWorkspace(o,u),P=(0,s.getWorkspaceIdentifier)(o);return{id:P.id,configPath:P.configPath,folders:(0,f.toWorkspaceFolders)(y.folders,P.configPath,E.extUriBiasedIgnorePathCase),remoteAuthority:y.remoteAuthority,transient:y.transient}}catch(y){this.logService.warn(y.toString())}}doParseStoredWorkspace(o,u){const y=(0,D.parse)(u);if(y&&Array.isArray(y.folders))y.folders=y.folders.filter(P=>(0,f.isStoredWorkspaceFolder)(P));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return y}async createUntitledWorkspace(o,u){const{workspace:y,storedWorkspace:P}=this.newUntitledWorkspace(o,u),R=y.configPath.fsPath;return await p.Promises.mkdir((0,S.dirname)(R),{recursive:!0}),await p.Promises.writeFile(R,JSON.stringify(P,null,"	")),y}createUntitledWorkspaceSync(o,u){const{workspace:y,storedWorkspace:P}=this.newUntitledWorkspace(o,u),R=y.configPath.fsPath;return(0,n.mkdirSync)((0,S.dirname)(R),{recursive:!0}),(0,p.writeFileSync)(R,JSON.stringify(P,null,"	")),y}newUntitledWorkspace(o=[],u){const y=(Date.now()+Math.round(Math.random()*1e3)).toString(),P=(0,E.joinPath)(this.untitledWorkspacesHome,y),R=(0,E.joinPath)(P,a.UNTITLED_WORKSPACE_NAME),W=[];for(const U of o)W.push((0,f.getStoredWorkspaceFolder)(U.uri,!0,U.name,P,!C.isWindows,E.extUriBiasedIgnorePathCase));return{workspace:(0,s.getWorkspaceIdentifier)(R),storedWorkspace:{folders:W,remoteAuthority:u}}}async getWorkspaceIdentifier(o){return(0,s.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,a.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const u=(0,E.originalFSPath)(o.configPath);try{(0,p.rimrafSync)((0,S.dirname)(u));const y=(0,S.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,n.existsSync)(y)&&(0,p.writeFileSync)((0,S.join)(y,"obsolete"),"")}catch(y){this.logService.warn(`Unable to delete untitled workspace ${u} (${y}).`)}}getUntitledWorkspacesSync(){const o=[];try{const u=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(y=>(0,E.joinPath)(this.untitledWorkspacesHome,y,a.UNTITLED_WORKSPACE_NAME));for(const y of u){const P=(0,s.getWorkspaceIdentifier)(y),R=this.resolveLocalWorkspaceSync(y);R?o.push({workspace:P,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(P)}}catch(u){u.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${u}).`)}return o}async enterWorkspace(o,u,y){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,u,y))return;const R=this.doEnterWorkspace(o,(0,s.getWorkspaceIdentifier)(y));if(!!R)return this._onDidEnterWorkspace.fire({window:o,workspace:R.workspace}),R}async isValidTargetWorkspacePath(o,u,y){if(!y)return!0;if((0,a.isWorkspaceIdentifier)(o.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,y))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(u,y)){const P={title:this.productService.nameLong,type:"info",buttons:[(0,k.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,E.basename)(y)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(P,(0,I.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,u){if(!o.config)return;o.focus();let y;return o.config.extensionDevelopmentPath||(y=this.backupMainService.registerWorkspaceBackupSync({workspace:u,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,a.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=u,o.config.backupPath=y,{workspace:u,backupPath:y}}};i=ue([te(0,v.IEnvironmentMainService),te(1,h.ILogService),te(2,d.IBackupMainService),te(3,m.IDialogMainService),te(4,l.IProductService)],i),e.WorkspacesManagementMainService=i}),define(Z[104],x([0,1,12,23,5,34,25,42]),function(V,e,w,n,L,D,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,L.createDecorator)(e.ID);let g=class{constructor(C,E){this.windowsMainService=C,this.workspacesManagementMainService=E}async getRemoteDiagnostics(C){const E=this.windowsMainService.getWindows();return(await Promise.all(E.map(p=>new Promise(t=>{const d=p.remoteAuthority;if(d){const m=`vscode:getDiagnosticInfoResponse${p.id}`,v={includeProcesses:C.includeProcesses,folders:C.includeWorkspaceMetadata?this.getFolderURIs(p):void 0};p.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:m,args:v}),w.ipcMain.once(m,(M,h)=>{h||t({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),t(h)}),setTimeout(()=>{t({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)}else t(void 0)})))).filter(p=>!!p)}getFolderURIs(C){const E=[],I=C.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(I))E.push(I.uri);else if((0,k.isWorkspaceIdentifier)(I)){const p=this.workspacesManagementMainService.resolveLocalWorkspaceSync(I.configPath);p&&p.folders.forEach(d=>{E.push(d.uri)})}return E}};g=ue([te(0,D.IWindowsMainService),te(1,b.IWorkspacesManagementMainService)],g),e.DiagnosticsMainService=g}),define(Z[105],x([0,1,12,30,2,14,8,24,19,50,5,6,100,34,25,42]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,C.createDecorator)(e.ID);let m=class{constructor(M,h,l,c,a){this.logService=M,this.windowsMainService=h,this.urlService=l,this.workspacesManagementMainService=c,this.configurationService=a}async start(M,h){this.logService.trace("Received data from other instance: ",M,h),L.isMacintosh&&w.app.focus({steal:!0});const l=this.parseOpenUrl(M);if(l.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:a,url:f}of l)this.urlService.open(a,{originalUrl:f})})}else return this.startOpenWindow(M,h)}parseOpenUrl(M){return M["open-url"]&&M._urls&&M._urls.length>0?(0,n.coalesce)(M._urls.map(h=>{try{return{uri:k.URI.parse(h),url:h}}catch{return null}})):[]}async startOpenWindow(M,h){const l=(0,S.isLaunchedFromCli)(h)?0:4;let c=[];const a=M.wait&&M.waitMarkerFilePath?k.URI.file(M.waitMarkerFilePath):void 0,f=M.remote||void 0,s={context:l,cli:M,userEnv:h,waitMarkerFileURI:a,remoteAuthority:f};if(M.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(M.extensionDevelopmentPath,s);else if(!M._.length&&!M["folder-uri"]&&!M["file-uri"]){let i=!1;if(M["new-window"]||M["unity-launch"])i=!0;else if(M["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!L.isMacintosh}if(i)c=this.windowsMainService.open({...s,forceNewWindow:!0,forceEmpty:!0});else{const r=this.windowsMainService.getLastActiveWindow();r?(this.windowsMainService.openExistingWindow(r,s),c=[r]):c=this.windowsMainService.open({...s,forceEmpty:!0})}}else c=this.windowsMainService.open({...s,forceNewWindow:M["new-window"],preferNewWindow:!M["reuse-window"]&&!M.wait,forceReuseWindow:M["reuse-window"],diffMode:M.diff,addMode:M.add,noRecentEntry:!!M["skip-add-to-recently-opened"],gotoLineMode:M.goto});if(a&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,b.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const M=[];return w.BrowserWindow.getAllWindows().forEach(h=>{const l=this.windowsMainService.getWindowById(h.id);l?M.push(this.codeWindowToInfo(l)):M.push(this.browserWindowToInfo(h))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:M,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}getFolderURIs(M){const h=[],l=M.openedWorkspace;if((0,t.isSingleFolderWorkspaceIdentifier)(l))h.push(l.uri);else if((0,t.isWorkspaceIdentifier)(l)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);c&&c.folders.forEach(f=>{h.push(f.uri)})}return h}codeWindowToInfo(M){const h=this.getFolderURIs(M),l=(0,D.assertIsDefined)(M.win);return this.browserWindowToInfo(l,h,M.remoteAuthority)}browserWindowToInfo(M,h=[],l){return{pid:M.webContents.getOSProcessId(),title:M.getTitle(),folderURIs:h,remoteAuthority:l}}};m=ue([te(0,E.ILogService),te(1,p.IWindowsMainService),te(2,I.IURLService),te(3,d.IWorkspacesManagementMainService),te(4,g.IConfigurationService)],m),e.LaunchMainService=m}),define(Z[58],x([0,1,45,12,26,122,46,4,33,3,10,7,2,8,86,71,24,152,47,22,5,18,6,21,32,65,34,25,42]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M,h,l,c,a,f,s,i,r,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let y=class extends S.Disposable{constructor(R,W,U,G,ee,X,J,H,B,Y){super();this.sharedProcess=R,this.windowsMainService=W,this.dialogMainService=U,this.lifecycleMainService=G,this.environmentMainService=ee,this.telemetryService=X,this.logService=J,this.productService=H,this.themeMainService=B,this.workspacesManagementMainService=Y,this.onDidOpenWindow=b.Event.map(this.windowsMainService.onDidOpenWindow,se=>se.id),this.onDidMaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(se,$)=>$.id),se=>!!this.windowsMainService.getWindowById(se)),this.onDidUnmaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(se,$)=>$.id),se=>!!this.windowsMainService.getWindowById(se)),this.onDidBlurWindow=b.Event.filter(b.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(se,$)=>$.id),se=>!!this.windowsMainService.getWindowById(se)),this.onDidFocusWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),se=>!!se),se=>se.id),b.Event.filter(b.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(se,$)=>$.id),se=>!!this.windowsMainService.getWindowById(se))),this.onDidResumeOS=b.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new b.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new b.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(se,$,q)=>q),se=>!(Array.isArray(se)&&se.length===1&&se[0]==="workArea")),b.Event.fromNodeEventEmitter(n.screen,"display-added"),b.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(R){return this.windowsMainService.getWindowCount()}async getActiveWindowId(R){const W=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(R,W,U){return Array.isArray(W)?this.doOpenWindow(R,W,U):this.doOpenEmptyWindow(R,W)}async doOpenWindow(R,W,U=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:R,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0})}async doOpenEmptyWindow(R,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:R},W)}async toggleFullScreen(R){const W=this.windowById(R);W&&W.toggleFullScreen()}async handleTitleDoubleClick(R){const W=this.windowById(R);W&&W.handleTitleDoubleClick()}async isMaximized(R){const W=this.windowById(R);return W?.win?W.win.isMaximized():!1}async maximizeWindow(R){const W=this.windowById(R);W?.win&&W.win.maximize()}async unmaximizeWindow(R){const W=this.windowById(R);W?.win&&W.win.unmaximize()}async minimizeWindow(R){const W=this.windowById(R);W?.win&&W.win.minimize()}async focusWindow(R,W){W&&typeof W.windowId=="number"&&(R=W.windowId);const U=this.windowById(R);U&&U.focus({force:W?.force??!1})}async setMinimumSize(R,W,U){const G=this.windowById(R);if(G?.win){const[ee,X]=G.win.getSize(),[J,H]=G.win.getMinimumSize(),[B,Y]=[W??J,U??H],[se,$]=[Math.max(ee,B),Math.max(X,Y)];(J!==B||H!==Y)&&G.win.setMinimumSize(B,Y),(ee!==se||X!==$)&&G.win.setSize(se,$)}}async saveWindowSplash(R,W){this.themeMainService.saveWindowSplash(R,W)}async installShellCommand(R){const{source:W,target:U}=await this.getShellCommandLink();try{const{symbolicLink:G}=await m.SymlinkSupport.stat(W);if(G&&!G.dangling){const ee=await(0,t.realpath)(W);if(U===ee)return}await m.Promises.unlink(W)}catch(G){if(G.code!=="ENOENT")throw G}try{await m.Promises.symlink(U,W)}catch(G){if(G.code!=="EACCES"&&G.code!=="ENOENT")throw G;const{response:ee}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,g.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ee===0)try{const X=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${W}'\\" with administrator privileges"`;await(0,D.promisify)(w.exec)(X)}catch{throw new Error((0,v.localize)(3,null,W))}}}async uninstallShellCommand(R){const{source:W}=await this.getShellCommandLink();try{await m.Promises.unlink(W)}catch(U){switch(U.code){case"EACCES":{const{response:G}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,g.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,g.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(G===0)try{const ee=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,D.promisify)(w.exec)(ee)}catch{throw new Error((0,v.localize)(7,null,W))}break}case"ENOENT":break;default:throw U}}}async getShellCommandLink(){const R=(0,E.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await m.Promises.exists(R))throw new Error((0,v.localize)(8,null,R));return{source:W,target:R}}async showMessageBox(R,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(R))}async showSaveDialog(R,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(R))}async showOpenDialog(R,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(R))}toBrowserWindow(R){const W=this.windowById(R);if(W?.win)return W.win}async pickFileFolderAndOpen(R,W){const U=await this.dialogMainService.pickFileFolder(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openFileFolder",W.telemetryExtraData),this.doOpenPicked(await Promise.all(U.map(async G=>await m.SymlinkSupport.existsDirectory(G)?{folderUri:p.URI.file(G)}:{fileUri:p.URI.file(G)})),W,R))}async pickFolderAndOpen(R,W){const U=await this.dialogMainService.pickFolder(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openFolder",W.telemetryExtraData),this.doOpenPicked(U.map(G=>({folderUri:p.URI.file(G)})),W,R))}async pickFileAndOpen(R,W){const U=await this.dialogMainService.pickFile(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openFile",W.telemetryExtraData),this.doOpenPicked(U.map(G=>({fileUri:p.URI.file(G)})),W,R))}async pickWorkspaceAndOpen(R,W){const U=await this.dialogMainService.pickWorkspace(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openWorkspace",W.telemetryExtraData),this.doOpenPicked(U.map(G=>({workspaceUri:p.URI.file(G)})),W,R))}doOpenPicked(R,W,U){this.windowsMainService.open({context:3,contextWindowId:U,cli:this.environmentMainService.args,urisToOpen:R,forceNewWindow:W.forceNewWindow})}sendPickerTelemetry(R,W,U){const G=R?R.length:0;this.telemetryService.publicLog(W,{...U,outcome:G?"success":"canceled",numberOfPaths:G})}async showItemInFolder(R,W){n.shell.showItemInFolder(W)}async setRepresentedFilename(R,W){const U=this.windowById(R);U&&U.setRepresentedFilename(W)}async setDocumentEdited(R,W){const U=this.windowById(R);U&&U.setDocumentEdited(W)}async openExternal(R,W){return I.isLinuxSnap?this.safeSnapOpenExternal(W):n.shell.openExternal(W),!0}safeSnapOpenExternal(R){const W=process.env.GDK_PIXBUF_MODULE_FILE,U=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(R),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=U}moveItemToTrash(R,W){return n.shell.trashItem(W)}async isAdmin(){let R;return I.isWindows?R=(await new Promise((W,U)=>{V(["native-is-elevated"],W,U)}))():R=process.getuid()===0,R}async writeElevated(R,W,U,G){const ee=await new Promise((X,J)=>{V(["@vscode/sudo-prompt"],X,J)});return new Promise((X,J)=>{const H=[`"${this.cliPath}"`];G?.unlock&&H.push("--file-chmod"),H.push("--file-write",`"${W.fsPath}"`,`"${U.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:I.isMacintosh&&this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ee.exec(H.join(" "),B,(Y,se,$)=>{se&&this.logService.trace(`[sudo-prompt] received stdout: ${se}`),$&&this.logService.trace(`[sudo-prompt] received stderr: ${$}`),Y?J(Y):X(void 0)})})}get cliPath(){return I.isWindows?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):I.isLinux?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,E.join)(this.environmentMainService.appRoot,"bin","code"):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,L.totalmem)(),freemem:(0,L.freemem)(),loadavg:(0,L.loadavg)()}}async getOSProperties(){return{arch:(0,L.arch)(),platform:(0,L.platform)(),release:(0,L.release)(),type:(0,L.type)(),cpus:(0,L.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}get osColorScheme(){return{highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(R,W,U){process.kill(W,U)}async readClipboardText(R,W){return n.clipboard.readText(W)}async writeClipboardText(R,W,U){return n.clipboard.writeText(W,U)}async readClipboardFindText(R){return n.clipboard.readFindText()}async writeClipboardFindText(R,W){return n.clipboard.writeFindText(W)}async writeClipboardBuffer(R,W,U,G){return n.clipboard.writeBuffer(W,Buffer.from(U),G)}async readClipboardBuffer(R,W){return n.clipboard.readBuffer(W)}async hasClipboard(R,W,U){return n.clipboard.has(W,U)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(R,W){const U=this.windowById(R);U&&U.updateTouchBar(W)}async notifyReady(R){const W=this.windowById(R);W&&W.setReady()}async relaunch(R,W){return this.lifecycleMainService.relaunch(W)}async reload(R,W){const U=this.windowById(R);if(U){if((0,o.isWorkspaceIdentifier)(U.openedWorkspace)){const G=U.openedWorkspace.configPath;if(G.scheme===C.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(G))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(U,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(R){this.closeWindowById(R,R)}async closeWindowById(R,W){const U=this.windowById(W);if(U?.win)return U.win.close()}async quit(R){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(R,W){await this.lifecycleMainService.kill(W)}async resolveProxy(R,W){const G=this.windowById(R)?.win?.webContents?.session;if(G)return G.resolveProxy(W)}async openDevTools(R,W){const U=this.windowById(R);U?.win&&U.win.webContents.openDevTools(W)}async toggleDevTools(R){const W=this.windowById(R);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(R,W){const U=this.windowById(R);U?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&U.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(R,W,U,G){if(!I.isWindows)return;const ee=await new Promise((X,J)=>{V(["@vscode/windows-registry"],X,J)});try{return ee.GetStringRegKey(W,U,G)}catch{return}}windowById(R){if(typeof R=="number")return this.windowsMainService.getWindowById(R)}};ue([k.memoize],y.prototype,"cliPath",null),y=ue([te(1,r.IWindowsMainService),te(2,M.IDialogMainService),te(3,c.ILifecycleMainService),te(4,h.IEnvironmentMainService),te(5,s.ITelemetryService),te(6,a.ILogService),te(7,f.IProductService),te(8,i.IThemeMainService),te(9,u.IWorkspacesManagementMainService)],y),e.NativeHostMainService=y}),define(Z[240],x([0,1,12,26,33,3,10,2,87,150,75,104,47,22,5,105,6,58,53,21,54,66]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M,h,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,t.createDecorator)("issueMainService");let a=class Ct{constructor(s,i,r,o,u,y,P,R,W,U){this.userEnv=s,this.environmentMainService=i,this.launchMainService=r,this.logService=o,this.diagnosticsService=u,this.diagnosticsMainService=y,this.dialogMainService=P,this.nativeHostMainService=R,this.protocolMainService=W,this.productService=U,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[i,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(i,r);this.safeSend(s,"vscode:issueSystemInfoResponse",o)}),w.ipcMain.on("vscode:listProcesses",async s=>{const i=[];try{const r=await this.launchMainService.getMainProcessId();i.push({name:(0,S.localize)(0,null),rootProcess:await(0,g.listProcesses)(r)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(u=>{(0,C.isRemoteDiagnosticError)(u)?i.push({name:u.hostName,rootProcess:u}):u.processes&&i.push({name:u.hostName,rootProcess:u.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(s,"vscode:listProcessesResponse",i)}),w.ipcMain.on("vscode:issueReporterClipboard",async s=>{const i={title:this.productService.nameLong,message:(0,S.localize)(1,null),type:"warning",buttons:[(0,L.mnemonicButtonLabel)((0,S.localize)(2,null)),(0,L.mnemonicButtonLabel)((0,S.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(i,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",r.response===0)}}),w.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const i=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",i)}),w.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,S.localize)(4,null),type:"warning",buttons:[(0,L.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,L.mnemonicButtonLabel)((0,S.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),w.ipcMain.on("vscode:workbenchCommand",(s,i)=>{const{id:r,from:o,args:u}=i;let y;switch(o){case"issueReporter":y=this.issueReporterParentWindow;break;case"processExplorer":y=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}y&&y.webContents.send("vscode:runAction",{id:r,from:o,args:u})}),w.ipcMain.on("vscode:openExternal",(s,i)=>{this.nativeHostMainService.openExternal(void 0,i)}),w.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),w.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),w.ipcMain.on("vscode:windowsInfoRequest",async s=>{const i=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",i.windows)})}safeSend(s,i,...r){s.sender.isDestroyed()||s.sender.send(i,...r)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new D.DisposableStore,r=i.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,r,{backgroundColor:s.styles.backgroundColor,title:(0,S.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:M.default}),this.issueReporterWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new D.DisposableStore,r=i.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,r,{backgroundColor:s.styles.backgroundColor,title:(0,S.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:M.default}),this.processExplorerWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,i,r,o){const u=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:r.title,backgroundColor:r.backgroundColor||Ct.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`,`--vscode-window-kind=${o}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,c.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop,experimentalDarkMode:!0});return u.setMenuBarVisibility(!1),u}async getSystemStatus(){const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,i)}getWindowPosition(s,i,r){let o;const u=w.screen.getAllDisplays();if(u.length===1)o=u[0];else{if(b.isMacintosh){const R=w.screen.getCursorScreenPoint();o=w.screen.getDisplayNearestPoint(R)}!o&&s&&(o=w.screen.getDisplayMatching(s.getBounds())),o||(o=w.screen.getPrimaryDisplay()||u[0])}const y={width:i,height:r},P=o.bounds;return y.x=P.x+P.width/2-y.width/2,y.y=P.y+P.height/2-y.height/2,P.width>0&&P.height>0&&(y.x<P.x&&(y.x=P.x),y.y<P.y&&(y.y=P.y),y.x>P.x+P.width&&(y.x=P.x),y.y>P.y+P.height&&(y.y=P.y),y.width>P.width&&(y.width=P.width),y.height>P.height&&(y.height=P.height)),y}async getPerformanceInfo(){try{const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,i)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};a.DEFAULT_BACKGROUND_COLOR="#1E1E1E",a=ue([te(1,p.IEnvironmentMainService),te(2,d.ILaunchMainService),te(3,m.ILogService),te(4,C.IDiagnosticsService),te(5,E.IDiagnosticsMainService),te(6,I.IDialogMainService),te(7,v.INativeHostMainService),te(8,l.IProtocolMainService),te(9,h.IProductService)],a),e.IssueMainService=a}),define(Z[241],x([0,1,23,19,22,18,6,58,21,56,32,41,82]),function(V,e,w,n,L,D,k,b,g,S,C,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends I.AbstractUpdateService{constructor(d,m,v,M,h,l,c,a){super(d,m,M,h,l,a);this.telemetryService=v,this.nativeHostMainService=c}buildUpdateFeedUrl(d){return(0,I.createUpdateURL)(`linux-${process.arch}`,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(E.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},w.CancellationToken.None).then(S.asJson).then(m=>{!m||!m.url||!m.version||!m.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(E.State.Idle(1))):this.setState(E.State.AvailableForDownload(m))}).then(void 0,m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const v=d?m.message||m:void 0;this.setState(E.State.Idle(1,v))}))}async doDownloadUpdate(d){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(E.State.Idle(1))}};p=ue([te(0,D.ILifecycleMainService),te(1,n.IConfigurationService),te(2,C.ITelemetryService),te(3,L.IEnvironmentMainService),te(4,S.IRequestService),te(5,k.ILogService),te(6,b.INativeHostMainService),te(7,g.IProductService)],p),e.LinuxUpdateService=p}),define(Z[242],x([0,1,45,29,26,9,23,46,7,8,119,24,19,22,20,18,6,58,21,56,32,41,82]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M,h,l,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function f(o,u=1e3){for(;!o();)await(0,D.timeout)(u)}let s;function i(){return typeof s=="undefined"&&(s=n.existsSync(g.join(g.dirname(process.execPath),"unins000.exe"))?0:1),s}let r=class extends a.AbstractUpdateService{constructor(u,y,P,R,W,U,G,ee,X){super(u,y,R,W,U,X);this.telemetryService=P,this.fileService=G,this.nativeHostMainService=ee}get cachePath(){const u=g.join((0,L.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return E.Promises.mkdir(u,{recursive:!0}).then(()=>u)}initialize(){super.initialize()}buildUpdateFeedUrl(u){let y="win32";return process.arch!=="ia32"&&(y+=`-${process.arch}`),i()===1?y+="-archive":this.productService.target==="user"&&(y+="-user"),(0,a.createUpdateURL)(y,u,this.productService)}doCheckForUpdates(u){!this.url||(this.setState(c.State.CheckingForUpdates(u)),this.requestService.request({url:this.url},k.CancellationToken.None).then(h.asJson).then(y=>{const P=i();return!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u}),this.setState(c.State.Idle(P)),Promise.resolve(null)):P===1?(this.setState(c.State.AvailableForDownload(y)),Promise.resolve(null)):(this.setState(c.State.Downloading(y)),this.cleanup(y.version).then(()=>this.getUpdatePackagePath(y.version).then(R=>E.Promises.exists(R).then(W=>{if(W)return Promise.resolve(R);const U=y.url,G=y.hash,ee=`${R}.tmp`;return this.requestService.request({url:U},k.CancellationToken.None).then(X=>this.fileService.writeFile(S.URI.file(ee),X.stream)).then(G?()=>(0,C.checksum)(ee,y.hash):()=>{}).then(()=>E.Promises.rename(ee,R)).then(()=>R)})).then(R=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:R},W&&y.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(y)):this.setState(c.State.Ready(y))})))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!u});const P=u?y.message||y:void 0;this.setState(c.State.Idle(i(),P))}))}async doDownloadUpdate(u){u.update.url&&this.nativeHostMainService.openExternal(void 0,u.update.url),this.setState(c.State.Idle(i()))}async getUpdatePackagePath(u){const y=await this.cachePath;return g.join(y,`CodeSetup-${this.productService.quality}-${u}.exe`)}async cleanup(u=null){const y=u?U=>!new RegExp(`${this.productService.quality}-${u}\\.exe$`).test(U):()=>!0,P=await this.cachePath,W=(await E.Promises.readdir(P)).filter(y).map(async U=>{try{await E.Promises.unlink(g.join(P,U))}catch{}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const u=this.state.update;this.setState(c.State.Updating(u));const y=await this.cachePath;this.availableUpdate.updateFilePath=g.join(y,`CodeSetup-${this.productService.quality}-${u.version}.flag`),await E.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(i()))});const R=`${this.productService.win32MutexName}-ready`,W=await new Promise((U,G)=>{V(["windows-mutex"],U,G)});f(()=>W.isActive(R)).then(()=>this.setState(c.State.Ready(u)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};ue([b.memoize],r.prototype,"cachePath",null),r=ue([te(0,d.ILifecycleMainService),te(1,I.IConfigurationService),te(2,l.ITelemetryService),te(3,p.IEnvironmentMainService),te(4,h.IRequestService),te(5,m.ILogService),te(6,t.IFileService),te(7,v.INativeHostMainService),te(8,M.IProductService)],r),e.Win32UpdateService=r}),define(Z[243],x([0,1,12,9,23,39,4,33,3,10,7,63,2,8,157,51,19,47,22,50,20,18,6,21,54,210,81,32,213,65,66,34,25,42,101]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M,h,l,c,a,f,s,i,r,o,u,y,P,R,W,U,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ee;(function(J){J[J.NONE=0]="NONE",J[J.NAVIGATING=1]="NAVIGATING",J[J.READY=2]="READY"})(ee||(ee={}));let X=class extends g.Disposable{constructor(H,B,Y,se,$,q,Q,z,F,N,T,A,O,_,j){super();this.logService=B,this.environmentMainService=Y,this.fileService=se,this.globalStorageMainService=$,this.configurationService=q,this.themeMainService=Q,this.workspacesManagementMainService=z,this.backupMainService=F,this.telemetryService=N,this.dialogMainService=T,this.lifecycleMainService=A,this.productService=O,this.protocolMainService=_,this.windowsMainService=j,this._onWillLoad=this._register(new k.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new k.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new k.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new k.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ie,ae]=this.restoreWindowState(H.state);this.windowState=ie,this.logService.trace("window#ctor: using window state",ie);const ce=this.windowState.mode===0||this.windowState.mode===3,ne=this.configurationService.getValue("window"),le={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:P.WindowMinimumSize.WIDTH,minHeight:P.WindowMinimumSize.HEIGHT,show:!ce,title:this.productService.nameLong,webPreferences:{preload:S.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,P.zoomLevelToZoomFactor)(ne?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};I.isLinux?le.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(le.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(le.fullscreenable=!1),I.isMacintosh&&(le.acceptFirstMouse=!0,ne?.clickThroughInactive===!1&&(le.acceptFirstMouse=!1));const he=I.isMacintosh&&ne?.nativeTabs===!0;he&&(le.tabbingIdentifier=this.productService.nameShort);const we=(0,P.getTitleBarStyle)(this.configurationService)==="custom";if(we&&(le.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,I.isMacintosh||(le.frame=!1)),(0,E.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(le),(0,E.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),I.isMacintosh&&we&&this._win.setSheetOffset(22),I.isMacintosh&&ae&&(!he||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(be=>typeof be=="number")){const be=this.windowState;this._win.setBounds({width:be.width,height:be.height,x:be.x,y:be.y})}ce&&((0,E.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,E.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(H){I.isMacintosh?this._win.setRepresentedFilename(H):this.representedFilename=H}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(H){I.isMacintosh&&this._win.setDocumentEdited(H),this.documentEdited=H}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(H){I.isMacintosh&&H?.force&&w.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.info(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(H=>{if(this.isReady)return H(this);this.whenReadyCallbacks.push(H)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(H=>{function B(){Y.dispose(),se.dispose(),H()}const Y=this.onDidClose(()=>B()),se=this.onWillLoad(()=>B())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(B,Y)=>this.onWindowError(2,Y)),this._win.webContents.on("did-fail-load",(B,Y,se)=>this.onWindowError(3,{reason:se,exitCode:Y})),this._win.webContents.on("will-prevent-unload",B=>{B.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",B=>{this.currentConfig&&(this.currentConfig.maximized=!0),w.app.emit("browser-window-maximize",B,this._win)}),this._win.on("unmaximize",B=>{this.currentConfig&&(this.currentConfig.maximized=!1),w.app.emit("browser-window-unmaximize",B,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",L.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",L.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(B=>this.onDidDeleteUntitledWorkspace(B)));const H=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:H},async(B,Y)=>{const se=await this.getMarketplaceHeaders();Y({cancel:!1,requestHeaders:Object.assign(B.requestHeaders,se)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(H,B){switch(H){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:H,reason:B?.reason,code:B?.exitCode}),H){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(H===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const Y=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,b.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(Y.response!==1){const se=Y.response===0;this.destroyWindow(se)}}else if(H===2){let Y;B?Y=(0,t.localize)(6,null,B.reason,B.exitCode??"<unknown>"):Y=(0,t.localize)(5,null);const $=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,b.mnemonicButtonLabel)((0,t.localize)(8,null))],message:Y,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow($)}break}}destroyWindow(H){if(this._onDidDestroy.fire(),this._win?.destroy(),H&&this.config){let B,Y;(0,W.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?B={folderUri:this.openedWorkspace.uri}:(0,W.isWorkspaceIdentifier)(this.openedWorkspace)?B={workspaceUri:this.openedWorkspace.configPath}:Y=!0;const[se]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:B?[B]:void 0,forceEmpty:Y,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});se.focus()}}onDidDeleteUntitledWorkspace(H){this.openedWorkspace?.id===H.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const H=this.getMenuBarVisibility();H!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=H,this.setMenuBarVisibility(H));let B=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;B?.endsWith("/")&&(B=B.substr(0,B.length-1));const Y=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((B||"").indexOf("@")===-1&&(B!==this.currentHttpProxy||Y!==this.currentNoProxy)){this.currentHttpProxy=B,this.currentNoProxy=Y;const se=B||"",$=Y?`${Y},<local>`:"<local>";this.logService.trace(`Setting proxy to '${se}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:se,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(H){I.isMacintosh&&H.win&&this._win.addTabbedWindow(H.win)}load(H,B=Object.create(null)){this.logService.info(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!B.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),B.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(H,B),this.readyState===0?this.currentConfig=H:this.pendingLoadConfig=H,this.readyState=1,this._win.loadURL(S.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const Y=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:H.workspace,reason:B.isReload?3:Y?2:1})}updateConfiguration(H,B){const Y=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(Y){const se=(0,h.isLaunchedFromCli)(Y)&&!(0,h.isLaunchedFromCli)(H.userEnv),$=this.isExtensionDevelopmentHost;(se||$)&&(H.userEnv={...Y,...H.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(H.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),B.disableExtensions!==void 0&&(H["disable-extensions"]=B.disableExtensions),H.fullscreen=this.isFullScreen,H.maximized=this._win.isMaximized(),H.partsSplash=this.themeMainService.getWindowSplash(),(0,E.mark)("code/willOpenNewWindow"),H.perfMarks=(0,E.getMarks)(),this.configObjectUrl.update(H)}async reload(H){const B=Object.assign({},this.currentConfig);B.workspace=await this.validateWorkspaceBeforeReload(B),delete B.filesToOpenOrCreate,delete B.filesToDiff,delete B.filesToWait,this.isExtensionDevelopmentHost&&H&&(B.verbose=H.verbose,B.debugId=H.debugId,B.extensionEnvironment=H.extensionEnvironment,B["inspect-extensions"]=H["inspect-extensions"],B["inspect-brk-extensions"]=H["inspect-brk-extensions"],B["extensions-dir"]=H["extensions-dir"]),B.isInitialStartup=!1,this.load(B,{isReload:!0,disableExtensions:H?.["disable-extensions"]})}async validateWorkspaceBeforeReload(H){if((0,W.isWorkspaceIdentifier)(H.workspace)){const B=H.workspace.configPath;if(B.scheme===S.Schemas.file&&!await this.fileService.exists(B))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(H.workspace)){const B=H.workspace.uri;if(B.scheme===S.Schemas.file&&!await this.fileService.exists(B))return}return H.workspace}serializeWindowState(){if(!this._win)return(0,G.defaultWindowState)();if(this.isFullScreen){let Y;try{Y=w.screen.getDisplayMatching(this.getBounds())}catch{}const se=(0,G.defaultWindowState)();return{mode:3,display:Y?Y.id:void 0,width:this.windowState.width||se.width,height:this.windowState.height||se.height,x:this.windowState.x||0,y:this.windowState.y||0}}const H=Object.create(null);let B;if(!I.isMacintosh&&this._win.isMaximized()?B=0:B=1,B===0?H.mode=0:H.mode=1,B===1||B===0){let Y;B===1?Y=this.getBounds():Y=this._win.getNormalBounds(),H.x=Y.x,H.y=Y.y,H.width=Y.width,H.height=Y.height}return H}restoreWindowState(H){(0,E.mark)("code/willRestoreCodeWindowState");let B=!1;if(H)try{const Y=w.screen.getAllDisplays();B=Y.length>1,H=this.validateWindowState(H,Y)}catch(Y){this.logService.warn(`Unexpected error validating window state: ${Y}
${Y.stack}`)}return(0,E.mark)("code/didRestoreCodeWindowState"),[H||(0,G.defaultWindowState)(),B]}validateWindowState(H,B){if(this.logService.trace(`window#validateWindowState: validating window state on ${B.length} display(s)`,H),typeof H.x!="number"||typeof H.y!="number"||typeof H.width!="number"||typeof H.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(H.width<=0||H.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(B.length===1){const $=this.getWorkingArea(B[0]);if($){let q=function(){!H||typeof H.x!="number"||typeof H.y!="number"||!$||(H.x<$.x&&(H.x=$.x),H.y<$.y&&(H.y=$.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",$),q(),H.width>$.width&&(H.width=$.width),H.height>$.height&&(H.height=$.height),H.x>$.x+$.width-128&&(H.x=$.x+$.width-H.width),H.y>$.y+$.height-128&&(H.y=$.y+$.height-H.height),q()}return H}if(H.display&&H.mode===3){const $=B.find(q=>q.id===H.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const q=(0,G.defaultWindowState)(3);return q.x=$.bounds.x,q.y=$.bounds.y,q}}let Y,se;try{Y=w.screen.getDisplayMatching({x:H.x,y:H.y,width:H.width,height:H.height}),se=this.getWorkingArea(Y)}catch{}if(Y&&se&&H.x+H.width>se.x&&H.y+H.height>se.y&&H.x<se.x+se.width&&H.y<se.y+se.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",se),H}getWorkingArea(H){if(H.workArea.width>0&&H.workArea.height>0)return H.workArea;if(H.bounds.width>0&&H.bounds.height>0)return H.bounds}getBounds(){const[H,B]=this._win.getPosition(),[Y,se]=this._win.getSize();return{x:H,y:B,width:Y,height:se}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(H){this.useNativeFullScreen()?this.setNativeFullScreen(H):this.setSimpleFullScreen(H),this.sendWhenReady(H?"vscode:enterFullScreen":"vscode:leaveFullScreen",L.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(H){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(H)}setSimpleFullScreen(H){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(H),this._win.webContents.focus()}useNativeFullScreen(){const H=this.configurationService.getValue("window");return!H||typeof H.nativeFullScreen!="boolean"||H.nativeTabs?!0:H.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let H=(0,P.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(H)<0&&(H="classic"),H}setMenuBarVisibility(H,B=!0){I.isMacintosh||(H==="toggle"&&B&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),H==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(H)}):this.doSetMenuBarVisibility(H))}doSetMenuBarVisibility(H){const B=this.isFullScreen;switch(H){case"classic":this._win.setMenuBarVisibility(!B),this._win.autoHideMenuBar=B;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(H,B,...Y){this.isReady?this.send(H,...Y):this.ready().then(()=>{B.isCancellationRequested||this.send(H,...Y)})}send(H,...B){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${H}' for window that is destroyed`);return}try{this._win.webContents.send(H,...B)}catch(Y){this.logService.warn(`Error sending IPC message to channel '${H}' of window ${this._id}: ${(0,D.toErrorMessage)(Y)}`)}}}updateTouchBar(H){!I.isMacintosh||this.touchBarGroups.forEach((B,Y)=>{const se=H[Y];B.segments=this.createTouchBarGroupSegments(se)})}createTouchBar(){if(!!I.isMacintosh){for(let H=0;H<10;H++){const B=this.createTouchBarGroup();this.touchBarGroups.push(B)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(H=[]){const B=this.createTouchBarGroupSegments(H),Y=new w.TouchBar.TouchBarSegmentedControl({segments:B,mode:"buttons",segmentStyle:"automatic",change:se=>{this.sendWhenReady("vscode:runAction",L.CancellationToken.None,{id:Y.segments[se].id,from:"touchbar"})}});return Y}createTouchBarGroupSegments(H=[]){return H.map(Y=>{let se;Y.icon&&!u.ThemeIcon.isThemeIcon(Y.icon)&&Y.icon?.dark?.scheme===S.Schemas.file&&(se=w.nativeImage.createFromPath(p.URI.revive(Y.icon.dark).fsPath),se.isEmpty()&&(se=void 0));let $;return typeof Y.title=="string"?$=Y.title:$=Y.title.value,{id:Y.id,label:se?void 0:$,icon:se}})}dispose(){super.dispose(),this._win=null}};X=ue([te(1,a.ILogService),te(2,M.IEnvironmentMainService),te(3,l.IFileService),te(4,r.IGlobalStorageMainService),te(5,m.IConfigurationService),te(6,y.IThemeMainService),te(7,U.IWorkspacesManagementMainService),te(8,d.IBackupMainService),te(9,o.ITelemetryService),te(10,v.IDialogMainService),te(11,c.ILifecycleMainService),te(12,f.IProductService),te(13,s.IProtocolMainService),te(14,R.IWindowsMainService)],X),e.CodeWindow=X}),define(Z[67],x([0,1,12,30,9,4,33,3,10,2,17,8,24,160,5,18,6,38,81,80,25,42]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M,h,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class $e extends b.Disposable{constructor(s,i,r,o,u){super();this.stateMainService=s,this.logService=i,this.workspacesManagementMainService=r,this.lifecycleMainService=o,this.globalStorageMainService=u,this._onDidChangeRecentlyOpened=this._register(new D.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new L.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){const i=[],r=[];for(let o of s)if((0,h.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,h.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const u=this.indexOfFile(r,o.fileUri)>=0,y=o.fileUri.scheme===g.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,C.basename)(o.fileUri))>=0;!u&&!y&&(r.push(o),S.isWindows&&o.fileUri.scheme===g.Schemas.file&&w.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,r),i.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(i.length=$e.MAX_TOTAL_RECENT_ENTRIES),r.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(r.length=$e.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:r}),this._onDidChangeRecentlyOpened.fire(),S.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(s){const i=y=>{const P=this.location(y);for(const R of s)if(C.extUriBiasedIgnorePathCase.isEqual(R,P))return!1;return!0},r=await this.getRecentlyOpened(),o=r.workspaces.filter(i),u=r.files.filter(i);(o.length!==r.workspaces.length||u.length!==r.files.length)&&(await this.saveRecentlyOpened({files:u,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),S.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(s){const i=[],r=[];if(s){const u=s.config?.workspace;(0,l.isWorkspaceIdentifier)(u)&&!this.workspacesManagementMainService.isUntitledWorkspace(u)?i.push({workspace:u,remoteAuthority:s.remoteAuthority}):(0,l.isSingleFolderWorkspaceIdentifier)(u)&&i.push({folderUri:u.uri,remoteAuthority:s.remoteAuthority})}const o=s?.config?.filesToOpenOrCreate;if(o)for(let u of o){const y=u.fileUri;y&&this.indexOfFile(r,y)===-1&&r.push({fileUri:y})}return await this.addEntriesFromStorage(i,r),{workspaces:i,files:r}}async addEntriesFromStorage(s,i){let r=await this.getRecentlyOpenedFromStorage();for(let o of r.workspaces){let u=(0,h.isRecentFolder)(o)?this.indexOfFolder(s,o.folderUri):this.indexOfWorkspace(s,o.workspace);u>=0?s[u].label=s[u].label||o.label:s.push(o)}for(let o of r.files){let u=this.indexOfFile(i,o.fileUri);u>=0?i[u].label=i[u].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let s;const i=this.globalStorageMainService.get($e.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof i=="string")try{s=JSON.parse(i)}catch(r){this.logService.error("Unexpected error parsing opened paths list",r)}else s=this.stateMainService.getItem($e.legacyRecentlyOpenedStorageKey),s&&(this.stateMainService.removeItem($e.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store($e.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(s),0,1));return(0,h.restoreRecentlyOpened)(s,this.logService)}async saveRecentlyOpened(s){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store($e.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,h.toStoreData)(s)),0,1)}location(s){return(0,h.isRecentFolder)(s)?s.folderUri:(0,h.isRecentFile)(s)?s.fileUri:s.workspace.configPath}indexOfWorkspace(s,i){return s.findIndex(r=>(0,h.isRecentWorkspace)(r)&&r.workspace.id===i.id)}indexOfFolder(s,i){return s.findIndex(r=>(0,h.isRecentFolder)(r)&&C.extUriBiasedIgnorePathCase.isEqual(r.folderUri,i))}indexOfFile(s,i){return s.findIndex(r=>C.extUriBiasedIgnorePathCase.isEqual(r.fileUri,i))}async handleWindowsJumpList(){!S.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!S.isWindows)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let i=[];for(let u of w.app.getJumpListSettings().removedItems){const y=u.args;if(y){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(y);P&&i.push(E.URI.parse(P[2]))}}await this.removeRecentlyOpened(i);let r=!1;const o=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,$e.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(u=>{const y=(0,h.isRecentWorkspace)(u)?u.workspace:u.folderUri,{title:P,description:R}=this.getWindowsJumpListLabel(y,u.label);let W;return E.URI.isUri(y)?W=`--folder-uri "${y.toString()}"`:(r=!0,W=`--file-uri "${y.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:R.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&s.push({type:"custom",name:r?(0,p.localize)(2,null):(0,p.localize)(3,null),items:o})}s.push({type:"recent"});try{w.app.setJumpList(s)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(s,i){if(i)return{title:(0,k.splitName)(i).name,description:i};if(E.URI.isUri(s))return{title:(0,C.basename)(s),description:this.renderJumpListPathDescription(s)};if(this.workspacesManagementMainService.isUntitledWorkspace(s))return{title:(0,p.localize)(4,null),description:""};let r=(0,C.basename)(s.configPath);return r.endsWith(l.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-l.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,r),description:this.renderJumpListPathDescription(s.configPath)}}renderJumpListPathDescription(s){return s.scheme==="file"?(0,k.normalizeDriveLetter)(s.fsPath):s.toString()}async updateMacOSRecentDocuments(){if(!S.isMacintosh)return;w.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),i=[];let r=0;for(let u=0;u<s.workspaces.length&&r<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;u++){const y=this.location(s.workspaces[u]);if(y.scheme===g.Schemas.file){const P=(0,C.originalFSPath)(y);await I.Promises.exists(P)&&(i.push(P),r++)}}const o=[];for(let u=0;u<s.files.length&&r<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;u++){const y=this.location(s.files[u]);if(y.scheme===g.Schemas.file){const P=(0,C.originalFSPath)(y);if($e.COMMON_FILES_FILTER.includes((0,C.basename)(y))||i.includes(P))continue;await I.Promises.exists(P)&&(o.push(P),r++)}}o.reverse().forEach(u=>w.app.addRecentDocument(u)),i.reverse().forEach(u=>w.app.addRecentDocument(u))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",a.legacyRecentlyOpenedStorageKey="openedPathsList",a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a=ue([te(0,v.IStateMainService),te(1,m.ILogService),te(2,c.IWorkspacesManagementMainService),te(3,d.ILifecycleMainService),te(4,M.IGlobalStorageMainService)],a),e.WorkspacesHistoryMainService=a}),define(Z[244],x([0,1,12,9,23,33,2,8,151,19,22,18,6,194,58,21,38,32,41,66,34,67]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M,h,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const a="menu";let f=class It{constructor(r,o,u,y,P,R,W,U,G,ee,X){this.updateService=r,this.configurationService=o,this.windowsMainService=u,this.environmentMainService=y,this.telemetryService=P,this.workspacesHistoryMainService=R,this.stateMainService=W,this.lifecycleMainService=U,this.logService=G,this.nativeHostMainService=ee,this.productService=X,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(k.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const r=this.stateMainService.getItem(It.lastKnownMenubarStorageKey);r&&(r.menus&&(this.menubarMenus=r.menus),r.keybindings&&(this.keybindings=r.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(R,W,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(R,W,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(R,W,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(R,W,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const r=this.productService.twitterUrl;r&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(r,"openTwitterUrl"));const o=this.productService.requestFeatureUrl;o&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(o,"openUserVoiceUrl"));const u=this.productService.reportIssueUrl;u&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(u,"openReportIssues"));const y=this.productService.licenseUrl;y&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(k.language){const R=y.indexOf("?")>0?"&":"?";this.openUrl(`${y}${R}lang=${k.language}`,"openLicenseUrl")}else this.openUrl(y,"openLicenseUrl")});const P=this.productService.privacyStatementUrl;P&&y&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(P,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(r=>this.onDidChangeWindowsCount(r)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let r=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get currentEnableNativeTabs(){if(!k.isMacintosh)return!1;let r=this.configurationService.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,o){this.menubarMenus=r.menus,this.keybindings=r.keybindings,this.stateMainService.setItem(It.lastKnownMenubarStorageKey,r),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(r){!k.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.closedLastWindow=r.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!k.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const r=w.Menu.getApplicationMenu();if(r&&this.oldMenus.push(r),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(k.isMacintosh?new w.Menu:null);return}const o=new w.Menu;let u;if(k.isMacintosh){const P=new w.Menu;u=new w.MenuItem({label:this.productService.nameShort,submenu:P}),this.setMacApplicationMenu(P),o.append(u)}if(k.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const P=new w.Menu;P.append(new w.MenuItem({label:this.mnemonicLabel(g.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(P)}if(this.shouldDrawMenu("File")){const P=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(g.localize(1,null)),submenu:P});this.setMenuById(P,"File"),o.append(R)}if(this.shouldDrawMenu("Edit")){const P=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(g.localize(2,null)),submenu:P});this.setMenuById(P,"Edit"),o.append(R)}if(this.shouldDrawMenu("Selection")){const P=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(g.localize(3,null)),submenu:P});this.setMenuById(P,"Selection"),o.append(R)}if(this.shouldDrawMenu("View")){const P=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(g.localize(4,null)),submenu:P});this.setMenuById(P,"View"),o.append(R)}if(this.shouldDrawMenu("Go")){const P=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(g.localize(5,null)),submenu:P});this.setMenuById(P,"Go"),o.append(R)}if(this.shouldDrawMenu("Run")){const P=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(g.localize(6,null)),submenu:P});this.setMenuById(P,"Run"),o.append(R)}if(this.shouldDrawMenu("Terminal")){const P=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(g.localize(7,null)),submenu:P});this.setMenuById(P,"Terminal"),o.append(R)}let y;if(this.shouldDrawMenu("Window")){const P=new w.Menu;y=new w.MenuItem({label:this.mnemonicLabel(g.localize(8,null)),submenu:P,role:"window"}),this.setMacWindowMenu(P)}if(y&&o.append(y),this.shouldDrawMenu("Help")){const P=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(g.localize(9,null)),submenu:P,role:"help"});this.setMenuById(P,"Help"),o.append(R)}o.items&&o.items.length>0?w.Menu.setApplicationMenu(o):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(r){const o=this.createMenuItem(g.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),u=this.getUpdateMenuItems();let y;if(this.shouldDrawMenu("Preferences")){const J=new w.Menu;this.setMenuById(J,"Preferences"),y=new w.MenuItem({label:this.mnemonicLabel(g.localize(11,null)),submenu:J})}const P=new w.Menu,R=new w.MenuItem({label:g.localize(12,null),role:"services",submenu:P}),W=new w.MenuItem({label:g.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new w.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),G=new w.MenuItem({label:g.localize(15,null),role:"unhide"}),ee=new w.MenuItem(this.likeAction("workbench.action.quit",{label:g.localize(16,null,this.productService.nameLong),click:()=>{const J=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||J?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),X=[o];X.push(...u),y&&X.push(s(),y),X.push(s(),R,s(),W,U,G,s(),ee),X.forEach(J=>r.append(J))}shouldDrawMenu(r){if(!k.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(r){case"File":case"Help":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[r];case"Window":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[r]}}setMenu(r,o){o.forEach(u=>{if((0,p.isMenubarMenuItemSeparator)(u))r.append(s());else if((0,p.isMenubarMenuItemSubmenu)(u)){const y=new w.Menu,P=new w.MenuItem({label:this.mnemonicLabel(u.label),submenu:y});this.setMenu(y,u.submenu.items),r.append(P)}else(0,p.isMenubarMenuItemRecentAction)(u)?r.append(this.createOpenRecentMenuItem(u)):(0,p.isMenubarMenuItemAction)(u)&&(u.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(r),k.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[u.id]?r.append(new w.MenuItem(this.likeAction(u.id,{label:this.mnemonicLabel(u.label),click:this.fallbackMenuHandlers[u.id]}))):r.append(this.createMenuItem(u.label,u.id,!1,u.checked)):r.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)):r.append(this.createMenuItem(u.label,u.id,u.enabled!==!1,!!u.checked)))})}setMenuById(r,o){this.menubarMenus&&this.menubarMenus[o]&&this.setMenu(r,this.menubarMenus[o].items)}insertCheckForUpdatesItems(r){const o=this.getUpdateMenuItems();o.length&&(o.forEach(u=>r.append(u)),r.append(s()))}createOpenRecentMenuItem(r){const o=b.URI.revive(r.uri),u=r.id,y=u==="openRecentFile"?{fileUri:o}:u==="openRecentWorkspace"?{workspaceUri:o}:{folderUri:o};return new w.MenuItem(this.likeAction(u,{label:r.label,click:(P,R,W)=>{const U=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[y],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:r.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([o])}},!1))}isOptionClick(r){return!!(r&&(!k.isMacintosh&&(r.ctrlKey||r.shiftKey)||k.isMacintosh&&(r.metaKey||r.altKey)))}createRoleMenuItem(r,o,u){const y={label:this.mnemonicLabel(r),role:u,enabled:!0};return new w.MenuItem(this.withKeybinding(o,y))}setMacWindowMenu(r){const o=new w.MenuItem({label:g.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),u=new w.MenuItem({label:g.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),y=new w.MenuItem({label:g.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),P=this.createMenuItem(g.localize(20,null),"workbench.action.switchWindow"),R=[];this.currentEnableNativeTabs&&(R.push(s()),R.push(this.createMenuItem(g.localize(21,null),"workbench.action.newWindowTab")),R.push(this.createRoleMenuItem(g.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.createRoleMenuItem(g.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.createRoleMenuItem(g.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.createRoleMenuItem(g.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[o,u,s(),P,...R,s(),y].forEach(W=>r.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(g.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:g.localize(27,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(g.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:g.localize(29,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(g.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:g.localize(31,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(g.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(r,o,u,y){const P=this.mnemonicLabel(r),R=typeof o=="function"?o:(X,J,H)=>{const B=X?X.userSettingsLabel:null;let Y=o;Array.isArray(o)&&(Y=this.isOptionClick(H)?o[1]:o[0]),B&&H.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:B}):this.runActionInRenderer({type:"commandId",commandId:Y})},W=typeof u=="boolean"?u:this.windowsMainService.getWindowCount()>0,U=typeof y=="boolean"?y:!1,G={label:P,click:R,enabled:W};U&&(G.type="checkbox",G.checked=U);let ee;return typeof o=="string"?ee=o:Array.isArray(o)&&(ee=o[0]),k.isMacintosh&&(ee==="editor.action.clipboardCutAction"?G.role="cut":ee==="editor.action.clipboardCopyAction"?G.role="copy":ee==="editor.action.clipboardPasteAction"&&(G.role="paste"),ee==="undo"?G.click=this.makeContextAwareClickHandler(R,{inDevTools:X=>X.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):ee==="redo"?G.click=this.makeContextAwareClickHandler(R,{inDevTools:X=>X.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):ee==="editor.action.selectAll"&&(G.click=this.makeContextAwareClickHandler(R,{inDevTools:X=>X.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(ee,G))}makeContextAwareClickHandler(r,o){return(u,y,P)=>{const R=w.BrowserWindow.getFocusedWindow();if(!R)return o.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return o.inDevTools(R.webContents.devToolsWebContents);r(u,y||R,P)}}runActionInRenderer(r){let o=w.BrowserWindow.getFocusedWindow();if(!o){const y=this.windowsMainService.getLastActiveWindow();y?.isMinimized()&&(o=y.win)}const u=o?this.windowsMainService.getWindowById(o.id):void 0;if(u){if(this.logService.trace("menubar#runActionInRenderer",r),k.isMacintosh&&!this.environmentMainService.isBuilt&&!u.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const y={id:r.commandId,from:"menu"};u.sendWhenReady("vscode:runAction",L.CancellationToken.None,y)}else{const y={userSettingsLabel:r.userSettingsLabel};u.sendWhenReady("vscode:runKeybinding",L.CancellationToken.None,y)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",r)}withKeybinding(r,o){const u=typeof r=="string"?this.keybindings[r]:void 0;if(u?.label){if(u.isNative!==!1)o.accelerator=u.label,o.userSettingsLabel=u.userSettingsLabel;else if(typeof o.label=="string"){const y=o.label.indexOf("[");y>=0?o.label=`${o.label.substr(0,y)} [${u.label}]`:o.label=`${o.label} [${u.label}]`}}else o.accelerator=void 0;return o}likeAction(r,o,u=!o.accelerator){u&&(o=this.withKeybinding(r,o));const y=o.click;return o.click=(P,R,W)=>{this.reportMenuActionTelemetry(r),y&&y(P,R,W)},o}openUrl(r,o){this.nativeHostMainService.openExternal(void 0,r),this.reportMenuActionTelemetry(o)}reportMenuActionTelemetry(r){this.telemetryService.publicLog2("workbenchActionExecuted",{id:r,from:a})}mnemonicLabel(r){return(0,D.mnemonicMenuLabel)(r,!this.currentEnableMenuBarMnemonics)}};f.lastKnownMenubarStorageKey="lastKnownMenubarData",f=ue([te(0,M.IUpdateService),te(1,S.IConfigurationService),te(2,l.IWindowsMainService),te(3,C.IEnvironmentMainService),te(4,v.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,m.IStateMainService),te(7,E.ILifecycleMainService),te(8,I.ILogService),te(9,t.INativeHostMainService),te(10,d.IProductService)],f),e.Menubar=f;function s(){return new w.MenuItem({type:"separator"})}}),define(Z[245],x([0,1,5,18,6,244]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let k=class{constructor(g,S,C){this.instantiationService=g,this.lifecycleMainService=S,this.logService=C,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(D.Menubar)}async updateMenubar(g,S){this.logService.trace("menubarService#updateMenubar",g),(await this.menubar).updateMenu(S,g)}};k=ue([te(0,w.IInstantiationService),te(1,n.ILifecycleMainService),te(2,L.ILogService)],k),e.MenubarMainService=k}),define(Z[246],x([0,1,12,29,26,30,23,4,28,43,33,3,10,7,63,2,36,17,14,8,158,51,19,47,22,20,5,18,6,53,21,54,78,38,66,243,102,226,25,103,67,42]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M,h,l,c,a,f,s,i,r,o,u,y,P,R,W,U,G,ee,X,J,H,B,Y,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function $(z){return(0,H.isWorkspaceIdentifier)(z?.workspace)}function q(z){return(0,H.isSingleFolderWorkspaceIdentifier)(z?.workspace)}let Q=class rt extends E.Disposable{constructor(F,N,T,A,O,_,j,ie,ae,ce,ne,le,he,we,be){super();this.machineId=F,this.initialUserEnv=N,this.logService=T,this.stateMainService=A,this.environmentMainService=O,this.lifecycleMainService=_,this.backupMainService=j,this.configurationService=ie,this.workspacesHistoryMainService=ae,this.workspacesManagementMainService=ce,this.instantiationService=ne,this.dialogMainService=le,this.fileService=he,this.productService=we,this.protocolMainService=be,this._onDidOpenWindow=this._register(new b.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new b.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new b.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new b.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new J.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(F=>this._onDidSignalReadyWindow.fire(F.window))),this._register(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const N=new E.DisposableStore;if(N.add(b.Event.any(F.onDidClose,F.onDidDestroy)(()=>N.dispose())),F.config.extensionDevelopmentPath)for(const T of F.config.extensionDevelopmentPath)N.add(this.protocolMainService.addValidFileRoot(T));F.config.extensionTestsPath&&N.add(this.protocolMainService.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,N){let T=this.environmentMainService.args;const A=N?.remoteAuthority||void 0,O=!0,_=N?.forceReuseWindow,j=!_;return this.open({...F,cli:T,forceEmpty:O,forceNewWindow:j,forceReuseWindow:_,remoteAuthority:A})}openExistingWindow(F,N){F.focus(),this.handleWaitMarkerFile(N,[F])}open(F){this.logService.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const N=[],T=[],A=[],O=[],_=[];let j,ie=0;const ae=this.getPathsToOpen(F);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const he of ae)q(he)?F.addMode?N.push(he):T.push(he):$(he)?A.push(he):he.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:he.remoteAuthority}),j.filesToOpenOrCreate.push(he)):he.backupPath?_.push({backupFolder:(0,p.basename)(he.backupPath),remoteAuthority:he.remoteAuthority}):ie++;F.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),j&&F.waitMarkerFileURI&&(j.filesToWait={paths:[...j.filesToDiff,...j.filesToOpenOrCreate],waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(O.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),A.push(...O),_.push(...this.backupMainService.getEmptyWindowBackupPaths())):_.length=0;const{windows:ce,filesOpenedInWindow:ne}=this.doOpen(F,A,T,_,ie,j,N);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${A.length}, foldersToOpen: ${T.length}, emptyToRestore: ${_.length}, emptyToOpen: ${ie})`),ce.length>1)if(ne)ne.focus();else{const he=this.windowsStateHandler.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let we=!0,be=!0;if(he){const Ce=ce.filter(Se=>this.windowsStateHandler.state.lastActiveWindow&&Se.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ce.length&&(Ce[0].focus(),we=!1,be=!1)}if(we)for(let Ce=ce.length-1;Ce>=0;Ce--){const Se=ce[Ce];if(!(Se.openedWorkspace&&O.some(pe=>Se.openedWorkspace&&pe.workspace.id===Se.openedWorkspace.id)||Se.backupPath&&_.some(pe=>Se.backupPath&&pe.backupFolder===(0,p.basename)(Se.backupPath)))){Se.focus(),be=!1;break}}be&&ce[ce.length-1].focus()}const le=j&&j.filesToDiff.length>0;if(!ce.some(he=>he.isExtensionDevelopmentHost)&&!le&&!F.noRecentEntry){const he=[];for(const we of ae)$(we)&&!we.transient?he.push({label:we.label,workspace:we.workspace,remoteAuthority:we.remoteAuthority}):q(we)?he.push({label:we.label,folderUri:we.workspace.uri,remoteAuthority:we.remoteAuthority}):we.fileUri&&he.push({label:we.label,fileUri:we.fileUri,remoteAuthority:we.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(he)}return this.handleWaitMarkerFile(F,ce),ce}handleWaitMarkerFile(F,N){const T=F.waitMarkerFileURI;F.context===0&&T&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.fileService.del(T)}catch{}})()}doOpen(F,N,T,A,O,_,j){const ie=[];let ae;function ce(Se,pe){ie.push(Se),pe&&(ae=Se,_=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:le}=this.shouldOpenNewWindow(F);if(!F.initialStartup&&j.length>0){const Se=j[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(Se);pe&&ce(this.doAddFoldersToExistingWindow(pe,j.map(Ee=>Ee.workspace.uri)))}const he=T.length+N.length+A.length;if(_&&he===0){const Se=_.filesToOpenOrCreate[0]||_.filesToDiff[0],pe=this.getWindows().filter(Le=>_&&(0,v.isEqualAuthority)(Le.remoteAuthority,_.remoteAuthority));let Ee;Se?.fileUri&&!le&&((F.context===4||F.context===0||F.context===1)&&(Ee=(0,X.findWindowOnFile)(pe,Se.fileUri,Le=>Le.configPath.scheme===I.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Le.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(pe))),Ee?(0,H.isWorkspaceIdentifier)(Ee.openedWorkspace)?N.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,H.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?T.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(F,Ee,_),!0):ce(this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:_,forceNewWindow:!0,remoteAuthority:_.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow}),!0)}const we=(0,D.distinct)(N,Se=>Se.workspace.id);if(we.length>0){const Se=(0,D.coalesce)(we.map(pe=>(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(Se.length>0){const pe=Se[0],Ee=(0,v.isEqualAuthority)(_?.remoteAuthority,pe.remoteAuthority)?_:void 0;ce(this.doOpenFilesInExistingWindow(F,pe,Ee),!!Ee),ne=!0}we.forEach(pe=>{if(Se.some(Ne=>Ne.openedWorkspace&&Ne.openedWorkspace.id===pe.workspace.id))return;const Ee=pe.remoteAuthority,Le=(0,v.isEqualAuthority)(_?.remoteAuthority,Ee)?_:void 0;ce(this.doOpenFolderOrWorkspace(F,pe,ne,Le),!!Le),ne=!0})}const be=(0,D.distinct)(T,Se=>v.extUriBiasedIgnorePathCase.getComparisonKey(Se.workspace.uri));if(be.length>0){const Se=(0,D.coalesce)(be.map(pe=>(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(Se.length>0){const pe=Se[0],Ee=(0,v.isEqualAuthority)(_?.remoteAuthority,pe.remoteAuthority)?_:void 0;ce(this.doOpenFilesInExistingWindow(F,pe,Ee),!!Ee),ne=!0}be.forEach(pe=>{if(Se.some(Ne=>(0,H.isSingleFolderWorkspaceIdentifier)(Ne.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Ne.openedWorkspace.uri,pe.workspace.uri)))return;const Ee=pe.remoteAuthority,Le=(0,v.isEqualAuthority)(_?.remoteAuthority,Ee)?_:void 0;ce(this.doOpenFolderOrWorkspace(F,pe,ne,Le),!!Le),ne=!0})}const Ce=(0,D.distinct)(A,Se=>Se.backupFolder);if(Ce.length>0&&Ce.forEach(Se=>{const pe=Se.remoteAuthority,Ee=(0,v.isEqualAuthority)(_?.remoteAuthority,pe)?_:void 0;ce(this.doOpenEmpty(F,!0,pe,Ee,Se),!!Ee),ne=!0}),ie.length===0||_){_&&!O&&O++;const Se=_?_.remoteAuthority:F.remoteAuthority;for(let pe=0;pe<O;pe++)ce(this.doOpenEmpty(F,ne,Se,_),!!_),ne=!0}return{windows:(0,D.distinct)(ie),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(F,N,T){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:T}),N.focus();const A={filesToOpenOrCreate:T?.filesToOpenOrCreate,filesToDiff:T?.filesToDiff,filesToWait:T?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",k.CancellationToken.None,A),N}doAddFoldersToExistingWindow(F,N){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),F.focus();const T={foldersToAdd:N};return F.sendWhenReady("vscode:addFolders",k.CancellationToken.None,T),F}doOpenEmpty(F,N,T,A,O){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!O,remoteAuthority:T,filesToOpen:A,forceNewWindow:N});let _;return!N&&typeof F.contextWindowId=="number"&&(_=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:T,forceNewWindow:N,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:A,windowToUse:_,emptyWindowBackupInfo:O})}doOpenFolderOrWorkspace(F,N,T,A,O){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:A}),!T&&!O&&typeof F.contextWindowId=="number"&&(O=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({workspace:N.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:T,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:A,windowToUse:O})}getPathsToOpen(F){let N,T=!1,A=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(N=this.doExtractPathsFromAPI(F),T=!0):F.forceEmpty?N=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(N=this.doExtractPathsFromCLI(F.cli),N.length===0&&N.push(Object.create(null)),T=!0):(N=this.doGetPathsFromLastSession(),N.length===0&&N.push(Object.create(null)),A=!0),!F.addMode&&T){const O=N.filter(_=>q(_));if(O.length>1){const _=O[0].remoteAuthority;if(O.every(j=>(0,v.isEqualAuthority)(j.remoteAuthority,_))){const j=this.workspacesManagementMainService.createUntitledWorkspaceSync(O.map(ie=>({uri:ie.workspace.uri})));N.push({workspace:j,remoteAuthority:_}),N=N.filter(ie=>!q(ie))}}}return F.initialStartup&&!A&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&N.unshift(...this.doGetPathsFromLastSession().filter(O=>$(O)||q(O)||O.backupPath)),N}doExtractPathsFromAPI(F){const N=[],T={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority};for(const A of(0,D.coalesce)(F.urisToOpen||[])){const O=this.resolveOpenable(A,T);if(O)O.label=A.label,N.push(O);else{const _=this.resourceFromOpenable(A),j={title:this.productService.nameLong,type:"info",buttons:[(0,C.mnemonicButtonLabel)((0,l.localize)(0,null))],defaultId:0,message:_.scheme===I.Schemas.file?(0,l.localize)(1,null):(0,l.localize)(2,null),detail:_.scheme===I.Schemas.file?(0,l.localize)(3,null,(0,C.getPathLabel)(_.fsPath,this.environmentMainService)):(0,l.localize)(4,null,_.toString()),noLink:!0};this.dialogMainService.showMessageBox(j,(0,M.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}}return N}doExtractPathsFromCLI(F){const N=[],T={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:!1},A=F["folder-uri"];if(A)for(const j of A){const ie=this.cliArgToUri(j);if(ie){const ae=this.resolveOpenable({folderUri:ie},T);ae&&N.push(ae)}}const O=F["file-uri"];if(O)for(const j of O){const ie=this.cliArgToUri(j);if(ie){const ae=this.resolveOpenable((0,H.hasWorkspaceFileExtension)(j)?{workspaceUri:ie}:{fileUri:ie},T);ae&&N.push(ae)}}const _=F._;for(const j of _){const ie=T.remoteAuthority?this.doResolvePathRemote(j,T):this.doResolveFilePath(j,T);ie&&N.push(ie)}return N}cliArgToUri(F){try{const N=h.URI.parse(F);if(!N.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${F}`);return}return N}catch(N){this.logService.error(`Invalid URI input string: ${F}, ${N.message}`)}}doGetPathsFromLastSession(){const F=this.getRestoreWindowsSetting();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];F!=="one"&&N.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&N.push(this.windowsStateHandler.state.lastActiveWindow);const T=[];for(const A of N)if(A.workspace){const O=this.resolveOpenable({workspaceUri:A.workspace.configPath},{remoteAuthority:A.remoteAuthority,rejectTransientWorkspaces:!0});$(O)&&T.push(O)}else if(A.folderUri){const O=this.resolveOpenable({folderUri:A.folderUri},{remoteAuthority:A.remoteAuthority});q(O)&&T.push(O)}else F!=="folders"&&A.backupPath&&T.push({backupPath:A.backupPath,remoteAuthority:A.remoteAuthority});return T}}}getRestoreWindowsSetting(){let F;return this.lifecycleMainService.wasRestarted?F="all":(F=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}resolveOpenable(F,N=Object.create(null)){let T=this.resourceFromOpenable(F);return T.scheme===I.Schemas.file?((0,G.isFileToOpen)(F)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(T.fsPath,N)):this.doResolveRemoteOpenable(F,N)}doResolveRemoteOpenable(F,N){let T=this.resourceFromOpenable(F);const A=(0,W.getRemoteAuthority)(T)||N.remoteAuthority;if(T=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(T)),(0,G.isFileToOpen)(F)){if(N.gotoLineMode){const{path:O,line:_,column:j}=(0,g.parseLineAndColumnAware)(T.path);return{fileUri:T.with({path:O}),selection:_?{startLineNumber:_,startColumn:j||1}:void 0,remoteAuthority:A}}return{fileUri:T,remoteAuthority:A}}else if((0,G.isWorkspaceToOpen)(F))return{workspace:(0,B.getWorkspaceIdentifier)(T),remoteAuthority:A};return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(T),remoteAuthority:A}}resourceFromOpenable(F){return(0,G.isWorkspaceToOpen)(F)?F.workspaceUri:(0,G.isFolderToOpen)(F)?F.folderUri:F.fileUri}doResolveFilePath(F,N){let T,A;N.gotoLineMode&&({path:F,line:T,column:A}=(0,g.parseLineAndColumnAware)(F)),F=(0,g.sanitizeFilePath)((0,p.normalize)(F),(0,m.cwd)());try{const O=(0,n.statSync)(F);if(O.isFile()){if(!N.forceOpenWorkspaceAsFile){const _=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(F));if(_)return _.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:_.id,configPath:_.configPath},type:i.FileType.File,exists:!0,remoteAuthority:_.remoteAuthority,transient:_.transient}}return{fileUri:h.URI.file(F),type:i.FileType.File,exists:!0,selection:T?{startLineNumber:T,startColumn:A||1}:void 0}}else{if(O.isDirectory())return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(h.URI.file(F),O),type:i.FileType.Directory,exists:!0};if(!d.isWindows&&F==="/dev/null")return{fileUri:h.URI.file(F),type:i.FileType.File,exists:!0}}}catch{const _=h.URI.file(F);if(this.workspacesHistoryMainService.removeRecentlyOpened([_]),N.ignoreFileNotFound)return{fileUri:_,type:i.FileType.File,exists:!1}}}doResolvePathRemote(F,N){const T=F.charCodeAt(0),A=N.remoteAuthority;let O,_;N.gotoLineMode&&({path:F,line:O,column:_}=(0,g.parseLineAndColumnAware)(F)),T!==47&&((0,g.isWindowsDriveLetter)(T)&&F.charCodeAt(F.charCodeAt(1))===58&&(F=(0,g.toSlashes)(F)),F=`/${F}`);const j=h.URI.from({scheme:I.Schemas.vscodeRemote,authority:A,path:F});if(F.charCodeAt(F.length-1)!==47){if((0,H.hasWorkspaceFileExtension)(F))return N.forceOpenWorkspaceAsFile?{fileUri:j,selection:O?{startLineNumber:O,startColumn:_||1}:void 0,remoteAuthority:N.remoteAuthority}:{workspace:(0,B.getWorkspaceIdentifier)(j),remoteAuthority:A};if(N.gotoLineMode||p.posix.basename(F).indexOf(".")!==-1)return{fileUri:j,selection:O?{startLineNumber:O,startColumn:_||1}:void 0,remoteAuthority:A}}return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:A}}shouldOpenNewWindow(F){const N=this.configurationService.getValue("window"),T=N?.openFoldersInNewWindow||"default",A=N?.openFilesInNewWindow||"off";let O=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(T==="on"||T==="off")&&(O=T==="on");let _=!1;return F.forceNewWindow||F.forceReuseWindow?_=!!F.forceNewWindow&&!F.forceReuseWindow:(d.isMacintosh?F.context===1&&(_=!0):F.context!==3&&F.context!==2&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(_=!0),!F.cli.extensionDevelopmentPath&&(A==="on"||A==="off")&&(_=A==="on")),{openFolderInNewWindow:!!O,openFilesInNewWindow:_}}openExtensionDevelopmentHostWindow(F,N){const T=(0,X.findWindowOnExtensionDevelopmentPath)(this.getWindows(),F);if(T)return this.lifecycleMainService.reload(T,N.cli),T.focus(),[T];let A=N.cli["folder-uri"]||[],O=N.cli["file-uri"]||[],_=N.cli._;if(!_.length&&!A.length&&!O.length&&!N.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=ce&&(ce.workspace||ce.folderUri);ne&&(h.URI.isUri(ne)?ne.scheme===I.Schemas.file?_=[ne.fsPath]:A=[ne.toString()]:ne.configPath.scheme===I.Schemas.file?_=[(0,v.originalFSPath)(ne.configPath)]:O=[ne.configPath.toString()])}let j=N.remoteAuthority;for(const ce of F)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=h.URI.parse(ce),le=(0,W.getRemoteAuthority)(ne);le&&(j?(0,v.isEqualAuthority)(le,j)||this.logService.error("more than one extension development path authority"):j=le)}_=_.filter(ce=>{const ne=h.URI.file(ce);return(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(ne),j)}),A=A.filter(ce=>{const ne=this.cliArgToUri(ce);return ne&&!!(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(ne),j):!1}),O=O.filter(ce=>{const ne=this.cliArgToUri(ce);return ne&&!!(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,v.isEqualAuthority)((0,W.getRemoteAuthority)(ne),j):!1}),N.cli._=_,N.cli["folder-uri"]=A,N.cli["file-uri"]=O;const ie=!_.length&&!A.length&&!O.length,ae={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:j};return this.open(ae)}openInBrowserWindow(F){const N=this.configurationService.getValue("window"),T={...this.environmentMainService.args,...F.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,p.join)(this.environmentMainService.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.initialUserEnv,...F.userEnv},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:y.default,isInitialStartup:F.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,L.release)(),hostname:(0,L.hostname)()},zoomLevel:typeof N?.zoomLevel=="number"?N.zoomLevel:void 0,autoDetectHighContrast:N?.autoDetectHighContrast??!0,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:{dark:w.nativeTheme.shouldUseDarkColors,highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors}};let A;if(!F.forceNewWindow&&!F.forceNewTabbedWindow&&(A=F.windowToUse||this.getLastActiveWindow(),A&&A.focus()),A){const O=A.config;!T.extensionDevelopmentPath&&O&&!!O.extensionDevelopmentPath&&(T.extensionDevelopmentPath=O.extensionDevelopmentPath,T.verbose=O.verbose,T["inspect-brk-extensions"]=O["inspect-brk-extensions"],T.debugId=O.debugId,T.extensionEnvironment=O.extensionEnvironment,T["inspect-extensions"]=O["inspect-extensions"],T["extensions-dir"]=O["extensions-dir"])}else{const O=this.windowsStateHandler.getNewWindowState(T);(0,t.mark)("code/willCreateCodeWindow");const _=A=this.instantiationService.createInstance(ee.CodeWindow,{state:O,extensionDevelopmentPath:T.extensionDevelopmentPath,isExtensionTestHost:!!T.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(_)}rt.WINDOWS.push(_),this._onDidOpenWindow.fire(_),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,S.once)(_.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(_)),(0,S.once)(_.onDidClose)(()=>this.onWindowClosed(_)),(0,S.once)(_.onDidDestroy)(()=>this._onDidDestroyWindow.fire(_));const j=(0,M.assertIsDefined)(_.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(_)),this.lifecycleMainService.registerWindow(_)}return T.windowId=A.id,A.isReady?this.lifecycleMainService.unload(A,4).then(O=>{O||this.doOpenInBrowserWindow(A,T,F)}):this.doOpenInBrowserWindow(A,T,F),A}doOpenInBrowserWindow(F,N,T){if(!N.extensionDevelopmentPath)if((0,H.isWorkspaceIdentifier)(N.workspace))N.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:N.workspace,remoteAuthority:N.remoteAuthority});else if((0,H.isSingleFolderWorkspaceIdentifier)(N.workspace))N.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority});else{const A=T.emptyWindowBackupInfo&&T.emptyWindowBackupInfo.backupFolder;N.backupPath=this.backupMainService.registerEmptyWindowBackupSync(A,N.remoteAuthority)}F.load(N)}onWindowClosed(F){const N=rt.WINDOWS.indexOf(F);rt.WINDOWS.splice(N,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const F=w.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(F){return this.doGetLastActiveWindow(this.getWindows().filter(N=>(0,v.isEqualAuthority)(N.remoteAuthority,F)))}doGetLastActiveWindow(F){const N=Math.max.apply(Math,F.map(T=>T.lastFocusTime));return F.find(T=>T.lastFocusTime===N)}sendToFocused(F,...N){const T=this.getFocusedWindow()||this.getLastActiveWindow();T&&T.sendWhenReady(F,k.CancellationToken.None,...N)}sendToAll(F,N,T){for(const A of this.getWindows())T&&T.indexOf(A.id)>=0||A.sendWhenReady(F,k.CancellationToken.None,N)}getWindows(){return rt.WINDOWS}getWindowCount(){return rt.WINDOWS.length}getWindowById(F){const N=this.getWindows().filter(T=>T.id===F);return(0,D.firstOrDefault)(N)}getWindowByWebContents(F){const N=w.BrowserWindow.fromWebContents(F);if(!!N)return this.getWindowById(N.id)}};Q.WINDOWS=[],Q=ue([te(2,u.ILogService),te(3,U.IStateMainService),te(4,s.IEnvironmentMainService),te(5,o.ILifecycleMainService),te(6,c.IBackupMainService),te(7,a.IConfigurationService),te(8,Y.IWorkspacesHistoryMainService),te(9,se.IWorkspacesManagementMainService),te(10,r.IInstantiationService),te(11,f.IDialogMainService),te(12,i.IFileService),te(13,P.IProductService),te(14,R.IProtocolMainService)],Q),e.WindowsMainService=Q}),define(Z[247],x([0,1,51,34,67,42]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let k=class{constructor(g,S,C,E){this.workspacesManagementMainService=g,this.windowsMainService=S,this.workspacesHistoryMainService=C,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(g,S){const C=this.windowsMainService.getWindowById(g);if(C)return this.workspacesManagementMainService.enterWorkspace(C,this.windowsMainService.getWindows(),S)}createUntitledWorkspace(g,S,C){return this.workspacesManagementMainService.createUntitledWorkspace(S,C)}deleteUntitledWorkspace(g,S){return this.workspacesManagementMainService.deleteUntitledWorkspace(S)}getWorkspaceIdentifier(g,S){return this.workspacesManagementMainService.getWorkspaceIdentifier(S)}getRecentlyOpened(g){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(g))}addRecentlyOpened(g,S){return this.workspacesHistoryMainService.addRecentlyOpened(S)}removeRecentlyOpened(g,S){return this.workspacesHistoryMainService.removeRecentlyOpened(S)}clearRecentlyOpened(g){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};k=ue([te(0,D.IWorkspacesManagementMainService),te(1,n.IWindowsMainService),te(2,L.IWorkspacesHistoryMainService),te(3,w.IBackupMainService)],k),e.WorkspacesMainService=k}),define(Z[248],x([0,1,12,29,26,16,39,15,28,43,44,33,3,10,7,2,14,8,31,71,126,37,129,89,221,139,51,230,19,74,195,168,75,104,47,231,92,166,22,50,98,174,196,175,227,93,176,177,20,190,77,73,5,76,240,206,105,18,6,192,245,58,21,78,235,79,38,224,81,207,32,209,211,64,41,215,238,241,239,242,100,216,217,218,219,222,34,246,223,25,80,67,247,42]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M,h,l,c,a,f,s,i,r,o,u,y,P,R,W,U,G,ee,X,J,H,B,Y,se,$,q,Q,z,F,N,T,A,O,_,j,ie,ae,ce,ne,le,he,we,be,Ce,Se,pe,Ee,Le,Ne,Ze,Fe,ze,Ge,st,wt,ot,Ye,He,Qe,K,re,oe,fe,ye,Re,Oe,Ke,Ve,Ae,qe,je,xe,tt,kt,Lt,Pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let pt=class extends I.Disposable{constructor(de,me,ve,ge,Pe,De,Me,Ie,ke,We){super();this.mainProcessNodeIpcServer=de,this.userEnv=me,this.mainInstantiationService=ve,this.logService=ge,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Ie,this.fileService=ke,this.productService=We,this.configureSession(),this.registerListeners()}configureSession(){const de=Ie=>Ie?.startsWith(`${p.Schemas.vscodeWebview}://`),me=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((Ie,ke,We,_e)=>de(_e.requestingUrl)?We(me.has(ke)):We(!1)),w.session.defaultSession.setPermissionCheckHandler((Ie,ke,We,_e)=>de(_e.requestingUrl)?me.has(ke):!1);const ve=new Set([p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemoteResource,"devtools"]),ge=Ie=>{for(let ke=Ie;ke;ke=ke.parent)if(ke.url.startsWith(`${p.Schemas.vscodeWebview}://`))return!0;return!1},Pe=Ie=>Ie.resourceType==="xhr"||ge(Ie.frame),De=Ie=>{const ke=Ie.frame;if(!ke||!this.windowsMainService)return!1;const We=w.BrowserWindow.getAllWindows();for(const _e of We)if(ke.processId===_e.webContents.mainFrame.processId)return!0;return!1};w.session.defaultSession.webRequest.onBeforeRequest((Ie,ke)=>{const We=v.URI.parse(Ie.url);return We.scheme===p.Schemas.vscodeFileResource&&!De(Ie)?(this.logService.error("Blocked vscode-file request",Ie.url),ke({cancel:!0})):We.path.endsWith(".svg")&&!ve.has(We.scheme)?ke({cancel:!Pe(Ie)}):ke({cancel:!1})}),w.session.defaultSession.webRequest.onHeadersReceived((Ie,ke)=>{const We=Ie.responseHeaders,_e=We["content-type"]||We["Content-Type"];if(_e&&Array.isArray(_e)){const Xe=v.URI.parse(Ie.url);if(Xe.path.endsWith(".svg")&&ve.has(Xe.scheme))return We["Content-Type"]=["image/svg+xml"],ke({cancel:!1,responseHeaders:We});if(!Xe.path.includes(p.Schemas.vscodeRemoteResource)&&_e.some(et=>et.toLowerCase().includes("image/svg")))return ke({cancel:!Pe(Ie)})}return ke({cancel:!1})});const Me=w.session.defaultSession;typeof Me.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Me.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,b.setUnexpectedErrorHandler)(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>(0,b.onUnexpectedError)(ve)),process.on("unhandledRejection",ve=>(0,b.onUnexpectedError)(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,l.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(ve,ge)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ge)}),w.app.on("activate",(ve,ge)=>{this.logService.trace("app#activate"),ge||this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(ve,ge)=>{ge.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),ge.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let de=[],me;w.app.on("open-file",(ve,ge)=>{this.logService.trace("app#open-file: ",ge),ve.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),me!==void 0&&(clearTimeout(me),me=void 0),me=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],me=void 0},100)}),w.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),w.ipcMain.handle("vscode:fetchShellEnv",ve=>{const ge=this.windowsMainService?.getWindowByWebContents(ve.sender);let Pe,De;return ge?.config?(Pe=ge.config,De={...process.env,...ge.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De,!1)}),w.ipcMain.handle("vscode:writeNlsFile",(ve,ge,Pe)=>{const De=this.validateNlsPath([ge]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,D.VSBuffer.fromString(Pe))}),w.ipcMain.handle("vscode:readNlsFile",async(ve,...ge)=>{const Pe=this.validateNlsPath(ge);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),w.ipcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),w.ipcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),w.ipcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(de){let me;for(const ve of de)typeof ve=="string"&&(typeof me!="string"?me=ve:me=(0,t.join)(me,ve));if(!(typeof me!="string"||!(0,t.isAbsolute)(me)||!(0,g.isEqualOrParent)(me,this.environmentMainService.cachedLanguagesPath,!d.isLinux)))return v.URI.file(me)}onUnexpectedError(de){if(de){const me={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(me))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;d.isWindows&&de&&w.app.setAppUserModelId(de);try{d.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ke){this.logService.error(ke)}const me=new a.Server;this.logService.trace("Resolving machine identifier...");const ve=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:ge,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(ve),Me=await this.initServices(ve,ge,Pe);if(this.environmentMainService.driverHandle){const ke=await(0,ee.serve)(me,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(ke)}this._register(Me.createInstance(s.ProxyAuthHandler)),Me.invokeFunction(ke=>this.initChannels(ke,me,De));const Ie=Me.invokeFunction(ke=>this.openFirstWindow(ke,me));Me.invokeFunction(ke=>this.afterWindowOpen(ke,ge)),this.environmentMainService.args.trace&&Me.invokeFunction(ke=>this.stopTracingEventually(ke,Ie))}async resolveMachineId(){let de=this.stateMainService.getItem(Ge.machineIdKey);return(!de||d.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await(0,h.getMachineId)(),this.stateMainService.setItem(Ge.machineIdKey,de)),de}setupSharedProcess(de){const me=this._register(this.mainInstantiationService.createInstance(Ee.SharedProcess,de,this.userEnv)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await me.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new f.Client(Pe,"main")})(),ge=(async()=>(await me.whenReady(),ve))();return{sharedProcess:me,sharedProcessReady:ge,sharedProcessClient:ve}}async initServices(de,me,ve){const ge=new ie.ServiceCollection;switch(process.platform){case"win32":ge.set(Ye.IUpdateService,new _.SyncDescriptor(oe.Win32UpdateService));break;case"linux":d.isLinuxSnap?ge.set(Ye.IUpdateService,new _.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(Ye.IUpdateService,new _.SyncDescriptor(K.LinuxUpdateService));break;case"darwin":ge.set(Ye.IUpdateService,new _.SyncDescriptor(Qe.DarwinUpdateService));break}ge.set(Ae.IWindowsMainService,new _.SyncDescriptor(qe.WindowsMainService,[de,this.userEnv])),ge.set(G.IDialogMainService,new _.SyncDescriptor(G.DialogMainService)),ge.set(ne.ILaunchMainService,new _.SyncDescriptor(ne.LaunchMainService)),ge.set(U.IDiagnosticsMainService,new _.SyncDescriptor(U.DiagnosticsMainService)),ge.set(W.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(ve.then(De=>De.getChannel("diagnostics"))))),ge.set(ae.IIssueMainService,new _.SyncDescriptor(ae.IssueMainService,[this.userEnv])),ge.set(X.IEncryptionMainService,new _.SyncDescriptor(J.EncryptionMainService,[de])),ge.set(ce.IKeyboardLayoutMainService,new _.SyncDescriptor(ce.KeyboardLayoutMainService)),ge.set(Ce.INativeHostMainService,new _.SyncDescriptor(Ce.NativeHostMainService,[me])),ge.set(y.ICredentialsMainService,new _.SyncDescriptor(P.CredentialsMainService,[!1])),ge.set(Ke.IWebviewManagerService,new _.SyncDescriptor(Ve.WebviewMainService)),ge.set(tt.IWorkspacesService,new _.SyncDescriptor(Lt.WorkspacesMainService)),ge.set(Pt.IWorkspacesManagementMainService,new _.SyncDescriptor(Pt.WorkspacesManagementMainService)),ge.set(kt.IWorkspacesHistoryMainService,new _.SyncDescriptor(kt.WorkspacesHistoryMainService)),ge.set(be.IMenubarMainService,new _.SyncDescriptor(be.MenubarMainService)),ge.set(se.IExtensionUrlTrustService,new _.SyncDescriptor($.ExtensionUrlTrustService)),ge.set(q.IExtensionHostStarter,new _.SyncDescriptor(Q.WorkerMainProcessExtensionHostStarter)),ge.set(Fe.IStorageMainService,new _.SyncDescriptor(Fe.StorageMainService)),ge.set(Fe.IGlobalStorageMainService,new _.SyncDescriptor(Fe.GlobalStorageMainService)),d.isWindows?ge.set(z.IExternalTerminalMainService,new _.SyncDescriptor(F.WindowsExternalTerminalService)):d.isMacintosh?ge.set(z.IExternalTerminalMainService,new _.SyncDescriptor(F.MacExternalTerminalService)):d.isLinux&&ge.set(z.IExternalTerminalMainService,new _.SyncDescriptor(F.LinuxExternalTerminalService));const Pe=new o.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(r.IBackupMainService,Pe),ge.set(fe.IURLService,new _.SyncDescriptor(Re.NativeURLService)),(0,ot.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,c.getDelayedChannel)(ve.then(_e=>_e.getChannel("telemetryAppender"))),Me=new st.TelemetryAppenderClient(De),Ie=(0,ze.resolveCommonProperties)(this.fileService,(0,L.release)(),(0,L.hostname)(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),ke=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],We={appenders:[Me],commonProperties:Ie,piiPaths:ke,sendErrorTelemetry:!0};ge.set(Ge.ITelemetryService,new _.SyncDescriptor(wt.TelemetryService,[We]))}else ge.set(Ge.ITelemetryService,ot.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,me,ve){const ge=c.ProxyChannel.fromService(de.get(ne.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const Pe=c.ProxyChannel.fromService(de.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Pe);const De=this.fileService.getProvider(p.Schemas.file);(0,m.assertType)(De instanceof O.DiskFileSystemProvider);const Me=new A.DiskFileSystemProviderChannel(De,this.logService,this.environmentMainService);me.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me),ve.then(Be=>Be.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Me));const Ie=new He.UpdateChannel(de.get(Ye.IUpdateService));me.registerChannel("update",Ie);const ke=c.ProxyChannel.fromService(de.get(ae.IIssueMainService));me.registerChannel("issue",ke);const We=c.ProxyChannel.fromService(de.get(X.IEncryptionMainService));me.registerChannel("encryption",We);const _e=c.ProxyChannel.fromService(de.get(y.ICredentialsMainService));me.registerChannel("credentials",_e);const Xe=c.ProxyChannel.fromService(de.get(Le.ISignService));me.registerChannel("sign",Xe);const et=c.ProxyChannel.fromService(de.get(ce.IKeyboardLayoutMainService));me.registerChannel("keyboardLayout",et),this.nativeHostMainService=de.get(Ce.INativeHostMainService);const ut=c.ProxyChannel.fromService(this.nativeHostMainService);me.registerChannel("nativeHost",ut),ve.then(Be=>Be.registerChannel("nativeHost",ut));const vt=c.ProxyChannel.fromService(de.get(tt.IWorkspacesService));me.registerChannel("workspaces",vt);const Ue=c.ProxyChannel.fromService(de.get(be.IMenubarMainService));me.registerChannel("menubar",Ue);const ht=c.ProxyChannel.fromService(de.get(fe.IURLService));me.registerChannel("url",ht);const at=c.ProxyChannel.fromService(de.get(se.IExtensionUrlTrustService));me.registerChannel("extensionUrlTrust",at);const ct=c.ProxyChannel.fromService(de.get(Ke.IWebviewManagerService));me.registerChannel("webview",ct);const lt=this._register(new Ze.StorageDatabaseChannel(this.logService,de.get(Fe.IStorageMainService)));me.registerChannel("storage",lt),ve.then(Be=>Be.registerChannel("storage",lt));const dt=c.ProxyChannel.fromService(de.get(z.IExternalTerminalMainService));me.registerChannel("externalTerminal",dt);const it=new we.LogLevelChannel(de.get(he.ILogService));me.registerChannel("logLevel",it),ve.then(Be=>Be.registerChannel("logLevel",it));const nt=new we.LoggerChannel(de.get(he.ILoggerService));me.registerChannel("logger",nt),ve.then(Be=>Be.registerChannel("logger",nt));const ft=new R.ElectronExtensionHostDebugBroadcastChannel(de.get(Ae.IWindowsMainService));me.registerChannel("extensionhostdebugservice",ft);const Te=c.ProxyChannel.fromService(de.get(q.IExtensionHostStarter));me.registerChannel(q.ipcExtensionHostStarterChannelName,Te)}openFirstWindow(de,me){const ve=this.windowsMainService=de.get(Ae.IWindowsMainService),ge=de.get(fe.IURLService),Pe=de.get(Ce.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Te=>{try{return{uri:v.URI.parse(Te),url:Te}}catch{return}}).filter(Te=>{if(!Te||this.shouldBlockURI(Te.uri))return!1;const Be=this.getWindowOpenableFromProtocolLink(Te.uri);return Be?(De.push(Be),!1):!0}),Ie=this,ke=this.environmentMainService,We=this.productService,_e=this.logService;ge.registerHandler({async handleURL(Te,Be){if(_e.trace("app#handleURL: ",Te.toString(!0),Be),Te.scheme===We.urlProtocol&&Te.path==="workspace"&&(Te=Te.with({authority:"file",path:v.URI.parse(Te.query).path,query:""})),Ie.shouldBlockURI(Te))return!0;const yt=Ie.getWindowOpenableFromProtocolLink(Te);if(_e.trace("app#handleURL: windowOpenableFromProtocolLink = ",yt),yt){const[St]=ve.open({context:5,cli:{...ke.args},urisToOpen:[yt],gotoLineMode:!0});return St.focus(),!0}if(d.isMacintosh&&ve.getWindowCount()===0){const[St]=ve.open({context:5,cli:{...ke.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,pe.getRemoteAuthority)(Te)});return await St.ready(),ge.open(Te,Be)}return!1}});const Xe=this._register(new je.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),et=new c.StaticRouter(Te=>Xe.getActiveClientId().then(Be=>Te===Be)),ut=new ye.URLHandlerRouter(et),vt=me.getChannel("urlHandler",ut);ge.registerHandler(new ye.URLHandlerChannelClient(vt)),this._register(new Oe.ElectronURLListener(Me,ge,ve,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,ht=global.macOpenFiles,at=(0,B.isLaunchedFromCli)(process.env)?0:4,ct=Ue._.length,lt=!!Ue["folder-uri"],dt=!!Ue["file-uri"],it=Ue["skip-add-to-recently-opened"]===!0,nt=Ue.wait&&Ue.waitMarkerFilePath?v.URI.file(Ue.waitMarkerFilePath):void 0,ft=Ue.remote||void 0;return De.length>0?ve.open({context:at,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!ct&&!lt&&!dt?ve.open({context:at,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:it,waitMarkerFileURI:nt,initialStartup:!0,remoteAuthority:ft}):ht.length&&!ct&&!lt&&!dt?ve.open({context:1,cli:Ue,urisToOpen:ht.map(Te=>this.getWindowOpenableFromPathSync(Te)),noRecentEntry:it,waitMarkerFileURI:nt,initialStartup:!0}):ve.open({context:at,cli:Ue,forceNewWindow:Ue["new-window"]||!ct&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:it,waitMarkerFileURI:nt,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ft})}shouldBlockURI(de){return!!(de.authority===p.Schemas.file&&d.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,E.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,E.getPathLabel)(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===p.Schemas.file){const me=v.URI.file(de.fsPath);return(0,xe.hasWorkspaceFileExtension)(me)?{workspaceUri:me}:{fileUri:me}}else if(de.authority===p.Schemas.vscodeRemote){const me=de.path.indexOf(t.posix.sep,1);if(me!==-1){const ve=de.path.substring(1,me),ge=de.path.substring(me),Pe=v.URI.from({scheme:p.Schemas.vscodeRemote,authority:ve,path:ge,query:de.query,fragment:de.fragment});return(0,xe.hasWorkspaceFileExtension)(ge)?{workspaceUri:Pe}:/:[\d]+$/.test(ge)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(de){try{if((0,n.statSync)(de).isDirectory())return{folderUri:v.URI.file(de)};if((0,xe.hasWorkspaceFileExtension)(de))return{workspaceUri:v.URI.file(de)}}catch{}return{fileUri:v.URI.file(de)}}async afterWindowOpen(de,me){this.lifecycleMainService.phase=3;let ve=!1;(0,S.once)(this.lifecycleMainService.onWillShutdown)(()=>ve=!0);const ge=de.get(Ge.ITelemetryService);this._register(me.onDidError(({type:Me,details:Ie})=>{let ke;switch(Me){case 1:ke="SharedProcess: detected unresponsive window";break;case 2:ke=`SharedProcess: crashed (detail: ${Ie?.reason??"<unknown>"}, code: ${Ie?.exitCode??"<unknown>"})`;break;case 3:ke=`SharedProcess: failed to load (detail: ${Ie?.reason??"<unknown>"}, code: ${Ie?.exitCode??"<unknown>"})`;break}(0,b.onUnexpectedError)(new Error(ke)),ge.publicLog2("sharedprocesserror",{type:Me,reason:Ie?.reason,code:Ie?.exitCode,visible:me.isVisible(),shuttingdown:ve})}));const Pe=this.productService.win32MutexName;if(d.isWindows&&Pe)try{const Me=V.__$__nodeRequire("windows-mutex").Mutex,Ie=new Me(Pe);(0,S.once)(this.lifecycleMainService.onWillShutdown)(()=>Ie.release())}catch(Me){this.logService.error(Me)}w.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(Me,Ie)=>{Ie({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=de.get(Ye.IUpdateService);(De instanceof oe.Win32UpdateService||De instanceof K.LinuxUpdateService||De instanceof Qe.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Ie=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,C.stripComments)(Ie))["enable-crash-reporter"]===void 0){const _e=(0,ot.getTelemetryLevel)(this.configurationService)>=1,Xe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${_e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,M.generateUuid)()}"`,"}"],et=Ie.substring(0,Ie.length-2).concat(`,
`,Xe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(et))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(de,me,ve){try{return await(0,Y.getResolvedShellEnv)(this.logService,de,me)}catch(ge){const Pe=(0,k.toErrorMessage)(ge);ve?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}stopTracingEventually(de,me){this.logService.info("Tracing: waiting for windows to get ready...");const ve=de.get(G.IDialogMainService);let ge=!1;const Pe=async Me=>{if(ge)return;ge=!0;const Ie=await w.contentTracing.stopRecording(`${(0,g.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ie}`):ve.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,Ie),buttons:[(0,E.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,m.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(me.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};pt=ue([te(2,j.IInstantiationService),te(3,he.ILogService),te(4,H.IEnvironmentMainService),te(5,le.ILifecycleMainService),te(6,u.IConfigurationService),te(7,Ne.IStateMainService),te(8,T.IFileService),te(9,Se.IProductService)],pt),e.CodeApplication=pt}),define(Z[255],x([0,1,12,29,30,9,39,15,28,43,33,10,7,63,2,36,27,24,37,57,248,11,19,200,208,22,50,171,20,188,77,73,182,76,18,95,6,193,96,53,21,54,197,99,237,56,234,79,205,38,236,64,65,214]),function(V,e,w,n,L,D,k,b,g,S,C,E,I,p,t,d,m,v,M,h,l,c,a,f,s,i,r,o,u,y,P,R,W,U,G,ee,X,J,H,B,Y,se,$,q,Q,z,F,N,T,A,O,_,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(ne){console.error(ne.message),w.app.exit(1)}}async startup(){(0,b.setUnexpectedErrorHandler)(pe=>console.error(pe));const[ne,le,he,we,be,Ce,Se]=this.createServices();try{try{await this.initServices(he,we,be)}catch(pe){throw this.handleStartupDataDirError(he,Se.nameLong,pe),pe}await ne.invokeFunction(async pe=>{const Ee=pe.get(X.ILogService),Le=pe.get(G.ILifecycleMainService),Ne=pe.get(u.IFileService),Ze=await this.claimInstance(Ee,he,Le,ne,Se,!0);return v.Promises.writeFile(he.mainLockfile,String(process.pid)).catch(Fe=>{Ee.warn(`Error writing main lockfile: ${Fe.stack}`)}),Ce.logger=new H.SpdLogLogger("main",(0,I.join)(he.logsPath,"main.log"),!0,!1,Ce.getLevel()),(0,S.once)(Le.onWillShutdown)(Fe=>{Ne.dispose(),we.dispose(),Fe.join(v.Promises.unlink(he.mainLockfile).catch(()=>{}))}),ne.createInstance(l.CodeApplication,Ze,le).startup()})}catch(pe){ne.invokeFunction(this.quit,pe)}}createServices(){const ne=new U.ServiceCollection,le={_serviceBrand:void 0,...B.default};ne.set(Y.IProductService,le);const he=new i.EnvironmentMainService(this.resolveArgs(),le),we=this.patchEnvironment(he);ne.set(i.IEnvironmentMainService,he);const be=new ee.BufferLogService,Ce=new X.MultiplexLogService([new X.ConsoleMainLogger((0,X.getLogLevel)(he)),be]);process.once("exit",()=>Ce.dispose()),ne.set(X.ILogService,Ce);const Se=new y.FileService(Ce);ne.set(u.IFileService,Se);const pe=new P.DiskFileSystemProvider(Ce);Se.registerProvider(E.Schemas.file,pe),ne.set(X.ILoggerService,new J.LoggerService(Ce,Se));const Ee=new f.ConfigurationService(he.settingsResource,Se);ne.set(a.IConfigurationService,Ee),ne.set(G.ILifecycleMainService,new R.SyncDescriptor(G.LifecycleMainService));const Le=new O.StateMainService(he,Ce,Se);return ne.set(A.IStateMainService,Le),ne.set(z.IRequestService,new R.SyncDescriptor(F.RequestMainService)),ne.set(j.IThemeMainService,new R.SyncDescriptor(j.ThemeMainService)),ne.set(N.ISignService,new R.SyncDescriptor(T.SignService)),ne.set(q.ITunnelService,new R.SyncDescriptor(Q.TunnelService)),ne.set(se.IProtocolMainService,new R.SyncDescriptor($.ProtocolMainService)),[new W.InstantiationService(ne,!0),we,he,Ee,Le,be,le]}patchEnvironment(ne){const le={VSCODE_IPC_HOOK:ne.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(he=>{const we=process.env[he];typeof we=="string"&&(le[he]=we)}),Object.assign(process.env,le),le}initServices(ne,le,he){return D.Promises.settled([Promise.all([ne.extensionsPath,ne.codeCachePath,ne.logsPath,ne.globalStorageHome.fsPath,ne.workspaceStorageHome.fsPath,ne.backupHome].map(we=>we?v.Promises.mkdir(we,{recursive:!0}):void 0)),le.initialize(),he.init()])}async claimInstance(ne,le,he,we,be,Ce){let Se;try{(0,p.mark)("code/willStartMainServer"),Se=await(0,h.serve)(le.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,S.once)(he.onWillShutdown)(()=>Se.dispose())}catch(pe){if(pe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,be.nameLong,pe),pe;let Ee;try{Ee=await(0,h.connect)(le.mainIPCHandle,"main")}catch(Fe){if(!Ce||t.isWindows||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,be.nameShort),(0,c.localize)(1,null),be.nameLong),Fe;try{(0,n.unlinkSync)(le.mainIPCHandle)}catch(ze){throw ne.warn("Could not delete obsolete instance handle",ze),ze}return this.claimInstance(ne,le,he,we,be,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Fe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ne.error(Fe),Ee.dispose(),new Error(Fe)}let Le;!le.args.wait&&!le.args.status&&(Le=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,be.nameShort),(0,c.localize)(3,null),be.nameLong)},1e4));const Ne=M.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0}),Ze=M.ProxyChannel.toService(Ee.getChannel("diagnostics"),{disableMarshalling:!0});if(le.args.status)return we.invokeFunction(async()=>{const Fe=new s.DiagnosticsService(_.NullTelemetryService,be),ze=await Ne.getMainProcessInfo(),Ge=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),st=await Fe.getDiagnostics(ze,Ge);throw console.log(st),new b.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Ne,ne),ne.trace("Sending env to running instance..."),await Ne.start(le.args,process.env),Ee.dispose(),Le&&clearTimeout(Le),new b.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw ne.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new b.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}handleStartupDataDirError(ne,le,he){if(he.code==="EACCES"||he.code==="EPERM"){const we=(0,L.coalesce)([ne.userDataPath,ne.extensionsPath,h.XDG_RUNTIME_DIR]).map(be=>(0,C.getPathLabel)(be,ne));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,k.toErrorMessage)(he),we.join(`
`)),le)}}showStartupWarningDialog(ne,le,he){w.dialog.showMessageBoxSync({title:he,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,c.localize)(6,null))],message:ne,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ne,le){if(t.isWindows){const he=await ne.getMainProcessId();le.trace("Sending some foreground love to the running instance:",he);try{(await new Promise((we,be)=>{V(["windows-foreground-love"],we,be)})).allowSetForegroundWindow(he)}catch(we){le.error(we)}}}quit(ne,le){const he=ne.get(X.ILogService),we=ne.get(G.ILifecycleMainService);let be=0;le&&(le.isExpected?le.message&&he.trace(le.message):(be=1,le.stack?he.error(le.stack):he.error(`Startup error: ${le.toString()}`))),we.kill(be)}resolveArgs(){const ne=this.validatePaths((0,r.parseMainProcessArgv)(process.argv));if(ne.wait&&!ne.waitMarkerFilePath){const le=(0,o.createWaitMarkerFile)(ne.verbose);le&&((0,r.addArg)(process.argv,"--waitMarkerFilePath",le),ne.waitMarkerFilePath=le)}return ne}validatePaths(ne){if(ne["open-url"]&&(ne._urls=ne._,ne._=[]),!ne.remote){const le=this.doValidatePaths(ne._,ne.goto);ne._=le}return ne}doValidatePaths(ne,le){const he=(0,d.cwd)(),we=ne.map(Se=>{let pe=String(Se),Ee;le&&(Ee=(0,g.parseLineAndColumnAware)(pe),pe=Ee.path),pe&&(pe=this.preparePath(he,pe));const Le=(0,g.sanitizeFilePath)(pe,he),Ne=(0,I.basename)(Le);return Ne&&!(0,g.isValidBasename)(Ne)?null:le&&Ee?(Ee.path=Le,this.toPath(Ee)):Le}),be=t.isWindows||t.isMacintosh,Ce=(0,L.distinct)(we,Se=>Se&&be?Se.toLowerCase():Se||"");return(0,L.coalesce)(Ce)}preparePath(ne,le){return t.isWindows&&(le=(0,m.rtrim)(le,'"')),le=(0,m.trim)((0,m.trim)(le," "),"	"),t.isWindows&&(le=(0,I.resolve)(ne,le),le=(0,m.rtrim)(le,".")),le}toPath(ne){const le=[ne.path];return typeof ne.line=="number"&&le.push(String(ne.line)),typeof ne.column=="number"&&le.push(String(ne.column)),le.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/eeeab304b9ac777b4a8dddf55f66ffebd9e4e7f2/core/vs/code/electron-main/main.js.map
