/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/types","vs/base/common/event","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/path","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","os","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/instantiation/common/descriptors","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/node/shellEnv","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/terminal/node/shellEnv","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/iterator","graceful-fs","crypto","vs/platform/environment/node/argvHelper","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(j){for(var t=[],D=0,R=j.length;D<R;D++)t[D]=Y[j[D]];return t};define(Y[55],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function D(R,b){if(!R)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=D}),define(Y[44],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function D(L){return(P,c,v)=>{let C=null,T=null;if(typeof v.value=="function"?(C="value",T=v.value):typeof v.get=="function"&&(C="get",T=v.get),!T)throw new Error("not supported");v[C]=L(T,c)}}t.createDecorator=D;function R(L,P,c){let v=null,C=null;if(typeof c.value=="function"?(v="value",C=c.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(v="get",C=c.get),!C)throw new Error("not supported");const T=`$memoize$${P}`;c[v]=function(...d){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,d)}),this[T]}}t.memoize=R;function b(L,P,c){return D((v,C)=>{const T=`$debounce$${C}`,d=`$debounce$result$${C}`;return function(...y){this[d]||(this[d]=c?c():void 0),clearTimeout(this[T]),P&&(this[d]=P(this[d],...y),y=[this[d]]),this[T]=setTimeout(()=>{v.apply(this,y),this[d]=c?c():void 0},L)}})}t.debounce=b;function I(L,P,c){return D((v,C)=>{const T=`$throttle$timer$${C}`,d=`$throttle$result$${C}`,y=`$throttle$lastRun$${C}`,w=`$throttle$pending$${C}`;return function(...g){if(this[d]||(this[d]=c?c():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[d]=P(this[d],...g)),this[w])return;const l=this[y]+L;l<=Date.now()?(this[y]=Date.now(),v.apply(this,[this[d]]),this[d]=c?c():void 0):(this[w]=!0,this[T]=setTimeout(()=>{this[w]=!1,this[y]=Date.now(),v.apply(this,[this[d]]),this[d]=c?c():void 0},l-Date.now()))}})}t.throttle=I}),define(Y[56],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var D;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(D=t.ScanError||(t.ScanError={}));var R;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(R=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var I;(function(e){e.DEFAULT={allowTrailingComma:!0}})(I=t.ParseOptions||(t.ParseOptions={}));function L(e,s=!1){let i=0,n=e.length,r="",a=0,u=16,h=0;function S(ie){let he=0,ue=0;for(;he<ie;){const x=e.charCodeAt(i);if(x>=48&&x<=57)ue=ue*16+x-48;else if(x>=65&&x<=70)ue=ue*16+x-65+10;else if(x>=97&&x<=102)ue=ue*16+x-97+10;else break;i++,he++}return he<ie&&(ue=-1),ue}function O(ie){i=ie,r="",a=0,u=16,h=0}function N(){const ie=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&v(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&v(e.charCodeAt(i)))for(i++;i<e.length&&v(e.charCodeAt(i));)i++;else return h=3,e.substring(ie,i);let he=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&v(e.charCodeAt(i))){for(i++;i<e.length&&v(e.charCodeAt(i));)i++;he=i}else h=3;return e.substring(ie,he)}function _(){let ie="",he=i;for(;;){if(i>=n){ie+=e.substring(he,i),h=2;break}const ue=e.charCodeAt(i);if(ue===34){ie+=e.substring(he,i),i++;break}if(ue===92){if(ie+=e.substring(he,i),i++,i>=n){h=2;break}switch(e.charCodeAt(i++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const te=S(4);te>=0?ie+=String.fromCharCode(te):h=4;break}default:h=5}he=i;continue}if(ue>=0&&ue<=31)if(c(ue)){ie+=e.substring(he,i),h=2;break}else h=6;i++}return ie}function J(){if(r="",h=0,a=i,i>=n)return a=n,u=17;let ie=e.charCodeAt(i);if(P(ie)){do i++,r+=String.fromCharCode(ie),ie=e.charCodeAt(i);while(P(ie));return u=15}if(c(ie))return i++,r+=String.fromCharCode(ie),ie===13&&e.charCodeAt(i)===10&&(i++,r+=`
`),u=14;switch(ie){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,r=_(),u=10;case 47:{const he=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<n&&!c(e.charCodeAt(i));)i++;return r=e.substring(he,i),u=12}if(e.charCodeAt(i+1)===42){i+=2;const ue=n-1;let x=!1;for(;i<ue;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,x=!0;break}i++}return x||(i++,h=1),r=e.substring(he,i),u=13}return r+=String.fromCharCode(ie),i++,u=16}case 45:if(r+=String.fromCharCode(ie),i++,i===n||!v(e.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=N(),u=11;default:for(;i<n&&re(ie);)i++,ie=e.charCodeAt(i);if(a!==i){switch(r=e.substring(a,i),r){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return r+=String.fromCharCode(ie),i++,u=16}}function re(ie){if(P(ie)||c(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let ie;do ie=J();while(ie>=12&&ie<=15);return ie}return{setPosition:O,getPosition:()=>i,scan:s?ee:J,getToken:()=>u,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>h}}t.createScanner=L;function P(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function v(e){return e>=48&&e<=57}var C;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(C||(C={}));function T(e,s){const i=[],n=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function h(S,O,N,_){a.value=S,a.offset=O,a.length=N,a.type=_,a.colonOffset=void 0,r=a}try{E(e,{onObjectBegin:(S,O)=>{if(s<=S)throw n;r=void 0,u=s>S,i.push("")},onObjectProperty:(S,O,N)=>{if(s<O||(h(S,O,N,"property"),i[i.length-1]=S,s<=O+N))throw n},onObjectEnd:(S,O)=>{if(s<=S)throw n;r=void 0,i.pop()},onArrayBegin:(S,O)=>{if(s<=S)throw n;r=void 0,i.push(0)},onArrayEnd:(S,O)=>{if(s<=S)throw n;r=void 0,i.pop()},onLiteralValue:(S,O,N)=>{if(s<O||(h(S,O,N,o(S)),s<=O+N))throw n},onSeparator:(S,O,N)=>{if(s<=O)throw n;if(S===":"&&r&&r.type==="property")r.colonOffset=O,u=!1,r=void 0;else if(S===","){const _=i[i.length-1];typeof _=="number"?i[i.length-1]=_+1:(u=!0,i[i.length-1]=""),r=void 0}}})}catch(S){if(S!==n)throw S}return{path:i,previousNode:r,isAtPropertyKey:u,matches:S=>{let O=0;for(let N=0;O<S.length&&N<i.length;N++)if(S[O]===i[N]||S[O]==="*")O++;else if(S[O]!=="**")return!1;return O===S.length}}}t.getLocation=T;function d(e,s=[],i=I.DEFAULT){let n=null,r=[];const a=[];function u(S){Array.isArray(r)?r.push(S):n!==null&&(r[n]=S)}return E(e,{onObjectBegin:()=>{const S={};u(S),a.push(r),r=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const S=[];u(S),a.push(r),r=S,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:u,onError:(S,O,N)=>{s.push({error:S,offset:O,length:N})}},i),r[0]}t.parse=d;function y(e,s=[],i=I.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function a(S){return n.children.push(S),S}E(e,{onObjectBegin:S=>{n=a({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,O,N)=>{n=a({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:O,length:N,parent:n})},onObjectEnd:(S,O)=>{n.length=S+O-n.offset,n=n.parent,r(S+O)},onArrayBegin:(S,O)=>{n=a({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,O)=>{n.length=S+O-n.offset,n=n.parent,r(S+O)},onLiteralValue:(S,O,N)=>{a({type:o(S),offset:O,length:N,parent:n,value:S}),r(O+N)},onSeparator:(S,O,N)=>{n.type==="property"&&(S===":"?n.colonOffset=O:S===","&&r(O))},onError:(S,O,N)=>{s.push({error:S,offset:O,length:N})}},i);const h=n.children[0];return h&&delete h.parent,h}t.parseTree=y;function w(e,s){if(!e)return;let i=e;for(let n of s)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}t.findNodeAtLocation=w;function g(e){if(!e.parent||!e.parent.children)return[];const s=g(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;s.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&s.push(i)}return s}t.getNodePath=g;function l(e){switch(e.type){case"array":return e.children.map(l);case"object":{const s=Object.create(null);for(let i of e.children){const n=i.children[1];n&&(s[i.children[0].value]=l(n))}return s}case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=l;function f(e,s,i=!1){return s>=e.offset&&s<e.offset+e.length||i&&s===e.offset+e.length}t.contains=f;function p(e,s,i=!1){if(f(e,s,i)){const n=e.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const a=p(n[r],s,i);if(a)return a}return e}}t.findNodeAtOffset=p;function E(e,s,i=I.DEFAULT){const n=L(e,!1);function r(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(K){return K?Z=>K(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=r(s.onObjectBegin),h=a(s.onObjectProperty),S=r(s.onObjectEnd),O=r(s.onArrayBegin),N=r(s.onArrayEnd),_=a(s.onLiteralValue),J=a(s.onSeparator),re=r(s.onComment),ee=a(s.onError),ie=i&&i.disallowComments,he=i&&i.allowTrailingComma;function ue(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:ie||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(K){case 12:case 13:ie?x(10):re();break;case 16:x(1);break;case 15:case 14:break;default:return K}}}function x(K,Z=[],q=[]){if(ee(K),Z.length+q.length>0){let M=n.getToken();for(;M!==17;){if(Z.indexOf(M)!==-1){ue();break}else if(q.indexOf(M)!==-1)break;M=ue()}}}function te(K){const Z=n.getTokenValue();return K?_(Z):h(Z),ue(),!0}function U(){switch(n.getToken()){case 11:{let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(x(2),K=0)}catch{x(2)}_(K);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return ue(),!0}function k(){return n.getToken()!==10?(x(3,[],[2,5]),!1):(te(!1),n.getToken()===6?(J(":"),ue(),ne()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function z(){u(),ue();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||x(4,[],[]),J(","),ue(),n.getToken()===2&&he)break}else K&&x(6,[],[]);k()||x(4,[],[2,5]),K=!0}return S(),n.getToken()!==2?x(7,[2],[]):ue(),!0}function G(){O(),ue();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||x(4,[],[]),J(","),ue(),n.getToken()===4&&he)break}else K&&x(6,[],[]);ne()||x(4,[],[4,5]),K=!0}return N(),n.getToken()!==4?x(8,[4],[]):ue(),!0}function ne(){switch(n.getToken()){case 3:return G();case 1:return z();case 10:return te(!0);default:return U()}}return ue(),n.getToken()===17?i.allowEmptyContent?!0:(x(4,[],[]),!1):ne()?(n.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}t.visit=E;function m(e,s){let i=L(e),n=[],r,a=0,u;do switch(u=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:a!==u&&n.push(e.substring(a,u)),s!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,s)),a=i.getPosition();break}while(r!==17);return n.join("")}t.stripComments=m;function o(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=o}),function(){function j(b){const I=[];typeof b=="number"&&I.push("code/timeOrigin",b);function L(c){I.push(c,Date.now())}function P(){const c=[];for(let v=0;v<I.length;v+=2)c.push({name:I[v],startTime:I[v+1]});return c}return{mark:L,getMarks:P}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const L of performance.getEntriesByType("mark"))I.push({name:L.name,startTime:Math.round(b+L.startTime)});return I}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function D(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=D(R))}(),define(Y[57],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var D;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(D=t.Source||(t.Source={}));var R;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(R=t.TerminateResponseCode||(t.TerminateResponseCode={}));function b(I,...L){const P=L.reduce((C,T)=>(C[T]=!0,C),{}),c=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(C=>!P[C]).forEach(C=>{for(let T=0;T<c.length;T++)if(C.search(c[T])!==-1){delete I[C];break}})}t.sanitizeProcessEnvironment=b}),function(j,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var D=t();for(var R in D)(typeof exports=="object"?exports:j)[R]=D[R]}}(typeof self!="undefined"?self:this,function(){return function(j){var t={};function D(R){if(t[R])return t[R].exports;var b=t[R]={i:R,l:!1,exports:{}};return j[R].call(b.exports,b,b.exports,D),b.l=!0,b.exports}return D.m=j,D.c=t,D.d=function(R,b,I){D.o(R,b)||Object.defineProperty(R,b,{enumerable:!0,get:I})},D.r=function(R){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},D.t=function(R,b){if(1&b&&(R=D(R)),8&b||4&b&&typeof R=="object"&&R&&R.__esModule)return R;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:R}),2&b&&typeof R!="string")for(var L in R)D.d(I,L,function(P){return R[P]}.bind(null,L));return I},D.n=function(R){var b=R&&R.__esModule?function(){return R.default}:function(){return R};return D.d(b,"a",b),b},D.o=function(R,b){return Object.prototype.hasOwnProperty.call(R,b)},D.p="",D(D.s=0)}([function(j,t,D){(function(R){var b;t=j.exports=q,b=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var I=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=t.re=[],c=t.src=[],v=0,C=v++;c[C]="0|[1-9]\\d*";var T=v++;c[T]="[0-9]+";var d=v++;c[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=v++;c[y]="("+c[C]+")\\.("+c[C]+")\\.("+c[C]+")";var w=v++;c[w]="("+c[T]+")\\.("+c[T]+")\\.("+c[T]+")";var g=v++;c[g]="(?:"+c[C]+"|"+c[d]+")";var l=v++;c[l]="(?:"+c[T]+"|"+c[d]+")";var f=v++;c[f]="(?:-("+c[g]+"(?:\\."+c[g]+")*))";var p=v++;c[p]="(?:-?("+c[l]+"(?:\\."+c[l]+")*))";var E=v++;c[E]="[0-9A-Za-z-]+";var m=v++;c[m]="(?:\\+("+c[E]+"(?:\\."+c[E]+")*))";var o=v++,e="v?"+c[y]+c[f]+"?"+c[m]+"?";c[o]="^"+e+"$";var s="[v=\\s]*"+c[w]+c[p]+"?"+c[m]+"?",i=v++;c[i]="^"+s+"$";var n=v++;c[n]="((?:<|>)?=?)";var r=v++;c[r]=c[T]+"|x|X|\\*";var a=v++;c[a]=c[C]+"|x|X|\\*";var u=v++;c[u]="[v=\\s]*("+c[a]+")(?:\\.("+c[a]+")(?:\\.("+c[a]+")(?:"+c[f]+")?"+c[m]+"?)?)?";var h=v++;c[h]="[v=\\s]*("+c[r]+")(?:\\.("+c[r]+")(?:\\.("+c[r]+")(?:"+c[p]+")?"+c[m]+"?)?)?";var S=v++;c[S]="^"+c[n]+"\\s*"+c[u]+"$";var O=v++;c[O]="^"+c[n]+"\\s*"+c[h]+"$";var N=v++;c[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=v++;c[_]="(?:~>?)";var J=v++;c[J]="(\\s*)"+c[_]+"\\s+",P[J]=new RegExp(c[J],"g");var re=v++;c[re]="^"+c[_]+c[u]+"$";var ee=v++;c[ee]="^"+c[_]+c[h]+"$";var ie=v++;c[ie]="(?:\\^)";var he=v++;c[he]="(\\s*)"+c[ie]+"\\s+",P[he]=new RegExp(c[he],"g");var ue=v++;c[ue]="^"+c[ie]+c[u]+"$";var x=v++;c[x]="^"+c[ie]+c[h]+"$";var te=v++;c[te]="^"+c[n]+"\\s*("+s+")$|^$";var U=v++;c[U]="^"+c[n]+"\\s*("+e+")$|^$";var k=v++;c[k]="(\\s*)"+c[n]+"\\s*("+s+"|"+c[u]+")",P[k]=new RegExp(c[k],"g");var z=v++;c[z]="^\\s*("+c[u]+")\\s+-\\s+("+c[u]+")\\s*$";var G=v++;c[G]="^\\s*("+c[h]+")\\s+-\\s+("+c[h]+")\\s*$";var ne=v++;c[ne]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)b(K,c[K]),P[K]||(P[K]=new RegExp(c[K]));function Z(F,W){if(F instanceof q)return F;if(typeof F!="string"||F.length>I||!(W?P[i]:P[o]).test(F))return null;try{return new q(F,W)}catch{return null}}function q(F,W){if(F instanceof q){if(F.loose===W)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof q))return new q(F,W);b("SemVer",F,W),this.loose=W;var $=F.trim().match(W?P[i]:P[o]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var de=+le;if(de>=0&&de<L)return de}return le}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}t.parse=Z,t.valid=function(F,W){var $=Z(F,W);return $?$.version:null},t.clean=function(F,W){var $=Z(F.trim().replace(/^[=v]+/,""),W);return $?$.version:null},t.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(F){return b("SemVer.compare",this.version,this.loose,F),F instanceof q||(F=new q(F,this.loose)),this.compareMain(F)||this.comparePre(F)},q.prototype.compareMain=function(F){return F instanceof q||(F=new q(F,this.loose)),A(this.major,F.major)||A(this.minor,F.minor)||A(this.patch,F.patch)},q.prototype.comparePre=function(F){if(F instanceof q||(F=new q(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var W=0;do{var $=this.prerelease[W],le=F.prerelease[W];if(b("prerelease compare",W,$,le),$===void 0&&le===void 0)return 0;if(le===void 0)return 1;if($===void 0)return-1;if($!==le)return A($,le)}while(++W)},q.prototype.inc=function(F,W){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",W);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",W);break;case"prepatch":this.prerelease.length=0,this.inc("patch",W),this.inc("pre",W);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",W),this.inc("pre",W);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}W&&(this.prerelease[0]===W?isNaN(this.prerelease[1])&&(this.prerelease=[W,0]):this.prerelease=[W,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},t.inc=function(F,W,$,le){typeof $=="string"&&(le=$,$=void 0);try{return new q(F,$).inc(W,le).version}catch{return null}},t.diff=function(F,W){if(X(F,W))return null;var $=Z(F),le=Z(W);if($.prerelease.length||le.prerelease.length){for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==le[de])return"pre"+de;return"prerelease"}for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==le[de])return de},t.compareIdentifiers=A;var M=/^[0-9]+$/;function A(F,W){var $=M.test(F),le=M.test(W);return $&&le&&(F=+F,W=+W),$&&!le?-1:le&&!$?1:F<W?-1:F>W?1:0}function V(F,W,$){return new q(F,$).compare(new q(W,$))}function B(F,W,$){return V(F,W,$)>0}function H(F,W,$){return V(F,W,$)<0}function X(F,W,$){return V(F,W,$)===0}function ae(F,W,$){return V(F,W,$)!==0}function ce(F,W,$){return V(F,W,$)>=0}function we(F,W,$){return V(F,W,$)<=0}function fe(F,W,$,le){var de;switch(W){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),de=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),de=F!==$;break;case"":case"=":case"==":de=X(F,$,le);break;case"!=":de=ae(F,$,le);break;case">":de=B(F,$,le);break;case">=":de=ce(F,$,le);break;case"<":de=H(F,$,le);break;case"<=":de=we(F,$,le);break;default:throw new TypeError("Invalid operator: "+W)}return de}function se(F,W){if(F instanceof se){if(F.loose===W)return F;F=F.value}if(!(this instanceof se))return new se(F,W);b("comparator",F,W),this.loose=W,this.parse(F),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(F,W){return A(W,F)},t.major=function(F,W){return new q(F,W).major},t.minor=function(F,W){return new q(F,W).minor},t.patch=function(F,W){return new q(F,W).patch},t.compare=V,t.compareLoose=function(F,W){return V(F,W,!0)},t.rcompare=function(F,W,$){return V(W,F,$)},t.sort=function(F,W){return F.sort(function($,le){return t.compare($,le,W)})},t.rsort=function(F,W){return F.sort(function($,le){return t.rcompare($,le,W)})},t.gt=B,t.lt=H,t.eq=X,t.neq=ae,t.gte=ce,t.lte=we,t.cmp=fe,t.Comparator=se;var pe={};function me(F,W){if(F instanceof me)return F.loose===W?F:new me(F.raw,W);if(F instanceof se)return new me(F.value,W);if(!(this instanceof me))return new me(F,W);if(this.loose=W,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function Ee(F){return!F||F.toLowerCase()==="x"||F==="*"}function Ie(F,W,$,le,de,Ce,Se,ke,Re,Oe,Ne,De,Le){return((W=Ee($)?"":Ee(le)?">="+$+".0.0":Ee(de)?">="+$+"."+le+".0":">="+W)+" "+(ke=Ee(Re)?"":Ee(Oe)?"<"+(+Re+1)+".0.0":Ee(Ne)?"<"+Re+"."+(+Oe+1)+".0":De?"<="+Re+"."+Oe+"."+Ne+"-"+De:"<="+ke)).trim()}function Me(F,W){for(var $=0;$<F.length;$++)if(!F[$].test(W))return!1;if(W.prerelease.length){for($=0;$<F.length;$++)if(b(F[$].semver),F[$].semver!==pe&&F[$].semver.prerelease.length>0){var le=F[$].semver;if(le.major===W.major&&le.minor===W.minor&&le.patch===W.patch)return!0}return!1}return!0}function xe(F,W,$){try{W=new me(W,$)}catch{return!1}return W.test(F)}function Ve(F,W,$,le){var de,Ce,Se,ke,Re;switch(F=new q(F,le),W=new me(W,le),$){case">":de=B,Ce=we,Se=H,ke=">",Re=">=";break;case"<":de=H,Ce=ce,Se=B,ke="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(F,W,le))return!1;for(var Oe=0;Oe<W.set.length;++Oe){var Ne=W.set[Oe],De=null,Le=null;if(Ne.forEach(function(Ae){Ae.semver===pe&&(Ae=new se(">=0.0.0")),De=De||Ae,Le=Le||Ae,de(Ae.semver,De.semver,le)?De=Ae:Se(Ae.semver,Le.semver,le)&&(Le=Ae)}),De.operator===ke||De.operator===Re||(!Le.operator||Le.operator===ke)&&Ce(F,Le.semver)||Le.operator===Re&&Se(F,Le.semver))return!1}return!0}se.prototype.parse=function(F){var W=this.loose?P[te]:P[U],$=F.match(W);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new q($[2],this.loose):this.semver=pe},se.prototype.toString=function(){return this.value},se.prototype.test=function(F){return b("Comparator.test",F,this.loose),this.semver===pe||(typeof F=="string"&&(F=new q(F,this.loose)),fe(F,this.operator,this.semver,this.loose))},se.prototype.intersects=function(F,W){if(!(F instanceof se))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new me(F.value,W),xe(this.value,$,W);if(F.operator==="")return $=new me(this.value,W),xe(F.semver,$,W);var le=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),de=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),ke=fe(this.semver,"<",F.semver,W)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Re=fe(this.semver,">",F.semver,W)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return le||de||Ce&&Se||ke||Re},t.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(F){var W=this.loose;F=F.trim(),b("range",F,W);var $=W?P[G]:P[z];F=F.replace($,Ie),b("hyphen replace",F),F=F.replace(P[k],"$1$2$3"),b("comparator trim",F,P[k]),F=(F=(F=F.replace(P[J],"$1~")).replace(P[he],"$1^")).split(/\s+/).join(" ");var le=W?P[te]:P[U],de=F.split(" ").map(function(Ce){return function(Se,ke){return b("comp",Se),Se=function(Re,Oe){return Re.trim().split(/\s+/).map(function(Ne){return function(De,Le){b("caret",De,Le);var Ae=Le?P[x]:P[ue];return De.replace(Ae,function(Fe,ve,ye,be,Pe){var Te;return b("caret",De,Fe,ve,ye,be,Pe),Ee(ve)?Te="":Ee(ye)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(be)?Te=ve==="0"?">="+ve+"."+ye+".0 <"+ve+"."+(+ye+1)+".0":">="+ve+"."+ye+".0 <"+(+ve+1)+".0.0":Pe?(b("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=ve==="0"?ye==="0"?">="+ve+"."+ye+"."+be+Pe+" <"+ve+"."+ye+"."+(+be+1):">="+ve+"."+ye+"."+be+Pe+" <"+ve+"."+(+ye+1)+".0":">="+ve+"."+ye+"."+be+Pe+" <"+(+ve+1)+".0.0"):(b("no pr"),Te=ve==="0"?ye==="0"?">="+ve+"."+ye+"."+be+" <"+ve+"."+ye+"."+(+be+1):">="+ve+"."+ye+"."+be+" <"+ve+"."+(+ye+1)+".0":">="+ve+"."+ye+"."+be+" <"+(+ve+1)+".0.0"),b("caret return",Te),Te})}(Ne,Oe)}).join(" ")}(Se,ke),b("caret",Se),Se=function(Re,Oe){return Re.trim().split(/\s+/).map(function(Ne){return function(De,Le){var Ae=Le?P[ee]:P[re];return De.replace(Ae,function(Fe,ve,ye,be,Pe){var Te;return b("tilde",De,Fe,ve,ye,be,Pe),Ee(ve)?Te="":Ee(ye)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(be)?Te=">="+ve+"."+ye+".0 <"+ve+"."+(+ye+1)+".0":Pe?(b("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=">="+ve+"."+ye+"."+be+Pe+" <"+ve+"."+(+ye+1)+".0"):Te=">="+ve+"."+ye+"."+be+" <"+ve+"."+(+ye+1)+".0",b("tilde return",Te),Te})}(Ne,Oe)}).join(" ")}(Se,ke),b("tildes",Se),Se=function(Re,Oe){return b("replaceXRanges",Re,Oe),Re.split(/\s+/).map(function(Ne){return function(De,Le){De=De.trim();var Ae=Le?P[O]:P[S];return De.replace(Ae,function(Fe,ve,ye,be,Pe,Te){b("xRange",De,Fe,ve,ye,be,Pe,Te);var je=Ee(ye),Ue=je||Ee(be),ze=Ue||Ee(Pe);return ve==="="&&ze&&(ve=""),je?Fe=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?(Ue&&(be=0),ze&&(Pe=0),ve===">"?(ve=">=",Ue?(ye=+ye+1,be=0,Pe=0):ze&&(be=+be+1,Pe=0)):ve==="<="&&(ve="<",Ue?ye=+ye+1:be=+be+1),Fe=ve+ye+"."+be+"."+Pe):Ue?Fe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ze&&(Fe=">="+ye+"."+be+".0 <"+ye+"."+(+be+1)+".0"),b("xRange return",Fe),Fe})}(Ne,Oe)}).join(" ")}(Se,ke),b("xrange",Se),Se=function(Re,Oe){return b("replaceStars",Re,Oe),Re.trim().replace(P[ne],"")}(Se,ke),b("stars",Se),Se}(Ce,W)}).join(" ").split(/\s+/);return this.loose&&(de=de.filter(function(Ce){return!!Ce.match(le)})),de=de.map(function(Ce){return new se(Ce,W)})},me.prototype.intersects=function(F,W){if(!(F instanceof me))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(le){return F.set.some(function(de){return de.every(function(Ce){return le.intersects(Ce,W)})})})})},t.toComparators=function(F,W){return new me(F,W).set.map(function($){return $.map(function(le){return le.value}).join(" ").trim().split(" ")})},me.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new q(F,this.loose));for(var W=0;W<this.set.length;W++)if(Me(this.set[W],F))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(F,W,$){var le=null,de=null;try{var Ce=new me(W,$)}catch{return null}return F.forEach(function(Se){Ce.test(Se)&&(le&&de.compare(Se)!==-1||(de=new q(le=Se,$)))}),le},t.minSatisfying=function(F,W,$){var le=null,de=null;try{var Ce=new me(W,$)}catch{return null}return F.forEach(function(Se){Ce.test(Se)&&(le&&de.compare(Se)!==1||(de=new q(le=Se,$)))}),le},t.validRange=function(F,W){try{return new me(F,W).range||"*"}catch{return null}},t.ltr=function(F,W,$){return Ve(F,W,"<",$)},t.gtr=function(F,W,$){return Ve(F,W,">",$)},t.outside=Ve,t.prerelease=function(F,W){var $=Z(F,W);return $&&$.prerelease.length?$.prerelease:null},t.intersects=function(F,W,$){return F=new me(F,$),W=new me(W,$),F.intersects(W)},t.coerce=function(F){if(F instanceof q)return F;if(typeof F!="string")return null;var W=F.match(P[N]);return W==null?null:Z((W[1]||"0")+"."+(W[2]||"0")+"."+(W[3]||"0"))}}).call(this,D(1))},function(j,t){var D,R,b=j.exports={};function I(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(l){if(D===setTimeout)return setTimeout(l,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(l,0);try{return D(l,0)}catch{try{return D.call(null,l,0)}catch{return D.call(this,l,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{R=typeof clearTimeout=="function"?clearTimeout:L}catch{R=L}})();var c,v=[],C=!1,T=-1;function d(){C&&c&&(C=!1,c.length?v=c.concat(v):T=-1,v.length&&y())}function y(){if(!C){var l=P(d);C=!0;for(var f=v.length;f;){for(c=v,v=[];++T<f;)c&&c[T].run();T=-1,f=v.length}c=null,C=!1,function(p){if(R===clearTimeout)return clearTimeout(p);if((R===L||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(p);try{R(p)}catch{try{return R.call(null,p)}catch{return R.call(this,p)}}}(l)}}function w(l,f){this.fun=l,this.array=f}function g(){}b.nextTick=function(l){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];v.push(new w(l,f)),v.length!==1||C||P(y)},w.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=g,b.addListener=g,b.once=g,b.off=g,b.removeListener=g,b.removeAllListeners=g,b.emit=g,b.prependListener=g,b.prependOnceListener=g,b.listeners=function(l){return[]},b.binding=function(l){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(l){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Y[58],Q([0,1]),function(j,t){"use strict";var D;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class R{constructor(P,c,v){this.level=P,this.key=c,this.value=v,this.forward=[]}}const b=void 0;class I{constructor(P,c=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new R(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,b,b)}has(P){return Boolean(I._search(this,P,this.comparator))}get(P){return I._search(this,P,this.comparator)?.value}set(P,c){return I._insert(this,P,c,this.comparator)&&(this._size+=1),this}delete(P){const c=I._delete(this,P,this.comparator);return c&&(this._size-=1),c}forEach(P,c){let v=this._header.forward[0];for(;v;)P.call(c,v.value,v.key,this),v=v.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",c=this._header.forward[0];for(;c;)P+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return P}static _search(P,c,v){let C=P._header;for(let T=P._level-1;T>=0;T--)for(;C.forward[T]&&v(C.forward[T].key,c)<0;)C=C.forward[T];if(C=C.forward[0],C&&v(C.key,c)===0)return C}static _insert(P,c,v,C){let T=[],d=P._header;for(let y=P._level-1;y>=0;y--){for(;d.forward[y]&&C(d.forward[y].key,c)<0;)d=d.forward[y];T[y]=d}if(d=d.forward[0],d&&C(d.key,c)===0)return d.value=v,!1;{let y=I._randomLevel(P);if(y>P._level){for(let w=P._level;w<y;w++)T[w]=P._header;P._level=y}d=new R(y,c,v);for(let w=0;w<y;w++)d.forward[w]=T[w].forward[w],T[w].forward[w]=d;return!0}}static _randomLevel(P,c=.5){let v=1;for(;Math.random()<c&&v<P._maxLevel;)v+=1;return v}static _delete(P,c,v){let C=[],T=P._header;for(let d=P._level-1;d>=0;d--){for(;T.forward[d]&&v(T.forward[d].key,c)<0;)T=T.forward[d];C[d]=T}if(T=T.forward[0],!T||v(T.key,c)!==0)return!1;for(let d=0;d<P._level&&C[d].forward[d]===T;d++)C[d].forward[d]=T.forward[d];for(;P._level>0&&P._header.forward[P._level-1]===b;)P._level-=1;return!0}}t.SkipList=I}),define(Y[38],Q([0,1,8,2]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function b(E){const m=E;return m?[m.on,m.pause,m.resume,m.destroy].every(o=>typeof o=="function"):!1}t.isReadableStream=b;function I(E){const m=E;return m?b(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}t.isReadableBufferedStream=I;function L(E,m){return new P(E,m)}t.newWriteableStream=L;class P{constructor(m,o){this.reducer=m,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(o=>o(m))}emitError(m){this.listeners.error.length===0?(0,D.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(o=>o(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,o){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(m,o){if(this.state.destroyed)return;let e;switch(m){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const s=e.indexOf(o);s>=0&&e.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(E,m){const o=[];let e;for(;(e=E.read())!==null;)o.push(e);return m(o)}t.consumeReadable=c;function v(E,m,o){const e=[];let s;for(;(s=E.read())!==null&&e.length<o;)e.push(s);return s===null&&e.length>0?m(e):{read:()=>{if(e.length>0)return e.shift();if(typeof s!="undefined"){const i=s;return s=void 0,i}return E.read()}}}t.peekReadable=v;function C(E,m){return new Promise((o,e)=>{const s=[];T(E,{onData:i=>{m&&s.push(i)},onError:i=>{m?e(i):o(void 0)},onEnd:()=>{o(m?m(s):void 0)}})})}t.consumeStream=C;function T(E,m){let o=!1;return E.on("error",e=>{o||m.onError(e)}),E.on("end",()=>{o||m.onEnd()}),E.on("data",e=>{o||m.onData(e)}),(0,R.toDisposable)(()=>o=!0)}t.listenStream=T;function d(E,m){return new Promise((o,e)=>{const s=new R.DisposableStore,i=[],n=u=>{if(i.push(u),i.length>m)return s.dispose(),E.pause(),o({stream:E,buffer:i,ended:!1})},r=u=>e(u),a=()=>o({stream:E,buffer:i,ended:!0});s.add((0,R.toDisposable)(()=>E.removeListener("error",r))),E.on("error",r),s.add((0,R.toDisposable)(()=>E.removeListener("end",a))),E.on("end",a),s.add((0,R.toDisposable)(()=>E.removeListener("data",n))),E.on("data",n)})}t.peekStream=d;function y(E,m){const o=L(m);return o.end(E),o}t.toStream=y;function w(){const E=L(()=>{throw new Error("not supported")});return E.end(),E}t.emptyStream=w;function g(E){let m=!1;return{read:()=>m?null:(m=!0,E)}}t.toReadable=g;function l(E,m,o){const e=L(o);return T(E,{onData:s=>e.write(m.data(s)),onError:s=>e.error(m.error?m.error(s):s),onEnd:()=>e.end()}),e}t.transform=l;function f(E,m,o){let e=!1;return{read:()=>{const s=m.read();return e?s:(e=!0,s!==null?o([E,s]):E)}}}t.prefixedReadable=f;function p(E,m,o){let e=!1;const s=L(o);return T(m,{onData:i=>e?s.write(i):(e=!0,s.write(o([E,i]))),onError:i=>s.error(i),onEnd:()=>{e||(e=!0,s.write(E)),s.end()}}),s}t.prefixedStream=p}),define(Y[17],Q([0,1,38]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const R=typeof Buffer!="undefined";let b,I;class L{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return R?new L(Buffer.allocUnsafe(h)):new L(new Uint8Array(h))}static wrap(h){return R&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new L(h)}static fromString(h,S){return!(S?.dontUseNodeBuffer||!1)&&R?new L(Buffer.from(h)):(b||(b=new TextEncoder),new L(b.encode(h)))}static fromByteArray(h){const S=L.alloc(h.length);for(let O=0,N=h.length;O<N;O++)S.buffer[O]=h[O];return S}static concat(h,S){if(typeof S=="undefined"){S=0;for(let _=0,J=h.length;_<J;_++)S+=h[_].byteLength}const O=L.alloc(S);let N=0;for(let _=0,J=h.length;_<J;_++){const re=h[_];O.set(re,N),N+=re.byteLength}return O}clone(){const h=L.alloc(this.byteLength);return h.set(this),h}toString(){return R?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(h,S){return new L(this.buffer.subarray(h,S))}set(h,S){if(h instanceof L)this.buffer.set(h.buffer,S);else if(h instanceof Uint8Array)this.buffer.set(h,S);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),S);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return v(this.buffer,h)}writeUInt32BE(h,S){C(this.buffer,h,S)}readUInt32LE(h){return T(this.buffer,h)}writeUInt32LE(h,S){d(this.buffer,h,S)}readUInt8(h){return y(this.buffer,h)}writeUInt8(h,S){w(this.buffer,h,S)}}t.VSBuffer=L;function P(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0}t.readUInt16LE=P;function c(u,h,S){u[S+0]=h&255,h=h>>>8,u[S+1]=h&255}t.writeUInt16LE=c;function v(u,h){return u[h]*2**24+u[h+1]*2**16+u[h+2]*2**8+u[h+3]}t.readUInt32BE=v;function C(u,h,S){u[S+3]=h,h=h>>>8,u[S+2]=h,h=h>>>8,u[S+1]=h,h=h>>>8,u[S]=h}t.writeUInt32BE=C;function T(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0|u[h+2]<<16>>>0|u[h+3]<<24>>>0}t.readUInt32LE=T;function d(u,h,S){u[S+0]=h&255,h=h>>>8,u[S+1]=h&255,h=h>>>8,u[S+2]=h&255,h=h>>>8,u[S+3]=h&255}t.writeUInt32LE=d;function y(u,h){return u[h]}t.readUInt8=y;function w(u,h,S){u[S]=h}t.writeUInt8=w;function g(u){return D.consumeReadable(u,h=>L.concat(h))}t.readableToBuffer=g;function l(u){return D.toReadable(u)}t.bufferToReadable=l;function f(u){return D.consumeStream(u,h=>L.concat(h))}t.streamToBuffer=f;async function p(u){return u.ended?L.concat(u.buffer):L.concat([...u.buffer,await f(u.stream)])}t.bufferedStreamToBuffer=p;function E(u){return D.toStream(u,h=>L.concat(h))}t.bufferToStream=E;function m(u){return D.transform(u,{data:h=>typeof h=="string"?L.fromString(h):L.wrap(h)},h=>L.concat(h))}t.streamToBufferReadableStream=m;function o(u){return D.newWriteableStream(h=>L.concat(h),u)}t.newWriteableBufferStream=o;function e(u,h){return D.prefixedReadable(u,h,S=>L.concat(S))}t.prefixedBufferReadable=e;function s(u,h){return D.prefixedStream(u,h,S=>L.concat(S))}t.prefixedBufferStream=s;function i(u){let h=0,S=0,O=0;const N=new Uint8Array(Math.floor(u.length/4*3)),_=re=>{switch(S){case 3:N[O++]=h|re,S=0;break;case 2:N[O++]=h|re>>>2,h=re<<6,S=3;break;case 1:N[O++]=h|re>>>4,h=re<<4,S=2;break;default:h=re<<2,S=1}};for(let re=0;re<u.length;re++){const ee=u.charCodeAt(re);if(ee>=65&&ee<=90)_(ee-65);else if(ee>=97&&ee<=122)_(ee-97+26);else if(ee>=48&&ee<=57)_(ee-48+52);else if(ee===43||ee===45)_(62);else if(ee===47||ee===95)_(63);else{if(ee===61)break;throw new SyntaxError(`Unexpected base64 character ${u[re]}`)}}const J=O;for(;S>0;)_(0);return L.wrap(N).slice(0,J)}t.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:u},h=!0,S=!1){const O=S?r:n;let N="";const _=u.byteLength%3;let J=0;for(;J<u.byteLength-_;J+=3){const re=u[J+0],ee=u[J+1],ie=u[J+2];N+=O[re>>>2],N+=O[(re<<4|ee>>>4)&63],N+=O[(ee<<2|ie>>>6)&63],N+=O[ie&63]}if(_===1){const re=u[J+0];N+=O[re>>>2],N+=O[re<<4&63],h&&(N+="==")}else if(_===2){const re=u[J+0],ee=u[J+1];N+=O[re>>>2],N+=O[(re<<4|ee>>>4)&63],N+=O[ee<<2&63],h&&(N+="=")}return N}t.encodeBase64=a}),define(Y[59],Q([0,1,26]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function R(f){return b(f,0)}t.hash=R;function b(f,p){switch(typeof f){case"object":return f===null?I(349,p):Array.isArray(f)?c(f,p):v(f,p);case"string":return P(f,p);case"boolean":return L(f,p);case"number":return I(f,p);case"undefined":return I(937,p);default:return I(617,p)}}t.doHash=b;function I(f,p){return(p<<5)-p+f|0}t.numberHash=I;function L(f,p){return I(f?433:863,p)}function P(f,p){p=I(149417,p);for(let E=0,m=f.length;E<m;E++)p=I(f.charCodeAt(E),p);return p}t.stringHash=P;function c(f,p){return p=I(104579,p),f.reduce((E,m)=>b(m,E),p)}function v(f,p){return p=I(181387,p),Object.keys(f).sort().reduce((E,m)=>(E=P(m,E),b(f[m],E)),p)}class C{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=b(p,this._value),this._value}}t.Hasher=C;var T;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function d(f,p,E=32){const m=E-p,o=~((1<<m)-1);return(f<<p|(o&f)>>>m)>>>0}function y(f,p=0,E=f.byteLength,m=0){for(let o=0;o<E;o++)f[p+o]=m}function w(f,p,E="0"){for(;f.length<p;)f=E+f;return f}function g(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(E=>E.toString(16).padStart(2,"0")).join(""):w((f>>>0).toString(16),p/4)}t.toHexString=g;class l{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const E=p.length;if(E===0)return;const m=this._buff;let o=this._buffLen,e=this._leftoverHighSurrogate,s,i;for(e!==0?(s=e,i=-1,e=0):(s=p.charCodeAt(0),i=0);;){let n=s;if(D.isHighSurrogate(s))if(i+1<E){const r=p.charCodeAt(i+1);D.isLowSurrogate(r)?(i++,n=D.computeCodePoint(s,r)):n=65533}else{e=s;break}else D.isLowSurrogate(s)&&(n=65533);if(o=this._push(m,o,n),i++,i<E)s=p.charCodeAt(i);else break}this._buffLen=o,this._leftoverHighSurrogate=e}_push(p,E,m){return m<128?p[E++]=m:m<2048?(p[E++]=192|(m&1984)>>>6,p[E++]=128|(m&63)>>>0):m<65536?(p[E++]=224|(m&61440)>>>12,p[E++]=128|(m&4032)>>>6,p[E++]=128|(m&63)>>>0):(p[E++]=240|(m&1835008)>>>18,p[E++]=128|(m&258048)>>>12,p[E++]=128|(m&4032)>>>6,p[E++]=128|(m&63)>>>0),E>=64&&(this._step(),E-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),E}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=l._bigBlock32,E=this._buffDV;for(let u=0;u<64;u+=4)p.setUint32(u,E.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)p.setUint32(u,d(p.getUint32(u-12,!1)^p.getUint32(u-32,!1)^p.getUint32(u-56,!1)^p.getUint32(u-64,!1),1),!1);let m=this._h0,o=this._h1,e=this._h2,s=this._h3,i=this._h4,n,r,a;for(let u=0;u<80;u++)u<20?(n=o&e|~o&s,r=1518500249):u<40?(n=o^e^s,r=1859775393):u<60?(n=o&e|o&s|e&s,r=2400959708):(n=o^e^s,r=3395469782),a=d(m,5)+n+i+r+p.getUint32(u*4,!1)&4294967295,i=s,s=e,e=d(o,30),o=m,m=a;this._h0=this._h0+m&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+i&4294967295}}t.StringSHA1=l,l._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Y[22],Q([0,1,6]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function R(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const l=Array.isArray(g)?[]:{};return Object.keys(g).forEach(f=>{g[f]&&typeof g[f]=="object"?l[f]=R(g[f]):l[f]=g[f]}),l}t.deepClone=R;function b(g){if(!g||typeof g!="object")return g;const l=[g];for(;l.length>0;){const f=l.shift();Object.freeze(f);for(const p in f)if(I.call(f,p)){const E=f[p];typeof E=="object"&&!Object.isFrozen(E)&&l.push(E)}}return g}t.deepFreeze=b;const I=Object.prototype.hasOwnProperty;function L(g,l){return P(g,l,new Set)}t.cloneAndChange=L;function P(g,l,f){if((0,D.isUndefinedOrNull)(g))return g;const p=l(g);if(typeof p!="undefined")return p;if((0,D.isArray)(g)){const E=[];for(const m of g)E.push(P(m,l,f));return E}if((0,D.isObject)(g)){if(f.has(g))throw new Error("Cannot clone recursive data-structure");f.add(g);const E={};for(let m in g)I.call(g,m)&&(E[m]=P(g[m],l,f));return f.delete(g),E}return g}function c(g,l,f=!0){return(0,D.isObject)(g)?((0,D.isObject)(l)&&Object.keys(l).forEach(p=>{p in g?f&&((0,D.isObject)(g[p])&&(0,D.isObject)(l[p])?c(g[p],l[p],f):g[p]=l[p]):g[p]=l[p]}),g):l}t.mixin=c;function v(g,l){if(g===l)return!0;if(g==null||l===null||l===void 0||typeof g!=typeof l||typeof g!="object"||Array.isArray(g)!==Array.isArray(l))return!1;let f,p;if(Array.isArray(g)){if(g.length!==l.length)return!1;for(f=0;f<g.length;f++)if(!v(g[f],l[f]))return!1}else{const E=[];for(p in g)E.push(p);E.sort();const m=[];for(p in l)m.push(p);if(m.sort(),!v(E,m))return!1;for(f=0;f<E.length;f++)if(!v(g[E[f]],l[E[f]]))return!1}return!0}t.equals=v;function C(g){const l=new Set;return JSON.stringify(g,(f,p)=>{if((0,D.isObject)(p)||Array.isArray(p)){if(l.has(p))return"[Circular]";l.add(p)}return p})}t.safeStringify=C;function T(g,l,f){const p=l(g);return typeof p=="undefined"?f:p}t.getOrDefault=T;function d(g,l){const f=Object.create(null);return!g||!l||Object.keys(l).forEach(E=>{const m=g[E],o=l[E];v(m,o)||(f[E]=o)}),f}t.distinct=d;function y(g,l){const f=l.toLowerCase(),p=Object.keys(g).find(E=>E.toLowerCase()===f);return p?g[p]:g[l]}t.getCaseInsensitive=y;function w(g,l){const f=Object.create(null);for(const[p,E]of Object.entries(g))l(p,E)&&(f[p]=E);return f}t.filter=w}),define(Y[60],Q([0,1,9]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function R(v){const C=v;return C&&typeof C.type=="string"&&typeof C.severity=="string"}t.isRemoteConsoleLog=R;function b(v){const C=[];let T;try{const d=JSON.parse(v.arguments),y=d[d.length-1];y&&y.__$stack&&(d.pop(),T=y.__$stack),C.push(...d)}catch{C.push("Unable to log remote console arguments",v.arguments)}return{args:C,stack:T}}t.parse=b;function I(v){if(typeof v!="string")return I(b(v).stack);const C=v;if(C){const T=L(C),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(T||"");if(d&&d.length===4)return{uri:D.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}t.getFirstFrame=I;function L(v){if(!v)return v;const C=v.indexOf(`
`);return C===-1?v:v.substring(0,C)}function P(v,C){const{args:T,stack:d}=b(v),y=typeof T[0]=="string"&&T.length===1;let w=L(d);w&&(w=`(${w.trim()})`);let g=[];if(typeof T[0]=="string"?w&&y?g=[`%c[${C}] %c${T[0]} %c${w}`,c("blue"),c(""),c("grey")]:g=[`%c[${C}] %c${T[0]}`,c("blue"),c(""),...T.slice(1)]:g=[`%c[${C}]%`,c("blue"),...T],w&&!y&&g.push(w),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,g)}t.log=P;function c(v){return`color: ${v}`}}),define(Y[61],Q([0,1,17,26,9]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function I(v){return JSON.stringify(v,P)}t.stringify=I;function L(v){let C=JSON.parse(v);return C=c(C),C}t.parse=L;function P(v,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,R.regExpFlags)(C)}:C}function c(v,C=0){if(!v||C>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return b.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 14:return new Date(v.source)}if(v instanceof D.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let T=0;T<v.length;++T)v[T]=c(v[T],C+1);else for(const T in v)Object.hasOwnProperty.call(v,T)&&(v[T]=c(v[T],C+1))}return v}t.revive=c}),define(Y[62],Q([0,1,45,10,11,12,19,26,9]),function(j,t,D,R,b,I,L,P,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function v(n,r,a){if(typeof n=="string"&&(n=c.URI.file(n)),a){const h=a.getWorkspaceFolder(n);if(h){const S=a.getWorkspace().folders.length>1;let O;if((0,L.isEqual)(h.uri,n)?O="":O=(0,L.relativePath)(h.uri,n),S){const N=h.name?h.name:(0,L.basename)(h.uri);O=O?N+" \u2022 "+O:N}return O}}if(n.scheme!==R.Schemas.file&&n.scheme!==R.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(n.fsPath))return(0,b.normalize)(T(n.fsPath));let u=(0,b.normalize)(n.fsPath);return!I.isWindows&&r?.userHome&&(u=y(u,r.userHome.fsPath)),u}t.getPathLabel=v;function C(n){if(!n)return;typeof n=="string"&&(n=c.URI.file(n));const r=(0,L.basename)(n)||(n.scheme===R.Schemas.file?n.fsPath:n.path);return I.isWindows&&(0,D.isRootOrDriveLetter)(r)?T(r):r}t.getBaseLabel=C;function T(n,r){return(0,D.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}t.normalizeDriveLetter=T;let d=Object.create(null);function y(n,r){if(I.isWindows||!n||!r)return n;let a=d.original===r?d.normalized:void 0;return a||(a=`${(0,P.rtrim)(r,b.posix.sep)}${b.posix.sep}`,d={original:r,normalized:a}),(I.isLinux?n.startsWith(a):(0,P.startsWithIgnoreCase)(n,a))&&(n=`~/${n.substr(a.length)}`),n}t.tildify=y;function w(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}t.untildify=w;const g="\u2026",l="\\\\",f="~";function p(n,r=b.sep){const a=new Array(n.length);let u=!1;for(let h=0;h<n.length;h++){let S=n[h];if(S===""){a[h]=`.${r}`;continue}if(!S){a[h]=S;continue}u=!0;let O="";S.indexOf(l)===0?(O=S.substr(0,S.indexOf(l)+l.length),S=S.substr(S.indexOf(l)+l.length)):S.indexOf(r)===0?(O=S.substr(0,S.indexOf(r)+r.length),S=S.substr(S.indexOf(r)+r.length)):S.indexOf(f)===0&&(O=S.substr(0,S.indexOf(f)+f.length),S=S.substr(S.indexOf(f)+f.length));const N=S.split(r);for(let _=1;u&&_<=N.length;_++)for(let J=N.length-_;u&&J>=0;J--){u=!1;let re=N.slice(J,J+_).join(r);for(let ee=0;!u&&ee<n.length;ee++)if(ee!==h&&n[ee]&&n[ee].indexOf(re)>-1){const ie=J+_===N.length,he=J>0&&n[ee].indexOf(r)>-1?r+re:re,ue=n[ee].endsWith(he);u=!ie||ue}if(!u){let ee="";(N[0].endsWith(":")||O!=="")&&(J===1&&(J=0,_++,re=N[0]+r+re),J>0&&(ee=N[0]+r),ee=O+ee),J>0&&(ee=ee+g+r),ee=ee+re,J+_<N.length&&(ee=ee+r+g),a[h]=ee}}u&&(a[h]=S)}return a}t.shorten=p;var E;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(E||(E={}));function m(n,r=Object.create(null)){const a=[];let u=!1,h="";for(const S of n)if(S==="$"||u&&S==="{")h&&a.push({value:h,type:E.TEXT}),h="",u=!0;else if(S==="}"&&u){const O=r[h];if(typeof O=="string")O.length&&a.push({value:O,type:E.VARIABLE});else if(O){const N=a[a.length-1];(!N||N.type!==E.SEPARATOR)&&a.push({value:O.label,type:E.SEPARATOR})}h="",u=!1}else h+=S;return h&&!u&&a.push({value:h,type:E.TEXT}),a.filter((S,O)=>{if(S.type===E.SEPARATOR){const N=a[O-1],_=a[O+1];return[N,_].every(J=>J&&(J.type===E.VARIABLE||J.type===E.TEXT)&&J.value.length>0)}return!0}).map(S=>S.value).join("")}t.template=m;function o(n,r){return I.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}t.mnemonicMenuLabel=o;function e(n,r){return I.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):I.isWindows?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function s(n){return n.replace(/&/g,"&&")}t.unmnemonicLabel=s;function i(n){const r=n.indexOf("/")!==-1?b.posix:b.win32,a=r.basename(n),u=r.dirname(n);return a.length?{name:a,parentPath:u}:{name:u,parentPath:""}}t.splitName=i}),define(Y[27],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(c){return D.test(c)}t.isUUID=R;const b=new Uint8Array(16),I=[];for(let c=0;c<256;c++)I.push(c.toString(16).padStart(2,"0"));let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(c){for(let v=0;v<c.length;v++)c[v]=Math.floor(Math.random()*256);return c};function P(){L(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let c=0,v="";return v+=I[b[c++]],v+=I[b[c++]],v+=I[b[c++]],v+=I[b[c++]],v+="-",v+=I[b[c++]],v+=I[b[c++]],v+="-",v+=I[b[c++]],v+=I[b[c++]],v+="-",v+=I[b[c++]],v+=I[b[c++]],v+="-",v+=I[b[c++]],v+=I[b[c++]],v+=I[b[c++]],v+=I[b[c++]],v+=I[b[c++]],v+=I[b[c++]],v}t.generateUuid=P}),define(Y[63],Q([0,1,132]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class R{constructor(I="utf8"){this.stringDecoder=new D.StringDecoder(I),this.remaining=null}write(I){const L=[],P=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(P.length<1)return L;let c=0,v,C=c;for(;C<P.length;)if(v=P.charCodeAt(C),v===13||v===10){if(L.push(P.substring(c,C)),C++,C<P.length){const T=v;v=P.charCodeAt(C),(T===13&&v===10||T===10&&v===13)&&C++}c=C}else C++;return this.remaining=c<P.length?P.substr(c):null,L}end(){return this.remaining}}t.LineDecoder=R}),define(Y[64],Q([0,1,33,11,15]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,L=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var c;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(c||(c={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class T{constructor(o,e,s){this.exePath=o,this.displayName=e,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:m=!1}={}){return m?v===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:m=!1,findPreview:o=!1}={}){const e=d({useAlternateBitness:m});if(!e)return null;const s=R.join(e,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(s))return null;let i=-1,n=null;for(const u of await b.Promises.readdir(s)){let h=-1;if(o){const O=u.indexOf("-");if(O<0)continue;const N=u.substring(0,O);if(!I.test(N)||u.substring(O+1)!=="preview")continue;h=parseInt(N,10)}else{if(!I.test(u))continue;h=parseInt(u,10)}if(h<=i)continue;const S=R.join(s,u,"pwsh.exe");!await b.SymlinkSupport.existsFile(S)||(n=S,i=h)}if(!n)return null;const r=e.includes("x86")?" (x86)":"",a=o?" Preview":"";return new T(n,`PowerShell${a}${r}`,!0)}async function w({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const o=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:e,pwshMsixName:s}=m?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const i of await b.Promises.readdir(o))if(e.test(i)){const n=R.join(o,i,"pwsh.exe");return new T(n,s)}return null}function g(){const m=R.join(D.homedir(),".dotnet","tools","pwsh.exe");return new T(m,".NET Core PowerShell Global Tool")}function l(){const m=R.join(process.env.windir,v===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new T(m,"Windows PowerShell",!0)}async function*f(){let m=await y();m&&(yield m),m=await y({useAlternateBitness:!0}),m&&(yield m),m=await w(),m&&(yield m),m=g(),m&&(yield m),m=await y({findPreview:!0}),m&&(yield m),m=await w({findPreview:!0}),m&&(yield m),m=await y({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=l(),m&&(yield m)}async function*p(){for await(const m of f())await m.exists()&&(yield m)}t.enumeratePowerShellInstallations=p;async function E(){for await(const m of p())return m;return null}t.getFirstAvailablePowerShellInstallation=E});var ge=this&&this.__decorate||function(j,t,D,R){var b=arguments.length,I=b<3?t:R===null?R=Object.getOwnPropertyDescriptor(t,D):R,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(j,t,D,R);else for(var P=j.length-1;P>=0;P--)(L=j[P])&&(I=(b<3?L(I):b>3?L(t,D,I):L(t,D))||I);return b>3&&I&&Object.defineProperty(t,D,I),I};define(Y[46],Q([0,1,18,3,17,24,44,8,7,2,61,26,6]),function(j,t,D,R,b,I,L,P,c,v,C,T,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var y;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(y=t.RequestType||(t.RequestType={}));function w(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(g=t.ResponseType||(t.ResponseType={}));function l(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(f||(f={}));class p{constructor(k){this.buffer=k,this.pos=0}read(k){const z=this.buffer.slice(this.pos,this.pos+k);return this.pos+=z.byteLength,z}}class E{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var m;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(m||(m={}));function o(U){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(U,0),k}function e(U){return U.read(4).readUInt32BE(0)}function s(U){const k=b.VSBuffer.alloc(1);return k.writeUInt8(U,0),k}const i={Undefined:s(m.Undefined),String:s(m.String),Buffer:s(m.Buffer),VSBuffer:s(m.VSBuffer),Array:s(m.Array),Object:s(m.Object)},n=typeof Buffer!="undefined";function r(U,k){if(typeof k=="undefined")U.write(i.Undefined);else if(typeof k=="string"){const z=b.VSBuffer.fromString(k);U.write(i.String),U.write(o(z.byteLength)),U.write(z)}else if(n&&Buffer.isBuffer(k)){const z=b.VSBuffer.wrap(k);U.write(i.Buffer),U.write(o(z.byteLength)),U.write(z)}else if(k instanceof b.VSBuffer)U.write(i.VSBuffer),U.write(o(k.byteLength)),U.write(k);else if(Array.isArray(k)){U.write(i.Array),U.write(o(k.length));for(const z of k)r(U,z)}else{const z=b.VSBuffer.fromString(JSON.stringify(k));U.write(i.Object),U.write(o(z.byteLength)),U.write(z)}}function a(U){switch(U.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return U.read(e(U)).toString();case m.Buffer:return U.read(e(U)).buffer;case m.VSBuffer:return U.read(e(U));case m.Array:{const z=e(U),G=[];for(let ne=0;ne<z;ne++)G.push(a(U));return G}case m.Object:return JSON.parse(U.read(e(U)).toString())}}class u{constructor(k,z,G=null,ne=1e3){this.protocol=k,this.ctx=z,this.logger=G,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(k,z){this.channels.set(k,z),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const z=this.send([k.type]);this.logger?.logOutgoing(z,0,1,l(k.type));return}case 201:case 202:case 204:case 203:{const z=this.send([k.type,k.id],k.data);this.logger?.logOutgoing(z,k.id,1,l(k.type),k.data);return}}}send(k,z=void 0){const G=new E;return r(G,k),r(G,z),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onRawMessage(k){const z=new p(k),G=a(z),ne=a(z),K=G[0];switch(K){case 100:return this.logger?.logIncoming(k.byteLength,G[1],1,`${w(K)}: ${G[2]}.${G[3]}`,ne),this.onPromise({type:K,id:G[1],channelName:G[2],name:G[3],arg:ne});case 102:return this.logger?.logIncoming(k.byteLength,G[1],1,`${w(K)}: ${G[2]}.${G[3]}`,ne),this.onEventListen({type:K,id:G[1],channelName:G[2],name:G[3],arg:ne});case 101:return this.logger?.logIncoming(k.byteLength,G[1],1,`${w(K)}`),this.disposeActiveRequest({type:K,id:G[1]});case 103:return this.logger?.logIncoming(k.byteLength,G[1],1,`${w(K)}`),this.disposeActiveRequest({type:K,id:G[1]})}}onPromise(k){const z=this.channels.get(k.channelName);if(!z){this.collectPendingRequest(k);return}const G=new I.CancellationTokenSource;let ne;try{ne=z.call(this.ctx,k.name,k.arg,G.token)}catch(q){ne=Promise.reject(q)}const K=k.id;ne.then(q=>{this.sendResponse({id:K,data:q,type:201}),this.activeRequests.delete(k.id)},q=>{q instanceof Error?this.sendResponse({id:K,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:K,data:q,type:203}),this.activeRequests.delete(k.id)});const Z=(0,v.toDisposable)(()=>G.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const z=this.channels.get(k.channelName);if(!z){this.collectPendingRequest(k);return}const G=k.id,K=z.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:G,data:Z,type:204}));this.activeRequests.set(k.id,K)}disposeActiveRequest(k){const z=this.activeRequests.get(k.id);z&&(z.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let z=this.pendingRequests.get(k.channelName);z||(z=[],this.pendingRequests.set(k.channelName,z));const G=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:k,timeoutTimer:G})}flushPendingRequests(k){const z=this.pendingRequests.get(k);if(z){for(const G of z)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=u;var h;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(h=t.RequestInitiator||(t.RequestInitiator={}));class S{constructor(k,z=null){this.protocol=k,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=z}getChannel(k){const z=this;return{call(G,ne,K){return z.isDisposed?Promise.reject(P.canceled()):z.requestPromise(k,G,ne,K)},listen(G,ne){return z.isDisposed?c.Event.None:z.requestEvent(k,G,ne)}}}requestPromise(k,z,G,ne=I.CancellationToken.None){const K=this.lastRequestId++,q={id:K,type:100,channelName:k,name:z,arg:G};if(ne.isCancellationRequested)return Promise.reject(P.canceled());let M;return new Promise((V,B)=>{if(ne.isCancellationRequested)return B(P.canceled());const H=()=>{const we=fe=>{switch(fe.type){case 201:this.handlers.delete(K),V(fe.data);break;case 202:{this.handlers.delete(K);const se=new Error(fe.data.message);se.stack=fe.data.stack,se.name=fe.data.name,B(se);break}case 203:this.handlers.delete(K),B(fe.data);break}};this.handlers.set(K,we),this.sendRequest(q)};let X=null;this.state===f.Idle?H():(X=(0,R.createCancelablePromise)(we=>this.whenInitialized()),X.then(()=>{X=null,H()}));const ae=()=>{X?(X.cancel(),X=null):this.sendRequest({id:K,type:101}),B(P.canceled())},ce=ne.onCancellationRequested(ae);M=(0,v.combinedDisposable)((0,v.toDisposable)(ae),ce),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(k,z,G){const ne=this.lastRequestId++,Z={id:ne,type:102,channelName:k,name:z,arg:G};let q=null;const M=new c.Emitter({onFirstListenerAdd:()=>{q=(0,R.createCancelablePromise)(V=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(M),this.sendRequest(Z)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(M),this.sendRequest({id:ne,type:103}))}}),A=V=>M.fire(V.data);return this.handlers.set(ne,A),M.event}sendRequest(k){switch(k.type){case 100:case 102:{const z=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(z,k.id,0,`${w(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const z=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(z,k.id,0,w(k.type));return}}}send(k,z=void 0){const G=new E;return r(G,k),r(G,z),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onBuffer(k){const z=new p(k),G=a(z),ne=a(z),K=G[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,l(K)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],0,l(K),ne),this.onResponse({type:G[0],id:G[1],data:ne})}}onResponse(k){if(k.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(k.id);z&&z(k)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,v.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([L.memoize],S.prototype,"onDidInitializePromise",null),t.ChannelClient=S;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:z,onDidClientDisconnect:G})=>{c.Event.once(z.onMessage)(K=>{const Z=new p(K),q=a(Z),M=new u(z,q),A=new S(z);this.channels.forEach((B,H)=>M.registerChannel(H,B));const V={channelServer:M,channelClient:A,ctx:q};this._connections.add(V),this._onDidAddConnection.fire(V),G(()=>{M.dispose(),A.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const k=[];return this._connections.forEach(z=>k.push(z)),k}getChannel(k,z){const G=this;return{call(ne,K,Z){let q;if((0,d.isFunction)(z)){let A=(0,D.getRandomElement)(G.connections.filter(z));q=A?Promise.resolve(A):c.Event.toPromise(c.Event.filter(G.onDidAddConnection,z))}else q=z.routeCall(G,ne,K);const M=q.then(A=>A.channelClient.getChannel(k));return _(M).call(ne,K,Z)},listen(ne,K){if((0,d.isFunction)(z))return G.getMulticastEvent(k,z,ne,K);const Z=z.routeEvent(G,ne,K).then(q=>q.channelClient.getChannel(k));return _(Z).listen(ne,K)}}}getMulticastEvent(k,z,G,ne){const K=this;let Z=new v.DisposableStore;const q=new c.Emitter({onFirstListenerAdd:()=>{Z=new v.DisposableStore;const M=new c.EventMultiplexer,A=new Map,V=H=>{const ae=H.channelClient.getChannel(k).listen(G,ne),ce=M.add(ae);A.set(H,ce)},B=H=>{const X=A.get(H);!X||(X.dispose(),A.delete(H))};K.connections.filter(z).forEach(V),c.Event.filter(K.onDidAddConnection,z)(V,void 0,Z),K.onDidRemoveConnection(B,void 0,Z),M.event(q.fire,q,Z),Z.add(M)},onLastListenerRemove:()=>{Z.dispose()}});return q.event}registerChannel(k,z){this.channels.set(k,z),this._connections.forEach(G=>{G.channelServer.registerChannel(k,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class N{constructor(k,z,G=null){const ne=new E;r(ne,z),k.send(ne.buffer),this.channelClient=new S(k,G),this.channelServer=new u(k,z,G)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,z){this.channelServer.registerChannel(k,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=N;function _(U){return{call(k,z,G){return U.then(ne=>ne.call(k,z,G))},listen(k,z){const G=new c.Relay;return U.then(ne=>G.input=ne.listen(k,z)),G.event}}}t.getDelayedChannel=_;function J(U){let k=!1;return{call(z,G,ne){return k?U.call(z,G,ne):(0,R.timeout)(0).then(()=>k=!0).then(()=>U.call(z,G,ne))},listen(z,G){if(k)return U.listen(z,G);const ne=new c.Relay;return(0,R.timeout)(0).then(()=>k=!0).then(()=>ne.input=U.listen(z,G)),ne.event}}}t.getNextTickChannel=J;class re{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const z of k.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await c.Event.toPromise(k.onDidAddConnection),await this.route(k)}}t.StaticRouter=re;var ee;(function(U){function k(K,Z){const q=K,M=Z&&Z.disableMarshalling,A=new Map;for(const V in q)G(V)&&A.set(V,c.Event.buffer(q[V],!0));return new class{listen(V,B,H){const X=A.get(B);if(X)return X;if(ne(B)){const ae=q[B];if(typeof ae=="function")return ae.call(q,H)}throw new Error(`Event not found: ${B}`)}call(V,B,H){const X=q[B];if(typeof X=="function"){if(!M&&Array.isArray(H))for(let ae=0;ae<H.length;ae++)H[ae]=(0,C.revive)(H[ae]);return X.apply(q,H)}throw new Error(`Method not found: ${B}`)}}}U.fromService=k;function z(K,Z){const q=Z&&Z.disableMarshalling;return new Proxy({},{get(M,A){if(typeof A=="string")return Z?.properties?.has(A)?Z.properties.get(A):ne(A)?function(V){return K.listen(A,V)}:G(A)?K.listen(A):async function(...V){let B;Z&&!(0,d.isUndefinedOrNull)(Z.context)?B=[Z.context,...V]:B=V;const H=await K.call(A,B);return q?H:(0,C.revive)(H)};throw new Error(`Property not found: ${String(A)}`)}})}U.toService=z;function G(K){return K[0]==="o"&&K[1]==="n"&&T.isUpperAsciiLetter(K.charCodeAt(2))}function ne(K){return/^onDynamic/.test(K)&&T.isUpperAsciiLetter(K.charCodeAt(9))}})(ee=t.ProxyChannel||(t.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let k=U.toString();if(k!=="[object Object]")return k}return U}function ue(U){return Array.isArray(U)?U.map(he):he(U)}function x(U,k,z,G,ne,K,Z){Z=ue(Z);const q=ie[ne],M=q[G%q.length];let A=[`%c[${U}]%c[${String(k).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(K)?(A=A.concat(Z),A.push(")")):A.push(Z),console.log.apply(console,A)}t.logWithColors=x;class te{constructor(k,z){this._outgoingPrefix=k,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,z,G,ne,K){this._totalOutgoing+=k,x(this._outgoingPrefix,this._totalOutgoing,k,z,G,ne,K)}logIncoming(k,z,G,ne,K){this._totalIncoming+=k,x(this._incomingPrefix,this._totalIncoming,k,z,G,ne,K)}}t.IPCLogger=te}),define(Y[65],Q([0,1,3,7,2,6]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var L;(function(T){T[T.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=t.StorageHint||(t.StorageHint={}));function P(T){const d=T;return d?.changed instanceof Map||d?.deleted instanceof Set}t.isStorageItemsChangeEvent=P;var c;(function(T){T[T.None=0]="None",T[T.Initialized=1]="Initialized",T[T.Closed=2]="Closed"})(c||(c={}));class v extends b.Disposable{constructor(d,y=Object.create(null)){super();this.database=d,this.options=y,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((y,w)=>this.accept(w,y)),d.deleted?.forEach(y=>this.accept(y,void 0))}accept(d,y){if(this.state===c.Closed)return;let w=!1;(0,I.isUndefinedOrNull)(y)?w=this.cache.delete(d):this.cache.get(d)!==y&&(this.cache.set(d,y),w=!0),w&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,y){const w=this.cache.get(d);return(0,I.isUndefinedOrNull)(w)?y:w}getBoolean(d,y){const w=this.get(d);return(0,I.isUndefinedOrNull)(w)?y:w==="true"}getNumber(d,y){const w=this.get(d);return(0,I.isUndefinedOrNull)(w)?y:parseInt(w,10)}async set(d,y){if(this.state===c.Closed)return;if((0,I.isUndefinedOrNull)(y))return this.delete(d);const w=String(y);if(this.cache.get(d)!==w)return this.cache.set(d,w),this.pendingInserts.set(d,w),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===c.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((y,w)=>this.items.set(w,y)),d.delete&&d.delete.forEach(y=>this.items.delete(y))}async close(){}}t.InMemoryStorageDatabase=C}),define(Y[66],Q([4,5]),function(j,t){return j.create("vs/base/common/date",t)}),define(Y[67],Q([0,1,66]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const R=60,b=R*60,I=b*24,L=I*7,P=I*30,c=I*365;function v(T,d,y){typeof T!="number"&&(T=T.getTime());const w=Math.round((new Date().getTime()-T)/1e3);if(w<-30)return(0,D.localize)(0,null,v(new Date().getTime()+w*1e3,!1));if(w<30)return(0,D.localize)(1,null);let g;return w<R?(g=w,d?g===1?y?(0,D.localize)(2,null,g):(0,D.localize)(3,null,g):y?(0,D.localize)(4,null,g):(0,D.localize)(5,null,g):g===1?y?(0,D.localize)(6,null,g):(0,D.localize)(7,null,g):y?(0,D.localize)(8,null,g):(0,D.localize)(9,null,g)):w<b?(g=Math.floor(w/R),d?g===1?y?(0,D.localize)(10,null,g):(0,D.localize)(11,null,g):y?(0,D.localize)(12,null,g):(0,D.localize)(13,null,g):g===1?y?(0,D.localize)(14,null,g):(0,D.localize)(15,null,g):y?(0,D.localize)(16,null,g):(0,D.localize)(17,null,g)):w<I?(g=Math.floor(w/b),d?g===1?y?(0,D.localize)(18,null,g):(0,D.localize)(19,null,g):y?(0,D.localize)(20,null,g):(0,D.localize)(21,null,g):g===1?y?(0,D.localize)(22,null,g):(0,D.localize)(23,null,g):y?(0,D.localize)(24,null,g):(0,D.localize)(25,null,g)):w<L?(g=Math.floor(w/I),d?g===1?(0,D.localize)(26,null,g):(0,D.localize)(27,null,g):g===1?(0,D.localize)(28,null,g):(0,D.localize)(29,null,g)):w<P?(g=Math.floor(w/L),d?g===1?y?(0,D.localize)(30,null,g):(0,D.localize)(31,null,g):y?(0,D.localize)(32,null,g):(0,D.localize)(33,null,g):g===1?y?(0,D.localize)(34,null,g):(0,D.localize)(35,null,g):y?(0,D.localize)(36,null,g):(0,D.localize)(37,null,g)):w<c?(g=Math.floor(w/P),d?g===1?y?(0,D.localize)(38,null,g):(0,D.localize)(39,null,g):y?(0,D.localize)(40,null,g):(0,D.localize)(41,null,g):g===1?y?(0,D.localize)(42,null,g):(0,D.localize)(43,null,g):y?(0,D.localize)(44,null,g):(0,D.localize)(45,null,g)):(g=Math.floor(w/c),d?g===1?y?(0,D.localize)(46,null,g):(0,D.localize)(47,null,g):y?(0,D.localize)(48,null,g):(0,D.localize)(49,null,g):g===1?y?(0,D.localize)(50,null,g):(0,D.localize)(51,null,g):y?(0,D.localize)(52,null,g):(0,D.localize)(53,null,g))}t.fromNow=v;function C(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=C}),define(Y[68],Q([4,5]),function(j,t){return j.create("vs/base/common/errorMessage",t)}),define(Y[28],Q([0,1,18,6,68]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.toErrorMessage=void 0;function I(T,d){return d&&(T.stack||T.stacktrace)?b.localize(0,null,P(T),L(T.stack)||L(T.stacktrace)):P(T)}function L(T){return Array.isArray(T)?T.join(`
`):T}function P(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?b.localize(1,null,T.message):T.message||b.localize(2,null)}function c(T=null,d=!1){if(!T)return b.localize(3,null);if(Array.isArray(T)){const y=D.coalesce(T),w=c(y[0],d);return y.length>1?b.localize(4,null,w,y.length):w}if(R.isString(T))return T;if(T.detail){const y=T.detail;if(y.error)return I(y.error,d);if(y.exception)return I(y.exception,d)}return T.stack?I(T,d):T.message?T.message:b.localize(5,null)}t.toErrorMessage=c;function v(T){const d=T;return d instanceof Error&&Array.isArray(d.actions)}t.isErrorWithActions=v;function C(T,d=Object.create(null)){const y=new Error(T);return d.actions&&(y.actions=d.actions),y}t.createErrorWithActions=C}),define(Y[69],Q([4,5]),function(j,t){return j.create("vs/base/node/processes",t)}),define(Y[47],Q([0,1,39,45,10,22,11,12,29,57,6,63,15,69]),function(j,t,D,R,b,I,L,P,c,v,C,T,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return v.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return v.TerminateResponseCode}});function w(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(e,s){if(P.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};s&&(i.cwd=s);const n=D.execFile("taskkill",["/T","/F","/PID",e.pid.toString()],i);return new Promise(r=>{n.once("error",a=>{r({success:!1,error:a})}),n.once("exit",(a,u)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?w(i.status):1})}else if(P.isLinux||P.isMacintosh)try{const i=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(n=>{D.execFile(i,[e.pid.toString()],{encoding:"utf8",shell:!0},(r,a,u)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else e.kill("SIGKILL");return Promise.resolve({success:!0})}function l(e){!e||(delete e.DEBUG,P.isMacintosh&&delete e.DYLD_LIBRARY_PATH,P.isLinux&&delete e.LD_PRELOAD)}t.removeDangerousEnvVariables=l;function f(e=c.env){return e.comspec||"cmd.exe"}t.getWindowsShell=f;class p{constructor(s,i,n,r){if(i!==void 0&&n!==void 0&&r!==void 0)this.cmd=s,this.args=i,this.shell=n,this.options=r;else{const a=s;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(c.env).forEach(u=>{a[u]=c.env[u]}),Object.keys(this.options.env).forEach(u=>{a[u]=this.options.env[u]}),this.options.env=a}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const i=s.lastIndexOf(L.sep);return i!==-1&&(s=s.substring(i+1)),p.WellKnowCommands[s]?s:"other"}start(s){return P.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(c.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(i=>{let n,r;const a=new Promise((u,h)=>{n=u,r=h});if(i){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=D.exec(u,this.options,(h,S,O)=>{this.childProcess=null;const N=h;N&&N.killed?r({killed:this.terminateRequested,stdout:S.toString(),stderr:O.toString()}):this.handleExec(n,s,h,S,O)})}else{let u=null;const h=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,n,s,r);const O={terminated:this.terminateRequested};C.isNumber(S)&&(O.cmdCode=S),n(O)};if(this.shell&&P.isWindows){const S=I.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let O=!1,N=!1;const _=[];let J=this.ensureQuotes(this.cmd);_.push(J.value),O=J.quoted,this.args&&this.args.forEach(ee=>{J=this.ensureQuotes(ee),_.push(J.value),N=N&&J.quoted});const re=["/s","/c"];O?N?re.push('"'+_.join(" ")+'"'):_.length>1?re.push('"'+_[0]+'" '+_.slice(1).join(" ")):re.push('"'+_[0]+'"'):re.push(_.join(" ")),u=D.spawn(f(),re,S)}else this.cmd&&(u=D.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(C.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",S=>{this.childProcess=null,r({terminated:this.terminateRequested,error:S})}),u.pid&&(this.childProcess.on("close",h),this.handleSpawn(u,n,s,r,!0)))}return a})}handleClose(s,i,n,r){}ensureQuotes(s){return p.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,g(s,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!P.isWindows)return s(!1);const i=D.spawn(f(),["/s","/c"]);i.on("error",n=>s(!0)),i.on("exit",n=>s(!1))})}}t.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class E extends p{constructor(s,i,n,r){super(s,i,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,i,n,r,a){[r,a].forEach((u,h)=>{const S=new T.LineDecoder;S.write(u).forEach(_=>{i({line:_,source:h===0?0:1})});const N=S.end();N&&i({line:N,source:h===0?0:1})}),s({terminated:this.terminateRequested,error:n})}handleSpawn(s,i,n,r,a){const u=new T.LineDecoder,h=new T.LineDecoder;s.stdout.on("data",S=>{u.write(S).forEach(N=>n({line:N,source:0}))}),s.stderr.on("data",S=>{h.write(S).forEach(N=>n({line:N,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=h}handleClose(s,i,n,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&n({line:u,source:1})}}t.LineProcess=E;function m(e){let s=[],i=!1;const n=function(r){if(i){s.push(r);return}(!e.send(r,u=>{if(u&&console.error(u),i=!1,s.length>0){const h=s.slice(0);s=[],h.forEach(S=>n(S))}})||P.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=m;var o;(function(e){async function s(i,n,r){if(L.isAbsolute(i))return i;if(n===void 0&&(n=c.cwd()),L.dirname(i)!=="."||(r===void 0&&C.isString(c.env.PATH)&&(r=c.env.PATH.split(L.delimiter)),r===void 0||r.length===0))return L.join(n,i);async function u(h){if(await d.Promises.exists(h)){let S;try{S=await d.Promises.stat(h)}catch(O){O.message.startsWith("EACCES")&&(S=await d.Promises.lstat(h))}return S?!S.isDirectory():!1}return!1}for(let h of r){let S;if(L.isAbsolute(h)?S=L.join(h,i):S=L.join(n,h,i),await u(S))return S;let O=S+".com";if(await u(O)||(O=S+".exe",await u(O)))return O}return L.join(n,i)}e.findExecutable=s})(o=t.win32||(t.win32={}))}),define(Y[70],Q([0,1,33,12,64,47]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function L(y,w){return y===1?R.isWindows?T():I.getWindowsShell(w):v(y,w)}t.getSystemShell=L;function P(y,w){return y===1?R.isWindows?d(w):I.getWindowsShell(w):v(y,w)}t.getSystemShellSync=P;let c=null;function v(y,w){if(R.isLinux&&y===2||R.isMacintosh&&y===3)return"/bin/bash";if(!c){let g;if(R.isWindows)g="/bin/bash";else{if(g=w.SHELL,!g)try{g=(0,D.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}c=g}return c}let C=null;async function T(){return C||(C=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),C}function d(y){if(C)return C;const w=R.isWindows&&parseFloat((0,D.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),l=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return w?l:I.getWindowsShell(y)}}),define(Y[71],Q([0,1,39,3,17,24,60,8,7,2,22,47,46]),function(j,t,D,R,b,I,L,P,c,v,C,T,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class y extends d.ChannelServer{constructor(l){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",f=>b.VSBuffer.wrap(Buffer.from(f,"base64")))},l);process.once("disconnect",()=>this.dispose())}}t.Server=y;class w{constructor(l,f){this.modulePath=l,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new R.Delayer(p),this.child=null,this._client=null}getChannel(l){const f=this;return{call(p,E,m){return f.requestPromise(l,p,E,m)},listen(p,E){return f.requestEvent(l,p,E)}}}requestPromise(l,f,p,E=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const m=this.getCachedChannel(l),o=(0,R.createCancelablePromise)(i=>m.call(f,p,i)),e=E.onCancellationRequested(()=>o.cancel()),s=(0,v.toDisposable)(()=>o.cancel());return this.activeRequests.add(s),o.finally(()=>{e.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(l,f,p){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let E;const m=new c.Emitter({onFirstListenerAdd:()=>{E=this.getCachedChannel(l).listen(f,p)(m.fire,m),this.activeRequests.add(E)},onLastListenerRemove:()=>{this.activeRequests.delete(E),E.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return m.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,T.removeDangerousEnvVariables)(f.env),this.child=(0,D.fork)(this.modulePath,l,f);const p=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,L.isRemoteConsoleLog)(n)){(0,L.log)(n,`IPC Library: ${this.options.serverName}`);return}p.fire(b.VSBuffer.wrap(Buffer.from(n,"base64")))});const m=this.options.useQueue?(0,T.createQueuedSender)(this.child):this.child,o=n=>this.child&&this.child.connected&&m.send(n.buffer.toString("base64")),e=p.event,s={send:o,onMessage:e};this._client=new d.ChannelClient(s);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,r)=>{process.removeListener("exit",i),this.activeRequests.forEach(a=>(0,v.dispose)(a)),this.activeRequests.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:r})})}return this._client}getCachedChannel(l){let f=this.channels.get(l);return f||(f=this.client.getChannel(l),this.channels.set(l,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=w}),define(Y[72],Q([4,5]),function(j,t){return j.create("vs/base/node/zip",t)}),define(Y[73],Q([4,5]),function(j,t){return j.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Y[74],Q([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Y[75],Q([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Y[76],Q([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Y[77],Q([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Y[78],Q([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Y[79],Q([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Y[80],Q([4,5]),function(j,t){return j.create("vs/platform/extensions/common/extensionValidator",t)}),define(Y[81],Q([4,5]),function(j,t){return j.create("vs/platform/files/common/fileService",t)}),define(Y[82],Q([4,5]),function(j,t){return j.create("vs/platform/files/common/io",t)}),define(Y[83],Q([4,5]),function(j,t){return j.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Y[84],Q([4,5]),function(j,t){return j.create("vs/platform/request/common/request",t)}),define(Y[85],Q([4,5]),function(j,t){return j.create("vs/platform/telemetry/common/telemetryService",t)}),define(Y[86],Q([4,5]),function(j,t){return j.create("vs/platform/terminal/node/shellEnv",t)}),define(Y[87],Q([0,1,67,44,10,11,29,19,9]),function(j,t,D,R,b,I,L,P,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class v{constructor(g,l,f){this._args=g,this.paths=l,this.productService=f}get appRoot(){return(0,I.dirname)(b.FileAccess.asFileUri("",j).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get cacheHome(){return c.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(c.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=L.env.VSCODE_PORTABLE;return g?c.URI.file((0,I.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,I.resolve)(g):(0,I.normalize)((0,I.join)(b.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,I.resolve)(g):(0,I.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,I.resolve)(g);const l=L.env.VSCODE_EXTENSIONS;if(l)return l;const f=L.env.VSCODE_PORTABLE;return f?(0,I.join)(f,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(l=>/^[^:/?#]+?:\/\//.test(l)?c.URI.parse(l):c.URI.file((0,I.normalize)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?c.URI.parse(g):c.URI.file((0,I.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ge([R.memoize],v.prototype,"appRoot",null),ge([R.memoize],v.prototype,"userHome",null),ge([R.memoize],v.prototype,"userDataPath",null),ge([R.memoize],v.prototype,"appSettingsHome",null),ge([R.memoize],v.prototype,"tmpDir",null),ge([R.memoize],v.prototype,"cacheHome",null),ge([R.memoize],v.prototype,"userRoamingDataHome",null),ge([R.memoize],v.prototype,"settingsResource",null),ge([R.memoize],v.prototype,"userDataSyncHome",null),ge([R.memoize],v.prototype,"userDataSyncLogResource",null),ge([R.memoize],v.prototype,"sync",null),ge([R.memoize],v.prototype,"machineSettingsResource",null),ge([R.memoize],v.prototype,"globalStorageHome",null),ge([R.memoize],v.prototype,"workspaceStorageHome",null),ge([R.memoize],v.prototype,"keybindingsResource",null),ge([R.memoize],v.prototype,"keyboardLayoutResource",null),ge([R.memoize],v.prototype,"argvResource",null),ge([R.memoize],v.prototype,"snippetsHome",null),ge([R.memoize],v.prototype,"isExtensionDevelopment",null),ge([R.memoize],v.prototype,"untitledWorkspacesHome",null),ge([R.memoize],v.prototype,"installSourcePath",null),ge([R.memoize],v.prototype,"builtinExtensionsPath",null),ge([R.memoize],v.prototype,"extensionsPath",null),ge([R.memoize],v.prototype,"extensionDevelopmentLocationURI",null),ge([R.memoize],v.prototype,"extensionDevelopmentKind",null),ge([R.memoize],v.prototype,"extensionTestsLocationURI",null),ge([R.memoize],v.prototype,"debugExtensionHost",null),ge([R.memoize],v.prototype,"serviceMachineIdResource",null),ge([R.memoize],v.prototype,"telemetryLogResource",null),ge([R.memoize],v.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=v;function C(w,g){return y(w["inspect-extensions"],w["inspect-brk-extensions"],5870,g,w.debugId,w.extensionEnvironment)}t.parseExtensionHostPort=C;function T(w,g){return y(w["inspect-search"],w["inspect-brk-search"],5876,g,w.extensionEnvironment)}t.parseSearchPort=T;function d(w,g){return y(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,g,w.extensionEnvironment)}t.parsePtyHostPort=d;function y(w,g,l,f,p,E){const o=Number(g||w)||(f?null:l),e=o?Boolean(!!g):!1;let s;if(E)try{s=JSON.parse(E)}catch{}return{port:o,break:e,debugId:p,env:s}}}),function(){"use strict";function j(t,D,R,b){function I(P){const c=L(P),v=[c];return t.isAbsolute(c)||v.unshift(b),t.resolve(...v)}function L(P){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return t.join(v,R);const C=P["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const T=process.env.USERPROFILE;if(typeof T!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=t.join(T,"AppData","Roaming")}break;case"darwin":v=t.join(D.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||t.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(v,R)}return{getUserDataPath:I}}if(typeof define=="function")define(Y[88],Q([0,133,33,10,19,29]),function(t,D,R,b,I,L){const P=I.dirname(b.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(I.joinPath(P,"package.json").fsPath);return j(D,R,c.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),D=require("path"),R=require("os");module.exports=j(D,R,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[89],Q([0,1,33,87,88]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class I extends R.AbstractNativeEnvironmentService{constructor(P,c){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,b.getUserDataPath)(P)},c)}}t.NativeEnvironmentService=I}),define(Y[90],Q([0,1,22]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const R=/^%([\w\d.-]+)%$/i;function b(I,L){const P=c=>{if(typeof c!="string")return;const v=R.exec(c);if(!v)return;const C=L[v[1]]??c;return typeof C=="string"?C:typeof C.message=="string"?C.message:c};return(0,D.cloneAndChange)(I,P)}t.localizeManifest=b}),define(Y[48],Q([0,1,80]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function I(d){return d=d.trim(),d==="*"||R.test(d)}t.isValidVersionStr=I;function L(d){if(!I(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=d.match(R);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}t.parseVersion=L;function P(d){if(!d)return null;let y=d.majorBase,w=d.majorMustEqual,g=d.minorBase,l=d.minorMustEqual,f=d.patchBase,p=d.patchMustEqual;d.hasCaret&&(y===0||(l=!1),p=!1);let E=0;if(d.preRelease){const m=b.exec(d.preRelease);if(m){const[,o,e,s]=m;E=Date.UTC(Number(o),Number(e)-1,Number(s))}}return{majorBase:y,majorMustEqual:w,minorBase:g,minorMustEqual:l,patchBase:f,patchMustEqual:p,isMinimum:d.hasGreaterEquals,notBefore:E}}t.normalizeVersion=P;function c(d,y,w){let g;typeof d=="string"?g=P(L(d)):g=d;let l;y instanceof Date?l=y.getTime():typeof y=="string"&&(l=new Date(y).getTime());let f;if(typeof w=="string"?f=P(L(w)):f=w,!g||!f)return!1;let p=g.majorBase,E=g.minorBase,m=g.patchBase,o=f.majorBase,e=f.minorBase,s=f.patchBase,i=f.notBefore,n=f.majorMustEqual,r=f.minorMustEqual,a=f.patchMustEqual;return f.isMinimum?p>o?!0:p<o?!1:E>e?!0:E<e||l&&l<i?!1:m>=s:(p===1&&o===0&&(!n||!r||!a)&&(o=1,e=0,s=0,n=!0,r=!1,a=!1),p<o?!1:p>o?!n:E<e?!1:E>e?!r:m<s?!1:m>s?!a:!(l&&l<i))}t.isValidVersion=c;function v(d,y,w,g){return w.isBuiltin||typeof w.main=="undefined"?!0:T(d,y,w.engines.vscode,g)}t.isValidExtensionVersion=v;function C(d,y,w){return d==="*"||T(y,w,d)}t.isEngineValid=C;function T(d,y,w,g=[]){let l=P(L(w));if(!l)return g.push(D.localize(0,null,w)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return g.push(D.localize(1,null,w)),!1}else if(!l.majorMustEqual)return g.push(D.localize(2,null,w)),!1;return c(d,y,l)?!0:(g.push(D.localize(3,null,d,w)),!1)}}),define(Y[91],Q([0,1,17,27]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(I,L,P){let c=P&&P.get("storage.serviceMachineId",0)||null;if(c)return c;try{const C=(await L.readFile(I.serviceMachineIdResource)).value.toString();c=(0,R.isUUID)(C)?C:null}catch{c=null}if(!c){c=(0,R.generateUuid)();try{await L.writeFile(I.serviceMachineIdResource,D.VSBuffer.fromString(c))}catch{}}return P&&P.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=b}),define(Y[40],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class D{constructor(b,I=[],L=!1){this.ctor=b,this.staticArguments=I,this.supportsDelayedInstantiation=L}}t.SyncDescriptor=D}),define(Y[92],Q([0,1,40]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const R=[];function b(L,P,c){P instanceof D.SyncDescriptor||(P=new D.SyncDescriptor(P,[],c)),R.push([L,P])}t.registerSingleton=b;function I(){return R}t.getSingletonServiceDescriptors=I}),define(Y[93],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class D{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}t.Node=D;class R{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let L of this._nodes.values())L.outgoing.size===0&&I.push(L);return I}insertEdge(I,L){const P=this.lookupOrInsertNode(I),c=this.lookupOrInsertNode(L);P.outgoing.set(this._hashFn(L),c),c.incoming.set(this._hashFn(I),P)}removeNode(I){const L=this._hashFn(I);this._nodes.delete(L);for(let P of this._nodes.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(I){const L=this._hashFn(I);let P=this._nodes.get(L);return P||(P=new D(I),this._nodes.set(L,P)),P}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[L,P]of this._nodes)I.push(`${L}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,L]of this._nodes){const P=new Set([I]),c=this._findCycle(L,P);if(c)return c}}_findCycle(I,L){for(let[P,c]of I.outgoing){if(L.has(P))return[...L,P].join(" -> ");L.add(P);const v=this._findCycle(c,L);if(v)return v;L.delete(P)}}}t.Graph=R}),define(Y[25],Q([0,1,6,9,13]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationUpdateOverrides=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,b.createDecorator)("configurationService");function I(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof R.URI)}t.isConfigurationOverrides=I;function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||D.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof R.URI)}t.isConfigurationUpdateOverrides=L;var P;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(P=t.ConfigurationTarget||(t.ConfigurationTarget={}));function c(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=c;function v(l,f){const p=Object.create(null);for(let E in l)C(p,E,l[E],f);return p}t.toValuesTree=v;function C(l,f,p,E){const m=f.split("."),o=m.pop();let e=l;for(let s=0;s<m.length;s++){let i=m[s],n=e[i];switch(typeof n){case"undefined":n=e[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${f} as ${m.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}e=n}if(typeof e=="object"&&e!==null)try{e[o]=p}catch{E(`Ignoring ${f} as ${m.join(".")} is ${JSON.stringify(e)}`)}else E(`Ignoring ${f} as ${m.join(".")} is ${JSON.stringify(e)}`)}t.addToValueTree=C;function T(l,f){const p=f.split(".");d(l,p)}t.removeFromValueTree=T;function d(l,f){const p=f.shift();if(f.length===0){delete l[p];return}if(Object.keys(l).indexOf(p)!==-1){const E=l[p];typeof E=="object"&&!Array.isArray(E)&&(d(E,f),Object.keys(E).length===0&&delete l[p])}}function y(l,f,p){function E(e,s){let i=e;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const m=f.split("."),o=E(l,m);return typeof o=="undefined"?p:o}t.getConfigurationValue=y;function w(l,f,p){Object.keys(f).forEach(E=>{E!=="__proto__"&&(E in l?D.isObject(l[E])&&D.isObject(f[E])?w(l[E],f[E],p):p&&(l[E]=f[E]):l[E]=f[E])})}t.merge=w;function g(l,f,p){const E=l.inspect(f),m=l.inspect(p);return typeof E.userValue!="undefined"||typeof E.workspaceValue!="undefined"||typeof E.workspaceFolderValue!="undefined"?E.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:E.defaultValue}t.getMigratedSettingValue=g}),define(Y[49],Q([0,1,13]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Y[20],Q([0,1,13]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,D.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,D.refineServiceDecorator)(t.IEnvironmentService)}),define(Y[50],Q([0,1,17,8,82,16]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(C,T,d,y,w,g){let l;try{await P(C,T,d,y,w,g)}catch(f){l=f}finally{l&&w.errorTransformer&&(l=w.errorTransformer(l)),typeof l!="undefined"&&d.error(l),d.end()}}t.readFileIntoStream=L;async function P(C,T,d,y,w,g){c(g);const l=await C.open(T,{create:!1});try{c(g);let f=0,p=0,E=w&&typeof w.length=="number"?w.length:void 0,m=D.VSBuffer.alloc(Math.min(w.bufferSize,typeof E=="number"?E:w.bufferSize)),o=w&&typeof w.position=="number"?w.position:0,e=0;do p=await C.read(l,o,m.buffer,e,m.byteLength-e),o+=p,e+=p,f+=p,typeof E=="number"&&(E-=p),e===m.byteLength&&(await d.write(y(m)),m=D.VSBuffer.alloc(Math.min(w.bufferSize,typeof E=="number"?E:w.bufferSize)),e=0);while(p>0&&(typeof E!="number"||E>0)&&c(g)&&v(f,w));if(e>0){let s=e;typeof E=="number"&&(s=Math.min(e,E)),d.write(y(m.slice(0,s)))}}catch(f){throw(0,I.ensureFileSystemProviderError)(f)}finally{await C.close(l)}}function c(C){if(C.isCancellationRequested)throw(0,R.canceled)();return!0}function v(C,T){if(T?.limits){if(typeof T.limits.memory=="number"&&C>T.limits.memory)throw(0,I.createFileSystemProviderError)((0,b.localize)(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof T.limits.size=="number"&&C>T.limits.size)throw(0,I.createFileSystemProviderError)((0,b.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[94],Q([0,1,18,7,2,12,134]),function(j,t,D,R,b,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcher=void 0;class P extends b.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(v){const C=this.normalizeRequests(v),T=C.filter(y=>{const w=this.watchers.get(y.path);return w?!(0,D.equals)(w.request.excludes,y.excludes):!0}),d=Array.from(this.watchers.values()).filter(({request:y})=>!C.find(w=>w.path===y.path&&(0,D.equals)(w.excludes,y.excludes))).map(({request:y})=>y.path);T.length&&this.trace(`Request to start watching: ${T.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"})`).join(",")}`),d.length&&this.trace(`Request to stop watching: ${d.join(",")}`);for(const y of d)this.stopWatching(y);for(const y of T)this.startWatching(y)}startWatching(v){const C=new L.NodeJSFileWatcherLibrary(v,d=>this._onDidChangeFile.fire(d),d=>this._onDidLogMessage.fire(d),this.verboseLogging),T={request:v,instance:C};this.watchers.set(v.path,T)}async stop(){for(const[v]of this.watchers)this.stopWatching(v);this.watchers.clear()}stopWatching(v){const C=this.watchers.get(v);C&&(this.watchers.delete(v),C.instance.dispose())}normalizeRequests(v){const C=new Map;for(const T of v){const d=I.isLinux?T.path:T.path.toLowerCase();C.set(d,T)}return Array.from(C.values())}async setVerboseLogging(v){this.verboseLogging=v;for(const[,C]of this.watchers)C.instance.setVerboseLogging(v)}trace(v){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(v)})}toMessage(v,C){return C?`[File Watcher (node.js)] ${v} (path: ${C.request.path})`:`[File Watcher (node.js)] ${v}`}}t.NodeJSWatcher=P}),define(Y[95],Q([0,1,51,94]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcherClient=void 0;class b extends D.AbstractNonRecursiveWatcherClient{constructor(L,P,c){super(L,P,c);this.init()}createWatcher(){return new R.NodeJSWatcher}}t.NodeJSWatcherClient=b}),define(Y[96],Q([0,1,10,46,71,51]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UniversalWatcherClient=void 0;class L extends I.AbstractUniversalWatcherClient{constructor(c,v,C){super(c,v,C);this.init()}createWatcher(c){const v=c.add(new b.Client(D.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(v.onDidProcessExit(({code:C,signal:T})=>this.onError(`terminated by itself with code ${C}, signal: ${T}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(v.getChannel("watcher")))}}t.UniversalWatcherClient=L}),define(Y[52],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class D{constructor(...b){this._entries=new Map;for(let[I,L]of b)this.set(I,L)}set(b,I){const L=this._entries.get(b);return this._entries.set(b,I),L}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=D}),define(Y[97],Q([0,1,3,8,40,93,13,52]),function(j,t,D,R,b,I,L,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Trace=t.InstantiationService=void 0;const c=!1;class v extends Error{constructor(w){super("cyclic dependency between services");this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class C{constructor(w=new P.ServiceCollection,g=!1,l){this._activeInstantiations=new Set,this._services=w,this._strict=g,this._parent=l,this._services.set(L.IInstantiationService,this)}createChild(w){return new C(w,this._strict,this)}invokeFunction(w,...g){let l=d.traceInvocation(w),f=!1;try{return w({get:E=>{if(f)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(E,l);if(!m)throw new Error(`[invokeFunction] unknown service '${E}'`);return m}},...g)}finally{f=!0,l.stop()}}createInstance(w,...g){let l,f;return w instanceof b.SyncDescriptor?(l=d.traceCreation(w.ctor),f=this._createInstance(w.ctor,w.staticArguments.concat(g),l)):(l=d.traceCreation(w),f=this._createInstance(w,g,l)),l.stop(),f}_createInstance(w,g=[],l){let f=L._util.getServiceDependencies(w).sort((m,o)=>m.index-o.index),p=[];for(const m of f){let o=this._getOrCreateServiceInstance(m.id,l);o||this._throwIfStrict(`[createInstance] ${w.name} depends on UNKNOWN service ${m.id}.`,!1),p.push(o)}let E=f.length>0?f[0].index:g.length;if(g.length!==E){console.warn(`[createInstance] First service dependency of ${w.name} at position ${E+1} conflicts with ${g.length} static arguments`);let m=E-g.length;m>0?g=g.concat(new Array(m)):g=g.slice(0,E)}return new w(...[...g,...p])}_setServiceInstance(w,g){if(this._services.get(w)instanceof b.SyncDescriptor)this._services.set(w,g);else if(this._parent)this._parent._setServiceInstance(w,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(w){let g=this._services.get(w);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(w):g}_getOrCreateServiceInstance(w,g){let l=this._getServiceInstanceOrDescriptor(w);return l instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(w,l,g.branch(w,!0)):(g.branch(w,!1),l)}_safeCreateAndCacheServiceInstance(w,g,l){if(this._activeInstantiations.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this._activeInstantiations.add(w);try{return this._createAndCacheServiceInstance(w,g,l)}finally{this._activeInstantiations.delete(w)}}_createAndCacheServiceInstance(w,g,l){const f=new I.Graph(m=>m.id.toString());let p=0;const E=[{id:w,desc:g,_trace:l}];for(;E.length;){const m=E.pop();if(f.lookupOrInsertNode(m),p++>1e3)throw new v(f);for(let o of L._util.getServiceDependencies(m.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(o.id);if(e||this._throwIfStrict(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),e instanceof b.SyncDescriptor){const s={id:o.id,desc:e,_trace:m._trace.branch(o.id,!0)};f.insertEdge(m,s),E.push(s)}}}for(;;){const m=f.roots();if(m.length===0){if(!f.isEmpty())throw new v(f);break}for(const{data:o}of m){if(this._getServiceInstanceOrDescriptor(o.id)instanceof b.SyncDescriptor){const s=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,s)}f.removeNode(o)}}return this._getServiceInstanceOrDescriptor(w)}_createServiceInstanceWithOwner(w,g,l=[],f,p){if(this._services.get(w)instanceof b.SyncDescriptor)return this._createServiceInstance(g,l,f,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(w,g,l,f,p);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(w,g=[],l,f){if(l){const p=new D.IdleValue(()=>this._createInstance(w,g,f));return new Proxy(Object.create(null),{get(E,m){if(m in E)return E[m];let o=p.value,e=o[m];return typeof e!="function"||(e=e.bind(o),E[m]=e),e},set(E,m,o){return p.value[m]=o,!0}})}else return this._createInstance(w,g,f)}_throwIfStrict(w,g){if(g&&console.warn(g),this._strict)throw new Error(w)}}t.InstantiationService=C;var T;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(T||(T={}));class d{constructor(w,g){this.type=w,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(w){return c?new d(1,w.name||w.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(w){return c?new d(0,w.name):d._None}branch(w,g){let l=new d(2,w.toString());return this._dep.push([w,g,l]),l}stop(){let w=Date.now()-this._start;d._totals+=w;let g=!1;function l(p,E){let m=[],o=new Array(p+1).join("	");for(const[e,s,i]of E._dep)if(s&&i){g=!0,m.push(`${o}CREATES -> ${e}`);let n=l(p+1,i);n&&m.push(n)}else m.push(`${o}uses -> ${e}`);return m.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(w>2||g)&&console.log(f.join(`
`))}}t.Trace=d,d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(Y[53],Q([0,1,13]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,D.createDecorator)("localizationsService");function R(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const I of b.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}t.isValidLocalization=R}),define(Y[14],Q([0,1,28,7,2,12,13]),function(j,t,D,R,b,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logCi=t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,L.createDecorator)("logService"),t.ILoggerService=(0,L.createDecorator)("loggerService");function P(){return new Date().toISOString()}var c;(function(i){i[i.Trace=0]="Trace",i[i.Debug=1]="Debug",i[i.Info=2]="Info",i[i.Warning=3]="Warning",i[i.Error=4]="Error",i[i.Critical=5]="Critical",i[i.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;function v(i,n,r){switch(n){case c.Trace:i.trace(r);break;case c.Debug:i.debug(r);break;case c.Info:i.info(r);break;case c.Warning:i.warn(r);break;case c.Error:i.error(r);break;case c.Critical:i.critical(r);break;default:throw new Error("Invalid log level")}}t.log=v;function C(i){let n="";for(let r=0;r<i.length;r++){let a=i[r];if(typeof a=="object")try{a=JSON.stringify(a)}catch{}n+=(r>0?" ":"")+a}return n}t.format=C;class T extends b.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=T;class d extends T{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...r){this.checkLogLevel(c.Trace)&&this.log(c.Trace,C([n,...r]))}debug(n,...r){this.checkLogLevel(c.Debug)&&this.log(c.Debug,C([n,...r]))}info(n,...r){this.checkLogLevel(c.Info)&&this.log(c.Info,C([n,...r]))}warn(n,...r){this.checkLogLevel(c.Warning)&&this.log(c.Warning,C([n,...r]))}error(n,...r){if(this.checkLogLevel(c.Error))if(n instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=n.stack,this.log(c.Error,C(a))}else this.log(c.Error,C([n,...r]))}critical(n,...r){this.checkLogLevel(c.Critical)&&this.log(c.Critical,C([n,...r]))}flush(){}}t.AbstractMessageLogger=d;class y extends T{constructor(n=t.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!I.isWindows}trace(n,...r){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...r):console.log(`[main ${P()}]`,n,...r))}debug(n,...r){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...r):console.log(`[main ${P()}]`,n,...r))}info(n,...r){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...r):console.log(`[main ${P()}]`,n,...r))}warn(n,...r){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,n,...r):console.warn(`[main ${P()}]`,n,...r))}error(n,...r){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,n,...r):console.error(`[main ${P()}]`,n,...r))}critical(n,...r){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,n,...r):console.error(`[main ${P()}]`,n,...r))}dispose(){}flush(){}}t.ConsoleMainLogger=y;class w extends T{constructor(n=t.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...r){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",n,...r)}critical(n,...r){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...r)}dispose(){}flush(){}}t.ConsoleLogger=w;class g extends T{constructor(n,r=t.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(r)}trace(n,...r){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(n),...r])}debug(n,...r){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(n),...r])}info(n,...r){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(n),...r])}warn(n,...r){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(n),...r])}error(n,...r){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(n),...r])}critical(n,...r){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(n),...r])}extractMessage(n){return typeof n=="string"?n:(0,D.toErrorMessage)(n,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=g;class l extends T{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.logServices)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const a of this.logServices)a.trace(n,...r)}debug(n,...r){for(const a of this.logServices)a.debug(n,...r)}info(n,...r){for(const a of this.logServices)a.info(n,...r)}warn(n,...r){for(const a of this.logServices)a.warn(n,...r)}error(n,...r){for(const a of this.logServices)a.error(n,...r)}critical(n,...r){for(const a of this.logServices)a.critical(n,...r)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}t.MultiplexLogService=l;class f extends b.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...r){this.logger.trace(n,...r)}debug(n,...r){this.logger.debug(n,...r)}info(n,...r){this.logger.info(n,...r)}warn(n,...r){this.logger.warn(n,...r)}error(n,...r){this.logger.error(n,...r)}critical(n,...r){this.logger.critical(n,...r)}flush(){this.logger.flush()}}t.LogService=f;class p extends b.Disposable{constructor(n,r){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(a))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,r){let a=this.loggers.get(n.toString());return a||(a=this.doCreateLogger(n,r?.always?c.Trace:this.logLevel,r),this.loggers.set(n.toString(),a),r?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=p;class E{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(n){}getLevel(){return c.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}t.NullLogService=E;function m(i){if(i.verbose)return c.Trace;if(typeof i.logLevel=="string"){const n=o(i.logLevel.toLowerCase());if(n!==void 0)return n}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=m;function o(i){switch(i){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=o;function e(i){switch(i){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=e;function s(i,n,...r){I.isCI?i.info.call(i,n,...r):i.trace.call(i,n,...r)}t.logCi=s});var oe=this&&this.__param||function(j,t){return function(D,R){t(D,R,j)}};define(Y[98],Q([0,1,39,3,28,7,2,10,11,15,20,14]),function(j,t,D,R,b,I,L,P,c,v,C,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let d=class extends L.Disposable{constructor(w,g){super();this.environmentService=w,this.logService=g,this.processesLimiter=new R.Limiter(5)}async postUninstall(w){const g=this.parseScript(w,"uninstall");return g&&(this.logService.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,w).then(()=>this.logService.info(w.identifier.id,w.manifest.version,"Finished running post uninstall script"),l=>this.logService.error(w.identifier.id,w.manifest.version,`Failed to run post uninstall script: ${l}`)))),v.Promises.rm(this.getExtensionStoragePath(w)).then(void 0,l=>this.logService.error("Error while removing extension storage path",l))}parseScript(w,g){const l=`vscode:${g}`;if(w.location.scheme===P.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[l]=="string"){const f=w.manifest.scripts[l].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(w.identifier.id,w.manifest.version,`${l} should be a node script`),null):{script:(0,c.join)(w.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(w,g,l,f,p){return new Promise((E,m)=>{const o=this.start(w,g,l,p);let e;const s=i=>{e&&(clearTimeout(e),e=null),i?m(i):E(void 0)};o.on("error",i=>{s((0,b.toErrorMessage)(i)||"Unknown")}),o.on("exit",(i,n)=>{s(i?`post-${g} process exited with code ${i}`:void 0)}),f&&(e=setTimeout(()=>{e=null,o.kill(),m("timed out")},5e3))})}start(w,g,l,f){const p={silent:!0,execArgv:void 0},E=(0,D.fork)(w,[`--type=extension-post-${g}`,...l],p);E.stdout.setEncoding("utf8"),E.stderr.setEncoding("utf8");const m=I.Event.fromNodeEventEmitter(E.stdout,"data"),o=I.Event.fromNodeEventEmitter(E.stderr,"data");m(i=>this.logService.info(f.identifier.id,f.manifest.version,`post-${g}`,i)),o(i=>this.logService.error(f.identifier.id,f.manifest.version,`post-${g}`,i));const e=I.Event.any(I.Event.map(m,i=>({data:`%c${i}`,format:[""]})),I.Event.map(o,i=>({data:`%c${i}`,format:["color: red"]})));return I.Event.debounce(e,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),E}getExtensionStoragePath(w){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};d=ge([oe(0,C.IEnvironmentService),oe(1,T.ILogService)],d),t.ExtensionsLifecycle=d}),define(Y[99],Q([0,1,18,3,8,7,2,11,51,14]),function(j,t,D,R,b,I,L,P,c,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class C extends L.Disposable{constructor(d,y){super();this.logService=d,this.options=y,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new I.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new R.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(d,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(d,y):this.watchNonRecursive(d,y)}watchUniversal(d,y){const w={path:this.toFilePath(d),excludes:y.excludes,recursive:y.recursive},g=(0,D.insert)(this.universalPathsToWatch,w);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(d=>(0,b.onUnexpectedError)(d))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,c.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)})));const d=this.options?.watcher?.recursive?.usePolling;if(d===!0)for(const y of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const y of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(y)&&d.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(d,y){const w={path:this.toFilePath(d),excludes:y.excludes,recursive:!1},g=(0,D.insert)(this.nonRecursivePathsToWatch,w);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(d=>(0,b.onUnexpectedError)(d))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(d=>this._onDidChangeFile.fire((0,c.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,P.normalize)(d.fsPath)}}t.AbstractDiskFileSystemProvider=C}),define(Y[100],Q([0,1,18,3,17,24,7,59,135,2,54,10,101,19,38,81,16,50,14]),function(j,t,D,R,b,I,L,P,c,v,C,T,d,y,w,g,l,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let E=class extends v.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(o,e){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const s=new v.DisposableStore;return this.provider.set(o,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:e}),s.add(e.onDidChangeFile(i=>this._onDidFilesChange.fire(new l.FileChangesEvent(i,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&s.add(e.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),s.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:o}))),(0,v.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:e}),this.provider.delete(o),(0,v.dispose)(s)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(s){e.push(s)}}),!this.provider.has(o)&&await R.Promises.settled(e)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,e){const s=this.provider.get(o.scheme);return!!(s&&s.capabilities&e)}listCapabilities(){return c.Iterable.map(this.provider,([o,e])=>({scheme:o,capabilities:e.capabilities}))}async withProvider(o){if(!(0,y.isAbsolutePath)(o))throw new l.FileOperationError((0,g.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const e=this.provider.get(o.scheme);if(!e){const s=new Error;throw s.name="ENOPRO",s.message=(0,g.localize)(1,null,o.toString()),s}return e}async withReadProvider(o){const e=await this.withProvider(o);if((0,l.hasOpenReadWriteCloseCapability)(e)||(0,l.hasReadWriteCapability)(e)||(0,l.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const e=await this.withProvider(o);if((0,l.hasOpenReadWriteCloseCapability)(e)||(0,l.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,e){try{return await this.doResolveFile(o,e)}catch(s){throw(0,l.toFileSystemProviderErrorCode)(s)===l.FileSystemProviderErrorCode.FileNotFound?new l.FileOperationError((0,g.localize)(2,null,this.resourceForError(o)),1):(0,l.ensureFileSystemProviderError)(s)}}async doResolveFile(o,e){const s=await this.withProvider(o),i=this.isPathCaseSensitive(s),n=e?.resolveTo,r=e?.resolveSingleChildDescendants,a=e?.resolveMetadata,u=await s.stat(o);let h;return this.toFileStat(s,o,u,void 0,!!a,(S,O)=>(h||(h=C.TernarySearchTree.forUris(()=>!i),h.set(o,!0),n&&h.fill(!0,n)),h.get(S.resource)||h.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&r?O===1:!1))}async toFileStat(o,e,s,i,n,r){const{providerExtUri:a}=this.getExtUri(o),u={resource:e,name:a.basename(e),isFile:(s.type&l.FileType.File)!=0,isDirectory:(s.type&l.FileType.Directory)!=0,isSymbolicLink:(s.type&l.FileType.SymbolicLink)!=0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&l.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,l.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(u.isDirectory&&r(u,i)){try{const h=await o.readdir(e),S=await R.Promises.settled(h.map(async([O,N])=>{try{const _=a.joinPath(e,O),J=n?await o.stat(_):{type:N};return await this.toFileStat(o,_,J,h.length,n,r)}catch(_){return this.logService.trace(_),null}}));u.children=(0,D.coalesce)(S)}catch(h){this.logService.trace(h),u.children=[]}return u}return u}async resolveAll(o){return R.Promises.settled(o.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const e=await this.withProvider(o),s=await e.stat(o);return this.toFileStat(e,o,s,void 0,!0,()=>!1)}async exists(o){const e=await this.withProvider(o);try{return!!await e.stat(o)}catch{return!1}}async canCreateFile(o,e){try{await this.doValidateCreateFile(o,e)}catch(s){return s}return!0}async doValidateCreateFile(o,e){if(!e?.overwrite&&await this.exists(o))throw new l.FileOperationError((0,g.localize)(3,null,this.resourceForError(o)),3,e)}async createFile(o,e=b.VSBuffer.fromString(""),s){await this.doValidateCreateFile(o,s);const i=await this.writeFile(o,e);return this._onDidRunOperation.fire(new l.FileOperationEvent(o,0,i)),i}async writeFile(o,e,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,s)||await this.mkdirp(i,n.dirname(o));let a;if((0,l.hasReadWriteCapability)(i)&&!(e instanceof b.VSBuffer))if((0,w.isReadableStream)(e)){const u=await(0,w.peekStream)(e,3);u.ended?a=b.VSBuffer.concat(u.buffer):a=u}else a=(0,w.peekReadable)(e,u=>b.VSBuffer.concat(u),3);else a=e;!(0,l.hasOpenReadWriteCloseCapability)(i)||(0,l.hasReadWriteCapability)(i)&&a instanceof b.VSBuffer?await this.doWriteUnbuffered(i,o,s,a):await this.doWriteBuffered(i,o,s,a instanceof b.VSBuffer?(0,b.bufferToReadable)(a):a),this._onDidRunOperation.fire(new l.FileOperationEvent(o,4))}catch(r){throw new l.FileOperationError((0,g.localize)(4,null,this.resourceForError(o),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),s)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,e,s){if(!!s?.unlock&&!(o.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(e)));let n;try{n=await o.stat(e)}catch{return}if((n.type&l.FileType.Directory)!=0)throw new l.FileOperationError((0,g.localize)(6,null,this.resourceForError(e)),0,s);if(this.throwIfFileIsReadonly(e,n),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==l.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&s.mtime<n.mtime&&s.etag!==(0,l.etag)({mtime:s.mtime,size:n.size}))throw new l.FileOperationError((0,g.localize)(7,null),3,s);return n}async readFile(o,e,s){const i=await this.withReadProvider(o);return e?.atomic?this.doReadFileAtomic(i,o,e,s):this.doReadFile(i,o,e,s)}async doReadFileAtomic(o,e,s,i){return new Promise((n,r)=>{this.writeQueue.queueFor(e,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,e,s,i);n(a)}catch(a){r(a)}})})}async doReadFile(o,e,s,i){const n=await this.doReadFileStream(o,e,{...s,preferUnbuffered:!0},i);return{...n,value:await(0,b.streamToBuffer)(n.value)}}async readFileStream(o,e,s){const i=await this.withReadProvider(o);return this.doReadFileStream(i,o,e,s)}async doReadFileStream(o,e,s,i){const n=new I.CancellationTokenSource(i),r=this.validateReadFile(e,s).then(u=>u,u=>{throw n.cancel(),u});let a;try{return typeof s?.etag=="string"&&s.etag!==l.ETAG_DISABLED&&await r,s?.atomic&&(0,l.hasFileAtomicReadCapability)(o)||!((0,l.hasOpenReadWriteCloseCapability)(o)||(0,l.hasFileReadStreamCapability)(o))||(0,l.hasReadWriteCapability)(o)&&s?.preferUnbuffered?a=this.readFileUnbuffered(o,e,s):(0,l.hasFileReadStreamCapability)(o)?a=this.readFileStreamed(o,e,n.token,s):a=this.readFileBuffered(o,e,n.token,s),{...await r,value:a}}catch(u){a&&await(0,w.consumeStream)(a);const h=(0,g.localize)(8,null,this.resourceForError(e),(0,l.ensureFileSystemProviderError)(u).toString());throw u instanceof l.NotModifiedSinceFileOperationError?new l.NotModifiedSinceFileOperationError(h,u.stat,s):new l.FileOperationError(h,(0,l.toFileOperationResult)(u),s)}}readFileStreamed(o,e,s,i=Object.create(null)){const n=o.readFileStream(e,i,s);return(0,w.transform)(n,{data:r=>r instanceof b.VSBuffer?r:b.VSBuffer.wrap(r),error:r=>new l.FileOperationError((0,g.localize)(9,null,this.resourceForError(e),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),i)},r=>b.VSBuffer.concat(r))}readFileBuffered(o,e,s,i=Object.create(null)){const n=(0,b.newWriteableBufferStream)();return(0,f.readFileIntoStream)(o,e,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new l.FileOperationError((0,g.localize)(10,null,this.resourceForError(e),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),i)},s),n}readFileUnbuffered(o,e,s){const i=(0,w.newWriteableStream)(n=>b.VSBuffer.concat(n));return(async()=>{try{let n;s?.atomic&&(0,l.hasFileAtomicReadCapability)(o)?n=await o.readFile(e,{atomic:!0}):n=await o.readFile(e),typeof s?.position=="number"&&(n=n.slice(s.position)),typeof s?.length=="number"&&(n=n.slice(0,s.length)),this.validateReadFileLimits(e,n.byteLength,s),i.end(b.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,e){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new l.FileOperationError((0,g.localize)(11,null,this.resourceForError(o)),0,e);if(typeof e?.etag=="string"&&e.etag!==l.ETAG_DISABLED&&e.etag===s.etag)throw new l.NotModifiedSinceFileOperationError((0,g.localize)(12,null),s,e);return this.validateReadFileLimits(o,s.size,e),s}validateReadFileLimits(o,e,s){if(s?.limits){let i;if(typeof s.limits.memory=="number"&&e>s.limits.memory&&(i=9),typeof s.limits.size=="number"&&e>s.limits.size&&(i=7),typeof i=="number")throw new l.FileOperationError((0,g.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,e,s){return this.doCanMoveCopy(o,e,"move",s)}async canCopy(o,e,s){return this.doCanMoveCopy(o,e,"copy",s)}async doCanMoveCopy(o,e,s,i){if(o.toString()!==e.toString())try{const n=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(n,o,r,e,s,i)}catch(n){return n}return!0}async move(o,e,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),r=await this.doMoveCopy(i,o,n,e,"move",!!s),a=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,e,s){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),r=await this.doMoveCopy(i,o,n,e,"copy",!!s),a=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,e,s,i,n,r){if(e.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(o,e,s,i,n,r);if(a&&!u&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(i)),n==="copy"){if(o===s&&(0,l.hasFileFolderCopyCapability)(o))await o.copy(e,i,{overwrite:r});else{const h=await this.resolve(e);h.isDirectory?await this.doCopyFolder(o,h,s,i):await this.doCopyFile(o,e,s,i)}return n}else return o===s?(await o.rename(e,i,{overwrite:r}),n):(await this.doMoveCopy(o,e,s,i,"copy",r),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(o,e,s,i){if((0,l.hasOpenReadWriteCloseCapability)(o)&&(0,l.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(o,e,s,i);if((0,l.hasOpenReadWriteCloseCapability)(o)&&(0,l.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(o,e,s,i);if((0,l.hasReadWriteCapability)(o)&&(0,l.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(o,e,s,i);if((0,l.hasReadWriteCapability)(o)&&(0,l.hasReadWriteCapability)(s))return this.doPipeUnbuffered(o,e,s,i)}async doCopyFolder(o,e,s,i){await s.mkdir(i),Array.isArray(e.children)&&await R.Promises.settled(e.children.map(async n=>{const r=this.getExtUri(s).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),s,r):this.doCopyFile(o,n.resource,s,r)}))}async doValidateMoveCopy(o,e,s,i,n,r){let a=!1;if(o===s){const{providerExtUri:h,isPathCaseSensitive:S}=this.getExtUri(o);if(S||(a=h.isEqual(e,i)),a&&n==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(e),this.resourceForError(i)));if(!a&&h.isEqualOrParent(i,e))throw new Error((0,g.localize)(15,null,this.resourceForError(e),this.resourceForError(i)))}const u=await this.exists(i);if(u&&!a){if(!r)throw new l.FileOperationError((0,g.localize)(16,null,this.resourceForError(e),this.resourceForError(i)),4);if(o===s){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(e,i))throw new Error((0,g.localize)(17,null,this.resourceForError(e),this.resourceForError(i)))}}return{exists:u,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const e=this.isPathCaseSensitive(o);return{providerExtUri:e?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(e,o);const s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,0,s)),s}async mkdirp(o,e){const s=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(e,i.dirname(e));)try{if(((await o.stat(e)).type&l.FileType.Directory)==0)throw new Error((0,g.localize)(18,null,this.resourceForError(e)));break}catch(n){if((0,l.toFileSystemProviderErrorCode)(n)!==l.FileSystemProviderErrorCode.FileNotFound)throw n;s.push(i.basename(e)),e=i.dirname(e)}for(let n=s.length-1;n>=0;n--){e=i.joinPath(e,s[n]);try{await o.mkdir(e)}catch(r){if((0,l.toFileSystemProviderErrorCode)(r)!==l.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,e){try{await this.doValidateDelete(o,e)}catch(s){return s}return!0}async doValidateDelete(o,e){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!e?.useTrash&&!(s.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(o)));let n;try{n=await s.stat(o)}catch{}if(n)this.throwIfFileIsReadonly(o,n);else throw new l.FileOperationError((0,g.localize)(20,null,this.resourceForError(o)),1);if(!!!e?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(o)))}return s}async del(o,e){const s=await this.doValidateDelete(o,e),i=!!e?.useTrash,n=!!e?.recursive;await s.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new l.FileOperationEvent(o,1))}watch(o,e={recursive:!1,excludes:[]}){const s=new v.DisposableStore;let i=!1,n=()=>{i=!0};return s.add((0,v.toDisposable)(()=>n())),(async()=>{try{const r=await this.doWatch(o,e);i?(0,v.dispose)(r):n=()=>(0,v.dispose)(r)}catch(r){this.logService.error(r)}})(),s}async doWatch(o,e){const s=await this.withProvider(o),i=(0,P.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(o),e]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:s.watch(o,e)},this.activeWatchers.set(i,n)),n.count+=1,(0,v.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,v.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,v.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,e,s,i){return this.writeQueue.queueFor(e,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(e,{create:!0,unlock:s?.unlock??!1});try{(0,w.isReadableStream)(i)||(0,w.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,n,i):await this.doWriteReadableBufferedQueued(o,n,i)}catch(r){throw(0,l.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,e,s){let i=0,n;if((0,w.isReadableBufferedStream)(s)){if(s.buffer.length>0){const r=b.VSBuffer.concat(s.buffer);await this.doWriteBuffer(o,e,r,r.byteLength,i,0),i+=r.byteLength}if(s.ended)return;n=s.stream}else n=s;return new Promise((r,a)=>{(0,w.listenStream)(n,{onData:async u=>{n.pause();try{await this.doWriteBuffer(o,e,u,u.byteLength,i,0)}catch(h){return a(h)}i+=u.byteLength,setTimeout(()=>n.resume())},onError:u=>a(u),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,e,s){let i=0,n;for(;(n=s.read())!==null;)await this.doWriteBuffer(o,e,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,e,s,i,n,r){let a=0;for(;a<i;)a+=await o.write(e,n+a,s.buffer,r+a,i-a)}async doWriteUnbuffered(o,e,s,i){return this.writeQueue.queueFor(e,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,e,s,i))}async doWriteUnbufferedQueued(o,e,s,i){let n;i instanceof b.VSBuffer?n=i:(0,w.isReadableStream)(i)?n=await(0,b.streamToBuffer)(i):(0,w.isReadableBufferedStream)(i)?n=await(0,b.bufferedStreamToBuffer)(i):n=(0,b.readableToBuffer)(i),await o.writeFile(e,n.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(o,e,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,e,s,i))}async doPipeBufferedQueued(o,e,s,i){let n,r;try{n=await o.open(e,{create:!1}),r=await s.open(i,{create:!0,unlock:!1});const a=b.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,h=0,S=0;do S=await o.read(n,u,a.buffer,h,a.byteLength-h),await this.doWriteBuffer(s,r,a,S,u,h),u+=S,h+=S,h===a.byteLength&&(h=0);while(S>0)}catch(a){throw(0,l.ensureFileSystemProviderError)(a)}finally{await R.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,e,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,e,s,i))}async doPipeUnbufferedQueued(o,e,s,i){return s.writeFile(i,await o.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,e,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,e,s,i))}async doPipeUnbufferedToBufferedQueued(o,e,s,i){const n=await s.open(i,{create:!0,unlock:!1});try{const r=await o.readFile(e);await this.doWriteBuffer(s,n,b.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,l.ensureFileSystemProviderError)(r)}finally{await s.close(n)}}async doPipeBufferedToUnbuffered(o,e,s,i){const n=await(0,b.streamToBuffer)(this.readFileBuffered(o,e,I.CancellationToken.None));await this.doWriteUnbuffered(s,i,void 0,n)}throwIfFileSystemIsReadonly(o,e){if(o.capabilities&2048)throw new l.FileOperationError((0,g.localize)(22,null,this.resourceForError(e)),6);return o}throwIfFileIsReadonly(o,e){if((e.permissions??0)&l.FilePermission.Readonly)throw new l.FileOperationError((0,g.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===T.Schemas.file?o.fsPath:o.toString(!0)}};E=ge([oe(0,p.ILogService)],E),t.FileService=E}),define(Y[102],Q([0,1,103,136,3,54,17,7,45,2,11,12,19,38,15,83,16,50,99,28,96,95]),function(j,t,D,R,b,I,L,P,c,v,C,T,d,y,w,g,l,f,p,E,m,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(D)}catch(s){console.error(`Error enabling graceful-fs: ${(0,E.toErrorMessage)(s)}`)}})();class e extends p.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n);this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new I.ResourceMap(r=>d.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,T.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:r}=await w.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await w.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async a=>{try{let u;a.isSymbolicLink()?u=(await this.stat((0,d.joinPath)(i,a.name))).type:u=this.toType(a),r.push([a.name,u])}catch(u){this.logService.trace(u)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let r;return n?.dangling?r=l.FileType.Unknown:i.isFile()?r=l.FileType.File:i.isDirectory()?r=l.FileType.Directory:r=l.FileType.Unknown,n&&(r|=l.FileType.SymbolicLink),r}async createResourceLock(i){const n=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const a=new b.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,v.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const a=this.toFilePath(i);return await w.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{r?.dispose()}}readFileStream(i,n,r){const a=(0,y.newWriteableStream)(u=>L.VSBuffer.concat(u.map(h=>L.VSBuffer.wrap(h))).buffer);return(0,f.readFileIntoStream)(this,i,a,u=>u.buffer,{...n,bufferSize:256*1024},r),a}async writeFile(i,n,r){let a;try{const u=this.toFilePath(i);if(!r.create||!r.overwrite){if(await w.Promises.exists(u)){if(!r.overwrite)throw(0,l.createFileSystemProviderError)((0,g.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,l.createFileSystemProviderError)((0,g.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(i,u)}finally{typeof a=="number"&&await this.close(a)}}async open(i,n){const r=this.toFilePath(i);let a;(0,l.isFileOpenForWriteOptions)(n)&&(a=await this.createResourceLock(i));let u;try{if((0,l.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:S}=await w.SymlinkSupport.stat(r);S.mode&128||await w.Promises.chmod(r,S.mode|128)}catch(S){this.logService.trace(S)}let h;if((0,l.isFileOpenForWriteOptions)(n)){if(T.isWindows)try{await w.Promises.truncate(r,0),h="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}h||(h="w")}else h="r";u=await w.Promises.open(r,h)}catch(h){throw a?.dispose(),(0,l.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(u,0),(0,l.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(u,i),a){const h=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${r})`),this.mapHandleToLock.set(u,a),h&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${r})`),h.dispose())}return u}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await w.Promises.fdatasync(i)}catch(r){this.canFlush=!1,this.logService.error(r)}return await w.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,a,u){const h=this.normalizePos(i,n);let S=null;try{S=(await w.Promises.read(i,r,a,u,h)).bytesRead}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(i,h,S)}return S}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,r){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,a+r):this.mapHandleToPos.delete(i)))}async write(i,n,r,a,u){return(0,b.retry)(()=>this.doWrite(i,n,r,a,u),100,3)}async doWrite(i,n,r,a,u){const h=this.normalizePos(i,n);let S=null;try{S=(await w.Promises.write(i,r,a,u,h)).bytesWritten}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),O)}finally{this.updatePos(i,h,S)}return S}async mkdir(i){try{await w.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const r=this.toFilePath(i);n.recursive?await w.Promises.rm(r,w.RimRafMode.MOVE):await w.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,n,r){const a=this.toFilePath(i),u=this.toFilePath(n);if(a!==u)try{await this.validateTargetDeleted(i,n,"move",r.overwrite),await w.Promises.move(a,u)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,g.localize)(2,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(u)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(i,n,r){const a=this.toFilePath(i),u=this.toFilePath(n);if(a!==u)try{await this.validateTargetDeleted(i,n,"copy",r.overwrite),await w.Promises.copy(a,u,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,g.localize)(3,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(u)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(i,n,r,a){const u=this.toFilePath(i),h=this.toFilePath(n);let S=!1;if(!!(this.capabilities&1024)||(S=(0,c.isEqual)(u,h,!0)),S&&r==="copy")throw(0,l.createFileSystemProviderError)((0,g.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!S&&await w.Promises.exists(h)){if(!a)throw(0,l.createFileSystemProviderError)((0,g.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(i,n,r){return new m.UniversalWatcherClient(a=>i(a),a=>n(a),r)}createNonRecursiveWatcher(i,n,r){return new o.NodeJSWatcherClient(a=>i(a),a=>n(a),r)}toFileSystemProviderError(i){if(i instanceof l.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=l.FileSystemProviderErrorCode.NoPermissions;break;default:n=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let r=this.toFileSystemProviderError(n);if(i&&r.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await w.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(r=(0,l.createFileSystemProviderError)(n,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return r}}t.DiskFileSystemProvider=e}),define(Y[104],Q([0,1,16,14]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;async function b(P,c,v,C,T){try{const d=await new Promise((w,g)=>{j(["spdlog"],w,g)});d.setFlushOn(R.LogLevel.Trace);const y=await d.createAsyncRotatingLogger(P,c,v,C);return T&&y.clearFormatters(),y}catch(d){console.error(d)}return null}function I(P,c,v){switch(c){case R.LogLevel.Trace:P.trace(v);break;case R.LogLevel.Debug:P.debug(v);break;case R.LogLevel.Info:P.info(v);break;case R.LogLevel.Warning:P.warn(v);break;case R.LogLevel.Error:P.error(v);break;case R.LogLevel.Critical:P.critical(v);break;default:throw new Error("Invalid log level")}}class L extends R.AbstractMessageLogger{constructor(c,v,C,T,d){super();this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(c,v,C,T),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}async _createSpdLogLogger(c,v,C,T){const d=C?6:1,y=30/d*D.ByteSize.MB,w=await b(c,v,y,d,T);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:g,message:l}of this.buffer)I(this._logger,g,l);this.buffer=[]}}log(c,v){this._logger?I(this._logger,c,v):this.getLevel()<=c&&this.buffer.push({level:c,message:v})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Y[32],Q([0,1,13]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,D.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(Y[30],Q([0,1,55,6]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(L,P){D.ok(R.isString(L)),D.ok(R.isObject(P)),D.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,P)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}t.Registry=new b}),define(Y[105],Q([0,1,7,30]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class I{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,v){this.schemasById[b(c)]=v,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new I;R.Registry.add(t.Extensions.JSONContribution,L)}),define(Y[34],Q([0,1,18,7,6,73,105,30]),function(j,t,D,R,b,I,L,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.keyFromOverrideIdentifiers=t.overrideIdentifiersFromKey=t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var c;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(c=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var v;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=P.Registry.as(L.Extensions.JSONContribution);class T{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},C.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,e=!0){this.registerConfigurations([o],e)}registerConfigurations(o,e=!0){const s=this.doRegisterConfigurations(o,e);C.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(o){const e=this.doDeregisterConfigurations(o);C.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e})}updateConfigurations({add:o,remove:e}){const s=[];s.push(...this.doDeregisterConfigurations(e)),s.push(...this.doRegisterConfigurations(o,!1)),C.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(s)})}registerDefaultConfigurations(o){const e=[],s=[];for(const{overrides:i,source:n}of o)for(const r in i)if(e.push(r),t.OVERRIDE_PROPERTY_REGEX.test(r)){const a={...this.configurationDefaultsOverrides.get(r)?.value||{},...i[r]};this.configurationDefaultsOverrides.set(r,{source:n,value:a});const u={type:"object",default:a,description:I.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:b.isString(n)?void 0:n};s.push(...w(r)),this.configurationProperties[r]=u,this.defaultLanguageConfigurationOverridesNode.properties[r]=u}else{this.configurationDefaultsOverrides.set(r,{value:i[r],source:n});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const e=[];for(const{overrides:s,source:i}of o)for(const n in s){const r=this.configurationDefaultsOverrides.get(n),a=b.isString(i)?i:i?.id,u=b.isString(r?.source)?r?.source:r?.source?.id;if(a===u)if(e.push(n),this.configurationDefaultsOverrides.delete(n),t.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const h=this.configurationProperties[n];h&&(this.updatePropertyDefaultValue(n,h),this.updateSchema(n,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const e of o)this.overrideIdentifiers.add(e);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,e){const s=[];return o.forEach(i=>{s.push(...this.validateAndRegisterProperties(i,e,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),s}doDeregisterConfigurations(o){const e=[],s=i=>{if(i.properties)for(const n in i.properties)e.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n]);i.allOf&&i.allOf.forEach(n=>s(n))};for(const i of o){s(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}return e}validateAndRegisterProperties(o,e=!0,s,i,n=3){n=b.isUndefinedOrNull(o.scope)?n:o.scope;let r=[],a=o.properties;if(a)for(let h in a){if(e&&p(h)){delete a[h];continue}const S=a[h];if(S.source=s,S.defaultDefaultValue=a[h].default,this.updatePropertyDefaultValue(h,S),t.OVERRIDE_PROPERTY_REGEX.test(h)?S.scope=void 0:(S.scope=b.isUndefinedOrNull(S.scope)?n:S.scope,S.restricted=b.isUndefinedOrNull(S.restricted)?!!i?.includes(h):S.restricted),a[h].hasOwnProperty("included")&&!a[h].included){this.excludedConfigurationProperties[h]=a[h],delete a[h];continue}else this.configurationProperties[h]=a[h];!a[h].deprecationMessage&&a[h].markdownDeprecationMessage&&(a[h].deprecationMessage=a[h].markdownDeprecationMessage),r.push(h)}let u=o.allOf;if(u)for(let h of u)r.push(...this.validateAndRegisterProperties(h,e,s,i,n));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const e=s=>{let i=s.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);let n=s.allOf;n&&n.forEach(e)};e(o)}updateSchema(o,e){switch(t.allSettings.properties[o]=e,e.scope){case 1:t.applicationSettings.properties[o]=e;break;case 2:t.machineSettings.properties[o]=e;break;case 6:t.machineOverridableSettings.properties[o]=e;break;case 3:t.windowSettings.properties[o]=e;break;case 4:t.resourceSettings.properties[o]=e;break;case 5:t.resourceSettings.properties[o]=e,this.resourceLanguageSettingsSchema.properties[o]=e;break}}removeFromSchema(o,e){switch(delete t.allSettings.properties[o],e.scope){case 1:delete t.applicationSettings.properties[o];break;case 2:delete t.machineSettings.properties[o];break;case 6:delete t.machineOverridableSettings.properties[o];break;case 3:delete t.windowSettings.properties[o];break;case 4:case 5:delete t.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const e=`[${o}]`,s={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(e,s),t.allSettings.properties[e]=s,t.applicationSettings.properties[e]=s,t.machineSettings.properties[e]=s,t.machineOverridableSettings.properties[e]=s,t.windowSettings.properties[e]=s,t.resourceSettings.properties[e]=s}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,e){const s=this.configurationDefaultsOverrides.get(o);let i=s?.value,n=s?.source;b.isUndefined(i)&&(i=e.defaultDefaultValue,n=void 0),b.isUndefined(i)&&(i=l(e.type)),e.default=i,e.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",y=new RegExp(d,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function w(m){const o=[];if(t.OVERRIDE_PROPERTY_REGEX.test(m)){let e=y.exec(m);for(;e?.length;){const s=e[1].trim();s&&o.push(s),e=y.exec(m)}}return(0,D.distinct)(o)}t.overrideIdentifiersFromKey=w;function g(m){return m.reduce((o,e)=>`${o}[${e}]`,"")}t.keyFromOverrideIdentifiers=g;function l(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=l;const f=new T;P.Registry.add(t.Extensions.Configuration,f);function p(m){return m.trim()?t.OVERRIDE_PROPERTY_REGEX.test(m)?I.localize(7,null,m):f.getConfigurationProperties()[m]!==void 0?I.localize(8,null,m):null:I.localize(6,null)}t.validateProperty=p;function E(){const m=[],o=f.getConfigurationProperties();for(const e of Object.keys(o))m.push([e,o[e].scope]);return m.push(["launch",4]),m.push(["task",4]),m}t.getScopes=E}),define(Y[106],Q([0,1,18,7,56,2,54,22,6,9,25,34,30]),function(j,t,D,R,b,I,L,P,c,v,C,T,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class y{constructor(i={},n=[],r=[]){this._contents=i,this._keys=n,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,C.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,n){const r=this.getContentsForOverrideIdentifer(n);return r?i?(0,C.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return D.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return D.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=P.deepClone(this.contents),r=P.deepClone(this.overrides),a=[...this.keys];for(const u of i){this.mergeContents(n,u.contents);for(const h of u.overrides){const[S]=r.filter(O=>D.equals(O.identifiers,h.identifiers));S?(this.mergeContents(S.contents,h.contents),S.keys.push(...h.keys),S.keys=D.distinct(S.keys)):r.push(P.deepClone(h))}for(const h of u.keys)a.indexOf(h)===-1&&a.push(h)}return new y(n,a,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const a of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[a],h=n[a];h&&(typeof u=="object"&&typeof h=="object"?(u=P.deepClone(u),this.mergeContents(u,h)):u=h),r[a]=u}return new y(r,this.keys,this.overrides)}mergeContents(i,n){for(const r of Object.keys(n)){if(r in i&&c.isObject(i[r])&&c.isObject(n[r])){this.mergeContents(i[r],n[r]);continue}i[r]=P.deepClone(n[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let n=null,r=null;const a=u=>{u&&(r?this.mergeContents(r,u):r=P.deepClone(u))};for(const u of this.overrides)D.equals(u.identifiers,[i])?n=u.contents:u.identifiers.includes(i)&&a(u.contents);return a(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,n){this.addKey(i),(0,C.addToValueTree)(this.contents,i,n,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,C.removeFromValueTree)(this.contents,i)}addKey(i){let n=this.keys.length;for(let r=0;r<n;r++)i.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,i)}removeKey(i){let n=this.keys.indexOf(i);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=y;class w extends y{constructor(i={}){const n=d.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(n),a=Object.create(null),u=[];for(const h in n){const S=i[h],O=S!==void 0?S:n[h].default;(0,C.addToValueTree)(a,h,O,N=>console.error(`Conflict in default settings: ${N}`))}for(const h of Object.keys(a))T.OVERRIDE_PROPERTY_REGEX.test(h)&&u.push({identifiers:(0,T.overrideIdentifiersFromKey)(h),keys:Object.keys(a[h]),contents:(0,C.toValuesTree)(a[h],S=>console.error(`Conflict in default settings file: ${S}`))});super(a,r,u)}}t.DefaultConfigurationModel=w;class g{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!c.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:r,keys:a,overrides:u,restricted:h}=this.doParseRaw(i,n);this._configurationModel=new y(r,a,u),this._restrictedConfigurations=h||[]}doParseContent(i){let n={},r=null,a=[],u=[],h=[];function S(N){Array.isArray(a)?a.push(N):r!==null&&(a[r]=N)}let O={onObjectBegin:()=>{let N={};S(N),u.push(a),a=N,r=null},onObjectProperty:N=>{r=N},onObjectEnd:()=>{a=u.pop()},onArrayBegin:()=>{let N=[];S(N),u.push(a),a=N,r=null},onArrayEnd:()=>{a=u.pop()},onLiteralValue:S,onError:(N,_,J)=>{h.push({error:N,offset:_,length:J})}};if(i)try{b.visit(i,O),n=a[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(i,n){const r=d.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),a=this.filter(i,r,!0,n);i=a.raw;const u=(0,C.toValuesTree)(i,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),h=Object.keys(i),S=this.toOverrides(i,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:u,keys:h,overrides:S,restricted:a.restricted}}filter(i,n,r,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:i,restricted:[]};const u={},h=[];for(let S in i)if(T.OVERRIDE_PROPERTY_REGEX.test(S)&&r){const O=this.filter(i[S],n,!1,a);u[S]=O.raw,h.push(...O.restricted)}else{const O=n[S],N=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&h.push(S),(N===void 0||a.scopes===void 0||a.scopes.includes(N))&&(a.skipRestricted&&O?.restricted||(u[S]=i[S]))}return{raw:u,restricted:h}}toOverrides(i,n){const r=[];for(const a of Object.keys(i))if(T.OVERRIDE_PROPERTY_REGEX.test(a)){const u={};for(const h in i[a])u[h]=i[a][h];r.push({identifiers:(0,T.overrideIdentifiersFromKey)(a),keys:Object.keys(u),contents:(0,C.toValuesTree)(u,n)})}return r}}t.ConfigurationModelParser=g;class l extends I.Disposable{constructor(i,n,r,a){super();this.userSettingsResource=i,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.any(R.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),R.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(1)||u.isOperation(4))&&r.isEqual(u.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=l;class f{constructor(i,n,r=new y,a=new y,u=new L.ResourceMap,h=new y,S=new L.ResourceMap,O=!0){this._defaultConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=u,this._memoryConfiguration=h,this._memoryConfigurationByResource=S,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(i,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(i)}updateValue(i,n,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new y,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(i):a.setValue(i,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,r){const a=this.getConsolidateConfigurationModel(n,r),u=this.getFolderConfigurationModelForResource(n.resource,r),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,S=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),O=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),N=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),_=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),J=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,re=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(i):u.freeze().getValue(i):void 0,ee=n.overrideIdentifier?h.override(n.overrideIdentifier).getValue(i):h.getValue(i),ie=a.getValue(i),he=D.distinct(D.flatten(a.overrides.map(ue=>ue.identifiers))).filter(ue=>a.getOverrideValue(i,ue)!==void 0);return{defaultValue:S,userValue:O,userLocalValue:N,userRemoteValue:_,workspaceValue:J,workspaceFolderValue:re,memoryValue:ee,value:ie,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspace:J!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspaceFolder:re!==void 0?{value:u?.freeze().getValue(i),override:n.overrideIdentifier?u?.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:h.getValue(i),override:n.overrideIdentifier?h.getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:a,updated:u,removed:h}=o(this._defaultConfiguration,i);n=[...a,...u,...h]}for(const a of n)for(const u of(0,T.overrideIdentifiersFromKey)(a)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(u),S=i.getKeysForOverrideIdentifier(u),O=[...S.filter(N=>h.indexOf(N)===-1),...h.filter(N=>S.indexOf(N)===-1),...h.filter(N=>!P.equals(this._defaultConfiguration.override(u).getValue(N),i.override(u).getValue(N)))];r.push([u,O])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:a,overrides:u}=o(this.localUserConfiguration,i),h=[...n,...r,...a];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:u}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:a,overrides:u}=o(this.remoteUserConfiguration,i);let h=[...n,...r,...a];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:u}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:a,overrides:u}=o(this.workspaceConfiguration,i);let h=[...n,...r,...a];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:u}}compareAndUpdateFolderConfiguration(i,n){const r=this.folderConfigurations.get(i),{added:a,updated:u,removed:h,overrides:S}=o(r,n);let O=[...a,...u,...h];return(O.length||!r)&&this.updateFolderConfiguration(i,n),{keys:O,overrides:S}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:a,removed:u,overrides:h}=o(n,void 0);return{keys:[...r,...a,...u],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,n){let r=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const a=n.getFolder(i);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const u=this._memoryConfigurationByResource.get(i);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(i);a?(n=r.merge(a),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(i,n)):n=r}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:r,overrides:a,keys:u}=this._folderConfigurations.get(n);return i.push([n,{contents:r,overrides:a,keys:u}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>i.add(n)),this.userConfiguration.freeze().keys.forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),a=this.parseConfigurationModel(i.workspace),u=i.folders.reduce((h,S)=>(h.set(v.URI.revive(S[0]),this.parseConfigurationModel(S[1])),h),new L.ResourceMap);return new f(n,r,new y,a,u,new y,new L.ResourceMap,!1)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides).freeze()}}t.Configuration=f;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,n=new Map;for(const a of s)a.keys.forEach(u=>i.add(u)),a.overrides.forEach(([u,h])=>{const S=(0,L.getOrSet)(n,u,new Set);h.forEach(O=>S.add(O))});const r=[];return n.forEach((a,u)=>r.push([u,[...a.values()]])),{keys:[...i.values()],overrides:r}}t.mergeChanges=p;class E{constructor(i,n,r,a){this.change=i,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=a,this._previousConfiguration=void 0;const u=new Set;i.keys.forEach(S=>u.add(S)),i.overrides.forEach(([,S])=>S.forEach(O=>u.add(O))),this.affectedKeys=[...u.values()];const h=new y;this.affectedKeys.forEach(S=>h.setValue(S,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!P.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(i,n){let r=(0,C.toValuesTree)({[n]:!0},()=>{}),a;for(;typeof r=="object"&&(a=Object.keys(r)[0]);){if(i=i[a],!i)return!1;r=r[a]}return!0}}t.ConfigurationChangeEvent=E;class m extends E{constructor(i,n,r,a){super({keys:i.allKeys(),overrides:[]},void 0,i,n);this.source=r,this.sourceConfig=a}}t.AllKeysConfigurationChangeEvent=m;function o(s,i){const{added:n,removed:r,updated:a}=e(i,s),u=[],h=s?.getAllOverrideIdentifiers()||[],S=i?.getAllOverrideIdentifiers()||[];if(i){const O=S.filter(N=>!h.includes(N));for(const N of O)u.push([N,i.getKeysForOverrideIdentifier(N)])}if(s){const O=h.filter(N=>!S.includes(N));for(const N of O)u.push([N,s.getKeysForOverrideIdentifier(N)])}if(i&&s){for(const O of h)if(S.includes(O)){const N=e({contents:s.getOverrideValue(void 0,O)||{},keys:s.getKeysForOverrideIdentifier(O)},{contents:i.getOverrideValue(void 0,O)||{},keys:i.getKeysForOverrideIdentifier(O)});u.push([O,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:r,updated:a,overrides:u}}function e(s,i){const n=s?i?s.keys.filter(u=>i.keys.indexOf(u)===-1):[...s.keys]:[],r=i?s?i.keys.filter(u=>s.keys.indexOf(u)===-1):[...i.keys]:[],a=[];if(s&&i){for(const u of i.keys)if(s.keys.indexOf(u)!==-1){const h=(0,C.getConfigurationValue)(i.contents,u),S=(0,C.getConfigurationValue)(s.contents,u);P.equals(h,S)||a.push(u)}}return{added:n,removed:r,updated:a}}}),define(Y[107],Q([0,1,3,7,2,19,25,106,34,30]),function(j,t,D,R,b,I,L,P,c,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class C extends b.Disposable{constructor(d,y){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,I.extUriBiasedIgnorePathCase,y)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(({properties:w})=>this.onDidDefaultConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,y){const w=typeof d=="string"?d:void 0,g=(0,L.isConfigurationOverrides)(d)?d:(0,L.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(w,g,void 0)}updateValue(d,y,w,g){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const y=this.configuration.toData(),w=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(w,y,1)}onDidDefaultConfigurationChange(d){const y=this.configuration.toData(),w=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,d);this.trigger(w,y,6)}trigger(d,y,w){const g=new P.ConfigurationChangeEvent(d,{data:y},this.configuration);g.source=w,g.sourceConfig=this.getTargetConfiguration(w),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=C}),define(Y[108],Q([0,1,10]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getRemoteName=t.getRemoteAuthority=void 0;function R(I){return I.scheme===D.Schemas.vscodeRemote?I.authority:void 0}t.getRemoteAuthority=R;function b(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}t.getRemoteName=b}),define(Y[35],Q([0,1,26,13,108]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.UNDEFINED_PUBLISHER=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.UNDEFINED_PUBLISHER="undefined_publisher",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}t.getWorkspaceSupportTypeMessage=I;function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=t.ExtensionType||(t.ExtensionType={}));class c{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,w){if(typeof y=="undefined"||y===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof y=="string"||typeof w=="string"){let g=typeof y=="string"?y:y.value,l=typeof w=="string"?w:w.value;return D.equalsIgnoreCase(g,l)}return y._lower===w._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}t.ExtensionIdentifier=c;function v(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}t.isLanguagePackExtension=v;function C(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=C;function T(d,y){if(y){const w=`onResolveRemoteAuthority:${(0,b.getRemoteName)(y)}`;return d.activationEvents?.indexOf(w)!==-1}return!1}t.isResolverExtension=T,t.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[21],Q([0,1,26,35]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function b(w,g){return w.uuid&&g.uuid?w.uuid===g.uuid:w.id===g.id?!0:(0,D.compareIgnoreCase)(w.id,g.id)===0}t.areSameExtensions=b;class I{constructor(g,l){this.version=l,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof I?b(this,g)&&this.version===g.version:!1}}t.ExtensionIdentifierWithVersion=I;function L(w,g){return`${w}.${g}`}t.getExtensionId=L;function P(w){return w.toLocaleLowerCase()}t.adoptToGalleryExtensionId=P;function c(w,g){return P(L(w,g))}t.getGalleryExtensionId=c;function v(w,g){const l=[],f=p=>{for(const E of l)if(E.some(m=>b(g(m),g(p))))return E;return null};for(const p of w){const E=f(p);E?E.push(p):l.push([p])}return l}t.groupByExtension=v;function C(w){return{id:w.identifier.id,name:w.manifest.name,galleryId:null,publisherId:w.publisherId,publisherName:w.manifest.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:w.manifest.extensionDependencies&&w.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=C;function T(w){return{id:w.identifier.id,name:w.name,galleryId:w.identifier.uuid,publisherId:w.publisherId,publisherName:w.publisher,publisherDisplayName:w.publisherDisplayName,isPreReleaseVersion:w.properties.isPreReleaseVersion,dependencies:!!(w.properties.dependencies&&w.properties.dependencies.length>0),...w.telemetryData}}t.getGalleryExtensionTelemetryData=T,t.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(w){const g=new Set;if(w.malicious)for(const l of w.malicious)g.add(l.id);return g}t.getMaliciousExtensionsSet=d;function y(w,g){const l=[],f=g.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const p=f.shift();if(p&&l.every(E=>!b(E.identifier,{id:p}))){const E=w.filter(m=>b(m.identifier,{id:p}));E.length===1&&(l.push(E[0]),f.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}t.getExtensionDependencies=y}),define(Y[23],Q([0,1,10,75,21,13]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.getIdAndVersion=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";const L=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function P(e){const s=L.exec(e);return s&&s[1]?[(0,b.adoptToGalleryExtensionId)(s[1]),s[2]]:[(0,b.adoptToGalleryExtensionId)(e),void 0]}t.getIdAndVersion=P;var c;(function(e){e.WIN32_X64="win32-x64",e.WIN32_IA32="win32-ia32",e.WIN32_ARM64="win32-arm64",e.LINUX_X64="linux-x64",e.LINUX_ARM64="linux-arm64",e.LINUX_ARMHF="linux-armhf",e.ALPINE_X64="alpine-x64",e.ALPINE_ARM64="alpine-arm64",e.DARWIN_X64="darwin-x64",e.DARWIN_ARM64="darwin-arm64",e.WEB="web",e.UNIVERSAL="universal",e.UNKNOWN="unknown",e.UNDEFINED="undefined"})(c=t.TargetPlatform||(t.TargetPlatform={}));function v(e){switch(e){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=v;function C(e){switch(e){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=C;function T(e,s){switch(e){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=T;function d(e,s){return s==="web"&&!e.includes("web")}t.isNotWebExtensionInWebTargetPlatform=d;function y(e,s,i){return d(s,i)?!1:e==="undefined"||e==="universal"?!0:e==="unknown"?!1:e===i?!0:w(i).includes(e)}t.isTargetPlatformCompatible=y;function w(e){switch(e){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=w;function g(e){return e&&typeof e=="object"&&typeof e.id=="string"&&(!e.uuid||typeof e.uuid=="string")}t.isIExtensionIdentifier=g;var l;(function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",e[e.PublisherName=3]="PublisherName",e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=10]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"})(l=t.SortBy||(t.SortBy={}));var f;(function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"})(f=t.SortOrder||(t.SortOrder={}));var p;(function(e){e.Install="install",e.Uninstall="uninstall"})(p=t.StatisticType||(t.StatisticType={}));var E;(function(e){e[e.None=1]="None",e[e.Install=2]="Install",e[e.Update=3]="Update",e[e.Migrate=4]="Migrate"})(E=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var m;(function(e){e.Unsupported="Unsupported",e.UnsupportedPreRelease="UnsupportedPreRelease",e.Malicious="Malicious",e.Incompatible="Incompatible",e.IncompatiblePreRelease="IncompatiblePreRelease",e.IncompatibleTargetPlatform="IncompatibleTargetPlatform",e.ReleaseVersionNotFound="ReleaseVersionNotFound",e.Invalid="Invalid",e.Download="Download",e.Extract="Extract",e.Delete="Delete",e.Rename="Rename",e.CorruptZip="CorruptZip",e.IncompleteZip="IncompleteZip",e.Internal="Internal"})(m=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class o extends Error{constructor(s,i){super(s);this.code=i,this.name=i}}t.ExtensionManagementError=o,t.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),t.ExtensionsLabel=(0,R.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,R.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(Y[109],Q([0,1,24,8,62,10,41,9,76,23,21,35]),function(j,t,D,R,b,I,L,P,c,v,C,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=void 0;const d=l=>(0,c.localize)(0,null,l),y=(0,c.localize)(1,null,"ms-dotnettools.csharp");function w(l,f){return f?`${l.publisher}.${l.name}@${l.version}`:`${l.publisher}.${l.name}`}let g=class{constructor(f,p){this.extensionManagementService=f,this.extensionGalleryService=p}get location(){}async listExtensions(f,p,E=console){let m=await this.extensionManagementService.getInstalled(1);const o=T.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(p&&p!==""){if(o.indexOf(p.toLowerCase())<0){E.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(s=>s.manifest.categories?s.manifest.categories.map(n=>n.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){E.log("Possible Categories: "),o.forEach(s=>{E.log(s)});return}this.location&&E.log((0,c.localize)(2,null,this.location)),m=m.sort((s,i)=>s.identifier.id.localeCompare(i.identifier.id));let e;for(let s of m)e!==s.identifier.id&&(e=s.identifier.id,E.log(w(s.manifest,f)))}async installExtensions(f,p,E,m,o=console){const e=[],s=[];f.length&&o.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1),n=(u,h)=>{const S=i.find(O=>(0,C.areSameExtensions)(O.identifier,{id:u}));if(S){if(!h&&!m)return o.log((0,c.localize)(5,null,u,S.manifest.version,u)),!1;if(h&&S.manifest.version===h)return o.log((0,c.localize)(6,null,`${u}@${h}`)),!1}return!0},r=[],a=[];for(const u of f)if(u instanceof P.URI)r.push(u);else{const[h,S]=(0,v.getIdAndVersion)(u);n(h,S)&&a.push({id:h,version:S,installOptions:{...E,isBuiltin:!1}})}for(const u of p){const[h,S]=(0,v.getIdAndVersion)(u);n(h,S)&&a.push({id:h,version:S,installOptions:{...E,isBuiltin:!0}})}if(r.length&&await Promise.all(r.map(async u=>{try{const h=await this.installVSIX(u,{...E,isBuiltin:!1},m,o);h&&s.push(h)}catch(h){o.error(h.message||h.stack||h),e.push(u.toString())}})),a.length){const u=await this.getGalleryExtensions(a);await Promise.all(a.map(async h=>{const S=u.get(h.id.toLowerCase());if(S)try{const O=await this.installFromGallery(h,S,i,m,o);O&&s.push(O)}catch(O){o.error(O.message||O.stack||O),e.push(h.id)}else o.error(`${d(h.version?`${h.id}@${h.version}`:h.id)}
${y}`),e.push(h.id)}))}if(e.length)throw new Error((0,c.localize)(7,null,e.join(", ")))}async installVSIX(f,p,E,m){const o=await this.extensionManagementService.getManifest(f);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,E,m))try{return await this.extensionManagementService.install(f,p),m.log((0,c.localize)(8,null,(0,b.getBaseLabel)(f))),o}catch(s){if((0,R.isCancellationError)(s))return m.log((0,c.localize)(9,null,(0,b.getBaseLabel)(f))),null;throw s}return null}async getGalleryExtensions(f){const p=new Map,E=f.some(o=>o.installOptions.installPreReleaseVersion),m=await this.extensionGalleryService.getExtensions(f.map(o=>({...o,preRelease:E})),D.CancellationToken.None);for(const o of m)p.set(o.identifier.id.toLowerCase(),o);return p}async installFromGallery({id:f,version:p,installOptions:E},m,o,e,s){const i=await this.extensionGalleryService.getManifest(m,D.CancellationToken.None);if(i&&!this.validateExtensionKind(i,s))return null;const n=o.find(r=>(0,C.areSameExtensions)(r.identifier,m.identifier));if(n){if(m.version===n.manifest.version)return s.log((0,c.localize)(10,null,p?`${f}@${p}`:f)),null;s.log((0,c.localize)(11,null,f,m.version))}try{return E.isBuiltin?s.log(p?(0,c.localize)(12,null,f,p):(0,c.localize)(13,null,f)):s.log(p?(0,c.localize)(14,null,f,p):(0,c.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(m,{...E,installGivenVersion:!!p}),s.log((0,c.localize)(16,null,f,m.version)),i}catch(r){if((0,R.isCancellationError)(r))return s.log((0,c.localize)(17,null,f)),null;throw r}}validateExtensionKind(f,p){return!0}async validateVSIX(f,p,E){const m={id:(0,C.getGalleryExtensionId)(f.publisher,f.name)},e=(await this.extensionManagementService.getInstalled(1)).find(s=>(0,C.areSameExtensions)(m,s.identifier)&&(0,L.gt)(s.manifest.version,f.version));return e&&!p?(E.log((0,c.localize)(18,null,e.identifier.id,e.manifest.version,f.version)),!1):this.validateExtensionKind(f,E)}async uninstallExtensions(f,p,E=console){const m=async e=>{if(e instanceof P.URI){const s=await this.extensionManagementService.getManifest(e);return w(s)}return e},o=[];for(const e of f){const s=await m(e),n=(await this.extensionManagementService.getInstalled()).filter(r=>(0,C.areSameExtensions)(r.identifier,{id:s}));if(!n.length)throw new Error(`${this.notInstalled(s)}
${y}`);if(n.some(r=>r.type===0)){E.log((0,c.localize)(19,null,s));return}if(!p&&n.some(r=>r.isBuiltin)){E.log((0,c.localize)(20,null,s));return}E.log((0,c.localize)(21,null,s));for(const r of n)await this.extensionManagementService.uninstall(r),o.push(r);this.location?E.log((0,c.localize)(22,null,s,this.location)):E.log((0,c.localize)(23,null,s))}}async locateExtension(f,p=console){const E=await this.extensionManagementService.getInstalled();f.forEach(m=>{E.forEach(o=>{if(o.identifier.id===m&&o.location.scheme===I.Schemas.file){p.log(o.location.fsPath);return}})})}notInstalled(f){return this.location?(0,c.localize)(24,null,f,this.location):(0,c.localize)(25,null,f)}};g=ge([oe(0,v.IExtensionManagementService),oe(1,v.IExtensionGalleryService)],g),t.ExtensionManagementCLIService=g}),define(Y[110],Q([0,1,3,8,2,12,19,41,9,27,15,20,23,21,16,14]),function(j,t,D,R,b,I,L,P,c,v,C,T,d,y,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const l=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let f=class extends b.Disposable{constructor(E,m,o,e){super();this.fileService=m,this.extensionGalleryService=o,this.logService=e,this.extensionsDownloadDir=c.URI.file(E.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(E,m){await this.cleanUpPromise;const o=this.getName(E),e=(0,L.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(e)){const s=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(E,s,m);try{await this.rename(s,e,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(s)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",E.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,s.path),i}}return e}async delete(E){await this.cleanUpPromise,await this.fileService.del(E)}async rename(E,m,o){try{await C.Promises.rename(E.fsPath,m.fsPath)}catch(e){if(I.isWindows&&e&&e.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${E} to ${m} with 'EPERM' error. Trying again...`),this.rename(E,m,o);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const E=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(E.children){const m=[],o=[];for(const i of E.children){const n=this.parse(i.name);n&&o.push([n,i])}const e=(0,y.groupByExtension)(o,([i])=>i),s=[];for(const i of e)i.sort((n,r)=>P.rcompare(n[0].version,r[0].version)),m.push(...i.slice(1).map(n=>n[1].resource)),s.push(i[0][1]);s.sort((i,n)=>i.mtime-n.mtime),m.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(i=>i.resource)),await D.Promises.settled(m.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(E){this.logService.error(E)}}getName(E){return this.cache?`${new y.ExtensionIdentifierWithVersion(E.identifier,E.version).key().toLowerCase()}${E.properties.targetPlatform!=="undefined"?`-${E.properties.targetPlatform}`:""}`:(0,v.generateUuid)()}parse(E){const m=l.exec(E);return m&&m[1]&&m[2]?new y.ExtensionIdentifierWithVersion({id:m[1]},m[2]):null}};f=ge([oe(0,T.INativeEnvironmentService),oe(1,w.IFileService),oe(2,d.IExtensionGalleryService),oe(3,g.ILogService)],f),t.ExtensionsDownloader=f}),define(Y[111],Q([0,1,2,11,15,35]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(c,v){super();this.environmentService=c,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(v.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(c){c.some(v=>!!v.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=L}),define(Y[112],Q([0,1,137,18,3,2,10,11,15,20,23,21,53,14]),function(j,t,D,R,b,I,L,P,c,v,C,T,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let w=class extends I.Disposable{constructor(f,p,E){super();this.extensionManagementService=f,this.logService=E,this.cache=this._register(new g(p,E)),this.extensionManagementService.registerParticipant({postInstall:async m=>this.postInstallExtension(m),postUninstall:async m=>this.postUninstallExtension(m)})}async getLanguageIds(){const f=await this.cache.getLanguagePacks(),p=["en",...Object.keys(f)];return(0,R.distinct)(p)}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const p=await this.cache.getLanguagePacks();Object.keys(p).some(E=>p[E]&&p[E].extensions.some(m=>(0,T.areSameExtensions)(m.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),E=await this.cache.update(p);return!(0,R.equals)(Object.keys(f),Object.keys(E))}};w=ge([oe(0,C.IExtensionManagementService),oe(1,v.INativeEnvironmentService),oe(2,y.ILogService)],w),t.LocalizationsService=w;let g=class extends I.Disposable{constructor(f,p){super();this.logService=p,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(p=>{Object.keys(p).forEach(E=>delete p[E]),this.createLanguagePacksFromExtensions(p,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...p){for(const E of p)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,E);Object.keys(f).forEach(E=>this.updateHash(f[E]))}createLanguagePacksFromExtension(f,p){const E=p.identifier,m=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of m)if(p.location.scheme===L.Schemas.file&&(0,d.isValidLocalization)(o)){let e=f[o.languageId];e||(e={hash:"",extensions:[],translations:{}},f[o.languageId]=e);let s=e.extensions.filter(i=>(0,T.areSameExtensions)(i.extensionIdentifier,E))[0];s?s.version=p.manifest.version:e.extensions.push({extensionIdentifier:E,version:p.manifest.version});for(const i of o.translations)e.translations[i.id]=(0,P.join)(p.location.fsPath,i.path)}}updateHash(f){if(f){const p=(0,D.createHash)("md5");for(const E of f.extensions)p.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);f.hash=p.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(p=f(E),E)).then(E=>{for(const o of Object.keys(E))E[o]||delete E[o];this.languagePacks=E,this.initializedCache=!0;const m=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",m),c.Promises.writeFile(this.languagePacksFilePath,m)}).then(()=>p,E=>this.logService.error(E))})}};g=ge([oe(0,v.INativeEnvironmentService),oe(1,y.ILogService)],g)}),define(Y[42],Q([0,1,17,84,34,13,30]),function(j,t,D,R,b,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,I.createDecorator)("requestService");function P(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}t.isSuccess=P;function c(w){return w.res.statusCode===204}async function v(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);return c(w)?null:(await(0,D.streamToBuffer)(w.stream)).toString()}t.asText=v;async function C(w){if(!P(w))throw new Error("Server returned "+w.res.statusCode);if(c(w))return null;const l=(await(0,D.streamToBuffer)(w.stream)).toString();try{return JSON.parse(l)}catch(f){throw f.message+=`:
`+l,f}}t.asJson=C;function T(w){y(w)}t.updateProxyConfigurationsScope=T;let d;function y(w){const g=L.Registry.as(b.Extensions.Configuration),l=d;d={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[d],remove:l?[l]:[]})}y(2)}),define(Y[113],Q([0,1,24,10,16,42]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let L=class{constructor(c,v){this.requestService=c,this.fileService=v}async download(c,v,C=D.CancellationToken.None){if(c.scheme===R.Schemas.file||c.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(c,v);return}const T={type:"GET",url:c.toString()},d=await this.requestService.request(T,C);if(d.res.statusCode===200)await this.fileService.writeFile(v,d.stream);else{const y=await(0,I.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${y}`)}}};L=ge([oe(0,I.IRequestService),oe(1,b.IFileService)],L),t.DownloadService=L}),define(Y[114],Q([0,1,115,6]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(L,P){return L.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:L.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function I(L,P,c={}){const v=(0,D.parse)(L),C=c.proxyUrl||b(v,P);if(!C)return null;const T=(0,D.parse)(C);if(!/^https?:$/.test(T.protocol||""))return null;const d={host:T.hostname||"",port:T.port||(T.protocol==="https"?"443":"80"),auth:T.auth,rejectUnauthorized:(0,R.isBoolean)(c.strictSSL)?c.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((y,w)=>{j(["http-proxy-agent"],y,w)}))(d):new(await new Promise((y,w)=>{j(["https-proxy-agent"],y,w)}))(d)}t.getProxyAgent=I}),define(Y[116],Q([0,1,3,7,2,101,6,65,13]),function(j,t,D,R,b,I,L,P,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const v="__$__targetStorageMarker";t.IStorageService=(0,c.createDecorator)("storageService");var C;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(C=t.WillSaveStateReason||(t.WillSaveStateReason={}));var T;(function(l){l[l.GLOBAL=0]="GLOBAL",l[l.WORKSPACE=1]="WORKSPACE"})(T=t.StorageScope||(t.StorageScope={}));var d;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(d=t.StorageTarget||(t.StorageTarget={}));class y extends b.Disposable{constructor(f={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,I.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,p){p===v?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:p,target:this.getKeyTargets(f)[p]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,p,E){return this.getStorage(p)?.get(f,E)}getBoolean(f,p,E){return this.getStorage(p)?.getBoolean(f,E)}getNumber(f,p,E){return this.getStorage(p)?.getNumber(f,E)}store(f,p,E,m){if((0,L.isUndefinedOrNull)(p)){this.remove(f,E);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,E,m),this.getStorage(E)?.set(f,p)})}remove(f,p){this.withPausedEmitters(()=>{this.updateKeyTarget(f,p,void 0),this.getStorage(p)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,p){const E=[],m=this.getKeyTargets(f);for(const o of Object.keys(m))m[o]===p&&E.push(o);return E}updateKeyTarget(f,p,E){const m=this.getKeyTargets(p);typeof E=="number"?m[f]!==E&&(m[f]=E,this.getStorage(p)?.set(v,JSON.stringify(m))):typeof m[f]=="number"&&(delete m[f],this.getStorage(p)?.set(v,JSON.stringify(m)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const p=this.get(v,f);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}isNew(f){return this.getBoolean(t.IS_NEW_KEY,f)===!0}async flush(f=C.NONE){this._onWillSaveState.fire({reason:f});const p=this.getStorage(0),E=this.getStorage(1);switch(f){case C.NONE:await D.Promises.settled([p?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([p?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve()]);break}}async logStorage(){const f=this.getStorage(0)?.items??new Map,p=this.getStorage(1)?.items??new Map;return g(f,p,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class w extends y{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}t.InMemoryStorageService=w;async function g(l,f,p,E){const m=a=>{try{return JSON.parse(a)}catch{return a}},o=new Map,e=new Map;l.forEach((a,u)=>{o.set(u,a),e.set(u,m(a))});const s=new Map,i=new Map;f.forEach((a,u)=>{s.set(u,a),i.set(u,m(a))}),console.group(`Storage: Global (path: ${p})`);let n=[];o.forEach((a,u)=>{n.push({key:u,value:a})}),console.table(n),console.groupEnd(),console.log(e),console.group(`Storage: Workspace (path: ${E})`);let r=[];s.forEach((a,u)=>{r.push({key:u,value:a})}),console.table(r),console.groupEnd(),console.log(i)}t.logStorage=g}),define(Y[117],Q([0,1,12,29,9,27]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function L(v){if(D.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function P(v,C,T,d,y,w,g,l,f,p){const E=Object.create(null);E["common.machineId"]=g,E.sessionID=(0,I.generateUuid)()+Date.now(),E.commitHash=y,E.version=w,E["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,D.PlatformToString)(D.platform),E["common.nodePlatform"]=R.platform,E["common.nodeArch"]=d,E["common.product"]=p||"desktop";const m=c(l||[]);m&&(E["common.msftInternal"]=m);let o=0;const e=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),D.isLinuxSnap&&(E["common.snap"]="true");const s=L(T);s&&(E["common.platformDetail"]=s);try{const i=await v.readFile(b.URI.file(f));E["common.source"]=i.value.toString().slice(0,30)}catch{}return E}t.resolveCommonProperties=P;function c(v){const C=R.env.USERDNSDOMAIN;if(!C)return!1;const T=C.toLowerCase();return v.some(d=>T===d)}t.verifyMicrosoftInternalDomain=c}),define(Y[31],Q([0,1,13]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,D.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(R=t.TelemetryLevel||(t.TelemetryLevel={}));var b;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(b=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Y[118],Q([0,1,18,3,24,8,7,2,12,6,9,74,23,21,14,32,31]),function(j,t,D,R,b,I,L,P,c,v,C,T,d,y,w,g,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let f=class extends P.Disposable{constructor(s,i,n,r){super();this.galleryService=s,this.telemetryService=i,this.logService=n,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(a=>a.cancel()),this.uninstallingExtensions.forEach(a=>a.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const i=await this.getTargetPlatform();return s.allTargetPlatforms.some(n=>(0,d.isTargetPlatformCompatible)(n,s.allTargetPlatforms,i))}async installFromGallery(s,i={}){try{if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(T.localize(0,null),d.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(s,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,i)}catch(n){throw m(this.telemetryService,"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(s),void 0,n),this.logService.error("Failed to install extension.",s.identifier.id),this.logService.error(n),E(n)}}async uninstall(s,i={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,i)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(1,null));const i=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...s.identifier,preRelease:s.preRelease}],{targetPlatform:i,compatible:!0},b.CancellationToken.None);if(!n)throw new Error(T.localize(2,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.extensionsControlManifest||s-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=s),this.extensionsControlManifest}registerParticipant(s){this.participants.push(s)}async installExtension(s,i,n){if(!C.URI.isUri(i)){let S=this.installingExtensions.get(new y.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(S)return this.logService.info("Extensions is already requested to install",i.identifier.id),S.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],a=[],u=this.createInstallExtensionTask(s,i,n);C.URI.isUri(i)||this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(u.identifier,s.version).key(),u),this._onInstallExtension.fire({identifier:u.identifier,source:i}),this.logService.info("Installing extension:",u.identifier.id),r.push({task:u,manifest:s});let h=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,s,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:N,manifest:_}of O)if(h=h||!!_.extensionDependencies?.some(J=>(0,y.areSameExtensions)({id:J},u.identifier)),this.installingExtensions.has(new y.ExtensionIdentifierWithVersion(N.identifier,N.version).key()))this.logService.info("Extension is already requested to install",N.identifier.id);else{const J=this.createInstallExtensionTask(_,N,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(J.identifier,_.version).key(),J),this._onInstallExtension.fire({identifier:J.identifier,source:N}),this.logService.info("Installing extension:",J.identifier.id),r.push({task:J,manifest:_})}}catch(O){if(C.URI.isUri(u.source))(0,D.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,O.message),(0,D.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),O}const S=r.reduce((O,{task:N,manifest:_})=>(O.set(N.identifier.id.toLowerCase(),{task:N,manifest:_}),O),new Map);for(;S.size;){let O;const N=[...S.values()].filter(({manifest:_})=>!_.extensionDependencies?.some(J=>S.has(J.toLowerCase())));N.length?O=S.size===1?N:N.filter(({task:_})=>!(_===u&&!h)):(this.logService.info("Found extensions with circular dependencies",N.map(({task:_})=>_.identifier.id)),O=[...S.values()]),await this.joinAllSettled(O.map(async({task:_})=>{const J=new Date().getTime(),re=(0,v.isUndefined)(n.operation)?_.operation:n.operation;try{const ee=await _.run();if(await this.joinAllSettled(this.participants.map(ie=>ie.postInstall(ee,_.source,n,b.CancellationToken.None))),!C.URI.isUri(_.source)&&(m(this.telemetryService,re===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-J,void 0),c.isWeb&&re!==3))try{await this.galleryService.reportStatistic(ee.manifest.publisher,ee.manifest.name,ee.manifest.version,"install")}catch{}a.push({local:ee,identifier:_.identifier,operation:re,source:_.source})}catch(ee){throw C.URI.isUri(_.source)||m(this.telemetryService,re===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-J,ee),this.logService.error("Error while installing the extension:",_.identifier.id),ee}finally{S.delete(_.identifier.id.toLowerCase())}}))}return a.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(a),a.filter(({identifier:O})=>(0,y.areSameExtensions)(O,u.identifier))[0].local}catch(S){if(r.forEach(({task:O})=>O.cancel()),a.length)try{const O=await Promise.allSettled(a.map(({local:N})=>this.createUninstallExtensionTask(N,{versionOnly:!0}).run()));for(let N=0;N<O.length;N++){const _=O[N],{identifier:J}=a[N];_.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",J.id):this.logService.warn("Rollback: Error while uninstalling extension",J.id,(0,I.getErrorMessage)(_.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,I.getErrorMessage)(O),a.map(({identifier:N})=>N.id))}throw this._onDidInstallExtensions.fire(r.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source}))),S}finally{for(const{task:S,manifest:O}of r)if(!C.URI.isUri(S.source)){const N=new y.ExtensionIdentifierWithVersion(S.identifier,O.version).key();this.installingExtensions.delete(N)||this.logService.warn("Installation task is not found in the cache",N)}}}async joinAllSettled(s){const i=[],n=[],r=await Promise.allSettled(s);for(const a of r)a.status==="fulfilled"?i.push(a.value):n.push(a.reason);if(n.length)throw p(n);return i}async getAllDepsAndPackExtensionsToInstall(s,i,n,r){if(!this.galleryService.isEnabled())return[];let a=await this.getInstalled();const u=[s,...a.map(O=>O.identifier)],h=[],S=async(O,N)=>{const _=N.extensionDependencies||[],J=[..._];if(N.extensionPack){const re=n?a.find(ee=>(0,y.areSameExtensions)(ee.identifier,O)):void 0;for(const ee of N.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(ie=>(0,y.areSameExtensions)({id:ie},{id:ee}))||J.every(ie=>!(0,y.areSameExtensions)({id:ie},{id:ee}))&&J.push(ee)}if(J.length){const re=[...u,...h.map(ie=>ie.gallery.identifier)],ee=J.filter(ie=>re.every(he=>!(0,y.areSameExtensions)(he,{id:ie})));if(ee.length){const ie=await this.galleryService.getExtensions(ee.map(he=>({id:he,preRelease:r})),b.CancellationToken.None);for(const he of ie){if(re.find(te=>(0,y.areSameExtensions)(te,he.identifier)))continue;const ue=_.some(te=>(0,y.areSameExtensions)({id:te},he.identifier));let x;try{x=await this.checkAndGetCompatibleVersion(he,!0,r)}catch(te){if(te instanceof d.ExtensionManagementError&&te.code===d.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ue){this.logService.info("Skipping the packed extension as it cannot be installed",he.identifier.id);continue}else throw te}h.push({gallery:x.extension,manifest:x.manifest}),await S(x.extension.identifier,x.manifest)}}}};return await S(s,i),a=await this.getInstalled(),h.filter(O=>!a.some(N=>(0,y.areSameExtensions)(N.identifier,O.gallery.identifier)))}async checkAndGetCompatibleVersion(s,i,n){const r=await this.getExtensionsControlManifest();if((0,y.getMaliciousExtensionsSet)(r).has(s.identifier.id))throw new d.ExtensionManagementError(T.localize(3,null,s.identifier.id),d.ExtensionManagementErrorCode.Malicious);if(!!r.unsupportedPreReleaseExtensions&&!!r.unsupportedPreReleaseExtensions[s.identifier.id])throw new d.ExtensionManagementError(T.localize(4,null,s.identifier.id,r.unsupportedPreReleaseExtensions[s.identifier.id].displayName),d.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(s)){const h=await this.getTargetPlatform();throw new d.ExtensionManagementError(T.localize(5,null,s.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(h)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(s,i,n);if(a){if(n&&i&&s.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new d.ExtensionManagementError(T.localize(6,null,s.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&s.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([s.identifier],b.CancellationToken.None))[0]?new d.ExtensionManagementError(T.localize(7,null,s.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.ExtensionManagementError(T.localize(8,null,s.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const u=await this.galleryService.getManifest(a,b.CancellationToken.None);if(u===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(u.version!==a.version)throw new d.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:u}}async getCompatibleVersion(s,i,n){const r=await this.getTargetPlatform();let a=null;return i&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==n&&(a=(await this.galleryService.getExtensions([{...s.identifier,preRelease:n}],{targetPlatform:r,compatible:!0},b.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(s,n,r)&&(a=s),!a&&i&&(a=await this.galleryService.getCompatibleExtension(s,n,r)),a}async unininstallExtension(s,i){const n=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),n.waitUntilTaskIsFinished();const r=(S,O)=>{const N=this.createUninstallExtensionTask(S,O);return this.uninstallingExtensions.set(N.extension.identifier.id.toLowerCase(),N),this.logService.info("Uninstalling extension:",S.identifier.id),this._onUninstallExtension.fire(S.identifier),N},a=(S,O)=>{O?this.logService.error("Failed to uninstall extension:",S.identifier.id,O.message):this.logService.info("Successfully uninstalled extension:",S.identifier.id),m(this.telemetryService,"extensionGallery:uninstall",(0,y.getLocalExtensionTelemetryData)(S),void 0,O),this._onDidUninstallExtension.fire({identifier:S.identifier,error:O?.code})},u=[],h=[];try{u.push(r(s,{}));const S=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const O=this.getAllPackExtensionsToUninstall(s,S);for(const N of O)this.uninstallingExtensions.has(N.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):u.push(r(N,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(u.map(O=>O.extension),S,s),await this.joinAllSettled(u.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(O.extension,i,b.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch{}a(O.extension)}catch(N){const _=N instanceof d.ExtensionManagementError?N:new d.ExtensionManagementError((0,I.getErrorMessage)(N),d.ExtensionManagementErrorCode.Internal);throw a(O.extension,_),_}finally{h.push(O)}}))}catch(S){const O=S instanceof d.ExtensionManagementError?S:new d.ExtensionManagementError((0,I.getErrorMessage)(S),d.ExtensionManagementErrorCode.Internal);for(const N of u){try{N.cancel()}catch{}h.includes(N)||a(N.extension,O)}throw O}finally{for(const S of u)this.uninstallingExtensions.delete(S.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",S.extension.identifier.id)}}checkForDependents(s,i,n){for(const r of s){const a=this.getDependents(r,i);if(a.length){const u=a.filter(h=>!s.some(S=>(0,y.areSameExtensions)(S.identifier,h.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(r,u,n))}}}getDependentsErrorMessage(s,i,n){return n===s?i.length===1?T.localize(9,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?T.localize(10,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):T.localize(11,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?T.localize(12,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?T.localize(13,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):T.localize(14,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(s,i,n=[]){if(n.indexOf(s)!==-1)return[];n.push(s);const r=s.manifest.extensionPack?s.manifest.extensionPack:[];if(r.length){const a=i.filter(h=>!h.isBuiltin&&r.some(S=>(0,y.areSameExtensions)({id:S},h.identifier))),u=[];for(const h of a)u.push(...this.getAllPackExtensionsToUninstall(h,i,n));return[...a,...u]}return[]}getDependents(s,i){return i.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(r=>(0,y.areSameExtensions)({id:r},s.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};f=ge([oe(0,d.IExtensionGalleryService),oe(1,l.ITelemetryService),oe(2,w.ILogService),oe(3,g.IProductService)],f),t.AbstractExtensionManagementService=f;function p(e){const s=Array.isArray(e)?e:[e];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((i,n)=>new Error(`${i.message}${i.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}t.joinErrors=p;function E(e){if(e instanceof d.ExtensionManagementError)return e;const s=new d.ExtensionManagementError(e.message,d.ExtensionManagementErrorCode.Internal);return s.stack=e.stack,s}function m(e,s,i,n,r){const a=r?r instanceof d.ExtensionManagementError?r.code:d.ExtensionManagementErrorCode.Internal:void 0;e.publicLogError(s,{...i,success:!r,duration:n,errorcode:a})}t.reportTelemetry=m;class o{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(s=>new Promise((i,n)=>{const r=s.onCancellationRequested(()=>{r.dispose(),n((0,I.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=o}),define(Y[36],Q([0,1,22,6,25,31]),function(j,t,D,R,b,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(f,p){return Promise.resolve(void 0)}publicLog2(f,p){return this.publicLog(f,p)}publicLogError(f,p){return Promise.resolve(void 0)}publicLogError2(f,p){return this.publicLogError(f,p)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=L,t.NullTelemetryService=new L;class P{async publicLog(f,p,E){}async publicLogError(f,p,E){}}t.NullEndpointTelemetryService=P,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(l,f){return f.onDidChangeConfiguration(p=>{p.source!==6&&l.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(p.source),configurationKeys:w(p.sourceConfig)})})}t.configurationTelemetry=c;function v(l,f){return!(f.disableTelemetry||!l.enableTelemetry||f.extensionTestsLocationURI)}t.supportsTelemetry=v;function C(l){const f=l.getValue(I.TELEMETRY_SETTING_ID),p=l.getValue("telemetry.enableCrashReporter");if(l.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||p===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=C;function T(l){const f=Object.create(null),p=Object.create(null),E=Object.create(null);y(l,E);for(let m in E){m=m.length>150?m.substr(m.length-149):m;const o=E[m];typeof o=="number"?p[m]=o:typeof o=="boolean"?p[m]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${o.length}`),f[m]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(f[m]=o)}return{properties:f,measurements:p}}t.validateTelemetryData=T;function d(l){if(!l)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{l.indexOf(`${E}+`)===0&&(f=E)}),f}t.cleanRemoteAuthority=d;function y(l,f,p=0,E){if(!!l)for(let m of Object.getOwnPropertyNames(l)){const o=l[m],e=E?E+m:m;Array.isArray(o)?f[e]=(0,D.safeStringify)(o):o instanceof Date?f[e]=o.toISOString():(0,R.isObject)(o)?p<2?y(o,f,p+1,e+"."):f[e]=(0,D.safeStringify)(o):f[e]=o}}function w(l){if(!l)return[];const f=[];return g(f,"",l),f}function g(l,f,p){p&&typeof p=="object"&&!Array.isArray(p)?Object.keys(p).forEach(E=>g(l,f?`${f}.${E}`:E,p[E])):l.push(f)}}),define(Y[119],Q([0,1,91,36]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=void 0;async function b(I,L,P,c,v,C){const T={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${L.nameShort})`},d=await(0,D.getServiceMachineId)(P,v,C);return(0,R.supportsTelemetry)(L,P)&&(0,R.getTelemetryLevel)(c)===3&&(T["X-Market-User-Id"]=d),T}t.resolveMarketplaceHeaders=b}),define(Y[120],Q([0,1,18,24,8,22,12,29,6,9,25,20,23,21,48,16,14,32,42,119,116,31]),function(j,t,D,R,b,I,L,P,c,v,C,T,d,y,w,g,l,f,p,E,m,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=L.isWeb?"web":(0,d.getTargetPlatform)(L.platform,P.arch);var s;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...M){return String(M.reduce((A,V)=>A|V,0))}var n;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class S{constructor(A=h){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,V=this.state.pageSize){return new S({...this.state,pageNumber:A,pageSize:V})}withFilter(A,...V){const B=[...this.state.criteria,...V.length?V.map(H=>({filterType:A,value:H})):[{filterType:A}]];return new S({...this.state,criteria:B})}withSortBy(A){return new S({...this.state,sortBy:A})}withSortOrder(A){return new S({...this.state,sortOrder:A})}withFlags(...A){return new S({...this.state,flags:A.reduce((V,B)=>V|B,0)})}withAssetTypes(...A){return new S({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:V,pageSize:B,sortBy:H,sortOrder:X,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:A,pageNumber:V,pageSize:B,sortBy:H,sortOrder:X}],assetTypes:ce,flags:ae}}get searchText(){const A=this.state.criteria.filter(V=>V.filterType===n.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(M,A){const V=(M||[]).filter(B=>B.statisticName===A)[0];return V?V.value:0}function N(M){const A="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(B=>B.assetType.indexOf(A)===0).reduce((B,H)=>{const X=ee(M,H.assetType);return X&&B.push([H.assetType.substring(A.length),X]),B},[])}function _(M){if(M.properties){const A=M.properties.filter(H=>H.key===r.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=A.filter(H=>V.test(H.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return ee(M,r.Repository)}function J(M){return{uri:`${M.fallbackAssetUri}/${r.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${r.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function re(M){const A=ee(M,r.Icon);if(A)return A;const V=d.DefaultIconPath;return{uri:V,fallbackUri:V}}function ee(M,A){return M.files.filter(B=>B.assetType===A)[0]?{uri:`${M.assetUri}/${A}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${A}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function ie(M,A){const V=M.properties?M.properties.filter(H=>H.key===A):[],B=V.length>0&&V[0].value;return B?B.split(",").map(H=>(0,y.adoptToGalleryExtensionId)(H)):[]}function he(M){const A=M.properties?M.properties.filter(V=>V.key===a.Engine):[];return A.length>0&&A[0].value||""}function ue(M){const A=M.properties?M.properties.filter(V=>V.key===a.PreRelease):[];return A.length>0&&A[0].value==="true"}function x(M){const A=M.properties?M.properties.filter(B=>B.key===a.LocalizedLanguages):[],V=A.length>0&&A[0].value||"";return V?V.split(","):[]}function te(M){return M.indexOf("preview")!==-1}function U(M){return M.targetPlatform?(0,d.toTargetPlatform)(M.targetPlatform):"undefined"}function k(M){const A=(0,D.distinct)(M.versions.map(U)),V=!!M.tags?.includes(d.WEB_EXTENSION_TAG),B=A.indexOf("web");return V?B===-1&&A.push("web"):B!==-1&&A.splice(B,1),A}function z(M,A){const V=(0,d.getFallbackTargetPlarforms)(A);for(let B=0;B<M.length;B++){const H=M[B];if(H.version===M[B-1]?.version){let X=B;const ae=U(H);if(ae===A)for(;X>0&&M[X-1].version===H.version;)X--;else if(V.includes(ae))for(;X>0&&M[X-1].version===H.version&&U(M[X-1])!==A;)X--;X!==B&&(M.splice(B,1),M.splice(X,0,H))}}return M}t.sortExtensionVersions=z;function G(M,A,V){M.telemetryData={index:A,querySource:V}}function ne(M,A,V){const B=M.versions[0],H={manifest:ee(A,r.Manifest),readme:ee(A,r.Details),changelog:ee(A,r.Changelog),license:ee(A,r.License),repository:_(A),download:J(A),icon:re(A),coreTranslations:N(A)};return{identifier:{id:(0,y.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:A.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,description:M.shortDescription||"",installCount:O(M.statistics,"install"),rating:O(M.statistics,"averagerating"),ratingCount:O(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:V,assets:H,properties:{dependencies:ie(A,a.Dependency),extensionPack:ie(A,a.ExtensionPack),engine:he(A),localizedLanguages:x(A),targetPlatform:U(A),isPreReleaseVersion:ue(A)},hasPreReleaseVersion:ue(B),hasReleaseVersion:!0,preview:te(M.flags)}}let K=class{constructor(A,V,B,H,X,ae,ce,we){this.requestService=V,this.logService=B,this.environmentService=H,this.telemetryService=X,this.fileService=ae,this.productService=ce,this.configurationService=we;const fe=ce.extensionsGallery;this.extensionsGalleryUrl=fe&&fe.serviceUrl,this.extensionsControlUrl=fe&&fe.controlUrl,this.commonHeadersPromise=(0,E.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,V,B){const H=R.CancellationToken.isCancellationToken(V)?{}:V,X=R.CancellationToken.isCancellationToken(V)?V:B,ae=[],ce=[],we=[],fe=[];let se=!0;for(const Ee of A){Ee.uuid?ce.push(Ee.uuid):ae.push(Ee.id);const Ie=!!(Ee.version||Ee.preRelease);we.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ie}),Ee.version&&fe.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),se=se&&!!Ee.hasPreRelease&&!Ie}if(!ce.length&&!ae.length)return[];let pe=new S().withPage(1,A.length);ce.length&&(pe=pe.withFilter(n.ExtensionId,...ce)),ae.length&&(pe=pe.withFilter(n.ExtensionName,...ae)),(H.queryAllVersions||se)&&(pe=pe.withFlags(pe.flags,s.IncludeVersions));const{extensions:me}=await this.queryGalleryExtensions(pe,{targetPlatform:H.targetPlatform??e,includePreRelease:we,versions:fe,compatible:!!H.compatible},X);return H.source&&me.forEach((Ee,Ie)=>G(Ee,Ie,H.source)),me}async getCompatibleExtension(A,V,B){if((0,d.isNotWebExtensionInWebTargetPlatform)(A.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(A,V,B))return A;const H=new S().withFlags(s.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,A.identifier.uuid),{extensions:X}=await this.queryGalleryExtensions(H,{targetPlatform:B,compatible:!0,includePreRelease:V},R.CancellationToken.None);return X[0]||null}async isExtensionCompatible(A,V,B){if(!(0,d.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,B)||!V&&A.properties.isPreReleaseVersion)return!1;let H=A.properties.engine;if(!H){const X=await this.getManifest(A,R.CancellationToken.None);if(!X)throw new Error("Manifest was not found");H=X.engines.vscode}return(0,w.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(A,V,B,H,X){if(!(0,d.isTargetPlatformCompatible)(U(A),H,X)||V!=="any"&&ue(A)!==(V==="prerelease"))return!1;if(B){const ae=await this.getEngine(A);if(!(0,w.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}return!0}async query(A,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=A.text||"";const H=(0,I.getOrDefault)(A,se=>se.pageSize,50);let X=new S().withPage(1,H);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,pe,me)=>(X=X.withFilter(n.Category,me||pe),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,pe,me)=>(X=X.withFilter(n.Tag,me||pe),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(n.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),X=X.withFilter(n.SearchText,B)),X=X.withSortBy(0)):A.ids?X=X.withFilter(n.ExtensionId,...A.ids):A.names?X=X.withFilter(n.ExtensionName,...A.names):X=X.withSortBy(4),typeof A.sortBy=="number"&&(X=X.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(X=X.withSortOrder(A.sortOrder));const ae=async(se,pe)=>{const{extensions:me,total:Ee}=await this.queryGalleryExtensions(se,{targetPlatform:e,compatible:!1,includePreRelease:!!A.includePreRelease},pe);return me.forEach((Ie,Me)=>G(Ie,(se.pageNumber-1)*se.pageSize+Me,A.source)),{extensions:me,total:Ee}},{extensions:ce,total:we}=await ae(X,V),fe=async(se,pe)=>{if(pe.isCancellationRequested)throw new b.CancellationError;const{extensions:me}=await ae(X.withPage(se+1),pe);return me};return{firstPage:ce,total:we,pageSize:X.pageSize,getPage:fe}}async queryGalleryExtensions(A,V,B){const H=A.flags;!!(A.flags&s.IncludeLatestVersionOnly)&&!!(A.flags&s.IncludeVersions)&&(A=A.withFlags(A.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(A.flags&s.IncludeLatestVersionOnly)&&!(A.flags&s.IncludeVersions)&&(A=A.withFlags(A.flags,s.IncludeLatestVersionOnly)),V.versions?.length&&(A=A.withFlags(A.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),A=A.withFlags(A.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:X,total:ae}=await this.queryRawGalleryExtensions(A,B);if(!(A.flags&s.IncludeLatestVersionOnly)){const se=[];for(const pe of X){const me=await this.toGalleryExtensionWithCriteria(pe,V,!0);me&&se.push(me)}return{extensions:se,total:ae}}const we=[],fe=new Map;for(let se=0;se<X.length;se++){const pe=X[se],me={id:(0,y.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Ee=(0,c.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(Me=>(0,y.areSameExtensions)(Me,me))?.includePreRelease;let Ie=await this.toGalleryExtensionWithCriteria(pe,V,!1);!Ie||Ie.properties.isPreReleaseVersion&&(!Ee||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==V.targetPlatform&&Ie.hasPreReleaseVersion?fe.set(pe.extensionId,se):we.push([se,Ie])}if(fe.size){const se=new Date().getTime(),pe=new S().withFlags(H&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,fe.size).withFilter(n.ExtensionId,...fe.keys()),{extensions:me}=await this.queryGalleryExtensions(pe,V,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-se,count:fe.size});for(const Ee of me){const Ie=fe.get(Ee.identifier.uuid);we.push([Ie,Ee])}}return{extensions:we.sort((se,pe)=>se[0]-pe[0]).map(([,se])=>se),total:ae}}async toGalleryExtensionWithCriteria(A,V,B){const H={id:(0,y.getGalleryExtensionId)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},X=V.versions?.find(fe=>(0,y.areSameExtensions)(fe,H))?.version,ae=(0,c.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(fe=>(0,y.areSameExtensions)(fe,H))?.includePreRelease,ce=k(A),we=z(A.versions,V.targetPlatform);if(V.compatible&&B&&(0,d.isNotWebExtensionInWebTargetPlatform)(ce,V.targetPlatform))return null;for(let fe=0;fe<we.length;fe++){const se=we[fe];if(!(X&&se.version!==X)){if(await this.isValidVersion(se,ae?"any":"release",V.compatible,ce,V.targetPlatform))return ne(A,se,ce);if(X&&se.version===X)return null}}return X||V.compatible?null:ne(A,A.versions[0],ce)}async queryRawGalleryExtensions(A,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,s.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(s.Unpublished));const B=await this.commonHeadersPromise,H=JSON.stringify(A.raw),X={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ae=new Date().getTime();let ce,we,fe=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:X},V),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:fe};const se=await(0,p.asJson)(ce);if(se){const pe=se.results[0],me=pe.extensions,Ee=pe.resultMetadata&&pe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return fe=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:fe}}return{galleryExtensions:[],total:fe}}catch(se){throw we=se,se}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-ae,success:!!ce&&(0,p.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:we?(0,b.isCancellationError)(we)?"canceled":(0,b.getErrorMessage)(we).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(A,V,B,H){if(!this.isEnabled())return;const X=L.isWeb?this.api(`/itemName/${A}.${V}/version/${B}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${V}/${B}/stats?statType=${H}`),ae=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",we={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:X,headers:we},R.CancellationToken.None)}catch{}}async download(A,V,B){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const H=(0,y.getGalleryExtensionTelemetryData)(A),X=new Date().getTime(),ae=se=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:se}),ce=B===2?"install":B===3?"update":"",we=ce?{uri:`${A.assets.download.uri}${v.URI.parse(A.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${A.assets.download.fallbackUri}${v.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:A.assets.download,fe=await this.getAsset(we);await this.fileService.writeFile(V,fe.stream),ae(new Date().getTime()-X)}async getReadme(A,V){if(A.assets.readme){const B=await this.getAsset(A.assets.readme,{},V);return await(0,p.asText)(B)||""}return""}async getManifest(A,V){if(A.assets.manifest){const B=await this.getAsset(A.assets.manifest,{},V),H=await(0,p.asText)(B);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(A,V){const B=ee(A,r.Manifest);if(!B)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},X=await this.getAsset(B,{headers:H});return await(0,p.asJson)(X)}async getCoreTranslation(A,V){const B=A.assets.coreTranslations.filter(H=>H[0]===V.toUpperCase())[0];if(B){const H=await this.getAsset(B[1]),X=await(0,p.asText)(H);return X?JSON.parse(X):null}return null}async getChangelog(A,V){if(A.assets.changelog){const B=await this.getAsset(A.assets.changelog,{},V);return await(0,p.asText)(B)||""}return""}async getAllCompatibleVersions(A,V,B){let H=new S().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);A.identifier.uuid?H=H.withFilter(n.ExtensionId,A.identifier.uuid):H=H.withFilter(n.ExtensionName,A.identifier.id);const{galleryExtensions:X}=await this.queryRawGalleryExtensions(H,R.CancellationToken.None);if(!X.length)return[];const ae=k(X[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(ae,B))return[];const ce=[],we=new Set;return await Promise.all(X[0].versions.map(async fe=>{try{if(we.has(fe.version))return;await this.isValidVersion(fe,V?"any":"release",!0,ae,B)&&(ce.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:ue(fe)}),we.add(fe.version))}catch{}})),ce}async getAsset(A,V={},B=R.CancellationToken.None){const H=await this.commonHeadersPromise,X={type:"GET"},ae={...H,...V.headers||{}};V={...V,...X,headers:ae};const ce=A.uri,we=A.fallbackUri,fe={...V,url:ce};try{const se=await this.requestService.request(fe,B);if(se.res.statusCode===200)return se;const pe=await(0,p.asText)(se);throw new Error(`Expected 200, got back ${se.res.statusCode} instead.

${pe}`)}catch(se){if((0,b.isCancellationError)(se))throw se;const pe=(0,b.getErrorMessage)(se);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:pe});const me={...V,url:we};return this.requestService.request(me,B)}}async getEngine(A){let V=he(A);if(!V){const B=await this.getManifestFromRawExtensionVersion(A,R.CancellationToken.None);if(!B)throw new Error("Manifest was not found");V=B.engines.vscode}return V}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,p.asJson)(A),B=[],H={};if(V){for(const X of V.malicious)B.push({id:X});if(V.unsupported)for(const X of Object.keys(V.unsupported)){const ae=V.unsupported[X];(0,c.isBoolean)(ae)||(H[X.toLowerCase()]=ae.preReleaseExtension)}if(V.migrateToPreRelease)for(const[X,ae]of Object.entries(V.migrateToPreRelease))(!ae.engine||(0,w.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(H[X.toLowerCase()]=ae)}return{malicious:B,unsupportedPreReleaseExtensions:H}}};K=ge([oe(1,p.IRequestService),oe(2,l.ILogService),oe(3,T.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,g.IFileService),oe(6,f.IProductService),oe(7,C.IConfigurationService)],K);let Z=class extends K{constructor(A,V,B,H,X,ae,ce,we){super(A,V,B,H,X,ae,ce,we)}};Z=ge([oe(0,m.IStorageService),oe(1,p.IRequestService),oe(2,l.ILogService),oe(3,T.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,g.IFileService),oe(6,f.IProductService),oe(7,C.IConfigurationService)],Z),t.ExtensionGalleryService=Z;let q=class extends K{constructor(A,V,B,H,X,ae,ce){super(void 0,A,V,B,H,X,ae,ce)}};q=ge([oe(0,p.IRequestService),oe(1,l.ILogService),oe(2,T.IEnvironmentService),oe(3,o.ITelemetryService),oe(4,g.IFileService),oe(5,f.IProductService),oe(6,C.IConfigurationService)],q),t.ExtensionGalleryServiceWithNoStorageService=q}),define(Y[121],Q([0,1,2,22,12,26,85,25,34,122,30,31,36]),function(j,t,D,R,b,I,L,P,c,v,C,T,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let y=class{constructor(l,f){this._configurationService=f,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=l.appenders,this._commonProperties=l.commonProperties||Promise.resolve({}),this._piiPaths=l.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let p of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,I.escapeRegExpCharacters)(p),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(l,f){this._experimentProperties[l]=f}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const l=await this._commonProperties;let f=l.sessionID,p=l["common.machineId"],E=l["common.firstSessionDate"],m=l["common.msftInternal"];return{sessionId:f,machineId:p,firstSessionDate:E,msftInternal:m}}dispose(){this._disposables.dispose()}_log(l,f,p,E){return this.telemetryLevel<f?Promise.resolve(void 0):this._commonProperties.then(m=>{p=(0,R.mixin)(p,m),p=(0,R.mixin)(p,this._experimentProperties),p=(0,R.cloneAndChange)(p,o=>{if(typeof o=="string")return this._cleanupInfo(o,E)}),this._appenders.forEach(o=>o.log(l,p))},m=>{console.error(m)})}publicLog(l,f,p){return this._log(l,3,f,p)}publicLog2(l,f,p){return this.publicLog(l,f,p)}publicLogError(l,f){return this.sendErrorTelemetry?this._log(l,2,f,!0):Promise.resolve(void 0)}publicLogError2(l,f){return this.publicLogError(l,f)}_anonymizeFilePaths(l){let f=l;const p=[];for(let e of this._cleanupPatterns)for(;;){const s=e.exec(l);if(!s)break;p.push([s.index,e.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(f="";;){const e=m.exec(l);if(!e)break;!E.test(e[0])&&p.every(([s,i])=>e.index<s||e.index>=i)&&(f+=l.substring(o,e.index)+"<REDACTED: user-file-path>",o=m.lastIndex)}return o<l.length&&(f+=l.substr(o)),f}_removePropertiesWithPossibleUserInfo(l){if(!l)return l;const f=l.toLowerCase(),p=/@[a-zA-Z0-9-.]+/,E=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,m=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return E.test(f)?"<REDACTED: secret>":p.test(f)?"<REDACTED: email>":m.test(f)?"<REDACTED: token>":l}_cleanupInfo(l,f){let p=l;f&&(p=this._anonymizeFilePaths(p));for(let E of this._cleanupPatterns)p=p.replace(E,"");return p=this._removePropertiesWithPossibleUserInfo(p),p}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ge([oe(1,P.IConfigurationService)],y),t.TelemetryService=y;function w(){const g=(0,L.localize)(0,null,v.default.nameLong),l=v.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=b.isWeb?"":(0,L.localize)(3,null),p=(0,L.localize)(4,null),E=(0,L.localize)(5,null),m=(0,L.localize)(6,null),o=(0,L.localize)(7,null),e=`
|       | ${p} | ${E} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,L.localize)(8,null);return`
${g} ${l} ${f}

&nbsp;

${o}
${e}

&nbsp;

${s}
`}C.Registry.as(c.Extensions.Configuration).registerConfiguration({id:T.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(9,null),properties:{[T.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),C.Registry.as(c.Extensions.Configuration).registerConfiguration({id:T.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[T.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,L.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,L.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${T.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[123],Q([0,1,8,22,36]),function(j,t,D,R,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function I(P,c){const v=await new Promise((T,d)=>{j(["applicationinsights"],T,d)});let C;return v.defaultClient?(C=new v.TelemetryClient(P),C.channel.setUseDiskRetryCaching(!0)):(v.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),C=v.defaultClient),P.indexOf("AIF-")===0&&(C.config.endpointUrl=c?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),C}class L{constructor(c,v,C,T,d){this._eventPrefix=c,this._defaultData=v,this.testCollector=T,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof C=="function"?this._aiClient=C():this._aiClient=C,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=I(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(v=>{c(v)},v=>{(0,D.onUnexpectedError)(v),console.error(v)})}}log(c,v){if(!!this._aiClient){v=(0,R.mixin)(v,this._defaultData),v=(0,b.validateTelemetryData)(v),this.testCollector&&(v.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(C=>C.trackEvent({name:this._eventPrefix+"/"+c,properties:v.properties,measurements:v.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(v=>{try{v.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})}catch{}})}):Promise.resolve(void 0)}}t.AppInsightsAppender=L}),define(Y[124],Q([0,1,11,15]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function b(I,L){const P=Object.create(null),c=(C,T)=>{const d=JSON.parse(C);P[T]=d};if(L){const C=[],T=await R.Promises.readdir(L);for(const y of T)try{(await R.Promises.stat((0,D.join)(L,y))).isDirectory()&&C.push(y)}catch{}const d=[];for(const y of C)(await R.Promises.readdir((0,D.join)(L,y))).filter(g=>g==="telemetry.json").length===1&&d.push(y);for(const y of d){const w=(await R.Promises.readFile((0,D.join)(L,y,"telemetry.json"))).toString();c(w,y)}}let v=(await R.Promises.readFile((0,D.join)(I,"telemetry-core.json"))).toString();return c(v,"vscode-core"),v=(await R.Promises.readFile((0,D.join)(I,"telemetry-extensions.json"))).toString(),c(v,"vscode-extensions"),JSON.stringify(P,null,4)}t.buildTelemetryMessage=b}),define(Y[125],Q([0,1,39,11,86,24,28,8,12,27,70,138,3]),function(j,t,D,R,b,I,L,P,c,v,C,T,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=void 0;const y=1e4;let w;async function g(f,p,E){return p["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,T.isLaunchedFromCli)(E)&&!p["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,T.isLaunchedFromCli)(E)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=d.Promises.withAsyncBody(async(m,o)=>{const e=new I.CancellationTokenSource,s=setTimeout(()=>{e.dispose(!0),o(new Error((0,b.localize)(0,null)))},y);try{m(await l(f,e.token))}catch(i){!(0,P.isCancellationError)(i)&&!e.token.isCancellationRequested?o(new Error((0,b.localize)(1,null,(0,L.toErrorMessage)(i)))):m({})}finally{clearTimeout(s),e.dispose()}})),w)}t.getResolvedShellEnv=g;async function l(f,p){const E=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",E);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",m);const o=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(o+"(.*)"+o),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};f.trace("getUnixShellEnvironment#env",s);const i=await(0,C.getSystemShell)(c.OS,s);return f.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(p.isCancellationRequested)return r((0,P.canceled)());const a=(0,R.basename)(i);let u,h;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(u=`& '${process.execPath}' ${S} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,h=["-Login","-Command"]):(u=`'${process.execPath}' ${S} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,a==="tcsh"?h=["-ic"]:h=["-ilc"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),u);const O=(0,D.spawn)(i,[...h,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});p.onCancellationRequested(()=>(O.kill(),r((0,P.canceled)()))),O.on("error",J=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(J)),r(J)});const N=[];O.stdout.on("data",J=>N.push(J));const _=[];O.stderr.on("data",J=>_.push(J)),O.on("close",(J,re)=>{const ee=Buffer.concat(N).toString("utf8");f.trace("getUnixShellEnvironment#raw",ee);const ie=Buffer.concat(_).toString("utf8");if(ie.trim()&&f.trace("getUnixShellEnvironment#stderr",ie),J||re)return r(new Error((0,b.localize)(2,null,J,re)));const he=e.exec(ee),ue=he?he[1]:"{}";try{const x=JSON.parse(ue);E?x.ELECTRON_RUN_AS_NODE=E:delete x.ELECTRON_RUN_AS_NODE,m?x.ELECTRON_NO_ATTACH_CONSOLE=m:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",x),n(x)}catch(x){f.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(x)),r(x)}})})}}),define(Y[37],Q([0,1,13]),function(j,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(Y[126],Q([0,1,7,2,9,20,21,16,14,37]),function(j,t,D,R,b,I,L,P,c,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let C=class extends R.Disposable{constructor(d,y,w,g,l){super();this.extensionsManagementService=d,this.logService=g,this.uriIdentityService=l,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(p=>{this.installedExtensions=p.map(E=>E.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(p=>this.onInstallExtension(p))),this._register(d.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(d.onDidUninstallExtension(p=>this.onDidUninstallExtension(p)));const f=b.URI.file(w.extensionsPath);this._register(y.watch(f)),this._register(D.Event.filter(y.onDidFilesChange,p=>p.rawChanges.some(E=>this.doesChangeAffects(E,f)))(()=>this.onDidChange()))}doesChangeAffects(d,y){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),y)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const y of d)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(y=>!(0,L.areSameExtensions)(y,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,L.areSameExtensions)(y,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),y=d.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(l=>(0,L.areSameExtensions)(l,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),w=this.installedExtensions.filter(g=>this.installingExtensions.some(l=>(0,L.areSameExtensions)(l,g))?!1:d.every(l=>!(0,L.areSameExtensions)(l.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=d.map(g=>g.identifier),(y.length||w.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:w})}}};C=ge([oe(1,P.IFileService),oe(2,I.INativeEnvironmentService),oe(3,c.ILogService),oe(4,v.IUriIdentityService)],C),t.ExtensionsWatcher=C}),define(Y[127],Q([0,1,37,92,16,19,58,7,2]),function(j,t,D,R,b,I,L,P,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class v{constructor(d){this.uri=d,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let C=class{constructor(d){this._fileService=d,this._dispooables=new c.DisposableStore,this._limit=2**16;const y=new Map,w=g=>{let l=y.get(g.scheme);return l===void 0&&(l=d.hasProvider(g)&&!this._fileService.hasCapability(g,1024),y.set(g.scheme,l)),l};this._dispooables.add(P.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(g=>{y.delete(g.scheme)})),this.extUri=new I.ExtUri(w),this._canonicalUris=new L.SkipList((g,l)=>this.extUri.compare(g,l,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,I.normalizePath)(d));let y=this._canonicalUris.get(d);return y?y.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new v(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((w,g)=>w[1].touch<g[1].touch?1:w[1].touch>g[1].touch?-1:0);v._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let w=0;w<y;w++)this._canonicalUris.set(d[w][0],d[w][1].touch())}};C=ge([oe(0,b.IFileService)],C),t.UriIdentityService=C,(0,R.registerSingleton)(D.IUriIdentityService,C,!0)}),define(Y[43],Q([0,1,103,3,11,6,15,72,139,140]),function(j,t,D,R,b,I,L,P,c,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class C extends Error{constructor(e,s){let i=s.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=e,this.cause=s}}t.ExtractError=C;function T(o){const e=o.externalFileAttributes>>16||33188;return[448,56,7].map(s=>e&s).reduce((s,i)=>s+i,e&61440)}function d(o){if(o instanceof C)return o;let e;return/end of central directory record signature not found/.test(o.message)&&(e="CorruptZip"),new C(e,o)}function y(o,e,s,i,n,r){const a=b.dirname(e),u=b.join(i,a);if(!u.startsWith(i))return Promise.reject(new Error(P.localize(0,null,e)));const h=b.join(i,e);let S;return r.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(L.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!r.isCancellationRequested)try{S=(0,D.createWriteStream)(h,{mode:s}),S.once("close",()=>O()),S.once("error",N),o.once("error",N),o.pipe(S)}catch(_){N(_)}}))}function w(o,e,s,i){let n=(0,R.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),o.close()}),new Promise((a,u)=>{const h=new R.Sequencer,S=O=>{O.isCancellationRequested||(r++,o.readEntry())};o.once("error",u),o.once("close",()=>n.then(()=>{i.isCancellationRequested||o.entryCount===r?a():u(new C("Incomplete",new Error(P.localize(1,null,r,o.entryCount))))},u)),o.readEntry(),o.on("entry",O=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(O.fileName)){S(i);return}const N=O.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(N)){const re=b.join(e,N);n=(0,R.createCancelablePromise)(ee=>L.Promises.mkdir(re,{recursive:!0}).then(()=>S(ee)).then(void 0,u));return}const _=l(o,O),J=T(O);n=(0,R.createCancelablePromise)(re=>h.queue(()=>_.then(ee=>y(ee,N,J,e,s,re).then(()=>S(re)))).then(null,u))})})}function g(o,e=!1){return new Promise((s,i)=>{(0,c.open)(o,e?{lazyEntries:!0}:void 0,(n,r)=>{n?i(d(n)):s((0,I.assertIsDefined)(r))})})}function l(o,e){return new Promise((s,i)=>{o.openReadStream(e,(n,r)=>{n?i(d(n)):s((0,I.assertIsDefined)(r))})})}function f(o,e){return new Promise((s,i)=>{const n=new v.ZipFile;e.forEach(a=>{a.contents?n.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&n.addFile(a.localPath,a.path)}),n.end();const r=(0,D.createWriteStream)(o);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>s(o))})}t.zip=f;function p(o,e,s={},i){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=g(o,!0);return s.overwrite&&(r=r.then(a=>L.Promises.rm(e).then(()=>a))),r.then(a=>w(a,e,{sourcePathRegex:n},i))}t.extract=p;function E(o,e){return g(o).then(s=>new Promise((i,n)=>{s.on("entry",r=>{r.fileName===e&&l(s,r).then(a=>i(a),a=>n(a))}),s.once("close",()=>n(new Error(P.localize(2,null,e))))}))}function m(o,e){return E(o,e).then(s=>new Promise((i,n)=>{const r=[];s.once("error",n),s.on("data",a=>r.push(a)),s.on("end",()=>i(Buffer.concat(r)))}))}t.buffer=m}),define(Y[128],Q([0,1,43,78]),function(j,t,D,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(I){return(0,D.buffer)(I,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}t.getManifest=b}),define(Y[129],Q([0,1,18,3,8,2,10,11,12,19,41,9,27,15,43,79,20,23,21,90,35,16,14,32]),function(j,t,D,R,b,I,L,P,c,v,C,T,d,y,w,g,l,f,p,E,m,o,e,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let i=class extends I.Disposable{constructor(r,a,u,h,S){super();this.beforeRemovingExtension=r,this.fileService=a,this.logService=u,this.environmentService=h,this.productService=S,this._devSystemExtensionsPath=null,this.systemExtensionsPath=h.builtinExtensionsPath,this.extensionsPath=h.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(r){const a=[];(r===null||r===0)&&a.push(this.scanSystemExtensions().then(null,u=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(u).message,f.ExtensionManagementErrorCode.Internal)))),(r===null||r===1)&&a.push(this.scanUserExtensions(!0).then(null,u=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(u).message,f.ExtensionManagementErrorCode.Internal))));try{const u=await Promise.all(a);return(0,D.flatten)(u)}catch(u){throw this.joinErrors(u)}}async scanUserExtensions(r){this.logService.trace("Started scanning user extensions");let[a,u]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return u=u.filter(h=>!a[new p.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).key()]),r&&(u=(0,p.groupByExtension)(u,S=>S.identifier).map(S=>S.sort((O,N)=>C.rcompare(O.manifest.version,N.manifest.version))[0])),this.logService.trace("Scanned user extensions:",u.length),u}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(r,a,u,h){const S=r.key(),O=P.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),N=P.join(this.extensionsPath,S);try{await y.Promises.rm(N)}catch{try{await y.Promises.rm(N)}catch{}throw new f.ExtensionManagementError((0,g.localize)(0,null,N,r.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(r,a,O,h);let _=await this.scanExtension(T.URI.file(O),1);if(!_)throw new Error((0,g.localize)(1,null,O));await this.storeMetadata(_,{...u,installedTimestamp:Date.now()});try{await this.rename(r,O,N,Date.now()+2*60*1e3),this.logService.info("Renamed to",N)}catch(J){try{await y.Promises.rm(O)}catch{}if(J.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",r.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(J)}. Deleted from extracted location`,O),J}try{_=await this.scanExtension(T.URI.file(N),1)}catch{}if(_)return _;throw new Error((0,g.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(r,a){return this.setMetadata(r,a),await this.storeMetadata(r,{...a,installedTimestamp:r.installedTimestamp}),r}async storeMetadata(r,a){a.isMachineScoped=a.isMachineScoped||void 0,a.isBuiltin=a.isBuiltin||void 0,a.installedTimestamp=a.installedTimestamp||void 0;const u=P.join(r.location.fsPath,"package.json"),h=await y.Promises.readFile(u,"utf8"),{manifest:S}=await this.parseManifest(h);return S.__metadata=a,await y.Promises.writeFile(u,JSON.stringify(S,null,"	")),r}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...r){const a=r.map(u=>new p.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version));await this.withUninstalledExtensions(u=>{a.forEach(h=>u[h.key()]=!0)})}async setInstalled(r){await this.withUninstalledExtensions(h=>delete h[r.key()]);const u=(await this.scanExtensions(1)).find(h=>new p.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).equals(r))||null;return u?(await this.storeMetadata(u,{installedTimestamp:Date.now()}),this.scanExtension(u.location,1)):null}async withUninstalledExtensions(r){return this.uninstalledFileLimiter.queue(async()=>{let a;try{a=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch(h){if(h.code!=="ENOENT")throw h}let u={};if(a)try{u=JSON.parse(a)}catch{}return r&&(r(u),Object.keys(u).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(u)):await y.Promises.rm(this.uninstalledPath)),u})}async removeExtension(r,a){this.logService.trace(`Deleting ${a} extension from disk`,r.identifier.id,r.location.fsPath),await y.Promises.rm(r.location.fsPath),this.logService.info("Deleted from disk",r.identifier.id,r.location.fsPath)}async removeUninstalledExtension(r){await this.removeExtension(r,"uninstalled"),await this.withUninstalledExtensions(a=>delete a[new p.ExtensionIdentifierWithVersion(r.identifier,r.manifest.version).key()])}async extractAtLocation(r,a,u,h){this.logService.trace(`Started extracting the extension from ${a} to ${u}`);try{await y.Promises.rm(u)}catch(S){throw new f.ExtensionManagementError(this.joinErrors(S).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,w.extract)(a,u,{sourcePath:"extension",overwrite:!0},h),this.logService.info(`Extracted extension to ${u}:`,r.id)}catch(S){try{await y.Promises.rm(u)}catch{}let O=f.ExtensionManagementErrorCode.Extract;throw S instanceof w.ExtractError&&(S.type==="CorruptZip"?O=f.ExtensionManagementErrorCode.CorruptZip:S.type==="Incomplete"&&(O=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(S.message,O)}}async rename(r,a,u,h){try{await y.Promises.rename(a,u)}catch(S){if(c.isWindows&&S&&S.code==="EPERM"&&Date.now()<h)return this.logService.info(`Failed renaming ${a} to ${u} with 'EPERM' error. Trying again...`,r.id),this.rename(r,a,u,h);throw new f.ExtensionManagementError(S.message||(0,g.localize)(3,null,a,u),S.code||f.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const r=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return r;const a=this.scanDevSystemExtensions(),[u,h]=await Promise.all([r,a]);return[...u,...h]}async scanExtensionsInDir(r,a){const u=new R.Limiter(10),h=await this.fileService.resolve(T.URI.file(r));return h.children?(await Promise.all(h.children.filter(O=>O.isDirectory).map(O=>u.queue(async()=>a===1&&(0,v.basename)(O.resource).indexOf(".")===0?null:this.scanExtension(O.resource,a))))).filter(O=>O&&O.identifier):[]}async scanExtension(r,a){try{const u=await this.fileService.resolve(r);if(u.children){const{manifest:h,metadata:S}=await this.readManifest(r.fsPath),O=u.children.find(({name:re})=>/^readme(\.txt|\.md|)$/i.test(re))?.resource,N=u.children.find(({name:re})=>/^changelog(\.txt|\.md|)$/i.test(re))?.resource,_={id:(0,p.getGalleryExtensionId)(h.publisher,h.name)},J={type:a,identifier:_,manifest:h,location:r,readmeUrl:O,changelogUrl:N,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:a===0};return this.setMetadata(J,S),J}}catch(u){a!==0&&this.logService.trace(u)}return null}async scanDefaultSystemExtensions(){const r=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",r.length),r}async scanDevSystemExtensions(){const r=this.getDevSystemExtensionsList();if(r.length){const a=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",a.length),a.filter(u=>r.some(h=>(0,p.areSameExtensions)(u.identifier,{id:h})))}else return[]}setMetadata(r,a){r.publisherDisplayName=a?.publisherDisplayName||null,r.publisherId=a?.publisherId||null,r.identifier.uuid=a?.id,r.isMachineScoped=!!a?.isMachineScoped,r.isPreReleaseVersion=!!a?.isPreReleaseVersion,r.preRelease=!!a?.preRelease,r.isBuiltin=r.type===0||!!a?.isBuiltin,r.installedTimestamp=a?.installedTimestamp}async removeUninstalledExtensions(){const r=await this.getUninstalledExtensions(),a=await this.scanAllUserExtensions(),u=new Set;for(const O of a)r[new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]||u.add(O.identifier.id.toLowerCase());const h=(0,p.groupByExtension)(a,O=>O.identifier);await R.Promises.settled(h.map(async O=>{const N=O.sort((_,J)=>C.rcompare(_.manifest.version,J.manifest.version))[0];u.has(N.identifier.id.toLowerCase())||await this.beforeRemovingExtension(N)}));const S=a.filter(O=>r[new p.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]);await R.Promises.settled(S.map(O=>this.removeUninstalledExtension(O)))}async removeOutdatedExtensions(){const r=await this.scanAllUserExtensions(),a=[],u=(0,p.groupByExtension)(r,h=>h.identifier);a.push(...(0,D.flatten)(u.map(h=>h.sort((S,O)=>C.rcompare(S.manifest.version,O.manifest.version)).slice(1)))),await R.Promises.settled(a.map(h=>this.removeExtension(h,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(r=>r.name)}joinErrors(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((u,h)=>new Error(`${u.message}${u.message?",":""}${h instanceof Error?h.message:h}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(L.FileAccess.asFileUri("",j).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(r){const a=[y.Promises.readFile(P.join(r,"package.json"),"utf8").then(O=>this.parseManifest(O)),y.Promises.readFile(P.join(r,"package.nls.json"),"utf8").then(void 0,O=>O.code!=="ENOENT"?Promise.reject(O):"{}").then(O=>JSON.parse(O))],[{manifest:u,metadata:h},S]=await Promise.all(a);return{manifest:(0,E.localizeManifest)(u,S),metadata:h}}parseManifest(r){return new Promise((a,u)=>{try{const h=JSON.parse(r);h.publisher||(h.publisher=m.UNDEFINED_PUBLISHER);const S=h.__metadata||null;a({manifest:h,metadata:S})}catch{u(new Error((0,g.localize)(4,null)))}})}};i=ge([oe(1,o.IFileService),oe(2,e.ILogService),oe(3,l.INativeEnvironmentService),oe(4,s.IProductService)],i),t.ExtensionsScanner=i}),define(Y[130],Q([0,1,28,8,10,11,12,29,19,41,6,9,27,15,43,77,49,20,118,23,21,110,98,128,111,129,126,48,16,13,14,32,31,37]),function(j,t,D,R,b,I,L,P,c,v,C,T,d,y,w,g,l,f,p,E,m,o,e,s,i,n,r,a,u,h,S,O,N,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let J=class extends p.AbstractExtensionManagementService{constructor(x,te,U,k,z,G,ne,K,Z){super(x,te,U,K);this.environmentService=k,this.downloadService=z,this.fileService=ne;const q=this._register(G.createInstance(e.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(n.ExtensionsScanner,A=>q.postUninstall(A))),this.manifestCache=this._register(new i.ExtensionsManifestCache(k,this)),this.extensionsDownloader=this._register(G.createInstance(o.ExtensionsDownloader));const M=this._register(new r.ExtensionsWatcher(this,ne,k,U,Z));this._register(M.onDidChangeExtensionsByAnotherSource(({added:A,removed:V})=>{A.length&&this._onDidInstallExtensions.fire(A.map(B=>({identifier:B.identifier,operation:1,local:B}))),V.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const x=await this.isAlpineLinux(),te=(0,E.getTargetPlatform)(x?"alpine":L.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",te),te})()),this._targetPlatformPromise}async isAlpineLinux(){if(!L.isLinux)return!1;let x;try{x=(await this.fileService.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{x=(await this.fileService.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(U){this.logService.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(U))}}return!!x&&(x.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(x){this.logService.trace("ExtensionManagementService#zip",x.identifier.id);const te=await this.collectFiles(x),U=await(0,w.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)()).fsPath,te);return T.URI.file(U)}async unzip(x){return this.logService.trace("ExtensionManagementService#unzip",x.toString()),(await this.install(x)).identifier}async getManifest(x){const te=await this.downloadVsix(x),U=I.resolve(te.fsPath);return(0,s.getManifest)(U)}getInstalled(x=null){return this.extensionsScanner.scanExtensions(x)}async install(x,te={}){this.logService.trace("ExtensionManagementService#install",x.toString());const U=await this.downloadVsix(x),k=await(0,s.getManifest)(I.resolve(U.fsPath));if(k.engines&&k.engines.vscode&&!(0,a.isEngineValid)(k.engines.vscode,this.productService.version,this.productService.date))throw new Error(g.localize(0,null,(0,m.getGalleryExtensionId)(k.publisher,k.name),this.productService.version));return this.installExtension(k,U,te)}async updateMetadata(x,te){this.logService.trace("ExtensionManagementService#updateMetadata",x.identifier.id);const U={...x.manifest.__metadata||{},...te};return te.isPreReleaseVersion&&(U.preRelease=!0),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,U),this.manifestCache.invalidate(),x}async updateExtensionScope(x,te){return this.logService.trace("ExtensionManagementService#updateExtensionScope",x.identifier.id),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,{...x.manifest.__metadata||{},isMachineScoped:te}),this.manifestCache.invalidate(),x}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(x){if(x.scheme===b.Schemas.file)return x;const te=(0,c.joinPath)(this.environmentService.tmpDir,(0,d.generateUuid)());return await this.downloadService.download(x,te),te}createInstallExtensionTask(x,te,U){return T.URI.isUri(te)?new ie(x,te,U,this.galleryService,this.extensionsScanner,this.logService):new ee(te,U,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(x,te){return new he(x,te,this.extensionsScanner)}async collectFiles(x){const te=async k=>{let z=await y.Promises.readdir(k);z=z.map(K=>I.join(k,K));const G=await Promise.all(z.map(K=>y.Promises.stat(K)));let ne=Promise.resolve([]);return G.forEach((K,Z)=>{const q=z[Z];K.isFile()&&(ne=ne.then(M=>[...M,q])),K.isDirectory()&&(ne=ne.then(M=>te(q).then(A=>[...M,...A])))}),ne};return(await te(x.location.fsPath)).map(k=>({path:`extension/${I.relative(x.location.fsPath,k)}`,localPath:k}))}};J=ge([oe(0,E.IExtensionGalleryService),oe(1,N.ITelemetryService),oe(2,S.ILogService),oe(3,f.INativeEnvironmentService),oe(4,l.IDownloadService),oe(5,h.IInstantiationService),oe(6,u.IFileService),oe(7,O.IProductService),oe(8,_.IUriIdentityService)],J),t.ExtensionManagementService=J;class re extends p.AbstractExtensionTask{constructor(x,te,U,k){super();this.identifier=x,this.source=te,this.extensionsScanner=U,this.logService=k,this._operation=2}get operation(){return this._operation}async installExtension(x,te){try{const U=await this.unsetUninstalledAndGetLocal(x.identifierWithVersion);if(U)return x.metadata?this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...x.metadata}):U}catch{throw L.isMacintosh?new E.ExtensionManagementError(g.localize(1,null),E.ExtensionManagementErrorCode.Internal):new E.ExtensionManagementError(g.localize(2,null),E.ExtensionManagementErrorCode.Internal)}return this.extract(x,te)}async unsetUninstalledAndGetLocal(x){if(!await this.isUninstalled(x))return null;this.logService.trace("Removing the extension from uninstalled list:",x.id);const U=await this.extensionsScanner.setInstalled(x);return this.logService.info("Removed the extension from uninstalled list:",x.id),U}async isUninstalled(x){return!!(await this.extensionsScanner.getUninstalledExtensions())[x.key()]}async extract({zipPath:x,identifierWithVersion:te,metadata:U},k){let z=await this.extensionsScanner.extractUserExtension(te,x,U,k);return this.logService.info("Extracting completed.",te.id),z}}class ee extends re{constructor(x,te,U,k,z){super(x.identifier,x,k,z);this.gallery=x,this.options=te,this.extensionsDownloader=U}async doRun(x){const U=(await this.extensionsScanner.scanExtensions(null)).find(z=>(0,m.areSameExtensions)(z.identifier,this.gallery.identifier));U&&(this._operation=3);const k=await this.downloadInstallableExtension(this.gallery,this._operation);k.metadata.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,k.metadata.isBuiltin=this.options.isBuiltin||U?.isBuiltin,k.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,k.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,C.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:U?.preRelease);try{const z=await this.installExtension(k,x);return U&&v.neq(U.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(U),z}catch(z){throw await this.deleteDownloadedVSIX(k.zipPath),z}}async deleteDownloadedVSIX(x){try{await this.extensionsDownloader.delete(T.URI.file(x))}catch(te){this.logService.warn("Error while deleting the downloaded vsix",x.toString(),(0,R.getErrorMessage)(te))}}async downloadInstallableExtension(x,te){const U={id:x.identifier.uuid,publisherId:x.publisherId,publisherDisplayName:x.publisherDisplayName};let k;try{this.logService.trace("Started downloading extension:",x.identifier.id),k=(await this.extensionsDownloader.downloadExtension(x,te)).fsPath,this.logService.info("Downloaded extension:",x.identifier.id,k)}catch(z){throw new E.ExtensionManagementError((0,p.joinErrors)(z).message,E.ExtensionManagementErrorCode.Download)}try{const z=await(0,s.getManifest)(k);return{zipPath:k,identifierWithVersion:new m.ExtensionIdentifierWithVersion(x.identifier,z.version),metadata:U}}catch(z){throw await this.deleteDownloadedVSIX(k),new E.ExtensionManagementError((0,p.joinErrors)(z).message,E.ExtensionManagementErrorCode.Invalid)}}}class ie extends re{constructor(x,te,U,k,z,G){super({id:(0,m.getGalleryExtensionId)(x.publisher,x.name)},te,z,G);this.manifest=x,this.location=te,this.options=U,this.galleryService=k}async doRun(x){const te=new m.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),k=(await this.extensionsScanner.scanExtensions(1)).find(G=>(0,m.areSameExtensions)(this.identifier,G.identifier)),z=await this.getMetadata(this.identifier.id,this.manifest.version,x);if(z.isMachineScoped=this.options.isMachineScoped||k?.isMachineScoped,z.isBuiltin=this.options.isBuiltin||k?.isBuiltin,k)if(this._operation=3,te.equals(new m.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version)))try{await this.extensionsScanner.removeExtension(k,"existing")}catch{throw new Error(g.localize(3,null,this.manifest.displayName||this.manifest.name))}else v.gt(k.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(k);else{const G=await this.unsetUninstalledAndGetLocal(te);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(g.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:I.resolve(this.location.fsPath),identifierWithVersion:te,metadata:z},x)}async getMetadata(x,te,U){try{let[k]=await this.galleryService.getExtensions([{id:x,version:te}],U);if(k||([k]=await this.galleryService.getExtensions([{id:x}],U)),k)return{id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class he extends p.AbstractExtensionTask{constructor(x,te,U){super();this.extension=x,this.options=te,this.extensionsScanner=U}async doRun(x){const te=[],U=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const k=new m.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);te.push(...U.filter(z=>k.equals(new m.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version))))}else te.push(...U.filter(k=>(0,m.areSameExtensions)(k.identifier,this.extension.identifier)));if(!te.length)throw new Error(g.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...te),this.options.remove)for(const k of te)try{x.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(k)}catch(z){throw new Error(g.localize(6,null,(0,D.toErrorMessage)(z)))}}}}),define(Y[131],Q([0,1,115,3,17,8,2,6,25,20,125,14,114,141]),function(j,t,D,R,b,I,L,P,c,v,C,T,d,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let w=class extends L.Disposable{constructor(l,f,p){super();this.environmentService=f,this.logService=p,this.configure(l.getValue()),this._register(l.onDidChangeConfiguration(()=>this.configure(l.getValue()),this))}configure(l){this.proxyUrl=l.http&&l.http.proxy,this.strictSSL=!!(l.http&&l.http.proxyStrictSSL),this.authorization=l.http&&l.http.proxyAuthorization}async request(l,f){this.logService.trace("RequestService#request",l.url);const{proxyUrl:p,strictSSL:E}=this;let m;try{m=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(s){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",s))}const o={...process.env,...m},e=l.agent?l.agent:await(0,d.getProxyAgent)(l.url||"",o,{proxyUrl:p,strictSSL:E});return l.agent=e,l.strictSSL=E,this.authorization&&(l.headers={...l.headers||{},"Proxy-Authorization":this.authorization}),this._request(l,f)}async getNodeRequest(l){return((0,D.parse)(l.url).protocol==="https:"?await new Promise((E,m)=>{j(["https"],E,m)}):await new Promise((E,m)=>{j(["http"],E,m)})).request}_request(l,f){return R.Promises.withAsyncBody(async(p,E)=>{let m;const o=(0,D.parse)(l.url),e=l.getRawRequest?l.getRawRequest(l):await this.getNodeRequest(l),s={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,P.isBoolean)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(s.auth=l.user+":"+l.password),m=e(s,i=>{const n=(0,P.isNumber)(l.followRedirects)?l.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...l,url:i.headers.location,followRedirects:n-1},f).then(p,E);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,y.createGunzip)())),p({res:i,stream:(0,b.streamToBufferReadableStream)(r)})}}),m.on("error",E),l.timeout&&m.setTimeout(l.timeout),l.data&&typeof l.data=="string"&&m.write(l.data),m.end(),f.onCancellationRequested(()=>{m.abort(),E((0,I.canceled)())})})}async resolveProxy(l){}};w=ge([oe(0,c.IConfigurationService),oe(1,v.INativeEnvironmentService),oe(2,T.ILogService)],w),t.RequestService=w}),define(Y[142],Q([0,1,33,3,17,28,8,2,10,11,29,9,15,25,107,49,113,20,89,120,23,109,130,16,100,102,40,97,52,53,112,14,104,122,32,42,131,117,31,121,36,123,124,37,127]),function(j,t,D,R,b,I,L,P,c,v,C,T,d,y,w,g,l,f,p,E,m,o,e,s,i,n,r,a,u,h,S,O,N,_,J,re,ee,ie,he,ue,x,te,U,k,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class G extends P.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,q]=await this.initServices();return Z.invokeFunction(async M=>{const A=M.get(O.ILogService),V=M.get(s.IFileService),B=M.get(f.INativeEnvironmentService),H=M.get(m.IExtensionManagementCLIService);A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(B,H,V),await Promise.all(q.map(X=>{(0,R.raceTimeout)(X.flush(),1e3)}))})}async initServices(){const Z=new u.ServiceCollection,q={_serviceBrand:void 0,..._.default};Z.set(J.IProductService,q);const M=new p.NativeEnvironmentService(this.argv,q);Z.set(f.INativeEnvironmentService,M),await Promise.all([M.appSettingsHome.fsPath,M.extensionsPath].map(we=>we?d.Promises.mkdir(we,{recursive:!0}):void 0));const A=(0,O.getLogLevel)(M),V=[];V.push(new N.SpdLogLogger("cli",(0,v.join)(M.logsPath,"cli.log"),!0,!1,A)),A===O.LogLevel.Trace&&V.push(new O.ConsoleLogger(A));const B=this._register(new O.MultiplexLogService(V));Z.set(O.ILogService,B);const H=this._register(new i.FileService(B));Z.set(s.IFileService,H);const X=this._register(new n.DiskFileSystemProvider(B));H.registerProvider(c.Schemas.file,X);const ae=this._register(new w.ConfigurationService(M.settingsResource,H));Z.set(y.IConfigurationService,ae),await ae.initialize(),Z.set(k.IUriIdentityService,new z.UriIdentityService(H)),Z.set(re.IRequestService,new r.SyncDescriptor(ee.RequestService)),Z.set(g.IDownloadService,new r.SyncDescriptor(l.DownloadService)),Z.set(m.IExtensionManagementService,new r.SyncDescriptor(e.ExtensionManagementService)),Z.set(m.IExtensionGalleryService,new r.SyncDescriptor(E.ExtensionGalleryServiceWithNoStorageService)),Z.set(m.IExtensionManagementCLIService,new r.SyncDescriptor(o.ExtensionManagementCLIService)),Z.set(h.ILocalizationsService,new r.SyncDescriptor(S.LocalizationsService));const ce=[];if((0,x.supportsTelemetry)(q,M)){q.aiConfig&&q.aiConfig.asimovKey&&ce.push(new te.AppInsightsAppender("monacoworkbench",null,q.aiConfig.asimovKey));const{appRoot:we,extensionsPath:fe,installSourcePath:se}=M,pe={appenders:ce,sendErrorTelemetry:!1,commonProperties:(async()=>{let me;try{const Ee=await d.Promises.readFile((0,v.join)(M.userDataPath,"storage.json"));me=JSON.parse(Ee.toString())[he.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&B.error(Ee)}return(0,ie.resolveCommonProperties)(H,(0,D.release)(),(0,D.hostname)(),process.arch,q.commit,q.version,me,q.msftInternalDomains,se)})(),piiPaths:[we,fe]};Z.set(he.ITelemetryService,new r.SyncDescriptor(ue.TelemetryService,[pe]))}else Z.set(he.ITelemetryService,x.NullTelemetryService);return[new a.InstantiationService(Z),ce]}registerErrorHandler(Z){(0,L.setUnexpectedErrorHandler)(q=>{const M=(0,I.toErrorMessage)(q,!0);!M||Z.error(`[uncaught exception in CLI]: ${M}`)}),process.on("uncaughtException",q=>(0,L.onUnexpectedError)(q)),process.on("unhandledRejection",q=>(0,L.onUnexpectedError)(q))}async doRun(Z,q,M){if(this.argv["install-source"])return this.setInstallSource(Z,M,this.argv["install-source"]);if(this.argv["list-extensions"])return q.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const A={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return q.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],A,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return q.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return q.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}}asExtensionIdOrVSIX(Z){return Z.map(q=>/\.vsix$/i.test(q)?T.URI.file((0,v.isAbsolute)(q)?q:(0,v.join)((0,C.cwd)(),q)):q)}async setInstallSource(Z,q,M){await q.writeFile(T.URI.file(Z.installSourcePath),b.VSBuffer.fromString(M.slice(0,30)))}}async function ne(K){const Z=new G(K);try{await Z.run()}finally{Z.dispose()}}t.main=ne})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/eeeab304b9ac777b4a8dddf55f66ffebd9e4e7f2/core/vs/code/node/cliProcessMain.js.map
